#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "nx.h"

/* main pour tester nx sur l'ecriture / lecture de fichiers ie32 */

int
main()
{
	FILE* file;
#define lbuffer 125000
        float fbuffer[lbuffer];
        int ibuffer[lbuffer];
        char cbuffer[lbuffer];
        int icbuffer[lbuffer];
	unsigned i;
	unsigned j;
	unsigned lus,ecrits;

	for(i=0;i<lbuffer;i++)
	{
	    fbuffer[i] = i;
	    ibuffer[i] = i;
	    cbuffer[i] = (char) (i%256);
	    icbuffer[i] = 0;
	}

    /* format ieee 32 bits avec fnxchfrm 
       (natif pour machines ieee 32 bits big endian) */

	file = fnxopen("/tmp/testnx","w");
	printf("file = %p\n",file);
	fnxchfrm(file,"ie32");
	printf("Test format ie32 avec fnxchfrm : ecriture\n");
	fnxwritf(file,lbuffer,fbuffer);
	ecrits = fnxnbkwi(file,ibuffer,lbuffer);
	printf("ecrits %d\n",ecrits);
	fnxwrite(file,cbuffer,lbuffer);
	fnxclose(file);

    /* relecture */

	file = fnxopen("/tmp/testnx","r");
	fnxchfrm(file,"ie32");
	printf("Test format ie32 avec fnxchfrm : lecture\n");
	fnxreadf(file,lbuffer,fbuffer);
	fnxreadi(file,lbuffer,ibuffer);
	lus = fnxnbkri(file,icbuffer,lbuffer);
	printf("lus %d\n",lus);
	fnxclose(file);

	for(i=0,j=0;i<lbuffer;i++)
	{

	    if(fbuffer[i] != i && j<1000)
	    {
		printf("%d = %g%c",i,fbuffer[i],(i+1)%10 ? ' ' : '\n');
		j++;
	    }

	    if(ibuffer[i] != i && j<1000)
	    {
		printf("%d = %g%c",i,ibuffer[i],(i+1)%10 ? ' ' : '\n');
		j++;
	    }

	    if(i>=lbuffer/4-10 && i<lbuffer/4+10)
		printf("%d = %d%c",i,icbuffer[i],(i+1)%10 ? ' ' : '\n');
	}

	printf("\nnb erreurs %d\n",j);

	return 0;
}
