#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "nx.h"

/* main pour tester nx sur l'ecriture / lecture de fichiers li64 */

int
main()
{
	FILE* file;
#define lbuffer 35000
        float fbuffer[lbuffer];
        int ibuffer[lbuffer];
        long lobuffer[lbuffer];
#ifdef NX_LONGLONG
        long long llbuffer[lbuffer];
#endif
        char cbuffer[lbuffer];
        int icbuffer[lbuffer];
	unsigned i,j,lus,ecrits;

	for(i=0;i<lbuffer;i++)
	{
	    fbuffer[i] = i;
	    ibuffer[i] = i-lbuffer/3;
	    lobuffer[i] = i;
#ifdef NX_LONGLONG
	    llbuffer[i] = i;
#endif
	    cbuffer[i] = (char) (i%256);
	    icbuffer[i] = 0;
	}

    /* format ieee little endian 64 bits avec fnxchfrm */

	file = fnxopen("/tmp/testnx","w");
	fnxchfrm(file,"li64");
	printf("Test format li64 avec fnxchfrm : ecriture\n");
	fnxwritf(file,lbuffer,fbuffer);
	fnxwrite_long(file,lbuffer,lobuffer);
#ifdef NX_LONGLONG
	fnxwrite_longlong(file,lbuffer,llbuffer);
#endif
	ecrits = fnxnbkwi(file,ibuffer,lbuffer);
	printf("ecrits %d\n",ecrits);
	fnxwrite(file,cbuffer,lbuffer);
	fnxclose(file);

    /* relecture */

	file = fnxopen("/tmp/testnx","r");
	fnxchfrm(file,"li64");
	printf("Test format li64 avec fnxchfrm : lecture\n");
	fnxreadf(file,lbuffer,fbuffer);
	printf("lecture long\n");
	fnxread_long(file,lbuffer,lobuffer);
#ifdef NX_LONGLONG
	printf("lecture long long\n");
	fnxread_longlong(file,lbuffer,llbuffer);
#endif
	printf("lecture int\n");
	fnxreadi(file,lbuffer,ibuffer);
	lus = fnxnbkri(file,icbuffer,lbuffer);
	printf("lus %d/%d\n",lus,ecrits/8);
	fnxclose(file);

	for(i=0,j=0;i<lbuffer;i++)
	{

	    if(fbuffer[i] != i && j<1000)
	    {
		if(j==0) printf("float ");
		printf("%d = %g%c",i,fbuffer[i],(i+1)%10 ? ' ' : '\n');
		j++;
	    }

	}

	printf("\nnb erreurs %d\n",j);

	for(i=0,j=0;i<lbuffer;i++)
	{

	    if(lobuffer[i] != i && j<1000)
	    {
		if(j==0) printf("long ");j++;
		printf("%d = %d%c",i,lobuffer[i],(i+1)%10 ? ' ' : '\n');
	    }

	}

	printf("\nnb erreurs %d\n",j);

#ifdef NX_LONGLONG
	for(i=0,j=0;i<lbuffer;i++)
	{

	    if(llbuffer[i] != i && j<1000)
	    {
		if(j==0) printf("long long ");j++;
		printf("%d = %ld%c",i,llbuffer[i],(i+1)%10 ? ' ' : '\n');
	    }

	}

	printf("\nnb erreurs %d\n",j);
#endif

	for(i=0,j=0;i<lbuffer;i++)
	{

	    if(ibuffer[i] != i-lbuffer/3 && j<1000)
	    {
		if(j==0) printf("int ");j++;
		printf("%d = %d%c",i,ibuffer[i],(i+1)%10 ? ' ' : '\n');
	    }

	}

	printf("\nnb erreurs %d\n",j);

	for(i=0;i<lbuffer;i++)
	{

	    if(i>=lbuffer/8-10 && i<lbuffer/8+10)
		printf("%d = %d%c",i,icbuffer[i],(i+1)%10 ? ' ' : '\n');

	}

	printf("\n");

	return 0;
}
