#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include "nx.h"

/* tests en ecriture */

#define lbuffer 500
#define lbuffi 200
#define lbufff 2001
#define lbuffd 65537

char buffer[lbuffer];
int buffi[lbuffi];
NXFLT bufff[lbufff];
NXDBLE buffd[lbuffd];

/* *********************************************************
     generateur de nbre aleatoire (ref RANF de CRAY)
     sizeof(unsigned) >= 32
   *********************************************************/

#ifdef CRAY
double _ranf();

double
alea()
{
	return _ranf();
}

#else
double
alea()
{
	static unsigned seedhi = 0x2bc6;
	static unsigned seedlo = 0x8cfe166d;

	register const unsigned mhi = 0x2875;
	register const unsigned mlohi = 0xa2e7;
	register const unsigned mlolo = 0xb175;

	register const unsigned seedlohi = (0xffff0000 & seedlo) >> 16;
	register const unsigned seedlolo = 0xffff & seedlo;

	register const double den = 0x10000;
	register double se1;
	register double se2;

	seedlo = seedlolo*mlolo + ((seedlolo*mlohi + seedlohi*mlolo) << 16);
	seedlo &= 0xffffffff;
	seedhi = ((seedlolo*mlohi + seedlohi*mlolo) >> 16) +
		seedlohi*mlohi + seedhi*mlolo + mhi*seedlolo;
	seedhi &= 0xffff;
	se1 = (double) seedhi/den;
	se2 = (double) seedlo/den;
	se2 /= den;
	se2 /= den;

	return se1 + se2;
}
#endif

int
alea2(int kd,int kf)
{
	register int ki = (int) ((kf-kd+1)*alea()) + kd;

	return ki > kf ? kf : ki;
}

/* test conversion float -> double */
/* test conversion double -> float */

void
nxconvtest_real_float_double()
{

	{
	    unsigned char s[16]; /* 16 au lieu de 8 pour le CRAY YMP */
	    unsigned char d[16];

	    printf("\nTest conversion reelle float -> double\n");

	/* 0x5fef6450 en ie32 */

	    ((NXFLT*) s)[0] = 3.45e+19;
	    printf("float %g\n",((NXFLT*) s)[0]);
	    printf("float (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_flt_dble(s,d,1);
	    printf("double (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);
#if defined(CRAY) && !defined(_CRAYMPP)
	    printf("double %Lg\n",((NXDBLE*) d)[0]);
#else
	    printf("double %g\n",((NXDBLE*) d)[0]);
#endif
	}

	{
	    unsigned char s[16];
	    unsigned char d[16];

	    printf("\nTest conversion reelle double -> float\n");
	    printf("Taille NXDBLE %d\n",sizeof(NXDBLE));
	    printf("Taille NXFLT %d\n",sizeof(NXFLT));

	    ((NXDBLE*) s)[0] = 2.4529e+200;
#if defined(CRAY) && !defined(_CRAYMPP)
	    printf("double %Lg\n",((NXDBLE*) s)[0]);
#else
	    printf("double %g\n",((NXDBLE*) s)[0]);
#endif
	    printf("double (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_dble_flt(s,d,1);
	    printf("float (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);
	    printf("float %g\n",((NXFLT*) d)[0]);
	}

}

/* test conversion float li32 -> cr64 */
/* test conversion float cr64 -> li32 */

void
nxconvtest_real_li32_cr64()
{

	{
	    unsigned char s[8]; /* 8 au lieu de 4 pour le CRAY YMP */
	    unsigned char d[8];

	    printf("\nTest conversion reelle li32 -> cr64\n");

	/* 0x5fef6450 en ie32 */

#if defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("li32 (float) %g\n",((float*) s)[0]);
#else
	    s[0] = 0x50;
	    s[1] = 0x64;
	    s[2] = 0xef;
	    s[3] = 0x5f;
#endif

	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_li32_to_cr64(s,d,1);
	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if !defined(_CRAYMPP) && defined(CRAY)
	    printf("cr64 (float) %g\n",((float*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle cr64 -> li32\n");

	/* 0x4041ef644f9b077d en cr64 */

#if defined(_CRAYMPP) || !defined(CRAY)
	    s[0] = 0x40;
	    s[1] = 0x41;
	    s[2] = 0xef;
	    s[3] = 0x64;
	    s[4] = 0x4f;
	    s[5] = 0x9b;
	    s[6] = 0x07;
	    s[7] = 0x7d;
#else /* CRAY CRI */
	    ((float*) s)[0] = 3.45e+19;
	    printf("cr64 (float) %g\n",((float*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_cr64_to_li32(s,d,1,&cr);
	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if defined(NX_LITTLEENDIAN)
	    printf("li32 (float) %g\n",((float*) d)[0]);
#endif
	}

}

/* test conversion float li32 -> ie64 */
/* test conversion float ie64 -> li32 */

void
nxconvtest_real_li32_ie64()
{

	{
	    unsigned char s[8]; /* 8 au lieu de 4 pour le CRAY YMP */
	    unsigned char d[8];

	    printf("\nTest conversion reelle li32 -> ie64\n");

	/* 0x5fef6450 en ie32 */

#if defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("li32 (float) %g\n",((float*) s)[0]);
#else
	    s[0] = 0x50;
	    s[1] = 0x64;
	    s[2] = 0xef;
	    s[3] = 0x5f;
#endif

	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_li32_to_ie64(s,d,1);
	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie64 (double) %g\n",((double*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle ie64 -> li32\n");

#if !defined(_CRAYMPP) && defined(CRAY) || defined(NX_LITTLEENDIAN)
	    s[0] = 0x43;
	    s[1] = 0xfd;
	    s[2] = 0xec;
	    s[3] = 0x89;
	    s[4] = 0xf3;
	    s[5] = 0x60;
	    s[6] = 0xef;
	    s[7] = 0xa0;
#else /* IEEE */
	    ((double*) s)[0] = 3.45e+19;
	    printf("ie64 (double) %g\n",((double*) s)[0]);
#endif

	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_ie64_to_li32(s,d,1,&cr);
	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if defined(NX_LITTLEENDIAN)
	    printf("li32 (float) %g\n",((float*) d)[0]);
#endif

	}

}

/* test conversion float li32 -> li64 */
/* test conversion float li64 -> li32 */

void
nxconvtest_real_li32_li64()
{

	{
	    unsigned char s[8]; /* 8 au lieu de 4 pour le CRAY YMP */
	    unsigned char d[8];

	    printf("\nTest conversion reelle li32 -> li64\n");

#if defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("li32 (float) %g\n",((float*) s)[0]);
#else
	    s[0] = 0x50;
	    s[1] = 0x64;
	    s[2] = 0xef;
	    s[3] = 0x5f;
#endif

	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_li32_to_li64(s,d,1);
	    printf("li64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if defined(NX_LITTLEENDIAN)
	    printf("li64 (double) %g\n",((double*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle li64 -> li32\n");

#if defined(NX_LITTLEENDIAN)
	    ((double*) s)[0] = 3.45e+19;
	    printf("li64 (double) %g\n",((double*) s)[0]);
#else
	    s[0] = 0xa0;
	    s[1] = 0xef;
	    s[2] = 0x60;
	    s[3] = 0xf3;
	    s[4] = 0x89;
	    s[5] = 0xec;
	    s[6] = 0xfd;
	    s[7] = 0x43;
#endif

	    printf("li64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_li64_to_li32(s,d,1,&cr);
	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if defined(NX_LITTLEENDIAN)
	    printf("li32 (float) %g\n",((float*) d)[0]);
#endif

	}

}

/* test conversion int ie32 -> cr64 */
/* test conversion int cr64 -> ie32 */

void
nxconvtest_int_ie32_cr64()
{

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion entiere ie32 -> cr64\n");

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((nx_int32*) s)[0] = -34598;
	    printf("ie32 (int) %d\n",((nx_int32*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0xff;
	    s[1] = 0xff;
	    s[2] = 0x78;
	    s[3] = 0xda;
#endif

	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_int_ie32_to_cr64(s,d,1);
	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if !defined(_CRAYMPP) && defined(CRAY)
	    printf("cr64 (int) %d\n",((int*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion entiere cr64 -> ie32\n");

#if defined(_CRAYMPP) || !defined(CRAY)
	    s[0] = 0xff;
	    s[1] = 0xff;
	    s[2] = 0xff;
	    s[3] = 0xff;
	    s[4] = 0xff;
	    s[5] = 0xff;
	    s[6] = 0x78;
	    s[7] = 0xda;
#else /* CRAY CRI */
	    ((int*) s)[0] = -34598;
	    printf("cr64 (int) %d\n",((int*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_int_cr64_to_ie32(s,d,1,&cr);
	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie32 (int) %d\n",((nx_int32*) d)[0]);
#endif

	}

}

/* test conversion int ie32 -> cr64 */
/* test conversion int cr64 -> ie32 */

void
nxconvtest_int_ie32_cr64b()
{

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion entiere ie32 -> cr64\n");

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((nx_int32*) s)[0] = -2147483648;
	    printf("ie32 (int) %d\n",((nx_int32*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x80;
	    s[1] = 0x00;
	    s[2] = 0x00;
	    s[3] = 0x00;
#endif

	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_int_ie32_to_cr64(s,d,1);
	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if !defined(_CRAYMPP) && defined(CRAY)
	    printf("cr64 (int) %d\n",((int*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion entiere cr64 -> ie32\n");

#if defined(_CRAYMPP) || !defined(CRAY)
	    s[0] = 0xff;
	    s[1] = 0xff;
	    s[2] = 0xff;
	    s[3] = 0xf8;
	    s[4] = 0x00;
	    s[5] = 0x00;
	    s[6] = 0x00;
	    s[7] = 0x00;
	/*((long long int*) s)[0] = -2147483648;*/
#else /* CRAY CRI */
	    ((int*) s)[0] = -2147483648;
	    printf("cr64 (int) %d\n",((int*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_int_cr64_to_ie32(s,d,1,&cr);
	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie32 (int) %d\n",((nx_int32*) d)[0]);
#endif

	}

}

/* test conversion float ie32 -> ie64 */
/* test conversion float ie64 -> ie32 */

void
nxconvtest_real_ie32_ie64()
{

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle ie32 -> ie64\n");

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("ie32 (float) %g\n",((float*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x5f;
	    s[1] = 0xef;
	    s[2] = 0x64;
	    s[3] = 0x50;
#endif

	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_ie32_to_ie64(s,d,1);
	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie64 (double) %g\n",((double*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle ie64 -> ie32\n");

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((double*) s)[0] = 3.45e+19;
	    printf("ie64 (double) %g\n",((double*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x43;
	    s[1] = 0xfd;
	    s[2] = 0xec;
	    s[3] = 0x8a;
	    s[4] = 0x00;
	    s[5] = 0x00;
	    s[6] = 0x00;
	    s[7] = 0x00;
#endif

	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_ie64_to_ie32(s,d,1,&cr);
	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie32 (float) %g\n",((float*) d)[0]);
#endif

	}

}

/* test conversion float ie32 -> ie128 */
/* test conversion float ie128 -> ie32 */

void
nxconvtest_real_ie32_ie128()
{

	{
	    unsigned char* s = (unsigned char*) malloc(8); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(16);

	    printf("\nTest conversion reelle ie32 -> ie128\n");

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("ie32 (float) %g\n",((float*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x5f;
	    s[1] = 0xef;
	    s[2] = 0x64;
	    s[3] = 0x50;
#endif

	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_ie32_to_ie128(s,d,1);
	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7],
			    d[8],d[9],d[10],d[11],d[12],d[13],d[14],d[15]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("taille long double = %d\n",sizeof(long double));
	    printf("ie128 (long double) %Lg\n",((long double*) d)[0]);
	    ((long double*) d)[0] = 3.45e+19;
	    printf("ie128 (hexa good) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7],
			    d[8],d[9],d[10],d[11],d[12],d[13],d[14],d[15]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char* s = (unsigned char*) malloc(16); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(8);

	    printf("\nTest conversion reelle ie128 -> ie32\n");

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((long double*) s)[0] = 3.45e+19;
	    printf("ie128 (long double) %Lg\n",((long double*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x40;
	    s[1] = 0x3f;
	    s[2] = 0xde;
	    s[3] = 0xc8;
	    s[4] = 0xa0;
	    s[5] = 0x00;
	    s[6] = 0x00;
	    s[7] = 0x00;
	    s[8] = 0x00;
	    s[9] = 0x00;
	    s[10] = 0x00;
	    s[11] = 0x00;
	    s[12] = 0x00;
	    s[13] = 0x00;
	    s[14] = 0x00;
	    s[15] = 0x00;
#endif

	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7],
			    s[8],s[9],s[10],s[11],s[12],s[13],s[14],s[15]);
	    nxconv_real_ie128_to_ie32(s,d,1,&cr);
	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie32 (float) %g\n",((float*) d)[0]);
#endif

	}

}

/* test conversion float li32 -> ie128 */
/* test conversion float ie128 -> ie32 */

void
nxconvtest_real_li32_ie128()
{

	{
	    unsigned char* s = (unsigned char*) malloc(8); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(16);

	    printf("\nTest conversion reelle li32 -> ie128\n");

#if defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("li32 (float) %g\n",((float*) s)[0]);
#else
	    s[0] = 0x50;
	    s[1] = 0x64;
	    s[2] = 0xef;
	    s[3] = 0x5f;
#endif

	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_li32_to_ie128(s,d,1);
	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7],
			    d[8],d[9],d[10],d[11],d[12],d[13],d[14],d[15]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("taille long double = %d\n",sizeof(long double));
	    printf("ie128 (long double) %Lg\n",((long double*) d)[0]);
	    ((long double*) d)[0] = 3.45e+19;
	    printf("ie128 (hexa good) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7],
			    d[8],d[9],d[10],d[11],d[12],d[13],d[14],d[15]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char* s = (unsigned char*) malloc(16); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(8);

	    printf("\nTest conversion reelle ie128 -> li32\n");

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((long double*) s)[0] = 3.45e+19;
	    printf("ie128 (long double) %Lg\n",((long double*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x40;
	    s[1] = 0x3f;
	    s[2] = 0xde;
	    s[3] = 0xc8;
	    s[4] = 0xa0;
	    s[5] = 0x00;
	    s[6] = 0x00;
	    s[7] = 0x00;
	    s[8] = 0x00;
	    s[9] = 0x00;
	    s[10] = 0x00;
	    s[11] = 0x00;
	    s[12] = 0x00;
	    s[13] = 0x00;
	    s[14] = 0x00;
	    s[15] = 0x00;
#endif

	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7],
			    s[8],s[9],s[10],s[11],s[12],s[13],s[14],s[15]);
	    nxconv_real_ie128_to_li32(s,d,1,&cr);
	    printf("li32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if defined(NX_LITTLEENDIAN)
	    printf("li32 (float) %g\n",((float*) d)[0]);
#endif

	}

}

/* test conversion float ie64 -> ie128 */
/* test conversion float ie128 -> ie64 */

void
nxconvtest_real_ie64_ie128()
{

	{
	    unsigned char* s = (unsigned char*) malloc(8); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(16);

	    printf("\nTest conversion reelle ie64 -> ie128\n");

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((double*) s)[0] = 345.67e+100;
	    printf("ie64 (double) %g\n",((double*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x55;
	    s[1] = 0x38;
	    s[2] = 0xb1;
	    s[3] = 0x8b;
	    s[4] = 0x10;
	    s[5] = 0xc6;
	    s[6] = 0x57;
	    s[7] = 0x71;
#endif

	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_ie64_to_ie128(s,d,1);
	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7],
			    d[8],d[9],d[10],d[11],d[12],d[13],d[14],d[15]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie128 (long double) %Lg\n",((long double*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char* s = (unsigned char*) malloc(16); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(8);

	    printf("\nTest conversion reelle ie128 -> ie64\n");

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((long double*) s)[0] = 345.67e+100;
	    printf("ie128 (long double) %Lg\n",((long double*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x41;
	    s[1] = 0x53;
	    s[2] = 0x8b;
	    s[3] = 0x18;
	    s[4] = 0xb1;
	    s[5] = 0x0c;
	    s[6] = 0x65;
	    s[7] = 0x77;
	    s[8] = 0x10;
	    s[9] = 0x00;
	    s[10] = 0x00;
	    s[11] = 0x00;
	    s[12] = 0x00;
	    s[13] = 0x00;
	    s[14] = 0x00;
	    s[15] = 0x00;
#endif

	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7],
			    s[8],s[9],s[10],s[11],s[12],s[13],s[14],s[15]);
	    nxconv_real_ie128_to_ie64(s,d,1,&cr);
	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie64 (double) %g\n",((double*) d)[0]);
#endif

	}

}

/* test conversion float ie128 -> cr64 */
/* test conversion float cr64 -> ie128 */

void
nxconvtest_real_ie128_cr64()
{

	{
	    int cr = 0;
	    unsigned char* s = (unsigned char*) malloc(16); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(8);

	    printf("\nTest conversion reelle ie128 -> cr64\n");

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((long double*) s)[0] = 345.67e+100;
	    printf("ie128 (long double) %Lg\n",((long double*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x41;
	    s[1] = 0x53;
	    s[2] = 0x8b;
	    s[3] = 0x18;
	    s[4] = 0xb1;
	    s[5] = 0x0c;
	    s[6] = 0x65;
	    s[7] = 0x77;
	    s[8] = 0x10;
	    s[9] = 0x00;
	    s[10] = 0x00;
	    s[11] = 0x00;
	    s[12] = 0x00;
	    s[13] = 0x00;
	    s[14] = 0x00;
	    s[15] = 0x00;
#endif

	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7],
			    s[8],s[9],s[10],s[11],s[12],s[13],s[14],s[15]);
	    nxconv_real_ie128_to_cr64(s,d,1);
	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if defined(CRAY) && !defined(_CRAYIEEE) && !defined(_CRAYMPP)
	    printf("cr64 (double) %g\n",((double*) d)[0]);
#endif

	}

	{
	    unsigned char* s = (unsigned char*) malloc(8); /* pour alignement */
	    unsigned char* d = (unsigned char*) malloc(16);

	    printf("\nTest conversion reelle cr64 -> ie128\n");

#if defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)
	    s[0] = 0x41;
	    s[1] = 0x55;
	    s[2] = 0xc5;
	    s[3] = 0x8c;
	    s[4] = 0x58;
	    s[5] = 0x86;
	    s[6] = 0x32;
	    s[7] = 0xbb;
#else /* CRAY CRI */
	    ((float*) s)[0] = 3.45e+19;
	    printf("cr64 (float) %g\n",((float*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_cr64_to_ie128(s,d,1);
	    printf("ie128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7],
			    d[8],d[9],d[10],d[11],d[12],d[13],d[14],d[15]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie128 (long double) %Lg\n",((long double*) d)[0]);
#endif

	}

}

/* test conversion float ie32 -> cr64 */
/* test conversion float cr64 -> ie32 */

void
nxconvtest_real_ie32_cr64()
{

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle ie32 -> cr64\n");

	/* 0x5fef644f en ie32 */

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("ie32 (float) %g\n",((float*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x5f;
	    s[1] = 0xef;
	    s[2] = 0x64;
	    s[3] = 0x50;
#endif

	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_ie32_to_cr64(s,d,1);
	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if !defined(_CRAYMPP) && defined(CRAY) && !defined(_CRAYIEEE)
	    printf("cr64 (float) %g\n",((float*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle cr64 -> ie32\n");

	/* 0x4041ef644f9b077d en cr64 */

#if defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)
	    s[0] = 0x40;
	    s[1] = 0x41;
	    s[2] = 0xef;
	    s[3] = 0x64;
	    s[4] = 0x4f;
	    s[5] = 0x9b;
	    s[6] = 0x07;
	    s[7] = 0x7d;
#else /* CRAY CRI */
	    ((float*) s)[0] = 3.45e+19;
	    printf("cr64 (float) %g\n",((float*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_cr64_to_ie32(s,d,1,&cr);
	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if (defined(_CRAYMPP) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie32 (float) %g\n",((float*) d)[0]);
#endif

	}

}

/* test conversion float ie32 -> cr128 */
/* test conversion float cr128 -> ie32 */

void
nxconvtest_real_ie32_cr128()
{

	{
	    unsigned char s[8];
	    unsigned char d[16];

	    printf("\nTest conversion reelle ie32 -> cr128\n");

	/* 0x5fef644f en ie32 */

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((float*) s)[0] = 3.45e+19;
	    printf("ie32 (float) %g\n",((float*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x5f;
	    s[1] = 0xef;
	    s[2] = 0x64;
	    s[3] = 0x50;
#endif

	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3]);
	    nxconv_real_ie32_to_cr128(s,d,1);
	    printf("cr128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7],
			    d[8],d[9],d[10],d[11],d[12],d[13],d[14],d[15]);

#if !defined(_CRAYMPP) && !defined(_CRAYIEEE) && defined(CRAY)
	    printf("cr128 (long double) %g\n",((long double*) d)[0]);
#endif

	}

	{
	    int cr = 0;
	    unsigned char s[16];
	    unsigned char d[8];

	    printf("\nTest conversion reelle cr128 -> ie32\n");

#if defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)
	    s[0] = 0x40;
	    s[1] = 0x41;
	    s[2] = 0xef;
	    s[3] = 0x64;
	    s[4] = 0x4f;
	    s[5] = 0x9b;
	    s[6] = 0x07;
	    s[7] = 0x7d;
	    s[8] = 0x00;
	    s[9] = 0x00;
	    s[10] = 0x00;
	    s[11] = 0x00;
	    s[12] = 0x00;
	    s[13] = 0x00;
	    s[14] = 0x00;
	    s[15] = 0x00;
#else /* CRAY CRI */
	    ((long double*) s)[0] = 3.45e+19;
	    printf("cr128 (long double) %g\n",((long double*) s)[0]);
#endif

	    printf("cr128 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x"
			    "%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7],
			    s[8],s[9],s[10],s[11],s[12],s[13],s[14],s[15]);
	    nxconv_real_cr128_to_ie32(s,d,1,&cr);
	    printf("ie32 (hexa) 0x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie32 (float) %g\n",((float*) d)[0]);
#endif

	}

}

/* test conversion float ie64 -> cr64 */
/* test conversion float cr64 -> ie64 */

void
nxconvtest_real_ie64_cr64()
{

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle ie64 -> cr64\n");

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    ((double*) s)[0] = 345.67e+100;
	    printf("ie64 (double) %g\n",((double*) s)[0]);
#else /* CRAY CRI */
	    s[0] = 0x55;
	    s[1] = 0x38;
	    s[2] = 0xb1;
	    s[3] = 0x8b;
	    s[4] = 0x10;
	    s[5] = 0xc6;
	    s[6] = 0x57;
	    s[7] = 0x71;
#endif

	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_ie64_to_cr64(s,d,1);
	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if !defined(_CRAYMPP) && !defined(_CRAYIEEE) && defined(CRAY)
	    printf("cr64 (float) %g\n",((float*) d)[0]);
#endif

	}

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle cr64 -> ie64\n");

#if defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)
	    s[0] = 0x41;
	    s[1] = 0x55;
	    s[2] = 0xc5;
	    s[3] = 0x8c;
	    s[4] = 0x58;
	    s[5] = 0x86;
	    s[6] = 0x32;
	    s[7] = 0xbb;
#else /* CRAY CRI */
	    ((float*) s)[0] =  345.67e+100;
	    printf("cr64 (float) %g\n",((float*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_cr64_to_ie64(s,d,1);
	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie64 (double) %g\n",((double*) d)[0]);
#endif

	}

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion 2*max(ie64)  cr64 -> ie64\n");

#if defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)
	    s[0] = 0x44;
	    s[1] = 0x01;
	    s[2] = 0xff;
	    s[3] = 0xff;
	    s[4] = 0xff;
	    s[5] = 0xff;
	    s[6] = 0xff;
	    s[7] = 0xff;
#else /* CRAY CRI */
	    ((float*) s)[0] = 3.59538626972463140e+308;
	    printf("cr64 (float) %g\n",((float*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_cr64_to_ie64(s,d,1);
	    printf("ie64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if (defined(_CRAYMPP) || defined(_CRAYIEEE) || !defined(CRAY)) && !defined(NX_LITTLEENDIAN)
	    printf("ie64 (double) %g\n",((double*) d)[0]);
#endif

	}

}

/* test conversion float li64 -> cr64 */
/* test conversion float cr64 -> li64 */

void
nxconvtest_real_li64_cr64()
{

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle li64 -> cr64\n");

#if defined(NX_LITTLEENDIAN)
	    ((double*) s)[0] = 345.67e+100;
	    printf("li64 (double) %g\n",((double*) s)[0]);
#else /* ! LITTLEENDIAN */
	    s[0] = 0x71;
	    s[1] = 0x57;
	    s[2] = 0xc6;
	    s[3] = 0x10;
	    s[4] = 0x8b;
	    s[5] = 0xb1;
	    s[6] = 0x38;
	    s[7] = 0x55;
#endif

	    printf("li64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_li64_to_cr64(s,d,1);
	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if !defined(_CRAYMPP) && defined(CRAY) && !defined(_CRAYIEEE)
	    printf("cr64 (float) %g\n",((float*) d)[0]);
#endif

	}

	{
	    unsigned char s[8];
	    unsigned char d[8];

	    printf("\nTest conversion reelle cr64 -> li64\n");

#if defined(_CRAYMPP) || !defined(CRAY) || defined(_CRAYIEEE)
	    s[0] = 0x41;
	    s[1] = 0x55;
	    s[2] = 0xc5;
	    s[3] = 0x8c;
	    s[4] = 0x58;
	    s[5] = 0x86;
	    s[6] = 0x32;
	    s[7] = 0xbb;
#else /* CRAY CRI */
	    ((float*) s)[0] =  345.67e+100;
	    printf("cr64 (float) %g\n",((float*) s)[0]);
#endif

	    printf("cr64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    s[0],s[1],s[2],s[3],s[4],s[5],s[6],s[7]);
	    nxconv_real_cr64_to_li64(s,d,1);
	    printf("li64 (hexa) 0x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x%2.2x\n",
			    d[0],d[1],d[2],d[3],d[4],d[5],d[6],d[7]);

#if defined(NX_LITTLEENDIAN)
	    printf("li64 (double) %g\n",((double*) d)[0]);
#endif

	}

}

void
nxtest_ecrit(FILE* file)
{
	int ecrits;

    /* entiers */

	printf("buffi[0] = %d\n",buffi[0]);
	ecrits = fnxwriti(file,lbuffi,buffi);
	printf("fnxwriti : %d entiers envoyes, code retour %d\n",
			lbuffi,ecrits);
	printf("buffi[0] = %d\n",buffi[0]);

	ecrits = fnxnbkwi(file,buffi,lbuffi);
	printf("fnxnbkwi : %d entiers envoyes, %d entiers ecrits\n",
			lbuffi,ecrits);
	printf("buffi[0] = %d\n",buffi[0]);

    /* float */

	printf("bufff[0] = %g\n",bufff[0]);
	ecrits = fnxwritf(file,lbufff,bufff);
	printf("fnxwritf : %d reals envoyes, code retour %d\n",
			lbufff,ecrits);
	printf("bufff[0] = %g\n",bufff[0]);

	ecrits = fnxnbkwf(file,bufff,lbufff);
	printf("fnxnbkwf : %d reals envoyes, %d reals ecrits\n",
			lbufff,ecrits);
	printf("bufff[0] = %g\n",bufff[0]);

    /* caracteres */

	ecrits = fnxwrite(file,buffer,lbuffer);
	printf("fnxwrite : %d caracteres envoyes, %d caracteres ecrits\n",
			lbuffer,ecrits);

    /* float ou double */

	printf("bufff[0] = %g\n",bufff[0]);
	ecrits = fnxwritt(file,lbufff,bufff,"sp","sp");
	printf("fnxwritt : %d reals (spsp) envoyes, code retour %d\n",
			lbufff,ecrits);
	printf("bufff[0] = %g\n",bufff[0]);

	ecrits = fnxwritt(file,lbufff,bufff,"sp","dp");
	printf("fnxwritt : %d reals (spdp) envoyes, code retour %d\n",
			lbufff,ecrits);
	printf("bufff[0] = %g\n",bufff[0]);

	printf("buffd[0] = %g\n",buffd[0]);
	ecrits = fnxwritt(file,lbuffd,buffd,"dp","sp");
	printf("fnxwritt : %d reals (dpsp) envoyes, code retour %d\n",
			lbuffd,ecrits);
	printf("buffd[0] = %g\n",buffd[0]);

	ecrits = fnxwritt(file,lbuffd,buffd,"dp","dp");
	printf("fnxwritt : %d reals (dpdp) envoyes, code retour %d\n",
			lbuffd,ecrits);
	printf("buffd[0] = %g\n",buffd[0]);
}

/* main pour tester nx sur l'ecriture et la lecture de fichiers */

int
main()
{
	FILE* file;
	register unsigned i;

	for(i=0;i<lbuffer;i++)
	{
	    buffer[i] = i%256;
	}

	buffi[0] = 1;

	for(i=1;i<lbuffi;i++)
	{
	    buffi[i] = alea2(-16700,4556627);
	}

	bufff[0] = 0.345e+20;

	for(i=1;i<lbufff;i++)
	{
	    bufff[i] = alea()*30.;
	}

	buffd[0] = 345.67e+100;

	for(i=1;i<lbuffd;i++)
	{
	    buffd[i] = alea()*11.456e+65;
	}

    /* test conversion int ie32 <-> cr64 */

	nxconvtest_int_ie32_cr64();

    /* test conversion int ie32 <-> cr64 */

	nxconvtest_int_ie32_cr64b();

    /* test conversion float ie32 <-> ie64 */

	nxconvtest_real_ie32_ie64();

    /* test conversion float li32 <-> ie64 */

	nxconvtest_real_li32_ie64();

    /* test conversion float li32 <-> li64 */

	nxconvtest_real_li32_li64();

    /* test conversion float li32 <-> cr64 */

	nxconvtest_real_li32_cr64();

    /* test conversion float ie32 <-> cr64 */

	nxconvtest_real_ie32_cr64();

    /* test conversion float ie32 <-> cr128 */

	nxconvtest_real_ie32_cr128();

    /* test conversion float ie64 <-> cr64 */

	nxconvtest_real_ie64_cr64();

    /* test conversion float li64 <-> cr64 */

	nxconvtest_real_li64_cr64();

    /* test conversion float ie32 <-> ie128 */

	nxconvtest_real_ie32_ie128();

    /* test conversion float li32 <-> ie128 */

	nxconvtest_real_li32_ie128();

    /* test conversion float ie64 <-> ie128 */

	nxconvtest_real_ie64_ie128();

    /* test conversion float cr64 <-> ie128 */

	nxconvtest_real_ie128_cr64();

    /* test conversion float <-> double */

	nxconvtest_real_float_double();

    /* format natif */

	file = fnxopen("/tmp/testnx","w");

	printf("\nTest format natif\n");
	nxtest_ecrit(file);
	fnxclose(file);

    /* format ieee 32 bits (natif pour machines ieee 32 bits big endian) */

	file = fnxopen("/tmp/testnx2@ie32","w");

	printf("\nTest format ie32\n");
	nxtest_ecrit(file);
	fnxclose(file);

    /* format ieee 32 bits avec fnxchfrm 
       (natif pour machines ieee 32 bits big endian) */

	file = fnxopen("/tmp/testnx3","w");

	fnxchfrm(file,"ie32");
	printf("\nTest format ie32 avec fnxchfrm\n");
	nxtest_ecrit(file);
	fnxclose(file);

    /* format cray 64 bits (natif pour CRAY CRI) */

	file = fnxopen("/tmp/testnx4@cr64","w");

	printf("\nTest format cr64\n");
	nxtest_ecrit(file);
	fnxclose(file);

    /* format ieee 64 bits (natif pour mpp) */

	file = fnxopen("/tmp/testnx5@ie64","w");

	printf("\nTest format ie64\n");
	nxtest_ecrit(file);
	fnxclose(file);

    /* format little endian 32 bits (natif pour machines ieee 32 bits 
       little endian) */

	file = fnxopen("/tmp/testnx6@li32","w");

	printf("\nTest format li32\n");
	nxtest_ecrit(file);
	fnxclose(file);

	return 0;
}
