c
c d'apres le programme lozach.f :
c modifications mineures pour dessiner des ensembles de Julia
c au lieu de l'ensemble de Mandelbrot
c
c  en faisant varier la constante complexe c, on obtient des variations
c  de forme du fractal
c
	program julia

 	parameter( nxmax=1024 , nymax=1024 , diter=49 , criter=100. )

	complex c, jul(nxmax)
	real cx, cy
	character com*5
	dimension it(nxmax), xpol(4), ypol(4)

	data xcen,ycen/ 0.000, 0.000 /,xlarg/4.000/
	data xcadre,ycadre/28.,28./
	data cx, cy /-0.25, 0.65/

	fx(x)= h*(x-(xmax+xmin)/2)
	fxi(x)= x/h + (xmax+xmin)/2
	fy(x)= h*(x-(ymax+ymin)/2)
	fyi(x)= x/h + (ymax+ymin)/2

	nx=64
	ny=64
	iter=diter

	call ingraf
	call destin('NEGS')
	call dterm('sun')
	call ccchoix('RAINBOWHLS', 64, ier)

	xmin=xcen-xlarg*0.5
	xmax=xcen+xlarg*0.5
	ymin=ycen-xlarg*ycadre/xcadre/2
	ymax=ycen+xlarg*ycadre/xcadre/2
	
	c= cmplx(cx,cy)

5	continue
	h=2/(xmax-xmin)
	print *,'Xmin, Xmax: ',xmin,xmax
	print *,'Ymin, Ymax: ',ymin,ymax
	print *,'Iterations : ',iter
	print *,'Pixels     : ',nx
	print *,'Hech       : ',h
	print *,'c          : ',cx,cy
	print *,fx(xmin),fy(ymin),fx(xmax),fy(ymax)
	call dspace(1,fx(xmin),fy(ymin),fx(xmax),fy(ymax))
	dx=(xmax-xmin)/nx
	dy=(ymax-ymin)/ny

	do 50 iy=1,ny
		y=ymin+iy*dy
		ypol(1)=fy(y-dy)
		ypol(2)=ypol(1)
		ypol(3)=fy(y)
		ypol(4)=ypol(3)
		do 10 ix=1,nx
			it(ix)= iter+1
			jul(ix)= cmplx(xmin+ix*dx,y)
10		continue
		do 30 i=1,iter
			do 20 ix=1,nx
				if( it(ix) .eq. (iter+1) ) then
c
c				on itere z**2 + c ( Zn = f(Zn-1) )
c				et on cherche le domaine ou la suite
c				{Zn} est bornee
c
				   jul(ix)= jul(ix)**2 + c
				   if( cabs(jul(ix)) .gt. criter ) then
					it(ix)= i
				   endif
				endif
20			continue
30		continue
		xpol(2)=fx(xmin)
		xpol(3)=xpol(2)
		id= it(1)
		do 40 ix=2,nx
			if( (it(ix) .ne. id) .or. (ix .eq. nx) ) then
				xpol(1)=fx(xmin+ix*dx)
				xpol(4)=xpol(1)
				icol=int(10 + 53 * (float(id)/(iter+1)))
				call dcolor(icol)
				call polyg(1,xpol,ypol,4)
				xpol(2)=xpol(1)
				xpol(3)=xpol(1)
				id=it(ix)
			endif	
40		continue
50	continue
	call flushim
	print *,xpol
	print *,ypol
	call stpage
60	print *,'(q,z,iXXXX,pXXXX,uN,c)'
	read(5,'(a)') com
	if( com(1:1) .eq. 'q' ) then
		call tmgraf
		stop 'Fin normale'
	elseif( com(1:1) .eq. 'z' ) then	
		call getpt(1,x1,y1)
		call getpt(1,x2,y2)
		x1=fxi(x1)
		x2=fxi(x2)
		y1=fyi(y1)
		y2=fyi(y2)
		xmin= amin1(x1,x2)
		ymin= amin1(y1,y2)
		dmax= amax1(abs(x2-x1),abs(y2-y1))
		xmax= xmin+dmax
		ymax= ymin+dmax
	elseif( com(1:1) .eq. 'i' ) then
		read(com(2:5),'(i4)') iter	
	elseif( com(1:1) .eq. 'p' ) then
		read(com(2:5),'(i4)') nx
		nx= min0(nx,nxmax)	
		ny= min0(nx,nymax)	
	elseif( com(1:1) .eq. 'u' ) then
		read(com(2:2),'(i1)') nu
		dmax= nu*(xmax-xmin)/2
		xmin= xmin-dmax
		ymin= ymin-dmax
		xmax= xmax+dmax
		ymax= ymax+dmax
	elseif( com(1:1) .eq. 'c' ) then
c
c 	changer la valeur de la constante du polynome complexe Z**2 + C
c
		print *,'entrer cx et cy : '
		read(5,*) cx, cy
		c= cmplx(cx, cy)
	else
		print *,'entree invalide, on recommence...'
		goto 60
	endif	

	go to 5

	end
