/* identification du source */

#ifndef lint
   static const char* const sccs_id = " %W% %G% P. Brochard";
#endif

#include "SpxP.h"
#include "SpxVisuDri.h"
#include "nx.h"
#include "SpxBase.h"
#include "SpxOpenP.h"

/*********************************************************/
/* envoi de donnees de type 2d base point                */
/*********************************************************/

SpxItem
SpxBase2DPoint(REEL_S x,REEL_S y,int couleur,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 0;
            fnxwriti(file_fich,3,temp);
	    fnxwritf(file_fich,1,&x);
    	    fnxwritf(file_fich,1,&y);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base segment              */
/*********************************************************/

SpxItem
SpxBase2DSegment(REEL_S x1,REEL_S y1,REEL_S x2,REEL_S y2,int couleur,
		SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 1;
            fnxwriti(file_fich,3,temp);
	    fnxwritf(file_fich,1,&x1);
    	    fnxwritf(file_fich,1,&y1);
	    fnxwritf(file_fich,1,&x2);
    	    fnxwritf(file_fich,1,&y2);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base arc                  */
/*********************************************************/

SpxItem
SpxBase2DArc(REEL_S x1,REEL_S y1,REEL_S x2,REEL_S y2,REEL_S x3,REEL_S y3,int couleur,
		SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 2;
            fnxwriti(file_fich,3,temp);
	    fnxwritf(file_fich,1,&x1);
    	    fnxwritf(file_fich,1,&y1);
	    fnxwritf(file_fich,1,&x2);
    	    fnxwritf(file_fich,1,&y2);
	    fnxwritf(file_fich,1,&x3);
    	    fnxwritf(file_fich,1,&y3);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base rectangle            */
/*********************************************************/

SpxItem
SpxBase2DRectangle(REEL_S x1,REEL_S y1,REEL_S x2,REEL_S y2,int couleur,
		SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 3;
            fnxwriti(file_fich,3,temp);
	    fnxwritf(file_fich,1,&x1);
    	    fnxwritf(file_fich,1,&y1);
	    fnxwritf(file_fich,1,&x2);
    	    fnxwritf(file_fich,1,&y2);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base polyligne            */
/*********************************************************/

SpxItem
SpxBase2DPolyligne(REEL_S x[],REEL_S y[],int taille,int couleur,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 4;
            fnxwriti(file_fich,3,temp);
            fnxwriti(file_fich,1,&taille);
	    fnxwritf(file_fich,taille,x);
    	    fnxwritf(file_fich,taille,y);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base polygone             */
/*********************************************************/

SpxItem
SpxBase2DPolygone(REEL_S x[],REEL_S y[],int taille,int couleur,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 5;
            fnxwriti(file_fich,3,temp);
            fnxwriti(file_fich,1,&taille);
	    fnxwritf(file_fich,taille,x);
    	    fnxwritf(file_fich,taille,y);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base polygone contoure    */
/*********************************************************/

SpxItem
SpxBase2DPolygoneContoure(REEL_S x[],REEL_S y[],int taille,
		int couleur,int couleurcont,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 6;
            fnxwriti(file_fich,3,temp);
            fnxwriti(file_fich,1,&taille);
	    fnxwritf(file_fich,taille,x);
    	    fnxwritf(file_fich,taille,y);
            fnxwriti(file_fich,1,&couleur);
            fnxwriti(file_fich,1,&couleurcont);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base tableau de points    */
/*********************************************************/

SpxItem
SpxBase2DTabPoint(REEL_S x[],REEL_S y[],int taille,int couleur,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 32;
            fnxwriti(file_fich,3,temp);
            fnxwriti(file_fich,1,&taille);
	    fnxwritf(file_fich,taille,x);
    	    fnxwritf(file_fich,taille,y);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base tableau de segments  */
/*********************************************************/

SpxItem
SpxBase2DTabSegment(REEL_S x1[],REEL_S y1[],REEL_S x2[],REEL_S y2[],
		int taille,int couleur,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 33;
            fnxwriti(file_fich,3,temp);
            fnxwriti(file_fich,1,&taille);
	    fnxwritf(file_fich,taille,x1);
    	    fnxwritf(file_fich,taille,y1);
	    fnxwritf(file_fich,taille,x2);
    	    fnxwritf(file_fich,taille,y2);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* envoi de donnees de type 2d base tableau d'arcs       */
/*********************************************************/

SpxItem
SpxBase2DTabArc(REEL_S x1[],REEL_S y1[],REEL_S x2[],REEL_S y2[],
		REEL_S x3[],REEL_S y3[],int taille,int couleur,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 34;
            fnxwriti(file_fich,3,temp);
            fnxwriti(file_fich,1,&taille);
	    fnxwritf(file_fich,taille,x1);
    	    fnxwritf(file_fich,taille,y1);
	    fnxwritf(file_fich,taille,x2);
    	    fnxwritf(file_fich,taille,y2);
	    fnxwritf(file_fich,taille,x3);
    	    fnxwritf(file_fich,taille,y3);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/***********************************************************/
/* envoi de donnees de type 2d base tableau de rectangless */
/***********************************************************/

SpxItem
SpxBase2DTabRectangle(REEL_S x1[],REEL_S y1[],REEL_S x2[],REEL_S y2[],
		int taille,int couleur,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;
	int temp2 = 0;

	if(!spx_file || SpxDebut(spx_file)) return 0;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = 35;
            fnxwriti(file_fich,3,temp);
            fnxwriti(file_fich,1,&taille);
	    fnxwritf(file_fich,taille,x1);
    	    fnxwritf(file_fich,taille,y1);
	    fnxwritf(file_fich,taille,x2);
    	    fnxwritf(file_fich,taille,y2);
            fnxwriti(file_fich,1,&couleur);
            fnxflush(file_fich);

	    if(spx_file->type == SPXSOCKET)
	    {
		fnxreadi(file_fich,1,&temp2);
	    }

            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);

	return (SpxItem) temp2;
}

/*********************************************************/
/* effacement d'un item base                             */
/*********************************************************/

void
SpxBase2DDelete(SpxItem item,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;

	if(!spx_file || SpxDebut(spx_file)) return;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[4];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = -1;
            temp[3] = item;
            fnxwriti(file_fich,4,temp);
            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);
}

/*********************************************************/
/* effacement de tous les items base                     */
/*********************************************************/

void
SpxBase2DDeleteAll(SPXFILE* spx_file)
{
	FILE* file_fich = NULL;

	if(!spx_file || SpxDebut(spx_file)) return;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp[3];

            temp[0] = -9;
            temp[1] = 1;
            temp[2] = -2;
            fnxwriti(file_fich,3,temp);
            fnxwrite(file_fich,"@",1);
            fnxflush(file_fich);
	}

	SpxFin(spx_file);
}

