/* identification du source */

#ifndef lint
    static const char* const sccs_id = "%W% %G% P. Brochard";
#endif

#include "SpxP.h"
#include "narcisse.h"
#include "SpxFtnP.h"

/*--------------------------------------------------------------*/
/*    nouveau binding fortran                                   */
/*--------------------------------------------------------------*/

/* spxgc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXGC(REEL_S* x,REEL_S* y,IntFtn* spx_file)
#else
FUNCDECL(spxgc)(REEL_S* x,REEL_S* y,IntFtn* spx_file)
#endif
{
	SpxGetCoord(x,y,(SPXFILE*) (*spx_file));
}

/* spx2gc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX2GC(REEL_S* x,REEL_S* y,IntFtn* spx_file)
#else
FUNCDECL(spx2gc)(REEL_S* x,REEL_S* y,IntFtn* spx_file)
#endif
{
	SpxGetCoord2d(x,y,(SPXFILE*) (*spx_file));
}

/* spx3gc : binding FORTRAN de SpxGetCoord3d */

void
#ifdef CRAY_PROTO
SPX3GC(REEL_S* x,REEL_S* y,REEL_S* z,IntFtn* spx_file)
#else
FUNCDECL(spx3gc)(REEL_S* x,REEL_S* y,REEL_S* z,IntFtn* spx_file)
#endif
{
	SpxGetCoord3d(x,y,z,(SPXFILE*) (*spx_file));
}

/* spx3gcm : binding FORTRAN de SpxGetCoord3dMaille */

void
#ifdef CRAY_PROTO
SPX3GCM(REEL_S* x,REEL_S* y,REEL_S* z,int* num_maille,
		int* num_bloc,IntFtn* spx_file)
#else
FUNCDECL(spx3gcm)(REEL_S* x,REEL_S* y,REEL_S* z,int* num_maille,
		int* num_bloc,IntFtn* spx_file)
#endif
{
	SpxGetCoord3dMaille(x,y,z,num_maille,num_bloc,(SPXFILE*) (*spx_file));
}

/* spxia appelable en FORTRAN */

int
#ifdef CRAY_PROTO
SPXIA(int spx_arg[],int* taille)
#else
FUNCDECL(spxia)(int spx_arg[],int* taille)
#endif
{
	int tai = *taille;

	tai *= sizeof(int);
	tai /= sizeof(SpxArg);
	SpxInitArg((SpxArg*) spx_arg,tai);

	return tai;
}

/* spxpa appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXPA(int spx_arg[],int* taille)
#else
FUNCDECL(spxpa)(int spx_arg[],int* taille)
#endif
{
	int tai = *taille;

	tai *= sizeof(int);
	tai /= sizeof(SpxArg);
	SpxPurgeArg((SpxArg*) spx_arg,tai);
}

/* spxvpa appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVPA(IntFtn* spx_file)
#else
FUNCDECL(spxvpa)(IntFtn* spx_file)
#endif
{
	SpxVPurgeArg((SPXFILE*) (*spx_file));
}

/* spxsai appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSAI(int spx_arg[],int* num,_fcd name,int* val)
#else
FUNCDECL(spxsai)(int spx_arg[],int* num,char* name,int* val,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	SpxArg* spxarg = (SpxArg*) spx_arg;

	spxarg += *num;
	SpxSetArgInt(spxarg,temp_name,*val);

	free(temp_name);
}

/* spxvsai appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVSAI(IntFtn* spx_file,_fcd name,int* val)
#else
FUNCDECL(spxvsai)(IntFtn* spx_file,char* name,int* val,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif

	SpxVSetArgInt((SPXFILE*) (*spx_file),temp_name,*val);

	free(temp_name);
}

/* spxsar appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSAR(int spx_arg[],int* num,_fcd name,REEL_S* val)
#else
FUNCDECL(spxsar)(int spx_arg[],int* num,char* name,REEL_S* val,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	SpxArg* spxarg = (SpxArg*) spx_arg;

	spxarg += *num;
	SpxSetArgReel(spxarg,temp_name,*val);

	free(temp_name);
}

/* spxvsar appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVSAR(IntFtn* spx_file,_fcd name,REEL_S* val)
#else
FUNCDECL(spxvsar)(IntFtn* spx_file,char* name,REEL_S* val,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif

	SpxVSetArgReel((SPXFILE*) (*spx_file),temp_name,*val);

	free(temp_name);
}

/* spxsac appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSAC(int spx_arg[],int* num,_fcd name,_fcd val)
#else
FUNCDECL(spxsac)(int spx_arg[],int* num,char* name,char* val,int lname,int lval)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
	char* temp_val = SpxStrCopy(_fcdtocp(val),_fcdlen(val));
#else
	char* temp_name = SpxStrCopy(name,lname);
	char* temp_val = SpxStrCopy(val,lval);
#endif
	SpxArg* spxarg = (SpxArg*) spx_arg;

	spxarg += *num;
	SpxSetArgChar(spxarg,temp_name,temp_val);

	free(temp_name);
	free(temp_val);
}

/* spxvsac appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVSAC(IntFtn* spx_file,_fcd name,_fcd val)
#else
FUNCDECL(spxvsac)(IntFtn* spx_file,char* name,char* val,int lname,int lval)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
	char* temp_val = SpxStrCopy(_fcdtocp(val),_fcdlen(val));
#else
	char* temp_name = SpxStrCopy(name,lname);
	char* temp_val = SpxStrCopy(val,lval);
#endif

	SpxVSetArgChar((SPXFILE*) (*spx_file),temp_name,temp_val);

	free(temp_name);
	free(temp_val);
}

/* spxsati appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSATI(int spx_arg[],int* num,_fcd name,int* val,int* indice)
#else
FUNCDECL(spxsati)(int spx_arg[],int* num,char* name,int* val,
		int* indice,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	SpxArg* spxarg = (SpxArg*) spx_arg;

	spxarg += *num;
	SpxSetArgTabInt(spxarg,temp_name,*val,*indice);

	free(temp_name);
}

/* spxvsati appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVSATI(IntFtn* spx_file,_fcd name,int* val,int* indice)
#else
FUNCDECL(spxvsati)(IntFtn* spx_file,char* name,int* val,int* indice,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif

	SpxVSetArgTabInt((SPXFILE*) (*spx_file),temp_name,*val,*indice);

	free(temp_name);
}

/* spxsatr appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSATR(int spx_arg[],int* num,_fcd name,REEL_S* val,int* indice)
#else
FUNCDECL(spxsatr)(int spx_arg[],int* num,char* name,REEL_S* val,
		int* indice,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	SpxArg* spxarg = (SpxArg*) spx_arg;

	spxarg += *num;
	SpxSetArgTabReel(spxarg,temp_name,*val,*indice);

	free(temp_name);
}

/* spxvsatr appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVSATR(IntFtn* spx_file,_fcd name,REEL_S* val,int* indice)
#else
FUNCDECL(spxvsatr)(IntFtn* spx_file,char* name,REEL_S* val,int* indice,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif

	SpxVSetArgTabReel((SPXFILE*) (*spx_file),temp_name,*val,*indice);

	free(temp_name);
}

/* spxsatc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSATC(int spx_arg[],int* num,_fcd name,_fcd val,int* indice)
#else
FUNCDECL(spxsatc)(int spx_arg[],int* num,char* name,char* val,int* indice,
		int lname,int lval)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
	char* temp_val = SpxStrCopy(_fcdtocp(val),_fcdlen(val));
#else
	char* temp_name = SpxStrCopy(name,lname);
	char* temp_val = SpxStrCopy(val,lval);
#endif
	SpxArg* spxarg = (SpxArg*) spx_arg;

	spxarg += *num;
	SpxSetArgTabChar(spxarg,temp_name,temp_val,*indice);

	free(temp_name);
	free(temp_val);
}

/* spxvsatc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVSATC(IntFtn* spx_file,_fcd name,_fcd val,int* indice)
#else
FUNCDECL(spxvsatc)(IntFtn* spx_file,char* name,char* val,int* indice,
		int lname,int lval)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
	char* temp_val = SpxStrCopy(_fcdtocp(val),_fcdlen(val));
#else
	char* temp_name = SpxStrCopy(name,lname);
	char* temp_val = SpxStrCopy(val,lval);
#endif

	SpxVSetArgTabChar((SPXFILE*) (*spx_file),temp_name,temp_val,*indice);

	free(temp_name);
	free(temp_val);
}

/* spxsv appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSV(IntFtn* fd,int spx_arg[],int* taille)
#else
FUNCDECL(spxsv)(IntFtn* fd,int spx_arg[],int* taille)
#endif
{
	SpxSetValues((SPXFILE*) (*fd),(SpxArg*) spx_arg,*taille);
}

/* spxvsv appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXVSV(IntFtn* fd)
#else
FUNCDECL(spxvsv)(IntFtn* fd)
#endif
{
	SpxVSetValues((SPXFILE*) (*fd));
}

/* spxopenr appelable en FORTRAN (subroutine au lieu de fonction) */

void
#ifdef CRAY_PROTO
SPXOPENR(_fcd name /* in */,IntFtn* fd /* out */)
#else
FUNCDECL(spxopenr)(char* name /* in */,IntFtn* fd /* out */,int lname /* in */)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	*fd = (IntFtn) SpxOpen(temp_name);

	free(temp_name);
}

/* spxopen appelable en FORTRAN */

IntFtn
#ifdef CRAY_PROTO
SPXOPEN(_fcd name)
#else
FUNCDECL(spxopen)(char* name,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	SPXFILE* fd = SpxOpen(temp_name);

	free(temp_name);

	return (IntFtn) fd;
}

/* spcopenr appelable en FORTRAN (subroutine au lieu de fonction) */

void
#ifdef CRAY_PROTO
SPCOPENR(_fcd name /* in */,IntFtn* fd /* out */)
#else
FUNCDECL(spcopenr)(char* name /* in */,IntFtn* fd /* out */,int lname /* in */)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	*fd = (IntFtn) SpcOpen(temp_name);

	free(temp_name);
}

/* spcopen appelable en FORTRAN */

IntFtn
#ifdef CRAY_PROTO
SPCOPEN(_fcd name)
#else
FUNCDECL(spcopen)(char* name,int lname)
#endif
{
#ifdef CRAY_PROTO
	char* temp_name = SpxStrCopy(_fcdtocp(name),_fcdlen(name));
#else
	char* temp_name = SpxStrCopy(name,lname);
#endif
	SPXFILE* fd = SpcOpen(temp_name);

	free(temp_name);

	return (IntFtn) fd;
}

/* spxsync appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXSYNC(IntFtn* fd)
#else
FUNCDECL(spxsync)(IntFtn* fd)
#endif
{
	SpxSync((SPXFILE*) (*fd));
}

/* spxclose appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPXCLOSE(IntFtn* fd)
#else
FUNCDECL(spxclose)(IntFtn* fd)
#endif
{
	SpxClose((SPXFILE*) (*fd));
}

/*****************************************************************/
/*  routines envoyant des donnees numeriques (binaire ou ASCII)  */
/*****************************************************************/

/* spx2moc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX2MOC(REEL_S xtab[],REEL_S ytab[],int* nx,IntFtn* spx_file)
#else
FUNCDECL(spx2moc)(REEL_S xtab[],REEL_S ytab[],int* nx,IntFtn* spx_file)
#endif
{
	SpxMonoCourbe(xtab,ytab,*nx,(SPXFILE*) (*spx_file));
}

/* spx2muc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX2MUC(REEL_S xtab[],REEL_S ytab[],int nxsto[],int* ny,IntFtn* spx_file)
#else
FUNCDECL(spx2muc)(REEL_S xtab[],REEL_S ytab[],int nxsto[],int* ny,IntFtn* spx_file)
#endif
{
	SpxMulCourbe(xtab,ytab,nxsto,*ny,(SPXFILE*) (*spx_file));
}

/* spx3prc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX3PRC(int* nx,int* ny,REEL_S z[],int* dimz,IntFtn* spx_file)
#else
FUNCDECL(spx3prc)(int* nx,int* ny,REEL_S z[],int* dimz,IntFtn* spx_file)
#endif
{
	SpxPrintSurf(*nx,*ny,z,*dimz,(SPXFILE*) (*spx_file));
}

/* spx3rec appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX3REC(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,IntFtn* spx_file)
#else
FUNCDECL(spx3rec)(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		IntFtn* spx_file)
#endif
{
	SpxRect3d(*nx,*ny,x,y,z,*dimz,(SPXFILE*) (*spx_file));
}

/* spx3recm appelable en FORTRAN (m pour donnees aux mailles) */

void
#ifdef CRAY_PROTO
SPX3RECM(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		IntFtn* spx_file)
#else
FUNCDECL(spx3recm)(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		IntFtn* spx_file)
#endif
{
	SpxMailleRect3d(*nx,*ny,x,y,z,*dimz,(SPXFILE*) (*spx_file));
}

/* spx3tec appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX3TEC(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,IntFtn* spx_file)
#else
FUNCDECL(spx3tec)(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,IntFtn* spx_file)
#endif
{
	SpxTetra3d(*nx,*ny,x,*dimx,y,*dimy,z,*dimz,(SPXFILE*) (*spx_file));
}

/* spx3tecm appelable en FORTRAN (m pour donnees aux mailles) */

void
#ifdef CRAY_PROTO
SPX3TECM(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,IntFtn* spx_file)
#else
FUNCDECL(spx3tecm)(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,IntFtn* spx_file)
#endif
{
	SpxMailleTetra3d(*nx,*ny,x,*dimx,y,*dimy,z,*dimz,(SPXFILE*) (*spx_file));
}

/* spx4rec appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX4REC(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		REEL_S c[],int* dimc,IntFtn* spx_file)
#else
FUNCDECL(spx4rec)(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		REEL_S c[],int* dimc,IntFtn* spx_file)
#endif
{
	SpxRect4d(*nx,*ny,x,y,z,*dimz,c,*dimc,(SPXFILE*) (*spx_file));
}

/* spx4recm appelable en FORTRAN (m pour donnees aux mailles) */

void
#ifdef CRAY_PROTO
SPX4RECM(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		REEL_S c[],int* dimc,IntFtn* spx_file)
#else
FUNCDECL(spx4recm)(int* nx,int* ny,REEL_S x[],REEL_S y[],REEL_S z[],int* dimz,
		REEL_S c[],int* dimc,IntFtn* spx_file)
#endif
{
	SpxMailleRect4d(*nx,*ny,x,y,z,*dimz,c,*dimc,(SPXFILE*) (*spx_file));
}

/* spx4tec appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX4TEC(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,REEL_S c[],int* dimc,IntFtn* spx_file)
#else
FUNCDECL(spx4tec)(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,REEL_S c[],int* dimc,IntFtn* spx_file)
#endif
{
	SpxTetra4d(*nx,*ny,x,*dimx,y,*dimy,z,*dimz,c,*dimc,
		(SPXFILE*) (*spx_file));
}

/* spx4tecm appelable en FORTRAN (m pour donnees aux mailles) */

void
#ifdef CRAY_PROTO
SPX4TECM(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,REEL_S c[],int* dimc,IntFtn* spx_file)
#else
FUNCDECL(spx4tecm)(int* nx,int* ny,REEL_S x[],int* dimx,REEL_S y[],int* dimy,
		REEL_S z[],int* dimz,REEL_S c[],int* dimc,IntFtn* spx_file)
#endif
{
	SpxMailleTetra4d(*nx,*ny,x,*dimx,y,*dimy,z,*dimz,c,*dimc,
		(SPXFILE*) (*spx_file));
}

/* spx4nsc appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX4NSC(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],IntFtn* spx_file)
#else
FUNCDECL(spx4nsc)(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],IntFtn* spx_file)
#endif
{
	SpxNonStruc4d(*npoints,x,y,z,c,*nmailles,*dimmailles,mailles,
			(SPXFILE*) (*spx_file));
}

/* spx4nscm appelable en FORTRAN (m pour donnees aux mailles) */

void
#ifdef CRAY_PROTO
SPX4NSCM(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],IntFtn* spx_file)
#else
FUNCDECL(spx4nscm)(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],IntFtn* spx_file)
#endif
{
	SpxMailleNonStruc4d(*npoints,x,y,z,c,*nmailles,*dimmailles,mailles,
			(SPXFILE*) (*spx_file));
}

/* spx4nscb appelable en FORTRAN (b pour donnees aux bras) */

void
#ifdef CRAY_PROTO
SPX4NSCB(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],
		int* nbras,int bras[],IntFtn* spx_file)
#else
FUNCDECL(spx4nscb)(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nmailles,int* dimmailles,int mailles[],
		int* nbras,int bras[],IntFtn* spx_file)
#endif
{
	SpxBrasNonStruc4d(*npoints,x,y,z,c,*nmailles,*dimmailles,mailles,
			*nbras,bras,(SPXFILE*) (*spx_file));
}

/* spx4pec appelable en FORTRAN (SpxPointsEpais4d) */

void
#ifdef CRAY_PROTO
SPX4PEC(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		IntFtn* spx_file)
#else
FUNCDECL(spx4pec)(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		IntFtn* spx_file)
#endif
{
	SpxPointsEpais4d(*npoints,x,y,z,c,(SPXFILE*) (*spx_file));
}

/* spx4ppc appelable en FORTRAN (SpxPointsPixel4d) */

void
#ifdef CRAY_PROTO
SPX4PPC(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		IntFtn* spx_file)
#else
FUNCDECL(spx4ppc)(int* npoints,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		IntFtn* spx_file)
#endif
{
	SpxPointsPixel4d(*npoints,x,y,z,c,(SPXFILE*) (*spx_file));
}

/* spx4parec appelable en FORTRAN */

void
#ifdef CRAY_PROTO
SPX4PAREC(int* nx,int* ny,int* nz,REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int* dimc1,int* dimc2,IntFtn* spx_file)
#else
FUNCDECL(spx4parec)(int* nx,int* ny,int* nz,REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int* dimc1,int* dimc2,IntFtn* spx_file)
#endif
{
	SpxParRect4d(*nx,*ny,*nz,x,y,z,c,*dimc1,*dimc2,(SPXFILE*) (*spx_file));
}

/*************************************************************************/
/* spxgda appelable en FORTRAN                                           */
/*									 */
/* proto fortran :                                                       */
/* integer spxgda                                                        */
/*                                                                       */
/* integer function spxgda(dimbloc,dimdon,dimc,dimmai,dimvol,            */
/*		x,y,z,c,nbloc,nx,ny,nz,                                  */
/*		type,typec,typemailles,                                  */
/*		nmailles,dimmailles,mailles,                             */
/*		nvolumes,dimvolumes,volumes,spx_file)                    */
/* integer dimbloc 2eme dim des tableaux x,y,z,c,mailles,volumes         */
/*   et 1ere dim des tableaux nx,ny,nz,type,typec,typemailles,           */
/*   nmailles,dimmailles,nvolumes,dimvolumes  (en entree)                */
/* integer dimxy 1ere dim des tableaux x,y    (en entree)                */
/* integer dimz 1ere dim du tableau z         (en entree)                */
/* integer dimc   1ere dim du tableau c       (en entree)                */
/* integer dimmai 1ere dim du tableau mailles  (en entree)               */
/* integer dimvol 1ere dim du tableau volumes   (en entree)              */
/* real x(dimdon,dimbloc),y(dimdon,dimbloc),z(dimdon,dimbloc) (en retour)*/
/* real c(dimc,dimbloc)                       (en retour)                */
/* integer nbloc nombre de blocs lus (en retour)                         */
/* integer nx(dimbloc),ny(dimbloc),nz(dimbloc) (en retour)               */
/* integer type(dimbloc),typec(dimbloc),typemailles(dimbloc) (en retour) */
/* integer nmailles(dimbloc),dimmailles(dimbloc) (en retour)             */
/* integer nvolumes(dimbloc),dimvolumes(dimbloc) (en retour)             */
/* integer mailles(dimmai,dimbloc) (en retour)                           */
/* integer volumes(dimvol,dimbloc) (en retour)                           */
/* integer spx_file (en entree)  donne par appel a spcopen               */
/* spxgda vaut 1 en retour si l'une des dimensions est trop petite pour  */
/*   contenir les donnees lues                                           */
/* spxgda vaut 0 en retour si tout va bien                               */
/* spxgda vaut -1 si spx_file vaut 0 (fichier non ouvert par spcopen     */
/*************************************************************************/

int
#ifdef CRAY_PROTO
SPXGDA(int* dimbloc,int* dimxy,int* dimz,int* dimc,int* dimmai,
		int* dimvol,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nbloc,int nx[],int ny[],int nz[],
		int type[],int typec[],int typemailles[],
		int nmailles[],int dimmailles[],int mailles[],
		int nvolumes[],int dimvolumes[],int volumes[],IntFtn* spx_file)
#else
FUNCDECL(spxgda)(int* dimbloc,int* dimxy,int* dimz,int* dimc,int* dimmai,
		int* dimvol,REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int* nbloc,int nx[],int ny[],int nz[],
		int type[],int typec[],int typemailles[],
		int nmailles[],int dimmailles[],int mailles[],
		int nvolumes[],int dimvolumes[],int volumes[],IntFtn* spx_file)
#endif
{
	return SpxGetDonneeAbstraite(*dimbloc,*dimxy,*dimz,*dimc,*dimmai,
		*dimvol,x,y,z,c,nbloc,nx,ny,nz,(SpxTypeDon*) type,
		(SpxTypeC*) typec,(SpxTypeMailles*) typemailles,nmailles,
		dimmailles,mailles,nvolumes,dimvolumes,volumes,
		(SPXFILE*) (*spx_file));
}

/**********************************************************************/
/*      Fonction FORTRAN SPXQRY                                       */
/*      le code retour indique la presence du serveur Narcisse :        */
/*          1 => Narcisse existe a coup sur                             */
/*          -1 => Narcisse n'existe pas                                 */
/*      nom_fichier est le nom fourni en entree.                      */
/*          Il est complete par la variable d'environnement DEST_SP3  */
/**********************************************************************/

int
#ifdef CRAY_PROTO
SPXQRY(_fcd nom_fichier)
#else
FUNCDECL(spxqry)(char* nom_fichier,int lnom)
#endif
{
#ifdef CRAY_PROTO
	char* temp_nom = SpxStrCopy(_fcdtocp(nom_fichier),_fcdlen(nom_fichier));
#else
	char* temp_nom = SpxStrCopy(nom_fichier,lnom);
#endif

	int ier = SpxQuery(temp_nom);

	free(temp_nom);

	return ier;
}

/**********************************************************************/
/*      Fonction FORTRAN SPXWHC                                       */
/*      le code retour indique la presence du serveur Narcisse :        */
/*       >= 1 => Narcisse existe a coup sur (il faut "NARCISSE.n"         */
/*               ou rien ou 0 dans le nom du fichier ou comme champ   */
/*               port de DEST_SP3) et on renvoit le numero du Narcisse  */
/*               contacte                                             */
/*          -1 => Narcisse n'existe pas a coup sur                      */
/*          0 => Narcisse existe mais on ne donne pas son numero        */
/*      nom_fichier est le nom fourni en entree.                      */
/*          Il est complete par la variable d'environnement DEST_SP3  */
/**********************************************************************/

int
#ifdef CRAY_PROTO
SPXWHC(_fcd nom_fichier)
#else
FUNCDECL(spxwhc)(char* nom_fichier,int lnom)
#endif
{
#ifdef CRAY_PROTO
	char* temp_nom = SpxStrCopy(_fcdtocp(nom_fichier),_fcdlen(nom_fichier));
#else
	char* temp_nom = SpxStrCopy(nom_fichier,lnom);
#endif

	int ier = SpxWhich(temp_nom);

	free(temp_nom);

	return ier;
}
