/* identification du source */

#ifndef lint
    static const char sccs_id[] = " %W% %G% P. Brochard";
#endif

#include "SpxP.h"
#include "SpxVisuDri.h"
#include "nx.h"
#include "SpxMonoCourbe.h"
#include "SpxOpenP.h"

static void
SpxGenMonoCourbe(void* x,void* y,int nx,int precision,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;

	if(!spx_file) return;

	if(SpxDebut(spx_file)) return;

	file_fich = spx_file->file;

	if(spx_file->type != SPXFICHIERASCII)
	{
            int temp = 0;

	    SPXDEFICOD(icod,precision);
            temp = 1;
            fnxwriti(file_fich,1,&temp);
            temp = 1;
            fnxwriti(file_fich,1,&temp);
            fnxwriti(file_fich,1,&nx);
    
            fnxwritt(file_fich,nx,x,icod,"sp");
            fnxwritt(file_fich,nx,y,icod,"sp");
    
            temp = 0;
            fnxwriti(file_fich,1,&temp);
            fnxwrite(file_fich,"@",1);
	}
	else
	{
	    char temp[80];
	    int i = 0;

	    for(;i<nx;i++)
	    {
		SPXASCII(precision,
				sprintf(temp,"%g %g\n",((REEL4*) x)[i],
						((REEL4*) y)[i]),
				sprintf(temp,"%g %g\n",((REEL_S*) x)[i],
						((REEL_S*) y)[i]),
				sprintf(temp,"%g %g\n",((REEL*) x)[i],
						((REEL*) y)[i]));
		fnxwrite(file_fich,temp,strlen(temp));
	    }

	}

	fnxflush(file_fich);
	SpxFin(spx_file);
}

void
SpxMonoCourbe(REEL_S x[],REEL_S y[],int nx,SPXFILE* spx_file)
{
	SpxGenMonoCourbe(x,y,nx,SPXREAL,spx_file);
}

void
SpxDMonoCourbe(REEL x[],REEL y[],int nx,SPXFILE* spx_file)
{
	SpxGenMonoCourbe(x,y,nx,SPXDOUBLEPRECISION,spx_file);
}

void
Spx4MonoCourbe(REEL4 x[],REEL4 y[],int nx,SPXFILE* spx_file)
{
	SpxGenMonoCourbe(x,y,nx,SPXREAL4,spx_file);
}

void
Spx8MonoCourbe(REEL8 x[],REEL8 y[],int nx,SPXFILE* spx_file)
{
#if defined(CRAY)
	SpxGenMonoCourbe(x,y,nx,SPXREAL,spx_file);
#else
	SpxGenMonoCourbe(x,y,nx,SPXDOUBLEPRECISION,spx_file);
#endif
}
