/* identification du source */

#ifndef lint
    static const char* const sccs_id = "%W% %G% P. Brochard";
#endif

#include "SpxP.h"
#include "SpxVisuDri.h"
#include "nx.h"
#include "SpxUcdWrite.h"
#include "SpxOpenP.h"

/*********************************************************/
/* envoi de donnees de type UCD d'AVS apres un SpuOpen   */
/* sur disque : un fichier par appel a SpuWrite          */
/* avec indent du numero de fichier                      */
/* sur socket : un fichier complet envoye par appel de   */
/* SpuWrite                                              */
/*********************************************************/

void
SpuWrite(char* buf,int lbuf,SPXFILE* spx_file)
{
	FILE* file_fich = NULL;

	if(!spx_file) return;

	switch(spx_file->type)
	{
	  case SPXFICHIERUCD:
	    {
		char file_temp[MAX_FILENAME_LENGTH];
		char* nomfich = spx_file->nom_fichier;
		char* marqueur = strstr(nomfich,".inp");
		int delta;

		if(marqueur)
		{
		    delta = marqueur-nomfich;
		}
		else
		{
		    delta = strlen(nomfich);
		}

		memcpy(file_temp,nomfich,delta);
		file_temp[delta] = '\0';
		sprintf(file_temp+delta,"%5d",spx_file->compteur_fichier_ucd);
		SpxRemplaceBlanc(file_temp+delta);
		spx_file->compteur_fichier_ucd++;
		strcat(file_temp,marqueur);
		file_fich = fnxopen(file_temp,"w");

		if(!file_fich)
		{
		    fprintf(stderr,
				    "Pb ouverture fichier : "
				    "SpuWrite a echoue\n");
		    spx_file->compteur_fichier_ucd--;

		    return;
		}

		fnxwrite(file_fich,buf,lbuf);
		fnxclose(file_fich);
	    }
	    break;

	  case SPXVISU:
	    {
		char pathrc[MAX_FILENAME_LENGTH];
		char* suffixe = ".inp";
		char nomfich[MAX_FILENAME_LENGTH];

		suffixe = ".inp";
		memset(pathrc,0,sizeof(pathrc));
		SpxOpenFichier(pathrc,suffixe);
		strcpy(nomfich,pathrc);
		file_fich = fnxopen(nomfich,"w");
		fnxwrite(file_fich,buf,lbuf);
		fnxclose(file_fich);
		SpxFermeFichier(pathrc);
	    }
	    break;

	  case SPXSOCKETUCD:
	    {
		unsigned compt = 0;

		while(!file_fich)
		{
		    file_fich = fnxopen(spx_file->nom_fichier,"w");

		    if(!file_fich)
		    {
			fnxperror("Demande de connexion");
			sleep(2);
			compt++;

			if(compt >= 10)
			{
			    fprintf(stderr,"Ouvrer Narcisse \nsinon "
					    "attendez qu'il soit moins "
					    "occupe\n");
			    return;
			}

		    }

		}

		fnxwrite(file_fich,buf,lbuf);
		fnxclose(file_fich);
	    }
	    break;

	  default:
	    fprintf(stderr,"Pb SpuWrite\n");
	    break;
	}

}
