#ifndef CELLULEFP_H
#define CELLULEFP_H

// %W% %G% P. Brochard

#include"S6compat.h"

#if defined(CRAY)
	static const unsigned Cellule_taille = 5;
#endif

#if defined(P4VERSION_AVEC_TEMPLATE) /* version avec template */

#  ifndef P4TABGEN_H
#     if P4VERSION_AVEC_TEMPLATE == 4
         template<class GEN> class TabGENbuf;
         typedef TabGENbuf<unsigned> Tabunsignedbuf;
#     else
         template<class GEN> class TabGENbuf;
#        define Tabunsignedbuf TabGENbuf<unsigned>
#     endif
#  endif

#else // version sans template

   class Tabunsignedbuf;

#endif

class Cellule 
{
    public :

	Cellule();
	~Cellule();

        void operator()(const Cellule& cel);

	unsigned Precedente();
	void     MajSuivante(unsigned);

	void     EcritFils(unsigned);
	void     EcritFilsSansDouble(unsigned);
	unsigned LitFils(unsigned n);
	void     LitAllFils(Tabunsignedbuf& tfils);
	void     EnleveFils(unsigned);
	void     PurgeFils(unsigned);
	unsigned Nfils();
	const unsigned* Fils();

	void     EcritPere(unsigned);
	unsigned LitPere(unsigned n);
	void     EnlevePere(unsigned);

	void     Enleve();

    private :

	unsigned  _prec;
	unsigned  _nfils;
	unsigned  _npere;
	unsigned* _fils;
	unsigned* _pere;

#if defined(CRAY)
	unsigned  _temp_fils[Cellule_taille];
	unsigned  _temp_pere[Cellule_taille];
#endif
};

#endif // fin CELLULEFP_H
