#ifndef CELLULEFP_I_H
#define CELLULEFP_I_H

// %W% %G% Pierre Brochard

#include "P4cellulefp.h"
#include "P4constant.h"
#include "dinosaure/P4tabgenbasec.h"
#include "dinosaure/P4tabgenbase.h"

// fonctions inline

inline Cellule::Cellule()
{
	_nfils = 0;
	_npere = 0;
	_fils = NULL;
	_pere = NULL;
	_prec = 0;
}

inline Cellule::~Cellule()
{

	if(_pere) free((char*) _pere);

	if(_fils) free((char*) _fils);

}

inline unsigned Cellule::LitFils(unsigned n)
{
	return(n<_nfils ? _fils[n] : Dep);
}

inline void Cellule::LitAllFils(Tabunsignedbuf& tn)
{
	tn.Ajoute(_fils,_nfils);
}

inline unsigned Cellule::LitPere(unsigned n)
{
	return(n<_npere ? _pere[n] : Dep);
}

inline unsigned Cellule::Nfils()
{
	return _nfils;
}

inline const unsigned* Cellule::Fils()
{
	return _fils;
}

inline unsigned  Cellule::Precedente()
{
	return _prec;
}

#endif
