/* identification du source */

struct SccsIdP4compfiltre
{
	static const char* const sccs_id;
};

const char* const SccsIdP4compfiltre::sccs_id = "%W% %G% Pierre Brochard";

/* includes standards */

#include "nxstreamiocompat.h"

/* includes */

#include "dinosaure/P4compfiltre.h"

// *********************************************************
//     comparaison d'un filtre type sh et d'une chaine
//     renvoit 1 si chaine acceptable pour filtre
//             0 sinon
// *********************************************************

int
P4CompareFiltre(const char* const name,const char* const filtre)
{

	if(!filtre) return 0;

	if(!name) return 0;
	    
	switch(*filtre)
	{
	  case '*' :
	    {
		int compt_name = 0;

		if(filtre[1] == '\0')
		{
		    return 1;
		}

		while(name[compt_name] != '\0' &&
				!P4CompareFiltre(name + compt_name,
						filtre + 1))
		{
		    compt_name++;
		}

		if(name[compt_name] == '\0')
		{
		    return 0;
		}
		else
		{
		    return P4CompareFiltre(name + compt_name,filtre + 1);
		}

	    }

	  case '?' :

	    if(*name != '\0')
	    {
		return P4CompareFiltre(name + 1,filtre + 1);
	    }
	    else
	    {
		return 0;
	    }

	  case '[':
	    {
		register int compt_filtre = 1;
		register int mode_inv = 0;

		if(filtre[1] == '!')
		{
		    mode_inv = 1;
		    compt_filtre = 2;
		}

		register char filtre_temp = filtre[compt_filtre];
		register int filtre_test = mode_inv;

		while(filtre_temp != ']' && filtre_temp != '\0')
		{

		    if(filtre[compt_filtre + 1] == '-')
		    {
			register char ffmax = filtre[compt_filtre + 2];

			if(ffmax != '\0')
			{
			    register char ff = filtre_temp;

			    for(;ff<=ffmax && ff != *name;ff++);

			    if(ff != ffmax) filtre_test = !mode_inv;

			}

			compt_filtre += 3;
			filtre_temp = filtre[compt_filtre];
		    }
		    else if(filtre_temp == *name)
		    {
			filtre_test = !mode_inv;
			compt_filtre++;
			filtre_temp = filtre[compt_filtre];
		    }
		    else
		    {
			compt_filtre++;
			filtre_temp = filtre[compt_filtre];
		    }


		}

		if(filtre_test)
		{

		    if(filtre_temp == '\0' && name[1] == '\0')
		    {
			return 1;
		    }
		    else
		    {
			return P4CompareFiltre(name + 1,
					filtre + compt_filtre + 1);
		    }

		}
		else
		{
		    return 0;
		}
		    
	    }

	  case '\'' :

	    return P4CompareFiltre(name,filtre + 1);

	  case '"' :

	    return P4CompareFiltre(name,filtre + 1);

	  case '\\' :

	    if(*name == '\0')
	    {
		return 1;
	    }
	    else if(*name == filtre[1])
	    {
		return P4CompareFiltre(name + 1,filtre + 2);
	    }
	    else
	    {
		return 0;
	    }

	  case '\0' :
	    
	    if(*name == '\0')
	    {
		return 1;
	    }
	    else
	    {
		return 0;
	    }
	
	  default:

	    if(*name == *filtre)
	    {
		return P4CompareFiltre(name + 1,filtre + 1);
	    }
	    else
	    {
		return 0;
	    }

	}

}
