#ifndef PILEFP_H
#define PILEFP_H

// %W% %G% P. Brochard

class Cellule;

class Pile
{
    public :

	Pile(unsigned n = 0);
	Pile(const Pile& p);
	~Pile();

	void      Empiler(unsigned,unsigned);
	void      Depiler(unsigned);
	P4Boolean Lit(unsigned n);

	void      EmpilerFils(unsigned,unsigned);
	void      AjoutFils(unsigned,unsigned);
	void      DepilerFils(unsigned,unsigned);
	void      PurgeFils(unsigned,unsigned);
	unsigned  LitFils(unsigned p,unsigned nfils);
	unsigned  LitFilsCond(unsigned p,unsigned nfils,unsigned* cond);
	void      LitAllFils(unsigned p,Tabunsignedbuf& tfils);
	unsigned  RechercheFils(unsigned p,unsigned fils);

	void      EmpilerPere(unsigned,unsigned);
	void      DepilerPere(unsigned,unsigned);
	unsigned  LitPere(unsigned p,unsigned npere);

	void      ModPrec(unsigned,unsigned);
	unsigned  LitPrec(unsigned);

	void      Ordonne(unsigned*); // suppose qu'un tri est deja fait
	void      OrdonneFin(unsigned*); // idem
	void      Profondeur(unsigned* prof); // idem
	void      Reclasse();	// idem
	void      EliminePere();	// idem
	void      CasseBoucle();	// idem

	operator unsigned() const;
	friend ostream& operator << (ostream& ost,Pile p) ; 

    private :

	const unsigned  _nsommet;
	Cellule*  _temp_alloc;
	Cellule** const _sommet;
};

#endif
