#ifndef SPXBASE_H
#define SPXBASE_H

/* %W% %G% P. Brochard */

#include "SpxOpen.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef int SpxItem;

SpxItem SpxBase2DPoint(REEL_S x,REEL_S y,int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DSegment(REEL_S segx1,REEL_S segy1,REEL_S segx2,REEL_S segy2,
		int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DArc(REEL_S arcx1,REEL_S arcy1,REEL_S arcx2,REEL_S arcy2,
		REEL_S arcx3,REEL_S arcy3,int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DRectangle(REEL_S coinx1,REEL_S coiny1,REEL_S coinx2,
		REEL_S coiny2,int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DPolyligne(REEL_S x[],REEL_S y[],int taille,
		int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DPolygone(REEL_S x[],REEL_S y[],int taille,
		int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DPolygoneContoure(REEL_S x[],REEL_S y[],int taille,
		int couleur,int couleurcont,SPXFILE* spx_file);

SpxItem SpxBase2DTabPoint(REEL_S x[],REEL_S y[],int taille,
		int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DTabSegment(REEL_S segx1[],REEL_S segy1[],REEL_S segx2[],
		REEL_S segy2[],int taille,int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DTabArc(REEL_S arcx1[],REEL_S arcy1[],REEL_S arcx2[],
		REEL_S arcy2[],REEL_S arcx3[],REEL_S arcy3[],int taille,
		int couleur,SPXFILE* spx_file);
SpxItem SpxBase2DTabRectangle(REEL_S coinx1[],REEL_S coiny1[],REEL_S coinx2[],
		REEL_S coiny2[],int taille,int couleur,SPXFILE* spx_file);

void SpxBase2DDelete(SpxItem item,SPXFILE* spx_file);
void SpxBase2DDeleteAll(SPXFILE* spx_file);

#ifdef __cplusplus
}
#endif

#endif
