#ifndef SPXOPEN_H
#define SPXOPEN_H

/* %W% %G% P. Brochard */

#ifdef __cplusplus
extern "C" {
#endif

/* types REEL_S et REEL identiques a NXFLT et NXDBLE de nx
   REEL8 est 64 bits s'il existe sinon la taille la plus proche
   REEL4 est 32 bits s'il existe sinon la taille la plus proche
   taille la plus proche est pris au sens min(abs(taille-taille_existante))
   si 2 solutions existent alors on prend la plus grande taille */

#if defined(CRAY) && !defined(_CRAYMPP)
	typedef float REEL_S; /* 64 bits */
	typedef long double REEL; /* 128 bits */
	typedef float REEL4; /* 64 bits */
	typedef double REEL8; /* 64 bits */
#elif defined(_CRAYMPP)
	typedef double REEL_S; /* 64 bits */
	typedef long double REEL; /* 64 bits */
	typedef float REEL4; /* 32 bits */
	typedef double REEL8; /* 64 bits */
#else
	typedef float REEL_S; /* 32 bits */
	typedef double REEL; /* 64 bits */
	typedef float REEL4; /* 32 bits */
	typedef double REEL8; /* 64 bits */
#endif

	typedef struct _SPXFILE SPXFILE;

	SPXFILE* SpxOpen(char* nom_fichier);
	SPXFILE* Sp3Open(char* nom_fichier);
	SPXFILE* SpcOpen(char* nom_fichier);
	SPXFILE* SpetoileOpen(char* nom_fichier);
	SPXFILE* SpcolOpen(char* nom_fichier);
	SPXFILE* SpuOpen(char* nom_fichier);

	void SpxClose(SPXFILE* spx_file);
	void SpxSync(SPXFILE* spx_file);

	int SpxQuery(const char* nom_fichier);
	int SpxWhich(const char* nom_fichier);

	int SpxLance(const char* nomexe,const char* nom_fichier,
			const char* machine,const char* port_name,char port[]);
	SPXFILE* SpcLOpen(const char* nomexe,const char* nom_fichier,
			const char* machine,const char* port_name);

#ifdef __cplusplus
}
#endif

#endif
