#ifndef SPXSETARG_H
#define SPXSETARG_H

/* %W% %G% P. Brochard */

#include "SpxOpen.h"

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	unsigned type;
	char* name;
} SpxArgTemplate;

typedef struct
{
	unsigned type;
	char* name;
	int value;
} SpxArgInt;

typedef struct
{
	unsigned type;
	char* name;
	REEL_S value;
} SpxArgReel;

typedef struct
{
	unsigned type;
	char* name;
	char* value;
} SpxArgChar;

typedef struct
{
	unsigned type;
	char* name;
	unsigned taille;
	int* value;
} SpxArgTabInt;

typedef struct
{
	unsigned type;
	char* name;
	unsigned taille;
	REEL_S* value;
} SpxArgTabReel;

typedef struct
{
	unsigned type;
	char* name;
	unsigned taille;
	char** value;
} SpxArgTabChar;

typedef union
{
	unsigned type;
	SpxArgTemplate gen;
	SpxArgInt entier;
	SpxArgReel reel;
	SpxArgChar caractere;
	SpxArgTabInt tab_entier;
	SpxArgTabReel tab_reel;
	SpxArgTabChar tab_caractere;
} SpxArg;

/****************************************************************/
/* Routines utilisant un tableau spx_arg cree par l'utilisateur */
/****************************************************************/

void SpxInitArg(SpxArg spx_arg[],unsigned taille);
void SpxPurgeArg(SpxArg spx_arg[],unsigned taille);

void SpxSetArgInt(SpxArg* spx_arg,char* name,int value);
void SpxSetArgReel(SpxArg* spx_arg,char* name,REEL_S value);
void SpxSetArgChar(SpxArg* spx_arg,char* name,char* value);

/* si indice vaut -1 le tableau est remis a zero */
/* mettre tous les indices du meme tableau dans le meme spx_arg !! */

void SpxSetArgTabInt(SpxArg* spx_arg,char* name,int value,int indice);
void SpxSetArgTabReel(SpxArg* spx_arg,char* name,REEL_S value,int indice);
void SpxSetArgTabChar(SpxArg* spx_arg,char* name,char* value,int indice);

/****************************************************************/
/* Routines utilisant un tableau spxarg cache a l'utilisateur   */
/****************************************************************/

void SpxVPurgeArg(SPXFILE* spx_file);

void SpxVSetArgInt(SPXFILE* spx_file,char* name,int value);
void SpxVSetArgReel(SPXFILE* spx_file,char* name,REEL_S value);
void SpxVSetArgChar(SPXFILE* spx_file,char* name,char* value);

/* si indice vaut -1 le tableau est remis a zero */
/* mettre tous les indices du meme tableau dans le meme spx_arg !! */

void SpxVSetArgTabInt(SPXFILE* spx_file,char* name,int value,int indice);
void SpxVSetArgTabReel(SPXFILE* spx_file,char* name,REEL_S value,int indice);
void SpxVSetArgTabChar(SPXFILE* spx_file,char* name,char* value,int indice);

/****************************************************************/
/* Routines utiles                                              */
/****************************************************************/

char* SpxStrCopy(char* string,int len);

#ifdef __cplusplus
}
#endif

#endif
