#ifndef P4TABGEN_MKDEP

#ifndef P4TAILLE_BUF
#define P4TAILLE_BUF
const int taille_buf_init = 10;
const int taille_buf_apres = 2;

extern char* P4Tabgen_resize_error;

# if defined(SUNOS) && defined(SUNOS_4)
#   define memmove(a,b,c) bcopy((b),(a),(c))
# endif

#endif // P4TAILLE_BUF

#if defined(P4VERSION_AVEC_TEMPLATE) /* version avec template */
#  define P4ElementClasse
#endif

// %W% %G% Pierre Brochard CEA/DAM-Ile de France

// Attention GEN dans Ajoute et Agrand peut appartenir au TabGEN (marche)
// sinon GEN et GEN* ne doivent pas appartenir au TabGEN mais ce n'est pas teste

P4TABGEN_TEMPLATE
TabGEN P4TABGEN_GEN::TabGEN(S6Unsigned n)
{
	_type_alloc = P4MALLOC;

	if(n)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));

	    if(!_tab)
	    {
		cerr << "pb allocation dans TabGEN::TabGEN(const TabGEN& t)" <<
		    endl;
		_taille = 0;
		return;
	    }

	}
	else
	{
	    _taille = 0;
	    _ctab = _tab = NULL;
	    return;
	}

	memset(_tab,0,n*sizeof(GEN));
	_taille = n;
}

P4TABGEN_TEMPLATE
TabGENbuf P4TABGEN_GEN::TabGENbuf(S6Unsigned n) : TabGEN P4TABGEN_GEN(n),
		_taille_allouee(n)
{
}

P4TABGEN_TEMPLATE
TabGEN P4TABGEN_GEN::TabGEN(const TabGEN P4TABGEN_GEN& t)
{
	_type_alloc = P4MALLOC;

	unsigned n = t;

	if(n)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));

	    if(!_tab)
	    {
		cerr << "pb allocation dans TabGEN::TabGEN(const TabGEN& t)" <<
		    endl;
		_taille = 0;
		return;
	    }

	}
	else
	{
	    _taille = 0;
	    _ctab = _tab = NULL;
	    return;
	}

	memcpy(_tab,t,n*sizeof(GEN));
	_taille = n;
}

P4TABGEN_TEMPLATE
TabGENbuf P4TABGEN_GEN::TabGENbuf(const TabGEN P4TABGEN_GEN& t) :
	 	TabGEN P4TABGEN_GEN(t),_taille_allouee(t)
{
}

P4TABGEN_TEMPLATE
TabGEN P4TABGEN_GEN::TabGEN(GEN* const tab,unsigned tai,TypeAlloc type_alloc)
{
	_type_alloc = type_alloc;

	if(type_alloc == P4UNKNOWN)
	{
	    _taille = tai;
	    _ctab = _tab = tab;

	    return;
	}

	if(tai)
	{
	    _ctab = _tab = (GEN*) malloc(tai*sizeof(GEN));

	    if(!_tab)
	    {
		cerr << "pb allocation" << __FILE__ << ' ' << __LINE__ << endl;
		_taille = 0;
		return;
	    }

	}
	else
	{
	    _taille = 0;
	    _ctab = _tab = NULL;
	    return;
	}

	memcpy(_tab,tab,tai*sizeof(GEN));
	_taille = tai;
}

P4TABGEN_TEMPLATE
TabGEN P4TABGEN_GEN::TabGEN(const GEN* const tab,unsigned tai,
		TypeAlloc type_alloc)
{
	_type_alloc = type_alloc;

	if(type_alloc == P4UNKNOWN)
	{
	    _taille = tai;
	    _tab = NULL;
	    _ctab = tab;

	    return;
	}

	if(tai)
	{
	    _ctab = _tab = (GEN*) malloc(tai*sizeof(GEN));

	    if(!_tab)
	    {
		cerr << "pb allocation" << __FILE__ << ' ' << __LINE__ << endl;
		_taille = 0;

		return;
	    }

	}
	else
	{
	    _taille = 0;
	    _ctab = _tab = NULL;

	    return;
	}

	memcpy(_tab,tab,tai*sizeof(GEN));
	_taille = tai;
}

P4TABGEN_TEMPLATE
TabGEN P4TABGEN_GEN::~TabGEN()
{

	if(_type_alloc==P4MALLOC && _tab)
	{
	    free((char*) _tab);
	    _tab = NULL;
	}

}

P4TABGEN_TEMPLATE
TabGENbuf P4TABGEN_GEN::~TabGENbuf()
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4MALLOC && TabGEN P4TABGEN_GEN::_tab)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    TabGEN P4TABGEN_GEN::_tab = NULL;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::operator()(const TabGEN P4TABGEN_GEN& t)
{
	register unsigned n = t;

	if(_type_alloc==P4UNKNOWN && (n != _taille || !_tab))
	{
	    _type_alloc = P4MALLOC;
	    _taille = 0;
	    _ctab = _tab = NULL;
	}

	if(!n)
	{

	    if(_tab) free((char*) _tab);

	    _taille = 0;
	    _ctab = _tab = NULL;
	    return;
	}

	if(_tab && n != _taille)
	{
	    free((char*) _tab);
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}
	else if(!_tab)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}

	if(!_tab)
	{
	    cerr << "pb allocation dans " << __FILE__ << " ligne " <<
		__LINE__ << endl;
	    _taille = 0;
	    return;
	}

	memcpy(_tab,t,n*sizeof(GEN));
	_taille = n;
}

P4TABGEN_TEMPLATE ostream&
TabGEN P4TABGEN_GEN::operator << (ostream& ost) const
{
	ost << "***Impression du Tableau***\n";
	ost << "Type d'allocation = " << _type_alloc;
	ost << "\nTaille            = " << _taille;
	ost << "\nTab               =\n";

	for (unsigned i=0;i<_taille;i++)
	{
	    ost << _ctab[i];

	    if((i+1)%10 == 0) ost << '\n';
	    else ost << ' ';

	}

	ost << endl;
	return ost;
}

P4TABGEN_TEMPLATE ostream&
TabGENbuf P4TABGEN_GEN::operator << (ostream& ost) const
{
	ost << "***Impression du Tableau***\n";
	ost << "Type d'allocation = " << TabGEN P4TABGEN_GEN::_type_alloc;
	ost << "\nTaille            = " << TabGEN P4TABGEN_GEN::_taille;
	ost << "\nTaille allouee    = " << _taille_allouee;
	ost << "\nTab               =\n";

	for (unsigned i=0;i<TabGEN P4TABGEN_GEN::_taille;i++)
	{
	    ost << TabGEN P4TABGEN_GEN::_ctab[i];

	    if((i+1)%10 == 0) ost << '\n';
	    else ost << ' ';

	}

	ost << endl;
	return ost;
}

P4TABGEN_TEMPLATE GEN
TabGEN P4TABGEN_GEN::Lit(unsigned i) const
{

	if(i>=_taille)
	{
	   cerr << "erreur depassement de tableau variable" << endl;
	   exit(1);
	}

	return _ctab[i];
}

P4TABGEN_TEMPLATE TabGEN P4TABGEN_GEN
TabGEN P4TABGEN_GEN::Lit(unsigned i,unsigned n) const
{

	if(!_tab || i+n-1>=_taille)
	{
	   cerr << "erreur depassement de tableau variable" << endl;
	   exit(1);
	}

	TabGEN P4TABGEN_GEN o(_tab+i,n);
	return  o;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::operator = (const TabGEN P4TABGEN_GEN& t)
{
	unsigned n = t;

	if(_type_alloc==P4UNKNOWN && (n != _taille || !_tab))
	{
	    _type_alloc = P4MALLOC;
	    _taille = 0;
	    _ctab = _tab = NULL;
	}

	if(_tab && n != _taille)
	{
	    free((char*) _tab);
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));

	}
	else if(!_tab && n>0)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}
	else
	{
	    _taille = 0;
	    _ctab = _tab = NULL;
	    return;
	}

	if(!_tab)
	{
	    cerr << "pb allocation dans " << __FILE__ << " ligne " <<
		__LINE__ << endl;
	    _taille = 0;
	    return;
	}

	memcpy(_tab,t,n*sizeof(GEN));
	_taille = n;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::operator = (const TabGEN P4TABGEN_GEN& t)
{
	unsigned n = t;

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN && (n > _taille_allouee || !TabGEN P4TABGEN_GEN::_tab))
	{
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	}

	if(!TabGEN P4TABGEN_GEN::_tab && n>0)
	{
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && n > _taille_allouee)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}

	memcpy(TabGEN P4TABGEN_GEN::_tab,t,n*sizeof(GEN));
	TabGEN P4TABGEN_GEN::_taille = n;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Lier(GEN* t,unsigned n)
{

	if(_type_alloc==P4MALLOC && _tab) free((char*) _tab);

	_type_alloc = P4UNKNOWN;
	_taille = n;
	_ctab = _tab = t;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Lier(GEN* t,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4MALLOC && TabGEN P4TABGEN_GEN::_tab) free((char*) TabGEN P4TABGEN_GEN::_tab);

	TabGEN P4TABGEN_GEN::_type_alloc = P4UNKNOWN;
	_taille_allouee = n;
	TabGEN P4TABGEN_GEN::_taille = n;
	TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = t;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Lier(const GEN* t,unsigned n)
{

	if(_type_alloc==P4MALLOC && _tab) free((char*) _tab);

	_type_alloc = P4UNKNOWN;
	_taille = n;
	_tab = NULL;
	_ctab = t;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Lier(const GEN* t,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4MALLOC && TabGEN P4TABGEN_GEN::_tab) free((char*) TabGEN P4TABGEN_GEN::_tab);

	TabGEN P4TABGEN_GEN::_type_alloc = P4UNKNOWN;
	_taille_allouee = n;
	TabGEN P4TABGEN_GEN::_taille = n;
	TabGEN P4TABGEN_GEN::_tab = NULL;
	TabGEN P4TABGEN_GEN::_ctab = t;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Lier(const TabGEN P4TABGEN_GEN& t)
{

	if(_type_alloc==P4MALLOC && _tab) free((char*) _tab);

	_type_alloc = P4UNKNOWN;
	_taille = t;
	_tab = t;
	_ctab = t;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Lier(const TabGEN P4TABGEN_GEN& t)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4MALLOC && TabGEN P4TABGEN_GEN::_tab) free((char*) TabGEN P4TABGEN_GEN::_tab);

	TabGEN P4TABGEN_GEN::_type_alloc = P4UNKNOWN;
	_taille_allouee = t;
	TabGEN P4TABGEN_GEN::_taille = t;
	TabGEN P4TABGEN_GEN::_tab = t;
	TabGEN P4TABGEN_GEN::_ctab = t;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Permute(unsigned p,unsigned q) const
{

	if(_tab && q<_taille && p<_taille)
	{
	   const GEN r=_tab[q];_tab[q]=_tab[p];_tab[p]=r;
	}
	else
	{
	   cerr << "TabGEN> Permute _tab NULL ou p ou q >= _taille" << endl;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Permute(unsigned bloc_1_min,unsigned bloc_1_max,
			unsigned bloc_2_min,unsigned bloc_2_max) const
{
	const unsigned bloc_1 = min(bloc_1_min,bloc_1_max);

	bloc_1_max = max(bloc_1_min,bloc_1_max);
	bloc_1_min = bloc_1;

	const unsigned bloc_2 = min(bloc_2_min,bloc_2_max);

	bloc_2_max = max(bloc_2_min,bloc_2_max);
	bloc_2_min = bloc_2;

	if(bloc_1_max>=bloc_2_min)
	{
	    cerr << "tabGEN> blocs se chevauchent dans Permute" << endl;
	}

	if(_tab && bloc_1_max<_taille && bloc_2_max<_taille)
	{
	    const unsigned bloc_2_taille = bloc_2_max-bloc_2_min+1;
	    const unsigned bloc_1_taille = bloc_1_max-bloc_1_min+1;

	    GEN* const temp = new GEN[bloc_2_taille];

	    memcpy(temp,_tab+bloc_2_min,bloc_2_taille*sizeof(GEN));
	    memmove(_tab+bloc_2_min,_tab+bloc_1_min,bloc_1_taille*sizeof(GEN));
	    memcpy(_tab+bloc_1_min,temp,bloc_2_taille*sizeof(GEN));

	    delete[] temp;
	}
	else
	{
	   cerr << "tabGEN> Permute _tab NULL ou blocs >= _taille" << endl;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Ajoute(const GEN& ob)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(_taille)
	{
	    const GEN tempob = ob; // car ob peut etre un element du TabGEN !!!!

	    _ctab = _tab = (GEN*) realloc((char*) _tab,(++_taille)*sizeof(GEN));
	    _tab[_taille-1] = tempob;
	}
	else
	{
	    _ctab = _tab = (GEN*) malloc((++_taille)*sizeof(GEN));
	    _tab[_taille-1] = ob;
	}

}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Ajoute(const GEN& ob)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));

	    if(!TabGEN P4TABGEN_GEN::_tab)
	    {
		cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
		_taille_allouee = 0;
		TabGEN P4TABGEN_GEN::_taille = 0;

		return;
	    }

	    TabGEN P4TABGEN_GEN::_tab[TabGEN P4TABGEN_GEN::_taille] = ob;
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille >= _taille_allouee)
	{
	    const GEN tempob = ob;

	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+taille_buf_apres;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,_taille_allouee*sizeof(GEN));

	    if(!TabGEN P4TABGEN_GEN::_tab)
	    {
		cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
		_taille_allouee = 0;
		TabGEN P4TABGEN_GEN::_taille = 0;

		return;
	    }

	    TabGEN P4TABGEN_GEN::_tab[TabGEN P4TABGEN_GEN::_taille] = tempob;
	}
	else
	{
	    TabGEN P4TABGEN_GEN::_tab[TabGEN P4TABGEN_GEN::_taille] = ob;
	}

	TabGEN P4TABGEN_GEN::_taille++;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Ajoute(const GEN& ob,unsigned buf_taille)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + buf_taille + 1;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	    TabGEN P4TABGEN_GEN::_tab[TabGEN P4TABGEN_GEN::_taille] = ob;
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille >= _taille_allouee)
	{
	    const GEN tempob = ob;

	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + buf_taille + 1;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,_taille_allouee*sizeof(GEN));
	    TabGEN P4TABGEN_GEN::_tab[TabGEN P4TABGEN_GEN::_taille] = tempob;
	}
	else
	{
	    TabGEN P4TABGEN_GEN::_tab[TabGEN P4TABGEN_GEN::_taille] = ob;
	}

	TabGEN P4TABGEN_GEN::_taille++;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::AjouteClean(const GEN& ob)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	const GEN temp = ob;

	if(_tab)
	{
	    _ctab = _tab = (GEN*) realloc((char*) _tab,(++_taille)*sizeof(GEN));
	}
	else
	{
	    _ctab = _tab = (GEN*) malloc((++_taille)*sizeof(GEN));
	}

	if(_tab)
	{
#if defined(P4ElementClasse)
	    (void) new(_tab+_taille-1) GEN;
#else
	    memset(_tab+_taille-1,0,sizeof(GEN));
#endif
	    _tab[_taille-1] = temp;
	}
	else
	{
	    cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
	    _taille = 0;
	}

}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::AjouteClean(const GEN& ob)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	const GEN temp = ob;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc((_taille_allouee)*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille >= _taille_allouee)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+taille_buf_apres;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,(_taille_allouee)*sizeof(GEN));
	}

	if(TabGEN P4TABGEN_GEN::_tab)
	{
#if defined(P4ElementClasse)
	    (void) new(TabGEN P4TABGEN_GEN::_tab+TabGEN P4TABGEN_GEN::_taille) GEN;
#else
	    memset(TabGEN P4TABGEN_GEN::_tab+TabGEN P4TABGEN_GEN::_taille,0,sizeof(GEN));
#endif
	    TabGEN P4TABGEN_GEN::_tab[TabGEN P4TABGEN_GEN::_taille] = temp;
	    TabGEN P4TABGEN_GEN::_taille++;
	}
	else
	{
	    cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Ajoute(const TabGEN P4TABGEN_GEN& t,unsigned n)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	register const unsigned tai = min(n,unsigned(t));

	if(!tai) return;

	if(_tab)
	{
	    _ctab = _tab =
		(GEN*) realloc((char*) _tab,(_taille+tai)*sizeof(GEN));
	}
	else
	{
	    _ctab = _tab = (GEN*) malloc(tai*sizeof(GEN));
	}

	if(_tab)
	{
	    memcpy(_tab+_taille,t,tai*sizeof(GEN));
	    _taille = _taille+tai;
	}
	else
	{
	    cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
	    _taille = 0;
	}

}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Ajoute(const TabGEN P4TABGEN_GEN& t,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	register const unsigned tai = min(n,unsigned(t));

	if(!tai) return;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + tai + taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille+tai > _taille_allouee)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + tai + taille_buf_apres;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,_taille_allouee*sizeof(GEN));
	}

	if(TabGEN P4TABGEN_GEN::_tab)
	{
	    memcpy(TabGEN P4TABGEN_GEN::_tab+TabGEN P4TABGEN_GEN::_taille,t,tai*sizeof(GEN));
	    TabGEN P4TABGEN_GEN::_taille += tai;
	}
	else
	{
	    cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Ajoute(const TabGEN P4TABGEN_GEN& t)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	register const unsigned tai = t;

	if(!tai) return;

	if(_tab)
	{
	    _ctab = _tab =
		(GEN*) realloc((char*) _tab,(_taille+tai)*sizeof(GEN));
	}
	else
	{
	    _ctab = _tab = (GEN*) malloc(tai*sizeof(GEN));
	}

	if(_tab)
	{
	    memcpy(_tab+_taille,t,tai*sizeof(GEN));
	    _taille = _taille+tai;
	}
	else
	{
	    cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
	    _taille = 0;
	}

}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Ajoute(const TabGEN P4TABGEN_GEN& t)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	register const unsigned tai = t;

	if(!tai) return;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + tai + taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille+tai >= _taille_allouee)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + tai+ taille_buf_apres;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,_taille_allouee*sizeof(GEN));
	}

	if(TabGEN P4TABGEN_GEN::_tab)
	{
	    memcpy(TabGEN P4TABGEN_GEN::_tab+TabGEN P4TABGEN_GEN::_taille,t,tai*sizeof(GEN));
	    TabGEN P4TABGEN_GEN::_taille += tai;
	}
	else
	{
	    cerr << "Pb alloc " << __FILE__ << " ligne " << __LINE__ << endl;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Ajoute(const GEN* const t,unsigned n)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(!n) return;

	if(_tab)
	{
	    _ctab = _tab = (GEN*) realloc((char*) _tab,(_taille+n)*sizeof(GEN));
	}
	else
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}

	memcpy(_tab+_taille,t,n*sizeof(GEN));
	_taille += n;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Ajoute(const GEN* const t,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(!n) return;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc((_taille_allouee)*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille+n >= _taille_allouee)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+n+1;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = 
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,(_taille_allouee)*sizeof(GEN));
	}

	memcpy(TabGEN P4TABGEN_GEN::_tab+TabGEN P4TABGEN_GEN::_taille,t,n*sizeof(GEN));
	TabGEN P4TABGEN_GEN::_taille += n;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Ajoute(const GEN* const t,unsigned n,unsigned buf_taille)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(!n) return;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + n + buf_taille;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille+n > _taille_allouee)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + n + buf_taille;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,_taille_allouee*sizeof(GEN));
	}

	memcpy(TabGEN P4TABGEN_GEN::_tab+TabGEN P4TABGEN_GEN::_taille,t,n*sizeof(GEN));
	TabGEN P4TABGEN_GEN::_taille += n;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Ajoute(const GEN* RESTRICT const t,unsigned nx,
		unsigned ny,int dimx)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	register const unsigned nxy = nx*ny;

	if(!nxy) return;

	if(_tab)
	{
	    _ctab = _tab =
		(GEN*) realloc((char*) _tab,(_taille+nxy)*sizeof(GEN));
	}
	else
	{
	    _ctab = _tab = (GEN*) malloc(nxy*sizeof(GEN));
	}

	register const GEN* pt = t;
	register GEN* ptab = _tab + _taille;

	if(dimx == -1)
	{
	    register GEN* const ptabmxy = ptab + nxy;

	    for(register GEN* ptabm = ptab + nx;ptabm<=ptabmxy;ptabm+=nx,pt++)
	    {
		const GEN opt = *pt;

#if defined(CRAY) && !defined(_CRAYMPP)
		for(register unsigned i=0;i<nx;i++)
		{
		    ptab[i] = opt;
		}

		ptab += nx;
#else
		switch(nx%8)
		{
		  case 0 : while(ptab<ptabm)
		  {
		    *ptab++ = opt;
		  case 7:
		    *ptab++ = opt;
		  case 6:
		    *ptab++ = opt;
		  case 5:
		    *ptab++ = opt;
		  case 4:
		    *ptab++ = opt;
		  case 3:
		    *ptab++ = opt;
		  case 2:
		    *ptab++ = opt;
		  case 1:
		    *ptab++ = opt;
		  }

	        }
#endif

	    }

	}
	else
	{
	    register const size_t nxsize = nx*sizeof(GEN);
	    register GEN* const ptabm = ptab + nxy;

	    for(;ptab < ptabm;pt+=dimx,ptab+=nx)
	    {
		memcpy(ptab,pt,nxsize);
	    }

	}

	_taille += nxy;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Ajoute(const GEN* RESTRICT const t,unsigned nx,
		unsigned ny,int dimx)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	register const unsigned nxy = nx*ny;

	if(!nxy) return;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + nxy + taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc((_taille_allouee)*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille+nxy >= _taille_allouee)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille + nxy + taille_buf_apres;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,(_taille_allouee)*sizeof(GEN));
	}

	register const GEN* RESTRICT pt = t;
	register GEN* RESTRICT ptab = TabGEN P4TABGEN_GEN::_tab + TabGEN P4TABGEN_GEN::_taille;

	if(dimx == -1)
	{
	    register GEN* const ptabmxy = ptab + nxy;

	    for(register GEN* RESTRICT ptabm = ptab + nx;ptabm<=ptabmxy;
		ptabm+=nx,pt++)
	    {
		const GEN opt = *pt;

#if defined(CRAY) && !defined(_CRAYMPP)
		for(register int i=0;i<nx;i++)
		{
		    ptab[i] = opt;
		}

		ptab += nx;
#else
		switch(nx%8)
		{
		  case 0 : while(ptab<ptabm)
		  {
		    *ptab++ = opt;
		  case 7:
		    *ptab++ = opt;
		  case 6:
		    *ptab++ = opt;
		  case 5:
		    *ptab++ = opt;
		  case 4:
		    *ptab++ = opt;
		  case 3:
		    *ptab++ = opt;
		  case 2:
		    *ptab++ = opt;
		  case 1:
		    *ptab++ = opt;
		  }

	        }
#endif

	    }

	}
	else
	{
	    register const size_t nxsize = nx*sizeof(GEN);
	    register GEN* const ptabm = ptab + nxy;

	    for(;ptab < ptabm;pt+=dimx,ptab+=nx)
	    {
		memcpy(ptab,pt,nxsize);
	    }

	}

	TabGEN P4TABGEN_GEN::_taille += nxy;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Agrand(const GEN ob,unsigned n)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(!n) return;

	const GEN tempob = ob; // car ob peut etre un element du TabGEN !!!!

	if(_tab)
	{
	    _ctab = _tab = (GEN*) realloc((char*) _tab,(_taille+n)*sizeof(GEN));
	}
	else
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}

#if defined(CRAY) && !defined(_CRAYMPP)
	for(register unsigned i=0;i<n;i++)
	{
	    _tab[i+_taille] = tempob;
	}
#else
	register GEN* tabi = _tab + _taille;
	register const GEN* const tabim = tabi + n;

	switch(n%8)
	{
	  case 0 : do
	      {
		  *tabi++ = tempob;
		case 7:
		      *tabi++ = tempob;
		case 6:
		      *tabi++ = tempob;
		case 5:
		      *tabi++ = tempob;
		case 4:
		      *tabi++ = tempob;
		case 3:
		      *tabi++ = tempob;
		case 2:
		      *tabi++ = tempob;
		case 1:
		      *tabi++ = tempob;
	      } while(tabi < tabim);

	}
#endif

	_taille += n;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Agrand(const GEN ob,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(!n) return;

	const GEN tempob = ob; // car ob peut etre un element du TabGEN !!!!

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc((_taille_allouee)*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && TabGEN P4TABGEN_GEN::_taille+n > _taille_allouee)
	{
	    _taille_allouee = TabGEN P4TABGEN_GEN::_taille+n+taille_buf_apres;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab =
		(GEN*) realloc((char*) TabGEN P4TABGEN_GEN::_tab,_taille_allouee*sizeof(GEN));
	}

#if defined(CRAY) && !defined(_CRAYMPP)
	for(register unsigned i=0;i<n;i++)
	{
	    TabGEN P4TABGEN_GEN::_tab[i+_taille] = tempob;
	}
#else
	register GEN* tabi = TabGEN P4TABGEN_GEN::_tab + TabGEN P4TABGEN_GEN::_taille;
	register const GEN* const tabim = tabi + n;

	switch(n%8)
	{
	  case 0 : do
	      {
		  *tabi++ = tempob;
		case 7:
		      *tabi++ = tempob;
		case 6:
		      *tabi++ = tempob;
		case 5:
		      *tabi++ = tempob;
		case 4:
		      *tabi++ = tempob;
		case 3:
		      *tabi++ = tempob;
		case 2:
		      *tabi++ = tempob;
		case 1:
		      *tabi++ = tempob;
	      } while(tabi < tabim);

	}
#endif

	TabGEN P4TABGEN_GEN::_taille += n;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::ModTab(const GEN* const t,unsigned n)
{

	if(_type_alloc==P4UNKNOWN && (n != _taille || !_tab))
	{
	    _type_alloc = P4MALLOC;
	    _taille = 0;
	    _ctab = _tab = NULL;
	}

	if(!n)
	{

	    if(_tab && _type_alloc==P4MALLOC) free((char*) _tab);

	    _taille = 0;
	    _ctab = _tab = NULL;
	    return;
	}

	if(_tab && n != _taille)
	{
	    free((char*) _tab);
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}
	else if(!_tab && n>0)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}

	memcpy(_tab,t,n*sizeof(GEN));
	_taille = n;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::ModTab(const GEN* const t,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN && (n > _taille_allouee || !TabGEN P4TABGEN_GEN::_tab))
	{
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	}

	if(!n)
	{
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    return;
	}

	if(!TabGEN P4TABGEN_GEN::_tab && n>0)
	{
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && n > _taille_allouee)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    cerr << "Pb alloc " << __FILE__ << ' ' << __LINE__ << '\n';
	    cerr << "taille allouee " << _taille_allouee << endl;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	}
	else
	{
	    memcpy(TabGEN P4TABGEN_GEN::_tab,t,n*sizeof(GEN));
	    TabGEN P4TABGEN_GEN::_taille = n;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::ModTab(const TabGEN P4TABGEN_GEN& t,unsigned n)
{

	if(_type_alloc==P4UNKNOWN && (n != _taille || !_tab))
	{
	    _type_alloc = P4MALLOC;
	    _taille = 0;
	    _ctab = _tab = NULL;
	}

	if(!n)
	{

	    if(_tab && _type_alloc==P4MALLOC) free((char*) _tab);

	    _taille = 0;
	    _ctab = _tab = NULL;
	    return;
	}

	if(_tab && n != _taille)
	{
	    free((char*) _tab);
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}
	else if(!_tab && n>0)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}

	const unsigned nmin = min(n,unsigned(t));

	memcpy(_tab,t,nmin*sizeof(GEN));
	memset(_tab+nmin,0,(n-nmin)*sizeof(GEN));
	_taille = n;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::ModTab(const TabGEN P4TABGEN_GEN& t,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN && (n > _taille_allouee || !TabGEN P4TABGEN_GEN::_tab))
	{
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	}

	if(!n)
	{
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    return;
	}

	if(!TabGEN P4TABGEN_GEN::_tab && n>0)
	{
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && n > _taille_allouee)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}

	const unsigned nmin = min(n,unsigned(t));

	memcpy(TabGEN P4TABGEN_GEN::_tab,t,n*sizeof(GEN));
	memset(TabGEN P4TABGEN_GEN::_tab+nmin,0,(n-nmin)*sizeof(GEN));
	TabGEN P4TABGEN_GEN::_taille = n;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::ModTab(const TabGEN P4TABGEN_GEN& t)
{
	const unsigned n = t;

	if(_type_alloc==P4UNKNOWN && (n != _taille || !_tab))
	{
	    _type_alloc = P4MALLOC;
	    _taille = 0;
	    _ctab = _tab = NULL;
	}

	if(_tab && n != _taille)
	{
	    free((char*) _tab);
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}
	else if(!_tab && n>0)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}

	memcpy(_tab,t,n*sizeof(GEN));
	_taille = n;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::ModTab(const TabGEN P4TABGEN_GEN& t)
{
	const unsigned n = t;

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN && (n > _taille_allouee || !TabGEN P4TABGEN_GEN::_tab))
	{
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	}

	if(!TabGEN P4TABGEN_GEN::_tab && n>0)
	{
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && n > _taille_allouee)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    _taille_allouee = n+taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}

	memcpy(TabGEN P4TABGEN_GEN::_tab,t,n*sizeof(GEN));
	TabGEN P4TABGEN_GEN::_taille = n;
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::ModValn(unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN && (n > TabGEN P4TABGEN_GEN::_taille || !TabGEN P4TABGEN_GEN::_tab))
	{
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	}

	if(!n) return;

	if(TabGEN P4TABGEN_GEN::_tab && n>TabGEN P4TABGEN_GEN::_taille)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(n*sizeof(GEN));
	}
	else if(!TabGEN P4TABGEN_GEN::_tab && n>0)
	{
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(n*sizeof(GEN));
	}

	memset(TabGEN P4TABGEN_GEN::_tab,0,n*sizeof(GEN));
	TabGEN P4TABGEN_GEN::_taille = max(TabGEN P4TABGEN_GEN::_taille,n);
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::ModValn(unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN && (n > _taille_allouee || !TabGEN P4TABGEN_GEN::_tab))
	{
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	}

	if(!n) return;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = n + taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && n > _taille_allouee)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    _taille_allouee = n + taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}

	memset(TabGEN P4TABGEN_GEN::_tab,0,n*sizeof(GEN));
	TabGEN P4TABGEN_GEN::_taille = max(TabGEN P4TABGEN_GEN::_taille,n);
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::ModValn(const GEN ob,unsigned n)
{

	if(_type_alloc==P4UNKNOWN && (n > _taille || !_tab))
	{
	    _type_alloc = P4MALLOC;
	    _taille = 0;
	    _ctab = _tab = NULL;
	}

	if(!n) return;

	if(_tab && n>_taille)
	{
	    free((char*) _tab);
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}
	else if(!_tab && n>0)
	{
	    _ctab = _tab = (GEN*) malloc(n*sizeof(GEN));
	}

#if defined(CRAY) && !defined(_CRAYMPP)
	for(register unsigned i=0;i<n;i++)
	{
	    _tab[i] = ob;
	}
#else
	register GEN* tabi = _tab;
	register const GEN* const tabim = tabi + n;

	switch(n%8)
	{
	  case 0 : do
	      {
		  *tabi++ = ob;
		case 7:
		      *tabi++ = ob;
		case 6:
		      *tabi++ = ob;
		case 5:
		      *tabi++ = ob;
		case 4:
		      *tabi++ = ob;
		case 3:
		      *tabi++ = ob;
		case 2:
		      *tabi++ = ob;
		case 1:
		      *tabi++ = ob;
	      } while(tabi < tabim);

	}
#endif

	_taille = max(_taille,n);
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::ModValn(const GEN ob,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN && (n > _taille_allouee || !TabGEN P4TABGEN_GEN::_tab))
	{
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	}

	if(!n) return;

	if(!TabGEN P4TABGEN_GEN::_tab)
	{
	    _taille_allouee = n + taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}
	else if(TabGEN P4TABGEN_GEN::_tab && n > _taille_allouee)
	{
	    free((char*) TabGEN P4TABGEN_GEN::_tab);
	    _taille_allouee = n + taille_buf_init;
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = (GEN*) malloc(_taille_allouee*sizeof(GEN));
	}

#if defined(CRAY) && !defined(_CRAYMPP)
	for(register unsigned i=0;i<n;i++)
	{
	    TabGEN P4TABGEN_GEN::_tab[i] = ob;
	}
#else
	register GEN* tabi = TabGEN P4TABGEN_GEN::_tab;
	register const GEN* const tabim = tabi + n;

	switch(n%8)
	{
	  case 0 : do
	      {
		  *tabi++ = ob;
		case 7:
		      *tabi++ = ob;
		case 6:
		      *tabi++ = ob;
		case 5:
		      *tabi++ = ob;
		case 4:
		      *tabi++ = ob;
		case 3:
		      *tabi++ = ob;
		case 2:
		      *tabi++ = ob;
		case 1:
		      *tabi++ = ob;
	      } while(tabi < tabim);

	}
#endif

	TabGEN P4TABGEN_GEN::_taille = max(TabGEN P4TABGEN_GEN::_taille,n);
}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Enleve()
{

	if(_type_alloc==P4UNKNOWN)
	{
	    _ctab = _tab = NULL;
	    _taille = 0;
	    _type_alloc = P4MALLOC;
	}
	else
	{

	    if(_tab) free((char*) _tab);

	    _ctab = _tab = NULL;
	    _taille = 0;
	    _type_alloc = P4MALLOC;
	}

}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Enleve()
{
	TabGEN P4TABGEN_GEN::_taille = 0;
}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Vide()
{

	if(TabGEN P4TABGEN_GEN::_type_alloc==P4UNKNOWN)
	{
	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	}
	else
	{

	    if(TabGEN P4TABGEN_GEN::_tab) free((char*) TabGEN P4TABGEN_GEN::_tab);

	    TabGEN P4TABGEN_GEN::_ctab = TabGEN P4TABGEN_GEN::_tab = NULL;
	    TabGEN P4TABGEN_GEN::_taille = 0;
	    _taille_allouee = 0;
	    TabGEN P4TABGEN_GEN::_type_alloc = P4MALLOC;
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Enleve(unsigned i)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(i<_taille) 
	{
	    _taille--;

	    if(_taille)
	    {
		memmove(&_tab[i],&_tab[i+1],(_taille-i)*sizeof(GEN));
		_ctab = _tab = (GEN*) realloc((char*) _tab,_taille*sizeof(GEN));
	    }
	    else
	    {

		if(_tab) free((char*) _tab);

		_ctab = _tab = NULL;
		_taille = 0;
	    }

	}
	else
	{
	    cerr << "TabGEN> erreur : i n'est pas dans TabGEN" << endl;
	    exit(1);
	}

}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Enleve(unsigned i)
{

	if(TabGEN P4TABGEN_GEN::_tab && i<TabGEN P4TABGEN_GEN::_taille) 
	{
	    memmove(&TabGEN P4TABGEN_GEN::_tab[i],&TabGEN P4TABGEN_GEN::_tab[i+1],(--TabGEN P4TABGEN_GEN::_taille-i)*sizeof(GEN));
	}
	else
	{
	    cerr << "erreur : i n'est pas dans TabGEN\ni " <<
		i << "_taille " << TabGEN P4TABGEN_GEN::_taille << endl;
	    exit(1);
	}

}

P4TABGEN_TEMPLATE void
TabGEN P4TABGEN_GEN::Enleve(unsigned i,unsigned n)
{

	if(_type_alloc==P4UNKNOWN)
	{
	    cerr << P4Tabgen_resize_error << endl;
	    return;
	}

	if(i+n<=_taille) 
	{

	    if(_taille!=n)
	    {
		memmove(&_tab[i],&_tab[i+n],(_taille-i-n)*sizeof(GEN));
		_ctab = _tab =
		    (GEN*) realloc((char*) _tab,(_taille-n)*sizeof(GEN));
		_taille -= n;
	    }
	    else
	    {

		if(_tab) free((char*) _tab);

		_ctab = _tab = NULL;
		_taille = 0;
	    }

	}
	else
	{ 
	    cerr << "TabGEN> erreur : [i,i+n-1] pas dans TabGEN" << endl;
	    exit(1);
	}

}

P4TABGEN_TEMPLATE void
TabGENbuf P4TABGEN_GEN::Enleve(unsigned i,unsigned n)
{

	if(TabGEN P4TABGEN_GEN::_tab && i+n<=TabGEN P4TABGEN_GEN::_taille) 
	{
	    memmove(&TabGEN P4TABGEN_GEN::_tab[i],&TabGEN P4TABGEN_GEN::_tab[i+n],(TabGEN P4TABGEN_GEN::_taille-i-n)*sizeof(GEN));
	    TabGEN P4TABGEN_GEN::_taille -= n;
	}
	else
	{
	    cerr << "TabGENbuf> erreur : [i,i+n-1] pas dans TabGEN" << endl;
	    exit(1);
	}

}

P4TABGEN_TEMPLATE P4Boolean
TabGENbuf P4TABGEN_GEN::Compare(const TabGENbuf P4TABGEN_GEN& t) const
{
    // Comparaison des valeurs de 2 tableaux a une permutation d'indices pres
    // algorithme en n2 (bien pour petits tableaux !)

	register const unsigned tai = t;

	if(TabGEN P4TABGEN_GEN::_taille != tai) return FALSE;

	static P4Boolean* booleen = NULL;
	static unsigned tai_bool = 0;

	if(tai_bool<tai)
	{
	    delete[] booleen;

	    booleen = new P4Boolean[tai];
	    tai_bool = tai;
	}

	memset(booleen,1,tai*sizeof(P4Boolean));

	register const GEN* const ctab = t._ctab;

	for(register unsigned i=0;i<tai;i++)
	{
	    register unsigned j = 0;
	    register const GEN& ctabi = TabGEN P4TABGEN_GEN::_ctab[i];

	    for(;j<tai;j++)
	    {

#if defined(CRAY) && !defined(_CRAYMPP)
		if((ctab[j]==ctabi) * booleen[j]) // vectorise
#else
		if(ctab[j]==ctabi && booleen[j])
#endif
		{
		    booleen[j] = FALSE;
		    break;
		}

	    }

	    if(j>=tai) return FALSE;

	}

	return TRUE;
}

P4TABGEN_TEMPLATE P4Boolean
TabGEN P4TABGEN_GEN::Contient(const GEN& ob) const
{

	if(_taille)
	{

	    for(register unsigned i=0;i<_taille;i++)
	    {

		if(ob == _ctab[i]) return TRUE;

	    }

	}

	return FALSE;
}

#endif // fin P4TABGEN_MKDEP
