#ifndef P4GRAF0_H
#define P4GRAF0_H

// %W% %G% Pierre Brochard

#include "P4constant.h"
#include "minotaure/P4sanglier.h"

class Proj;class Sommet;class Boite;class Bool3;class Bool4;
class Tronc;class Declog;

class P4Graf0
{
    protected :

        P4Boolean  _ecriture;          // lie au break negs
        P4Boolean  _time;              // impression temps
        P4Boolean  _time_geom;         // impression temps
        Proj&    _projh;               // proj vraie entre 0 et 1
        Proj&    _proja;               // proj de base entre 0 et 1 
        Sommet&  _orig;                // centre boite
        Sommet&  _omin;                // min boite
        Sommet&  _omax;                // max boite
        Boite&   _boite;               // sommets boite
        Boite&   _boite_proj;          // sommets projetes boite
        Bool4&   _lxyz;                // logx,logy,logz,logc
        Bool3&   _lixyz;
        int      _modetrace;           // type de la projection 3d
        Tronc&   _tronc;               // troncature
        Declog&  _dl;                  // decades log si < 0
        Masque   _masq;                // type de masquage
        int      _karv_titre;          // taille carac titre
        int      _karv_echelle;        // taille carac echelle
        int      _icob,_icoh,_icolor;  // couleurs haut et bas et courante
        int      _isupv;
        REEL     _c1,_s1,_c2,_s2,_c3,_s3;
        P4Boolean  _boit,_nosoc,_nobas,_noba,_mail,_inseg;
        REEL     _ax,_ay,_az;
        REEL     _ccx,_ccy,_ccz;
        REEL     _xl,_yl,_zl;
        REEL     _zcotes,_re,_rey;
        REEL     _flr,_fl,_fnr,_fu,_fup,_fur;
        int      _init,_ncotes;
	REEL     _xcen,_ycen,_scalx,_scaly;

    public :

        P4Graf0();
        P4Graf0(const P4Graf0& g);
        ~P4Graf0();

        P4Boolean  P4LitEcriture() const {return _ecriture;};
        int      Icoh()  const {return _icoh;}
        int      Icob()  const {return _icob;}
        const Proj&    Projh() const {return _projh;};
        const Proj&    Proja() const {return _proja;};
        const Sommet&  Orig()  const {return _orig;};
        const Sommet&  Omin()  const {return _omin;};
        const Sommet&  Omax()  const {return _omax;};
        const Bool4&   Lxyz()  const {return _lxyz;};
        int      Isupv() const {return _isupv;};

        int  P4ReOuvreL3();
        void P4Ecriture(P4Boolean ecriture = TRUE);

        void P4Time(P4Boolean my_time = FALSE) {_time = my_time;};
        void P4TimeGeom(P4Boolean time_geom=FALSE) {_time_geom =
            time_geom;};
        void P4ModeTrace(int modetrace) {_modetrace = modetrace;};

        int P4Ptvue(REEL,REEL,REEL,REEL,REEL,REEL,
            REEL redrv=0.,REEL redrh=0.);
        int P4PtvueScxy(REEL,REEL,REEL,REEL,REEL,REEL,REEL,
             REEL redrv=0.,REEL redrh=0.);
        int P4PtvueScxyGen(REEL,REEL,REEL,REEL,REEL,REEL,REEL,REEL,
            REEL redrv=0.,REEL redrh=0.);

        void P4Datas();
        void P4Dcoin(REEL decalx=0.,REEL decaly=0.,REEL decalz=0.);
        void P4Dcoin2(REEL,REEL,REEL,REEL,REEL,REEL);
        void P4Defpa(int,int jcolor=-1);
        void P4Def2(int,int,REEL zarg1=Dep);
        void P4Dtron(int,int jy=Dep,int jz=Dep);

        void P4Dsp3(REEL& x1,REEL& y1t,REEL& x2,REEL& y2) 
            {L3DefSpaceLog(0,x1,y1t,x2,y2,FAUX,FAUX);};
        void P4DefSpace(REEL,REEL,REEL,REEL,REEL,REEL,
            int logx=ECH3DINC,int logy=ECH3DINC,int logz=ECH3DINC,
            P4Boolean sans_sauvegarde=FALSE);
        void P4Dnbdgr(REEL x2s1=7.,REEL y2s1=7.,REEL z2s1=7.,
            REEL c2s1=7.,REEL h2s1=7.);

        void P4Dcolo(int ico) {_icolor=ico;L3Couleur(max(0,ico));};

        void operator = (const P4Graf0& g);

        friend ostream& operator << (ostream& ost,const P4Graf0& p23) ;
};

inline void P4Graf0::P4Ecriture(P4Boolean ecriture)
{
	_ecriture = ecriture;
}

#endif // P4GRAF0_H
