#ifndef P4INT3_H
#define P4INT3_H

#include"P4constant.h"

class Int3 {

	protected :

	    int _i,_j,_k;

	public :

	    Int3(int i=0,int j=0,int k=0)
		{_i=i;_j=j;_k=k;};
	    Int3(const Int3& i3) {_i=i3._i;_j=i3._j;_k=i3._k;};
	    ~Int3()     {};

	    int I() const {return _i;};
	    int J() const {return _j;};
	    int K() const {return _k;};

	    void I(int i) {_i=i;};
	    void J(int j) {_j=j;};
	    void K(int k) {_k=k;};

	    void operator = (const Int3& i3) {_i=i3._i;_j=i3._j;_k=i3._k;};

	    friend ostream& operator << (ostream& ost,const Int3& i3) 
		{return ost << " Int3 = " << i3._i << " " << i3._j
			    << " " << i3._k << endl;};
};

class Int4 : public Int3 {

	private :

	    int _l;

	public :

	    Int4(int i=0,int j=0,int k=0,int l=0) : Int3(i,j,k) {_l=l;};
	    Int4(const Int4& i4) : Int3(i4) {_l=i4._l;};
	    ~Int4()     {};

	    int L() const {return _l;};

	    void L(int l) {_l=l;};

	    void operator = (const Int4& i4)
		{_i=i4._i;_j=i4._j;_k=i4._k;_l=i4._l;};

	    friend ostream& operator << (ostream& ost,const Int4& i4) 
		{return ost << " Int4 = " << i4._i << " " << i4._j
			    << " " << i4._k << " " << i4._l << endl;};
};

#endif
