#ifndef P4MAILLENS3F_H
#define P4MAILLENS3F_H

// %W% %G% Pierre Brochard

#include "P4mailleqcq.h"

class MailleNS3f : public MailleQcq
{
    private:

    // -----------------------------------------------------
    //   par convention avec les codes non structures on
    //   commence ici les numeros de mailles a 1 
    // -----------------------------------------------------

	Tabint _mailles;
	unsigned _nsommets;
	Tabunsigned _sommets;

    public:

	MailleNS3f() : MailleQcq(),_nsommets(0) {};
	MailleNS3f(int nmailles,const Tabint& mailles) :
			MailleQcq(nmailles),_nsommets(0)
	{
		_mailles.Lier(mailles);
	}
	MailleNS3f(const int nmailles,const int mailles[][3]) :
			MailleQcq(nmailles),_nsommets(0)
	{
		_mailles.Lier((const int*) mailles,nmailles*3);
	}
	MailleNS3f(const MailleNS3f& m) : MailleQcq(m),_nsommets(0)
	{
		_mailles.Lier(m._mailles);
	}

	void VideMailles();

	int DonneSommets(Tabunsignedbuf& t,unsigned numaille) const;
	int DonneMaillesSommet(Tabunsignedbuf&,unsigned);

	int LitTraceFil(const unsigned,const unsigned) const
	{return TRACE_FIL_OUI;};
	int LitTraceFil(Tabcharbuf& t,unsigned numaille) const;

	MailleQcq* NewCopy() const {return new MailleNS3f;};

	void operator = (const MailleQcq& m)
	{
		_mailles.Lier(((const MailleNS3f&) m)._mailles);
		_nmailles = ((const MailleNS3f&) m)._nmailles;
		_nsommets = 0;
		_sommets.Enleve();
	}

};

#endif
