#ifndef P4MAILLENSF_H
#define P4MAILLENSF_H

// %W% %G% Pierre Brochard

#include "P4mailleqcq.h"

// class du meme type que MailleNS sauf que les sommets sont numerotes
// en commencant a 1 au lieu de 0 et
// que mailles est un Tabint au lie d'un Tabunsigned

class MailleNSf : public MailleQcq
{
    private:

	Tabint _mailles;
	unsigned _nsommets;
	Tabunsigned _sommets;

    public:

	MailleNSf() : MailleQcq(),_nsommets(0) {}
	MailleNSf(int nmailles,Tabint& mailles) :
			MailleQcq(nmailles),_nsommets(0)
	{
		_mailles.Lier(mailles);
	}
	MailleNSf(int nmailles,int mailles[],const int dimmailles) :
			MailleQcq(nmailles),_nsommets(0)
	{
		_mailles.Lier(mailles,dimmailles);
	}
	MailleNSf(int nmailles,const int mailles[],const int dimmailles) :
			MailleQcq(nmailles),_nsommets(0)
	{
		_mailles.Lier(mailles,dimmailles);
	}
	MailleNSf(const MailleNSf& m) : MailleQcq(m._nmailles),_nsommets(0)
	{
		_mailles.Lier(m._mailles);
	}

	void VideMailles();

	int DonneSommets(Tabunsignedbuf& t,unsigned numaille) const;
	int DonneMaillesSommet(Tabunsignedbuf&,unsigned);

	int  LitTraceFil(const unsigned,const unsigned) const
	{
		return TRACE_FIL_OUI;
	}
	int  LitTraceFil(Tabcharbuf& t,unsigned numaille) const;

	MailleQcq* NewCopy() const {return new MailleNSf;}

	void operator  = (const MailleQcq&  m)
	{
		_mailles.Lier(((const MailleNSf&) m)._mailles);
		_nmailles = ((const MailleNSf&) m)._nmailles;
		_nsommets = 0;
		_sommets.Enleve();
	}

};

#endif
