#ifndef P4MAILLEST4_H
#define P4MAILLEST4_H

// %W% %G% P. Brochard

#include "P4mailleqcq.h"

class MailleSt4 : public MailleQcq
{
    protected:

	unsigned _nx;

    public:

        MailleSt4() : MailleQcq(),_nx(0) {};
        MailleSt4(unsigned nmailles,unsigned nx) :
			MailleQcq(nmailles),_nx(nx) {};
        MailleSt4(MailleSt4& m) : MailleQcq(m),_nx(m._nx) {};

        const char* TypeMailles() const {return "MailleSt4";};

        void VideMailles() {_nmailles=0;_nx=0;};

        int DonneSommets(Tabunsignedbuf& t,unsigned numaille) const;
	int DonneMaillesSommet(Tabunsignedbuf&,unsigned);

        int  LitTraceFil(const unsigned,const unsigned) const
	{return TRACE_FIL_OUI;};
        int  LitTraceFil(Tabcharbuf& t,unsigned numaille) const;

        MailleQcq* NewCopy() const {return new MailleSt4;};

        void operator  = (const MailleQcq& m)
	{
		_nx=((const MailleSt4&) m)._nx;
		_nmailles=((const MailleSt4&) m)._nmailles;
	}

};

#endif
