#ifndef P4MINOS_H
#define P4MINOS_H

/* fichier include pour le binding C ANSI */

#include"P4constant.h"

#ifdef __cplusplus
extern "C" {
#endif

/* points d'entrees de P4graf0 */

void P4Time(enum P4Boolean time);
void P4TimeGeom(enum P4Boolean time_geom);
void P4ModeTrace(int modetrace);

int P4Ptvue(REEL site,REEL azimu,REEL dista,REEL xcen,
		REEL ycen,REEL scalxy,REEL redrv,REEL redrh);
int P4PtvueScxy(REEL site,REEL azimu,REEL dista,REEL xcen,REEL ycen,
		REEL scalx,REEL scaly,REEL redrv,REEL redrh);
int P4PtvueScxyGen(REEL site,REEL azimu,REEL angpl,REEL dista,
		REEL xcen,REEL ycen,REEL scalx,REEL scaly,
		REEL redrv,REEL redrh);

void P4Datas();
void P4Dcoin(REEL decalx,REEL decaly,REEL decalz);
void P4Dcoin2(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2);
void P4Defpa(int ibas,int jcolor);
void P4Def2(int masque,int icotes,REEL zarg1);
void P4Dtron(int jx,int jy,int jz);

void P4Dsp3(REEL x1,REEL y1,REEL x2,REEL y2);
void P4DefSpace(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2,
		int logx,int logy,int logz,
		enum P4Boolean sans_sauvegarde);
void P4Dnbdgr(REEL x2s1,REEL y2s1,REEL z2s1,REEL c2s1,REEL h2s1);

void P4Dcolo(int ico);

/* points d'entree de P4graf1 */

int P4CorrigeVecteur(REEL* px1,REEL* py1,REEL* pz1,REEL* px2,REEL* py2,
		REEL* pz2);

int  P4Vecteur(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2);
int  P4VecteurColor(REEL x1,REEL y1,REEL z1,REEL x2,REEL y2,REEL z2,
		int c) ;
int  P4VecteurColorBis(REEL x1,REEL y1,REEL z1,REEL c1,REEL x2,REEL y2,
		REEL z2,REEL c2) ;

void P4ChoixHauteurs(const enum Opt34d cz);

int P4InitHauteurs(REEL hauteurs[],int couleurs[],
		unsigned nbrehauteurs,enum Opt34d cz,
		const enum P4Boolean logh) ;
#ifndef REQRS
int P4InitHauteursBis(REEL_S hauteurs[],int couleurs[],
		unsigned nbrehauteurs,enum Opt34d cz,
		const enum P4Boolean logh) ;
#endif
int P4InitHauteursTer(REEL_S hauteurs[],unsigned nbrehauteurs,
		enum Opt34d cz,unsigned couleurmin,
		unsigned couleurmax,const enum P4Boolean logh) ;
int P4InitHauteursQua(REEL hmin,REEL hmax,REEL_S z[],int nx,int ny,
		int nz,enum Opt34d cz,unsigned nbrehauteurs,
		enum P4Boolean modlog,unsigned couleurmin,
		unsigned couleurmax);

int P4CalcHauteurs(REEL_S hauteurs[],const int nbrehauteurs,
		const REEL_S hmin,const REEL_S hmax,const REEL_S z[],
		const int nx,const int ny,const int nz,
		const enum P4Boolean modlog);

int P4LigneBrisee(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int npoints,int pas) ;
int P4LigneBriseeBis(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int npoints,int pas) ;

int P4LigneFermee(REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int npoints,const unsigned char* tf) ;
int P4LigneFermeeBis(REEL_S x[],REEL_S y[],REEL_S z[],int npoints) ;
int P4LigneFermeeTer(REEL_S x[],REEL_S y[],REEL_S z[],
		int npoints,const unsigned char* tf) ;

int P4Polygone(REEL_S x[],REEL_S y[],REEL_S z[],
		int npoints) ;
int P4PolygoneBis(REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],
		int npoints) ;

/* points d'entres de P4graf2 */

void P4ChercheMaillesInit(const enum P4Boolean cherche_mailles);

void P4DefEchelles(const REEL xmin,const REEL ymin,
		const REEL zmin,const REEL cmin,const REEL xmax,
		const REEL ymax,const REEL zmax,const REEL cmax,
		const int logx,const int logy,
		const int logz,const int logc);
void P4LitEchelles(REEL* pxmin,REEL* pymin,REEL* pzmin,
		REEL* pcmin,REEL* pxmax,REEL* pymax,REEL* pzmax,
		REEL* pcmax,int* plogx,int* plogy,int* plogz,int* plogc);

int P4LigneBriseeTer(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int npoints,
		enum P4Boolean trace_lent,int nombre_cesures) ;
int P4LigneBriseeQua(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int npoints,enum P4Boolean trace_lent,
		int nombre_cesures) ;
int P4PolygoneTer(REEL_S x[],REEL_S y[],REEL_S z[],int npoints);

void P4Init34d(enum Opt34d fil,enum Opt34d fac,enum Opt34d niv,enum Opt34d lis);

int P4Filaire(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int dimx,int dimy,int dimz,int dimc,
		int nx,int ny);
int P4FilaireBis(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int dimx,int dimy,int dimz,int dimc,
		int nx,int ny,unsigned mailles[],unsigned nmailles,
		int dimmailles,enum Fil opt_fil);
int P4Lissage(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int dimx,int dimy,int dimz,int dimc,
		int nx,int ny,unsigned mailles[],unsigned nmailles,
		int dimmailles,enum Lisse opt_lisse);

void P4TraceGrilles();
void P4AnnuleGrilles();

void P4DefCaracGrille(int taille_caract_titres,
		int taille_caract_echelles) ;

void P4AnnuleGrillesSimple();
void P4NouvelleGrilleSimple();
void P4DefTitreSimple(char* titre_axe_bas,char* titre_axe_haut,
		char* titre_axe_droite,char* titre_axe_gauche,
		char* unite_axe_bas,char* unite_axe_haut,
		char* unite_axe_droite,char* unite_axe_gauche) ;
void P4DefGrilleSimple(enum Face face,REEL decalx,
		enum P4Boolean texte_horizontal,int grad_axex,int grad_axey,
		int* type_axe,enum P4Boolean* label_axe,
		int* grad_inter_axe, int* factorisation_axe) ;

void P4AnnuleGrillesAuto();
void P4NouvelleGrilleAuto();
void P4DefTitreAuto(char* titre_x,char* titre_y,
		char* titre_z,char* unite_x,char* unite_y,
		char* unite_z) ;
void P4DefGrilleAuto(REEL decalx,REEL decaly,REEL decalz,
		enum P4Boolean texte_horizontal,int grad_axex,int grad_axey,
		int grad_axez,int type_grilles,
		int* grad_inter) ;

#ifdef __cplusplus
}
#endif

#endif
