#ifndef P4MINOSF_H
#define P4MINOSF_H

/* fichier include pour le binding fortran */

#include"P4constant.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifdef CRAY
typedef float REEL_F; 
#else
typedef float REEL_F;
#endif

/* points d'entrees de P4graf0 */

#ifdef CRAY
void P4INIT();    /*   appel obligatoire avant tout appel a minotaure */
void P4TIME(const P4Boolean& time);
void P4TIMEG(const P4Boolean& time_geom);
#else
void p4init_();   /*   appel obligatoire avant tout appel a minotaure */
void p4time_(const P4Boolean& time);
void p4timeg_(const P4Boolean& time_geom);
#endif

void p4modtra_(const int& modetrace);

int p4ptvue_(REEL_F& site,REEL_F& azimu,REEL_F& dista,REEL_F& xcen,
			REEL_F& ycen,REEL_F& scalxy,REEL_F& redrv,
			REEL_F& redrh);
int p4ptvus_(REEL_F& site,REEL_F& azimu,REEL_F& dista,REEL_F& xcen,
			REEL_F& ycen,REEL_F& scalx,REEL_F& scaly,
			REEL_F& redrv,REEL_F& redrh);
int p4ptvsg_(REEL_F& site,REEL_F& azimu,REEL_F& angpl,REEL_F& dista,
			REEL_F& xcen,REEL_F& ycen,REEL_F& scalx,REEL_F& scaly,
			REEL_F& redrv,REEL_F& redrh);

void p4datas_();

void p4dcoins_(const REEL_F& decalx,const REEL_F& decaly,const REEL_F& decalz);
void p4dcoins2_(REEL_F& x1,REEL_F& y1,REEL_F& z1,REEL_F& x2,REEL_F& y2,
		REEL_F& z2);

void p4defpa_(const int& ibas,const int& jcolor);
void p4def2_(const int& masque,const int& icotes,const REEL_F& zarg1);

void p4dtron_(const int& jx,const int& jy,const int& jz);

void p4dsp3_(REEL_F& x1,REEL_F& y1,REEL_F& x2,REEL_F& y2) ;

void p4dspace_(REEL_F& x1,REEL_F& y1,REEL_F& z1,REEL_F& x2,REEL_F& y2,
		REEL_F& z2,int& logx,int& logy,int& logz,
		P4Boolean& sans_sauvegarde);

void p4dnbdgr_(REEL_F& x2s1,REEL_F& y2s1,REEL_F& z2s1,REEL_F& c2s1,
		REEL_F& h2s1);

void p4dcolo_(const int& ico);

// points d'entree de P4graf1

int p4corrv_(REEL_F& x1,REEL_F& y1,REEL_F& z1,REEL_F& x2,REEL_F& y2,REEL_F& z2);

int  p4vect_(REEL_F& x1,REEL_F& y1,REEL_F& z1,REEL_F& x2,REEL_F& y2,REEL_F& z2);
int  p4vectc_(REEL_F& x1,REEL_F& y1,REEL_F& z1,REEL_F& x2,REEL_F& y2,
		REEL_F& z2,int& c);
int  p4vectcb_(REEL_F& x1,REEL_F& y1,REEL_F& z1,REEL_F& c1,REEL_F& x2,
		REEL_F& y2,REEL_F& z2,REEL_F& c2);

void p4chhau_(const Opt34d& cz);

int p4inith_(REEL hauteurs[],int couleurs[],
		int& nbrehauteurs,Opt34d& cz,const P4Boolean& logh);
#ifndef REQRS
int p4inithb_(REEL_S hauteurs[],int couleurs[],
		int& nbrehauteurs,Opt34d& cz,const P4Boolean& logh);
#endif
int p4inithc_(REEL_S hauteurs[],int& nbrehauteurs,Opt34d& cz,
		int& couleurmin,int& couleurmax,const P4Boolean& logh);
int p4inithd_(REEL_F& hmin,REEL_F& hmax,REEL_S z[],int& nx,int& ny,
		int& nz,Opt34d& cz,int& nbrehauteurs,
		P4Boolean& modlog,int& couleurmin,int& couleurmax);

int p4calch_(REEL_S hauteurs[],const int& nbrehauteurs,
		const REEL_S& hmin,const REEL_S& hmax,const REEL_S z[],
		const int& nx,const int& ny,const int& nz,
		const P4Boolean& modlog);

int p4ligbr_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int& npoints,int& pas);
int p4ligbrb_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int& npoints,int& pas);

int p4ligfe_(REEL_S x[],REEL_S y[],REEL_S z[],
		REEL_S c[],int& npoints,const unsigned char* tf);
int p4ligfeb_(REEL_S x[],REEL_S y[],REEL_S z[],int& npoints);
int p4ligfec_(REEL_S x[],REEL_S y[],REEL_S z[],
		int& npoints,const unsigned char* tf);

int p4polyg_(REEL_S x[],REEL_S y[],REEL_S z[],int& npoints) ;
int p4polygb_(REEL_S x[],REEL_S y[],REEL_S z[],REEL_S c[],int& npoints);

// points d'entres de P4graf2

void p4chmain_(const P4Boolean& cherche_mailles);

void p4defec_(const REEL_F& xmin,const REEL_F& ymin,
		const REEL_F& zmin,const REEL_F& cmin,const REEL_F& xmax,
		const REEL_F& ymax,const REEL_F& zmax,const REEL_F& cmax,
		const int& logx,const int& logy,
		const int& logz,const int& logc);

void p4litec_(REEL_F& xmin,REEL_F& ymin,REEL_F& zmin,REEL_F& cmin,REEL_F& xmax,
		REEL_F& ymax,REEL_F& zmax,REEL_F& cmax,int& logx,int& logy,
		int& logz,int& logc);

int p4ligbrc_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],const REEL_S c[],int& npoints,
		P4Boolean& trace_lent,int& nombre_cesures);
int p4ligbrd_(const REEL_S x[],const REEL_S y[],
		const REEL_S z[],int& npoints,P4Boolean& trace_lent,
		int& nombre_cesures);

int p4polygc_(REEL_S x[],REEL_S y[],REEL_S z[],int& npoints);

void p4in34d_(const Opt34d& fil,const Opt34d& fac,const Opt34d& niv,
		const Opt34d& lis);

int p4fil_(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int& dimx,int& dimy,int& dimz,int& dimc,
		int& nx,int& ny);
int p4filb_(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int& dimx,int& dimy,int& dimz,int& dimc,
		int& nx,int& ny,int mailles[],int& nmailles,
		int& dimmailles,Fil& opt_fil);
int p4filc_(const int& nbrnoeuds,const int& nbrmailles,
		const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],const int mailles[][3],const Fil& opt_fil);

int p4lis_(const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],int& dimx,int& dimy,int& dimz,int& dimc,
		int& nx,int& ny,int mailles[],int& nmailles,
		int& dimmailles,Lisse& opt_lisse);
int p4lisb_(const int& nbrnoeuds,const int& nbrmailles,
		const REEL_S x[],const REEL_S y[],const REEL_S z[],
		const REEL_S c[],const int mailles[][3],const Lisse& opt_lisse);

	/* gestion des grilles */

void p4tragr_();   /* trace des grilles empilees */

void p4delgr_();   /* on vide les piles des grilles simples et autos */

void p4defcg_(int& taille_caract_titres,int& taille_caract_echelles);
	/* definition des tailles de caracteres titres et echelles
	   recuperee par les p4defgr*_ suivants */

void p4delgrs_();  /* on vide la pile des grilles simples */

void p4newgrs_();  /* on empile une nouvelle grille simple dont les parametres
		      seront precises avec p4defts_ et p4defgrs_ */

void p4defts_(char* titre_axe_bas,char* titre_axe_haut,
		char* titre_axe_droite,char* titre_axe_gauche,
		char* unite_axe_bas,char* unite_axe_haut,
		char* unite_axe_droite,char* unite_axe_gauche);
	/* definitions des parametres de titre de grille simple
	   pour la derniere grille empilee */

void p4defgrs_(Face& face,REEL_F& decalx,
		P4Boolean& texte_horizontal,int& grad_axex,int& grad_axey,
		int* type_axe,P4Boolean* label_axe,
		int* grad_inter_axe, int* factorisation_axe);
	/* definitions des parametres de grille simple
	   pour la derniere grille empilee */

void p4delgra_();  /* idem pour les grilles auto que les grilles simples */

void p4newgra_();

void p4defta_(char* titre_x,char* titre_y,
		char* titre_z,char* unite_x,char* unite_y,
		char* unite_z);

void p4defgra_(REEL_F& decalx,REEL_F& decaly,REEL_F& decalz,
		P4Boolean& texte_horizontal,int& grad_axex,int& grad_axey,
		int& grad_axez,int& type_grilles,
		int* grad_inter);

	/* fin trace des grilles */

#ifdef __cplusplus
}
#endif

#endif
