#ifndef P4TRONC_H
#define P4TRONC_H

#include"P4constant.h"

class Tronc {
	private :
	    int     _jx,_jy,_jz; 
	    P4Boolean _notron;
	    P4Boolean _fulltron;

	public :
	    Tronc(int jx=TRONC3D_NOTRONC,int jy=TRONC3D_NOTRONC,
		int jz=TRONC3D_NOTRONC,P4Boolean notron=TRUE,
		P4Boolean fulltron=FALSE)
		{_jx=jx;_jy=jy;_jz=jz;_notron=notron;_fulltron=fulltron;};
	    Tronc(const Tronc& t)
		{_jx=t._jx;_jy=t._jy;_jz=t._jz;
		_notron=t._notron;_fulltron=t._fulltron;};
	    ~Tronc()     {};

	    int     Jx()       const {return _jx;};
	    int     Jy()       const {return _jy;};
	    int     Jz()       const {return _jz;};
	    P4Boolean Notron()   const {return _notron;};
	    P4Boolean Fulltron() const {return _fulltron;};

	    void Jx(int jx) {_jx=jx;};
	    void Jy(int jy) {_jy=jy;};
	    void Jz(int jz) {_jz=jz;};
	    void Notron(P4Boolean notron) {_notron=notron;};
	    void Notron(int notron)     {_notron=(P4Boolean) notron;};
	    void Fulltron(P4Boolean fulltron) {_fulltron=fulltron;};
	    void Fulltron(int fulltron)     {_fulltron=(P4Boolean) fulltron;};

	    void Tron(int jx,int jy,int jz,P4Boolean notron,P4Boolean fulltron)
		{_jx=jx;_jy=jy;_jz=jz;_notron=notron;_fulltron=fulltron;};

	    void operator = (const Tronc& t) {_jx=t._jx;_jy=t._jy;_jz=t._jz;
		_notron=t._notron;_fulltron=t._fulltron;};

	    friend ostream& operator << (ostream& ost,Tronc tron) 
		{return ost << " Tronc = " << tron._jx << " " << tron._jy
			    << " " << tron._jz << " " << tron._notron
			    << " " << tron._fulltron << endl;};
};

#endif


