#ifndef S6BOUTTONS10_H
#define S6BOUTTONS10_H

// %W% %G% Pierre Brochard
// definitions des classes de bouttons

// *************************************************************
// sous-menu destinations drivers...............................
// *************************************************************

class DestNegs : public BoutonDeChoix
{   	
    public:
   
	DestNegs(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestNegs() {};
      
	void SelectCB(XtPointer call_data);
};

class DestT4014 : public BoutonDeChoix
{   	
    public:
   
	DestT4014(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestT4014() {};
      
	void SelectCB(XtPointer call_data);
};

class DestVisu : public BoutonDeChoix
{   	
    public:
   
	DestVisu(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestVisu() {};
      
	void SelectCB(XtPointer call_data);
};

class DestPost : public BoutonDeChoix
{   	
    public:
   
	DestPost(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestPost() {};
      
	void SelectCB(XtPointer call_data);
};

class DestPostCoul : public BoutonDeChoix
{   	
    public:
   
	DestPostCoul(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestPostCoul() {};
      
	void SelectCB(XtPointer call_data);
};

class DestPostCoulFich : public BoutonDeChoix
{   	
    public:
   
	DestPostCoulFich(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestPostCoulFich() {};
      
	void SelectCB(XtPointer call_data);
};

class DestPostscript : public BoutonDeChoix
{   	
    public:
   
	DestPostscript(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestPostscript() {};
      
	void SelectCB(XtPointer call_data);
};

class DestGif : public BoutonDeChoix
{   	
    public:
   
	DestGif(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestGif() {};
      
	void SelectCB(XtPointer call_data);
};

class DestPng : public BoutonDeChoix
{   	
    public:
   
	DestPng(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestPng() {};
      
	void SelectCB(XtPointer call_data);
};

class DestLwc : public BoutonDeChoix
{   	
    public:
   
	DestLwc(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestLwc() {};
      
	void SelectCB(XtPointer call_data);
};

class DestLwct : public BoutonDeChoix
{   	
    public:
   
	DestLwct(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestLwct() {};
      
	void SelectCB(XtPointer call_data);
};

class DestPgml : public BoutonDeChoix
{   	
    public:
   
	DestPgml(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestPgml() {};
      
	void SelectCB(XtPointer call_data);
};

class DestSvg : public BoutonDeChoix
{   	
    public:
   
	DestSvg(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestSvg() {};
      
	void SelectCB(XtPointer call_data);
};

class DestXfig : public BoutonDeChoix
{   	
    public:
   
	DestXfig(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestXfig() {};
      
	void SelectCB(XtPointer call_data);
};

class DestX11 : public BoutonDeChoix
{   	
    public:
   
	DestX11(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~DestX11() {};
      
	void SelectCB(XtPointer call_data);
};

class DestDriver;

#ifdef GPHIGS
class DestPhigs : public BoutonDeChoix
{
    private :

	DestDriver* _pto;
	
    public :
   
	DestPhigs(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestPhigs() {};

	void Attach(DestDriver* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

class DestPhigsx11 : public BoutonDeChoix
{
    private :

	DestDriver* _pto;
	
    public:
   
	DestPhigsx11(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestPhigsx11() {};

	void Attach(DestDriver* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

class DestPhigscgm : public BoutonDeChoix
{
    private :

	DestDriver* _pto;

    public:
   
	DestPhigscgm(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestPhigscgm() {};

	void Attach(DestDriver* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

class DestPhigsps : public BoutonDeChoix
{
    private :

	DestDriver* _pto;

    public:
   
	DestPhigsps(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestPhigsps() {};

	void Attach(DestDriver* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

class DestPhigspsc : public BoutonDeChoix
{
    private :

	DestDriver* _pto;

    public:
   
	DestPhigspsc(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestPhigspsc() {};

	void Attach(DestDriver* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};

class DestPhigsrle : public BoutonDeChoix
{
    private :

	DestDriver* _pto;

    public:
   
	DestPhigsrle(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestPhigsrle() {};

	void Attach(DestDriver* pto) {_pto = pto;};
	void SelectCB(XtPointer call_data);
};
#endif

#ifdef GL
class DestGl : public BoutonDeChoix
{
    private :

	DestDriver* _pto;

    public:
   
	DestGl(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestGl() {};

	void Attach(DestDriver* pto) {_pto = pto;};   
	void SelectCB(XtPointer call_data);
};
#endif

#ifdef XGL
class DestXgl : public BoutonDeChoix
{
    private :

	DestDriver* _pto;

    public:
   
	DestXgl(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {_pto = NULL;};
	~DestXgl() {};

	void Attach(DestDriver* pto) {_pto = pto;};   
	void SelectCB(XtPointer call_data);
};
#endif

class DestDriver : public PullDownSubMenuExclusif
{
    private :

	DestNegs		_negs;
	DestT4014		_t4014;
	DestVisu		_visu;
	DestPost		_post;
	DestPostCoul		_postcoul;
	DestPostCoulFich	_postcoulfich;
	DestPostscript   	_postscript;
	DestLwc			_lwc;
	DestLwct		_lwct;
	DestPgml		_pgml;
	DestSvg		        _svg;
	DestXfig		_xfig;
	DestGif                 _gif;
	DestPng                 _png;
#ifdef GPHIGS
	DestPhigs		_phigs;
	DestPhigsx11		_phigsx11;
	DestPhigscgm		_phigscgm;
	DestPhigsps		_phigsps;
	DestPhigspsc		_phigspsc;
	DestPhigsrle		_phigsrle;
#endif
#ifdef GL
	DestGl			_gl;
#endif
#ifdef XGL
	DestXgl			_xgl;
#endif
	DestX11			_x11;

    public :

	DestDriver(const Widget& parent,const char *label);
	~DestDriver() {};

	void Change(char*& choix);
};

// ***************************************************************
// Pour calcul de coordonnees a partir de l'afficheur X11
// ***************************************************************

class U8CoordPsyche : public U8Coord
{
    public:

	U8CoordPsyche() {};
	~U8CoordPsyche() {};

	void Action(REEL,REEL);
};

// ***************************************************************
// Pour mode pixmap a partir de et pour l'afficheur X11
// ***************************************************************

class U8PixmapPsyche : public U8Pixmap
{
    public:

	U8PixmapPsyche() {};
	~U8PixmapPsyche() {};

	void Action(P4Boolean);
};

// ***************************************************************
// Pour calcul de zoom agrandissement a partir de l'afficheur X11
// ***************************************************************

class U8AgrandPsyche : public U8Agrand
{
    public:

	U8AgrandPsyche() {};
	~U8AgrandPsyche() {};

	void Action();
};

// ***************************************************************
// Pour calcul de zoom reduction a partir de l'afficheur X11
// ***************************************************************

class U8ReducPsyche : public U8Reduc
{
    public:

	U8ReducPsyche() {};
	~U8ReducPsyche() {};

	void Action();
};

// ***************************************************************
// Pour calcul d'annulation de zoom a partir de l'afficheur X11
// ***************************************************************

class U8UnzoomPsyche : public U8Unzoom
{
    public:

	U8UnzoomPsyche() {};
	~U8UnzoomPsyche() {};

	void Action();
};

// ***************************************************************
// Pour calcul image a partir de l'afficheur X11
// ***************************************************************

class U8CalcImagePsyche : public U8CalcImage
{
    public:

	U8CalcImagePsyche() {};
	~U8CalcImagePsyche() {};

	void Action();
};

// ***************************************************************
// Pour calcul image L3 a partir de l'afficheur X11
// ***************************************************************

class U8CalcImageL3Psyche : public U8CalcImageL3
{
    public:

	U8CalcImageL3Psyche() {};
	~U8CalcImageL3Psyche() {};

	void Action();
};

// ********************************************************
//           Options 3d Panneau
// ********************************************************

class Coupes3dPanel;

class Coupes3dPanelChoix : public BoutonDeChoix
{
    protected :

	Coupes3dPanel* _pto;

    public :

	Coupes3dPanelChoix(const Widget& parent, const char *label,
		Coupes3dPanel* pto=NULL) :
		BoutonDeChoix(parent,label) {_pto=pto;};
	~Coupes3dPanelChoix() {};

	void Attach(Coupes3dPanel* pto) {_pto=pto;};
};

class Coupes3dPanelChoixCoNon : public Coupes3dPanelChoix
{   	
    public:
   
	Coupes3dPanelChoixCoNon(const Widget& parent, const char *label,
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelChoix(parent,label,pto) {};
	~Coupes3dPanelChoixCoNon() {};
      
	void SelectCB(XtPointer call_data);
};

class Coupes3dPanelChoixCoOui : public Coupes3dPanelChoix
{   	
    public:
   
	Coupes3dPanelChoixCoOui(const Widget& parent, const char *label,
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelChoix(parent,label,pto) {};
	~Coupes3dPanelChoixCoOui() {};
      
	void SelectCB(XtPointer call_data);
};

class Coupes3dPanelSX : public Saisie
{
    protected:

	Coupes3dPanel* _pto;

    public:

	Coupes3dPanelSX(const Widget& parent, const char* label,
			short int taille = 20,const char* classe = "TXT",
			Coupes3dPanel* pto=NULL) :
			Saisie(parent,label,taille,classe) {_pto=pto;};
	~Coupes3dPanelSX() {};

	void Attach(Coupes3dPanel* pto) {_pto=pto;};
};

struct Coupes3dPanelSA : public Coupes3dPanelSX
{
	Coupes3dPanelSA(const Widget& parent,const char* label,
			short int taille = 20,
			const char* classe="Coupes3dPanelSA",
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelSX(parent,label,taille,classe,pto) {};
	~Coupes3dPanelSA() {};
      
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelSB : public Coupes3dPanelSX
{
	Coupes3dPanelSB(const Widget& parent,const char* label,
			short int taille = 20,
			const char* classe="Coupes3dPanelSB",
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelSX(parent,label,taille,classe,pto) {};
	~Coupes3dPanelSB() {};
      
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelSC : public Coupes3dPanelSX
{
	Coupes3dPanelSC(const Widget& parent,const char* label,
			short int taille = 20,
			const char* classe="Coupes3dPanelSC",
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelSX(parent,label,taille,classe,pto) {};
	~Coupes3dPanelSC() {};
      
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelSD : public Coupes3dPanelSX
{
	Coupes3dPanelSD(const Widget& parent,const char* label,
			short int taille = 20,
			const char* classe="Coupes3dPanelSD",
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelSX(parent,label,taille,classe,pto) {};
	~Coupes3dPanelSD() {};
      
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelSE : public Coupes3dPanelSX
{
	Coupes3dPanelSE(const Widget& parent,const char* label,
			short int taille = 20,
			const char* classe="Coupes3dPanelSE",
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelSX(parent,label,taille,classe,pto) {};
	~Coupes3dPanelSE() {};
      
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelSPAS : public Coupes3dPanelSX
{
	Coupes3dPanelSPAS(const Widget& parent,const char* label,
			short int taille = 20,
			const char* classe="Coupes3dPanelSPAS",
			Coupes3dPanel* pto=NULL) :
			Coupes3dPanelSX(parent,label,taille,classe,pto) {};
	~Coupes3dPanelSPAS() {};
      
	void SelectCB(XtPointer call_data);
};

class Coupes3dPanelOK : public Bouton
{
    private :

	Coupes3dPanel* _pto;

    public :

	Coupes3dPanelOK(const Widget& parent, const char* label,
		const char* classe,Coupes3dPanel* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~Coupes3dPanelOK() {};

	void Attach(Coupes3dPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelAnnuler : public Bouton
{	   
	Coupes3dPanelAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~Coupes3dPanelAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelAide : public Bouton
{	   
	Coupes3dPanelAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~Coupes3dPanelAide() {};
      
	void SelectCB(XtPointer call_data);
};

struct Coupes3dPanelAppel : public PullDownEntry
{
	Coupes3dPanelAppel(const Widget& parent,const char* label);
	~Coupes3dPanelAppel() {};

	void SelectCB(XtPointer call_data);
};

class Coupes3dPanelSaisie : public Saisie
{
    private:

	Coupes3dPanel* _pto;
	
    public:
   
	Coupes3dPanelSaisie(const Widget& parent,const char* label,
			short int taille=3,
			const char* classe = "Coupes3dSaisie",
			Coupes3dPanel* pto=NULL) :
			Saisie(parent,label,taille,classe) {_pto = pto;};
	~Coupes3dPanelSaisie() {};

	void Attach(Coupes3dPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void ChangeValeur(int nombre);
};

class NumeroCoupes3dSliderMin : public Slider
{
   private:

	Coupes3dPanel* _pto;
	
   public:
   
	NumeroCoupes3dSliderMin(const Widget& parent, const char *label, 
			const int& mini,const int& maxi,
			const int& ValeurInitiale,
			const char* classe,int width=200,
			Coupes3dPanel* pto=NULL) :
			Slider(parent,label,mini,maxi,ValeurInitiale,
					classe,width)
	{_pto=pto;};
	~NumeroCoupes3dSliderMin() {};

	void Attach(Coupes3dPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class NumeroCoupes3dSliderMax : public Slider
{
   private:

	Coupes3dPanel* _pto;
	
   public:
   
	NumeroCoupes3dSliderMax(const Widget& parent, const char *label, 
			const int& mini, const int& maxi,
			const int& ValeurInitiale,
			const char* classe,int width=200,
			Coupes3dPanel* pto=NULL) :
			Slider(parent,label,mini,maxi,ValeurInitiale,
					classe,width)
	{_pto=pto;};
	~NumeroCoupes3dSliderMax() {};

	void Attach(Coupes3dPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class Coupes3dPanel : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli			_opt_j;
	ConteneurLigne			_opt_l;

	ConteneurColonne		_opt_c;

	ConteneurColonne	      	_bloc_l;

	ConteneurLigne			_bloc;

	ConteneurJoli                   _nombre_j;
	ConteneurColonne		_nombre;
	Label				_nombre_label;
	Coupes3dPanelSaisie		_nombre_saisie;

	ConteneurJoli                   _numero_j;
	ConteneurLigne   		_numero_l;

	ConteneurColonne		_numero_min;
	Label				_numero_label_min;
	NumeroCoupes3dSliderMin        _numero_slider_min;

	ConteneurColonne		_numero_max;
	Label				_numero_label_max;
	NumeroCoupes3dSliderMax		_numero_slider_max;

	ConteneurJoli			_coupe_j;
	ConteneurLigne			_coupe_l;

	ConteneurColonne		_coupe;
	Label				_coupe_label;
	ConteneurExclusifColonne	_coupe_type;
	Coupes3dPanelChoixCoNon		_conon;
	Coupes3dPanelChoixCoOui		_cooui;

	ConteneurColonne		_coupe2;
	Label				_lppas;
	Coupes3dPanelSPAS		_cppas;

	ConteneurJoli			_plan_j;
	ConteneurLigne			_plan_l;

	ConteneurColonne		_plan;
	Label				_lpa;
	Coupes3dPanelSA			_cpa;
	Label				_lpb;
	Coupes3dPanelSB			_cpb;
	Label				_lpc;

	ConteneurColonne		_plan2;
	Coupes3dPanelSC			_cpc;
	Label				_lpd;
	Coupes3dPanelSD			_cpd;
	Label				_lpe;
	Coupes3dPanelSE			_cpe;
	Label				_lpf;

	ConteneurJoli			_standard_j;

	ConteneurColonne		_standard;
	Coupes3dPanelOK			_ok;
	Coupes3dPanelAnnuler		_annuler;
	Coupes3dPanelAide		_aide;

	int				_bloc_nombre;
	int				_bloc_numero_min;
	int				_bloc_numero_max;

    public:

	Coupes3dPanel(const Widget& root);
	~Coupes3dPanel() {};

	void ChangeCoupe(int choix);

	void ChangeCoNon(int choix) {_conon.Change(choix);};
	void ChangeCoOui(int choix) {_cooui.Change(choix);};

	void ChangePlan(REEL a,REEL b,REEL c,REEL d,REEL e,REEL pas);

	void LitPlan();

	void CalculCoupe(int choix);
	void CalculCoupeA(REEL choix);
	void CalculCoupeB(REEL choix);
	void CalculCoupeC(REEL choix);
	void CalculCoupeD(REEL choix);
	void CalculCoupeE(REEL choix);
	void CalculCoupePAS(REEL choix);

	void Change(int min,int max,int pos_min,int pos_max);
	void Charge(int bloc_num_min,int bloc_num_max);
	void ChangeValeur(int nombre);
	void ChangeNombre();

	int GetValueSliderMin() {return _numero_slider_min.GetValue();};
	int GetValueSliderMax() {return _numero_slider_max.GetValue();};
};

#endif /* fin S6BOUTTONS10_H */
