//
// Identification du source
//

struct SccsIdS6Bouttons7
{
	static const char* const sccs_id;
};

const char* const SccsIdS6Bouttons7::sccs_id = "%W% %G% Pierre Brochard";

// Includes

#include "S6bouttonsys2.h"
#include "S6bouttons7.h"
#include "S6boutfich.h"
#include "S6boutgenpsy.h"
#include "S6constant.h"
#include "S6trace.h"
#include "S6gerefenet.h"
#include "S6gerefich.h"
#include "S6gereenv.h"
#include "S6gereconfig.h"
#include "nx.h"
#include "S6namecomp.h"
#include "S6traduc.h"
#include "S6outils.h"
#include "S6flagssup.h"
#include "dinosaure/S6string.h"

// ******************************************************************
//		classes bouttons (suite) de Psyche
// ******************************************************************

// axes ................................................

AxesAppel::AxesAppel(const Widget& parent,const char *label) :
		PullDownEntry(parent, label)
{
}

void
AxesAppel::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);

	if(!S6GereFenet::axes)
	{
	    cout << "AxesAppel> creation pop-up Axes" << endl;

	    register ElementVisuel* const elv = S6GereFenet::root->ElVisuel();

	    S6GereFenet::axes = new Axes(elv->GetId());
	    S6GereFenet::ReConfigAxes();
	    S6GereFenet::CacheExpose();
	}

	S6GereFenet::axes->PopUp::Montre();
}

Axes::Axes(const Widget& root) :
		PopUp(root, S6Traduc::traduc[119],500,200),
		_tout(GetId(),"AXE_TOUT",-1),

		_blocs(_tout.GetId(),"AXE_TOUT",-1),

		_axe_j(_blocs.GetId(),"AXE_J"),
		_axe(_axe_j.GetId(),"AXE",-1),

		_axe_x(_axe.GetId(),"AXE_X",-1),
		_axe_x_label(_axe_x.GetId(),S6Traduc::traduc[120]),
		_axe_x_type(_axe_x.GetId(),"AXE_X_TYPE"),
		_axe_x_lin(_axe_x_type.GetId(),S6Traduc::traduc[121],
			"axe_x_lin"),
		_axe_x_log(_axe_x_type.GetId(),S6Traduc::traduc[122],
			"axe_x_log"),

		_axe_y(_axe.GetId(),"AXE_Y",-1),
		_axe_y_label(_axe_y.GetId(),S6Traduc::traduc[124]),
		_axe_y_type(_axe_y.GetId(),"AXE_Y_TYPE"),
		_axe_y_lin(_axe_y_type.GetId(),S6Traduc::traduc[121],
			"axe_y_lin"),
		_axe_y_log(_axe_y_type.GetId(),S6Traduc::traduc[122],
			"axe_y_log"),

		_axe_z(_axe.GetId(),"AXE_Z",-1),
		_axe_z_label(_axe_z.GetId(),S6Traduc::traduc[126]),
		_axe_z_type(_axe_z.GetId(),"AXE_Z_TYPE"),
		_axe_z_lin(_axe_z_type.GetId(),S6Traduc::traduc[121],
			"axe_z_lin"),
		_axe_z_log(_axe_z_type.GetId(),S6Traduc::traduc[122],
			"axe_z_log"),

		_axe_c(_axe.GetId(),"AXE_C",-1),
		_axe_c_label(_axe_c.GetId(),S6Traduc::traduc[128]),
		_axe_c_type(_axe_c.GetId(),"AXE_C_TYPE"),
		_axe_c_lin(_axe_c_type.GetId(),S6Traduc::traduc[121],
			"axe_c_lin"),
		_axe_c_log(_axe_c_type.GetId(),S6Traduc::traduc[122],
			"axe_c_log"),

		_axe_standard_j(_tout.GetId(),"AXE_STANDARD_J"),
		_axe_standard(_axe_standard_j.GetId(),"AXE_STANDARD",1),
		_axe_ok(_axe_standard.GetId(),S6Traduc::traduc[227],"BTN_OAA"),
		_axe_annuler(_axe_standard.GetId(),S6Traduc::traduc[228],
			"BTN_OAA"),
		_axe_aide(_axe_standard.GetId(),S6Traduc::traduc[229],
				"BTN_OAA"),

		_axe_bornes_j(_blocs.GetId(),"AXE_BORNES_J"),
		_axe_bornes(_axe_bornes_j.GetId(),"AXE_BORNES",-1),

		_axe_x_bornes(_axe_bornes.GetId(),"AXE_X_MIN",-1),
		_axe_x_min_label(_axe_x_bornes.GetId(),S6Traduc::traduc[129]),
		_axe_x_min_texte(_axe_x_bornes.GetId(),""),
		_axe_x_max_label(_axe_x_bornes.GetId(),S6Traduc::traduc[130]),
		_axe_x_max_texte(_axe_x_bornes.GetId(),""),
		_axe_x_auto(_axe_x_bornes.GetId(),S6Traduc::traduc[131]),

		_axe_y_bornes(_axe_bornes.GetId(),"AXE_Y_MIN",-1),
		_axe_y_min_label(_axe_y_bornes.GetId(),S6Traduc::traduc[132]),
		_axe_y_min_texte(_axe_y_bornes.GetId(),""),
		_axe_y_max_label(_axe_y_bornes.GetId(),S6Traduc::traduc[133]),
		_axe_y_max_texte(_axe_y_bornes.GetId(),""),
		_axe_y_auto(_axe_y_bornes.GetId(),S6Traduc::traduc[134]),

		_axe_z_bornes(_axe_bornes.GetId(),"AXE_Z_MIN",-1),
		_axe_z_min_label(_axe_z_bornes.GetId(),S6Traduc::traduc[135]),
		_axe_z_min_texte(_axe_z_bornes.GetId(),""),
		_axe_z_max_label(_axe_z_bornes.GetId(),S6Traduc::traduc[136]),
		_axe_z_max_texte(_axe_z_bornes.GetId(),""),
		_axe_z_auto(_axe_z_bornes.GetId(),S6Traduc::traduc[137]),

		_axe_c_bornes(_axe_bornes.GetId(),"AXE_C_MIN",-1),
		_axe_c_min_label(_axe_c_bornes.GetId(),S6Traduc::traduc[138]),
		_axe_c_min_texte(_axe_c_bornes.GetId(),""),
		_axe_c_max_label(_axe_c_bornes.GetId(),S6Traduc::traduc[139]),
		_axe_c_max_texte(_axe_c_bornes.GetId(),""),
		_axe_c_auto(_axe_c_bornes.GetId(),S6Traduc::traduc[140])
{
	_axe_x_type.Margin(0);
	_axe_y_type.Margin(0);
	_axe_z_type.Margin(0);
	_axe_c_type.Margin(0);

	_axe_x_lin.Change(TRUE);
	_axe_y_lin.Change(TRUE);
	_axe_z_lin.Change(TRUE);
	_axe_c_lin.Change(TRUE);

	_axe_x_auto.Attach(this);
	_axe_y_auto.Attach(this);
	_axe_z_auto.Attach(this);
	_axe_c_auto.Attach(this);

	_axe_ok.Attach(this);

	BloqueGeom();
}

void Axes::ChangeAxeX()
{
	_axe_x_lin.Change(axe_log_x==0);
	_axe_x_log.Change(axe_log_x==1);
}

void Axes::ChangeAxeY()
{
	_axe_y_lin.Change(axe_log_y==0);
	_axe_y_log.Change(axe_log_y==1);
}

void Axes::ChangeAxeZ()
{
	_axe_z_lin.Change(axe_log_z==0);
	_axe_z_log.Change(axe_log_z==1);
}

void Axes::ChangeAxeC()
{
	_axe_c_lin.Change(axe_log_c==0);
	_axe_c_log.Change(axe_log_c==1);
}

void Axes::ChangeAxeMinX()
{
	ChangeAxeMinX(axe_x_min);
}

void Axes::ChangeAxeMinX(REEL xmin)
{
	const S6String ss(xmin);
	char* ptos = ss;

	_axe_x_min_texte.Change(ptos);

	delete[] ptos;
}

void Axes::ChangeAxeMaxX()
{
	ChangeAxeMaxX(axe_x_max);
}

void Axes::ChangeAxeMaxX(REEL xmax)
{
	const S6String ss(xmax);
	char* ptos = ss;

	_axe_x_max_texte.Change(ptos);

	delete[] ptos;
}

void Axes::ChangeAxeMinY()
{
	ChangeAxeMinY(axe_y_min);
}

void Axes::ChangeAxeMinY(REEL ymin)
{
	const S6String ss(ymin);
	char* ptos = ss;

	_axe_y_min_texte.Change(ptos);

	delete[] ptos;
}

void Axes::ChangeAxeMaxY()
{
	ChangeAxeMaxY(axe_y_max);
}

void Axes::ChangeAxeMaxY(REEL ymax)
{
	const S6String ss(ymax);
	char* ptos = ss;

	_axe_y_max_texte.Change(ptos);

	delete[] ptos;
}

void Axes::ChangeAxeMinZ()
{
	ChangeAxeMinZ(axe_z_min);
}

void Axes::ChangeAxeMinZ(REEL zmin)
{
	const S6String ss(zmin);
	char* ptos = ss;

	_axe_z_min_texte.Change(ptos);

	delete[] ptos;
}

void Axes::ChangeAxeMaxZ()
{
	ChangeAxeMaxZ(axe_z_max);
}

void Axes::ChangeAxeMaxZ(REEL zmax)
{
	const S6String ss(zmax);
	char* ptos = ss;

	_axe_z_max_texte.Change(ptos);

	delete[] ptos;
}

void Axes::ChangeAxeMinC()
{
	ChangeAxeMinC(axe_c_min);
}

void Axes::ChangeAxeMinC(REEL cmin)
{
	const S6String ss(cmin);
	char* ptos = ss;

	_axe_c_min_texte.Change(ptos);

	delete[] ptos;
}

void Axes::ChangeAxeMaxC()
{
	ChangeAxeMaxC(axe_c_max);
}

void Axes::ChangeAxeMaxC(REEL cmax)
{
	const S6String ss(cmax);
	char* ptos = ss;

	_axe_c_max_texte.Change(ptos);

	delete[] ptos;
}

void Axes::Cache()
{
	LibereGeom();
	_axe_z.Cache();
	_axe_c.Cache();
	_axe_z_bornes.Cache();
	_axe_c_bornes.Cache();
	BloqueGeom();
}

void Axes::Montre()
{
	LibereGeom();
	_axe_z.Montre();
	_axe_c.Montre();
	_axe_z_bornes.Montre();
	_axe_c_bornes.Montre();
	BloqueGeom();
}

void Axes::LitAxeMinX(REEL& xmin)
{
	istrstream is(_axe_x_min_texte.GetText());

	is >> xmin;
}

void Axes::LitAxeMaxX(REEL& xmax)
{
	istrstream is(_axe_x_max_texte.GetText());

	is >> xmax;
}

void Axes::LitAxeMinY(REEL& ymin)
{
	istrstream is(_axe_y_min_texte.GetText());

	is >> ymin;
}

void Axes::LitAxeMaxY(REEL& ymax)
{
	istrstream is(_axe_y_max_texte.GetText());

	is >> ymax;
}

void Axes::LitAxeMinZ(REEL& zmin)
{
	istrstream is(_axe_z_min_texte.GetText());

	is >> zmin;
}

void Axes::LitAxeMaxZ(REEL& zmax)
{
	istrstream is(_axe_z_max_texte.GetText());

	is >> zmax;
}

void Axes::LitAxeMinC(REEL& cmin)
{
	istrstream is(_axe_c_min_texte.GetText());

	is >> cmin;
}

void Axes::LitAxeMaxC(REEL& cmax)
{
	istrstream is(_axe_c_max_texte.GetText());

	is >> cmax;
}

void AxeOK::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // lecture de tous les champs textes

	_pto->LitAxeMinX(p_axe_x_min);p_axe_x_min_reel = p_axe_x_min;
	_pto->LitAxeMaxX(p_axe_x_max);p_axe_x_max_reel = p_axe_x_max;
	_pto->LitAxeMinY(p_axe_y_min);p_axe_y_min_reel = p_axe_y_min;
	_pto->LitAxeMaxY(p_axe_y_max);p_axe_y_max_reel = p_axe_y_max;
	_pto->LitAxeMinZ(p_axe_z_min);p_axe_z_min_reel = p_axe_z_min;
	_pto->LitAxeMaxZ(p_axe_z_max);p_axe_z_max_reel = p_axe_z_max;
	_pto->LitAxeMinC(p_axe_c_min);p_axe_c_min_reel = p_axe_c_min;
	_pto->LitAxeMaxC(p_axe_c_max);p_axe_c_max_reel = p_axe_c_max;

    // on prend en compte les valeurs de la config partielles lues
    // precedemment

	S6GereConfig::_config = S6GereConfigP::_p_axe_config;

	if(calcul_ok_cache) _pto->PopUp::Cache();

}

void AxeAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on annule les valeurs lues dans la config partielle

	S6GereConfigP::_p_axe_config = S6GereConfig::_config;
	S6GereFenet::ReConfigAxes();
	S6GereFenet::axes->PopUp::Cache();
}

void AxeAide::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(S6GereFenet::axes_help == NULL)
	{
	    cout << " creation pop-up-help Axes " << endl;

	    S6GereFenet::axes_help = new Help(GetId(),S6Traduc::traduc[230],
		"AXES_HELP");
	}	

	S6GereFenet::axes_help->Montre();
}

void AxeChoixLinX::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_x = 0;	
}

void AxeChoixLogX::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_x = 1;	
}

void AxeChoixLinY::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_y = 0;	
}

void AxeChoixLogY::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_y = 1;	
}

void AxeChoixLinZ::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_z = 0;	
}

void AxeChoixLogZ::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_z = 1;	
}

void AxeChoixLinC::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_c = 0;	
}

void AxeChoixLogC::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	p_axe_log_c = 1;	
}

void AxeMinX::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL xmin = 0;

	is >> xmin;

	cout << "AxeMinX> xmin " << xmin << endl;

	p_axe_x_min = xmin;
	p_axe_x_min_reel = xmin;
}

void AxeMaxX::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL xmax = 0;

	is >> xmax;

	cout << "AxeMaxX> xmax " << xmax << endl;

	p_axe_x_max = xmax;
	p_axe_x_max_reel = xmax;
}

void AxeAutoXBouton::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	p_axe_x_min = 0.;
	p_axe_x_max = 0.;
	p_axe_x_min_reel = 0.;
	p_axe_x_max_reel = 0.;

	_pto->ChangeAxeMinX(0.);
	_pto->ChangeAxeMaxX(0.);
}

void AxeMinY::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL ymin = 0;

	is >> ymin;

	cout << "AxeMinY> ymin " << ymin << endl;

	p_axe_y_min = ymin;
	p_axe_y_min_reel = ymin;
}

void AxeMaxY::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL ymax = 0;

	is >> ymax;

	cout << "AxeMaxY> ymax " << ymax << endl;

	p_axe_y_max = ymax;
	p_axe_y_max_reel = ymax;
}

void AxeAutoYBouton::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	p_axe_y_min = 0.;
	p_axe_y_max = 0.;
	p_axe_y_min_reel = 0.;
	p_axe_y_max_reel = 0.;

	_pto->ChangeAxeMinY(0.);
	_pto->ChangeAxeMaxY(0.);
}

void AxeMinZ::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL zmin = 0;

	is >> zmin;

	cout << "AxeMinZ> zmin " << zmin << endl;

	p_axe_z_min = zmin;
	p_axe_z_min_reel = zmin;
}

void AxeMaxZ::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL zmax = 0;

	is >> zmax;

	cout << "AxeMaxZ> zmax " << zmax << endl;

	p_axe_z_max = zmax;
	p_axe_z_max_reel = zmax;
}

void AxeAutoZBouton::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	p_axe_z_min = 0.;
	p_axe_z_max = 0.;
	p_axe_z_min_reel = 0.;
	p_axe_z_max_reel = 0.;

	_pto->ChangeAxeMinZ(0.);
	_pto->ChangeAxeMaxZ(0.);
}

void AxeMinC::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL cmin = 0;

	is >> cmin;

	cout << "AxeMinC> cmin " << cmin << endl;

	p_axe_c_min = cmin;
	p_axe_c_min_reel = cmin;
}

void AxeMaxC::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	istrstream is(GetText());
	REEL cmax = 0;

	is >> cmax;

	cout << "AxeMaxC> cmax " << cmax << endl;

	p_axe_c_max = cmax;
	p_axe_c_max_reel = cmax;
}

void AxeAutoCBouton::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	p_axe_c_min = 0.;
	p_axe_c_max = 0.;
	p_axe_c_min_reel = 0.;
	p_axe_c_max_reel = 0.;

	_pto->ChangeAxeMinC(0.);
	_pto->ChangeAxeMaxC(0.);
}

// Panneau Titres Axes.

void
ChoixVerticalCouleurTitresAxes::ChargeInv()
{
	p_axe_couleur_titre = Choix();

	if(!parametre_couleur_fond && !p_axe_couleur_titre)
	    p_axe_couleur_titre = 1;

}

void
ChoixVerticalTailleTitresAxes::ChargeInv()
{
	p_axe_taille_titre = max((Choix() + 1) * 8,10);
}

TitresAxesAppel::TitresAxesAppel(const Widget& parent,const char *label) :
		PullDownEntry(parent, label)
{
}

void
TitresAxesAppel::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);

	if(!S6GereFenet::titresaxes)
	{
	    cout << "TitresAxesAppel> creation pop-up Titres Axes" << endl;

	    register ElementVisuel* const elv = S6GereFenet::root->ElVisuel();

	    S6GereFenet::titresaxes = new TitresAxes(elv->GetId());
	    S6GereFenet::ReConfigTitresAxes();
	    S6GereFenet::CacheExpose();
	}

	S6GereFenet::titresaxes->PopUp::Montre();
}

TitresAxes::TitresAxes(const Widget& root) :
		PopUp(root, S6Traduc::traduc[359],500,200),
		_tout(GetId(),"AXE_TOUT",-1),

		_axe_j(_tout.GetId(),"AXE_J"),
		_axe(_axe_j.GetId(),"AXE",-1),

		_axe_x_titre(_axe.GetId(),"AXE_X_TITRE"),
		_axe_x_titre_label(_axe_x_titre.GetId(),S6Traduc::traduc[123]),
		_axe_x_titre_texte(_axe_x_titre.GetId(),""),

		_axe_y_titre(_axe.GetId(),"AXE_Y_TITRE"),
		_axe_y_titre_label(_axe_y_titre.GetId(),S6Traduc::traduc[125]),
		_axe_y_titre_texte(_axe_y_titre.GetId(),""),

		_axe_yd_titre(_axe.GetId(),"AXE_DROIT_Y_TITRE"),
		_axe_yd_titre_label(_axe_yd_titre.GetId(),S6Traduc::traduc[263]),
		_axe_yd_titre_texte(_axe_yd_titre.GetId(),""),

		_axe_z_titre(_axe.GetId(),"AXE_Z_TITRE"),
		_axe_z_titre_label(_axe_z_titre.GetId(),S6Traduc::traduc[127]),
		_axe_z_titre_texte(_axe_z_titre.GetId(),""),

		_params_j(_tout.GetId(),"AXE_PARAM_J"),

		_params(_params_j.GetId(),"AXE_PARAM",2),
		_params2(_params.GetId(),"AXE_PARAM2"),
		_couleur_titres(_params2.GetId(),*(S6GereFenet::couleur),
			"AXE_COULEUR_TITRE",S6Traduc::traduc[141],-1,this),
		_taille_titres(_params2.GetId(),*(S6GereFenet::taille),
			"AXE_TAILLE_TITRE",S6Traduc::traduc[142],-1,this),

		_axe_standard_j(_tout.GetId(),"AXE_STANDARD_J"),
		_axe_standard(_axe_standard_j.GetId(),"AXE_STANDARD",1),
		_axe_ok(_axe_standard.GetId(),S6Traduc::traduc[227],"BTN_OAA"),
		_axe_annuler(_axe_standard.GetId(),S6Traduc::traduc[228],
			"BTN_OAA"),
		_axe_aide(_axe_standard.GetId(),S6Traduc::traduc[229],
				"BTN_OAA")
{
	_axe_ok.Attach(this);

	BloqueGeom();
}

void
TitresAxes::ChangeAxeX()
{
	_axe_x_titre_texte.Change(axe_valeur_x);
}

void
TitresAxes::ChangeAxeY()
{
	_axe_y_titre_texte.Change(axe_valeur_y);
}

void
TitresAxes::ChangeAxeYD()
{
	_axe_yd_titre_texte.Change(axe_valeur_yd);
}

void
TitresAxes::ChangeAxeZ()
{
	_axe_z_titre_texte.Change(axe_valeur_z);
}

void
TitresAxes::Cache()
{
	LibereGeom();
	_axe_yd_titre.Montre();
	_axe_z_titre.Cache();
	BloqueGeom();
}

void
TitresAxes::Montre()
{
	LibereGeom();
	_axe_yd_titre.Cache();
	_axe_z_titre.Montre();
	BloqueGeom();
}

void
TitresAxes::LitAxeX(char*& tx)
{
	delete[] tx;

	const S6String ss(_axe_x_titre_texte.GetText());

	tx = ss;
}

void
TitresAxes::LitAxeY(char*& ty)
{
	delete[] ty;

	const S6String ss(_axe_y_titre_texte.GetText());

	ty = ss;
}

void
TitresAxes::LitAxeYD(char*& ty)
{
	delete[] ty;

	const S6String ss(_axe_yd_titre_texte.GetText());

	ty = ss;
}

void
TitresAxes::LitAxeZ(char*& tz)
{
	delete[] tz;

	const S6String ss(_axe_z_titre_texte.GetText());

	tz = ss;
}

void
TitresAxes::ChangeChoixVertical()
{
	_couleur_titres.Change(axe_couleur_titre);
	_taille_titres.Change(min(15,max(0,axe_taille_titre/8-1)));
}

void
TitresAxeOK::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // lecture de tous les champs textes
	_pto->LitAxeX(p_axe_valeur_x);
	_pto->LitAxeY(p_axe_valeur_y);
	_pto->LitAxeYD(p_axe_valeur_yd);
	_pto->LitAxeZ(p_axe_valeur_z);

    // on prend en compte les valeurs de la config partielles lues
    // precedemment

	S6GereConfig::_config = S6GereConfigP::_p_titreaxe_config;

	if(calcul_ok_cache) _pto->PopUp::Cache();

}

void
TitresAxeAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on annule les valeurs lues dans la config partielle

	S6GereConfigP::_p_titreaxe_config = S6GereConfig::_config;
	S6GereFenet::ReConfigTitresAxes();
	S6GereFenet::titresaxes->PopUp::Cache();
}

void
TitresAxeAide::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(S6GereFenet::titresaxes_help == NULL)
	{
	    cout << " creation pop-up-help Titres Axes " << endl;

	    S6GereFenet::titresaxes_help = new Help(GetId(),S6Traduc::traduc[358],
		"TITRESAXES_HELP");
	}	

	S6GereFenet::titresaxes_help->Montre();
}

void
TitresAxeTitreX::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	delete[] p_axe_valeur_x;

	const S6String ss(GetText());

	p_axe_valeur_x = ss;
}

void
TitresAxeTitreY::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	delete[] p_axe_valeur_y;

	const S6String ss(GetText());

	p_axe_valeur_y = ss;
}

void
TitresAxeTitreZ::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	delete[] p_axe_valeur_z;

	const S6String ss(GetText());

	p_axe_valeur_z = ss;
}

void
TitresAxeDroitTitreY::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	delete[] p_axe_valeur_yd;

	S6String ss(GetText());

	p_axe_valeur_yd = ss;
}
