// ******************************************************************
//		classes bouttons (suite 2) de Psyche
// ******************************************************************

// Ident

struct SccsIdS6Bouttons8
{
	static const char* const sccs_id;
};

const char* const SccsIdS6Bouttons8::sccs_id = "%W% %G% Pierre Brochard";

// Includes

#include "S6bouttonsys3.h"
#include "S6bouttons8.h"
#include "S6boutgenpsy.h"
#include "S6constant.h"
#include "S6gerefich.h"
#include "S6gereenv.h"
#include "S6gereconfig.h"
#include "S6trace.h"
#include "S6gerefenet.h"
#include "sanglier.h"
#include "nx.h"
#include "S6namecomp.h"
#include "S6traduc.h"
#include "S6outils.h"
#include "S6flagssup.h"
#include "S6initcourbe.h"
#include "sanglierP.h"
#include "dinosaure/S6string.h"

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

// communication avec le panneau print de l'afficheur X11...............

void
U8PrintPsyche::DestFichDeb(char* const fichier)
{

    // fichier ressort avec la chaine de caractere initiale mais est
    // modifiee dans le corps de cette methode avant d'etre remis
    // a sa valeur initiale.

	if(impression_dest_fichd)
	{
	    delete[] impression_dest_fichd;

	    size_t taille =  strlen(fichier) + 1;

	    impression_dest_fichd = new char[taille];
	    memcpy(impression_dest_fichd,fichier,taille);
	}
	else
	{
	    impression_dest_fichd = new char[1];
	    impression_dest_fichd[0] = '\0';
	}

    // noms reserves :
    //   *auto[.suffixe]
    //   sinon format nx
    // exemple : | ps2gif 512 512 > auto.gif
    // 
    // Attention le compilateur SC5 de SUN patche aout 99 reduit
    // les fonctionalites de strstr en exigeant que l'argument de retour
    // soit un const char*.

	const char* marqueur = strstr(fichier,"auto");

	if(marqueur && (strlen(marqueur) >= 5 && marqueur[4] == '.'
			|| strlen(marqueur) == 4))
	{
	    const size_t tai = strlen(fichier) +
		strlen(S6NameComp::imp_dest_fichd) + 1;

	    if(!S6NameComp::imp_dest_fichd) S6NameComp::NameComp();

	    char* const imp_dest_fichd = new char[tai];

	    if(imp_dest_fichd)
	    {
		char* mfichier = fichier + (marqueur - fichier);

		*mfichier = '\0';
		strcpy(imp_dest_fichd,fichier);
		strcat(imp_dest_fichd,S6NameComp::imp_dest_fichd);
		strcat(imp_dest_fichd,"XXXX");
		strcat(imp_dest_fichd,marqueur+4);
		*mfichier = 'a';
		L3SetOptPost(imp_dest_fichd,FICHIERDEBUT);

		delete imp_dest_fichd;
	    }

	}
	else
	{
	    L3SetOptPost(fichier,FICHIERDEBUT);
	}

}

void
U8PrintPsyche::DestFich(const char* const fichier)
{

	if(impression_dest_fich)
	{
	    delete[] impression_dest_fich;

	    const size_t taille =  strlen(fichier) + 1;

	    impression_dest_fich = new char[taille];
	    memcpy(impression_dest_fich,fichier,taille);
	}
	else
	{
	    impression_dest_fich = new char[1];
	    impression_dest_fich[0] = '\0';
	}

	L3SetOptPost(fichier, FICHIER);
}

void
U8PrintPsyche::DestImp(const char* const imprimante)
{

	if(impression_dest_imp)
	{
	    delete[] impression_dest_imp;

	    const size_t taille =  strlen(imprimante) + 1;

	    impression_dest_imp = new char[taille];
	    memcpy(impression_dest_imp,imprimante,taille);
	}
	else
	{
	    impression_dest_imp = new char[1];
	    impression_dest_imp[0] = '\0';
	}

	L3SetOptPost(imprimante, PRINTER);
}

void
U8PrintPsyche::DestType(int type)
{
	impression_dest_type = type;

	if(type == 2)
	{
	    L3SetOptPost(impression_dest_fich,FICHIERDEBUT);
	}
	else if(type)
	{
	    L3SetOptPost(impression_dest_fich,FICHIER);
	}
	else
	{
	    L3SetOptPost(impression_dest_imp,PRINTER);
	}

}

void
U8PrintPsyche::Couleur(int coul)
{

	if(coul == 1)
	{
	    int i = TRUE;

	    impression_couleur = 1;
	    L3SetOptPost(&i,ENCOULEUR);
	}
	else if(coul == -1)
	{
	    int i = TRUE;

	    impression_couleur = -1;
	    L3SetOptPost(&i,TOUTNOIR);
	}
	else if(!coul)
	{
	    int i = TRUE;

	    impression_couleur = 0;
	    L3SetOptPost(&i,NOIRETBLANC);
	}

}

void
U8PrintPsyche::Ident(int ident)
{
	impression_ident = !ident;
	L3SetOptPost(&ident, AUTEUR);
}

void
U8PrintPsyche::Chrono(int chrono)
{
	impression_chrono = chrono;
	L3SetOptPost(&chrono, CHRONO);
}

void
U8PrintPsyche::VideoInv(int video_inv)
{
	impression_video_inv = video_inv;
	L3SetOptPost(&video_inv, REVERSEVIDEO);
}

void
U8PrintPsyche::Logo(int logo)
{
	impression_logo = !logo;
	L3SetOptPost(&logo, LOGO);
}

void
U8PrintPsyche::Eps(int eps)
{
	impression_eps = eps;
	L3SetOptPost(&eps, NOINITGRAPHICS);
}

void
U8PrintPsyche::TexteNoir(int texte_noir)
{
	impression_texte_noir = texte_noir;
	L3SetOptPost(&texte_noir, TEXTESNOIR);
}

void
U8PrintPsyche::DimExacte(int dim_exacte)
{
	impression_dim_exacte = dim_exacte;
	L3SetOptPost(&dim_exacte, ABSOLU);
}

void
U8PrintPsyche::Landscape(int landscape)
{
	impression_landscape = landscape;
	L3SetOptPost(&landscape,LANDSCAPE);
}

void
U8PrintPsyche::Titre(const char* const titre)
{

	if(impression_titre)
	{
	    delete[] impression_titre;

	    const size_t taille =  strlen(titre) + 1;

	    impression_titre = new char[taille];
	    memcpy(impression_titre,titre,taille);
	}
	else
	{
	    impression_titre = new char[1];
	    impression_titre[0] = '\0';
	}

	L3SetOptPost(titre,TITRE);
}

// communication avec le panneau taille de l'afficheur X11...............

void
PsycheTailleCommuniq::Action(unsigned largeur,unsigned hauteur,
				  REEL clip_largeur,REEL clip_hauteur)
{
	afficheur_largeur = largeur;
	afficheur_hauteur = hauteur;
	afficheur_clip_largeur = clip_largeur;
	afficheur_clip_hauteur = clip_hauteur;
	
    // sauvegarde des tailles de l'afficheur pour utilisation eventuelle
    // par un driver derive du postscript (postscript + filtre)
	const int fd_index = open(S6NameComp::imp_dest_fichtaille,
			O_WRONLY|O_CREAT|O_TRUNC,S_IRUSR|S_IWUSR);
	char buf[128];

	sprintf(buf,"%d %d\n",afficheur_largeur,afficheur_hauteur);
	write(fd_index,buf,strlen(buf));
	close(fd_index);
}

// communication avec le bouton break de l'afficheur X11...............

void
PsycheBreakCommuniq::Action()
{
	S6Trace::BreakPsyche(0);
}

// sous-menu zoom graphique .............................................

ZoomGraf::ZoomGraf(const Widget& parent,const char* label) :
		_graf(parent, label),
		_graf_agrand(_graf.GetId(),S6Traduc::traduc[275]),
		_graf_agrand_carre(_graf.GetId(),S6Traduc::traduc[336]),
		_graf_reduc(_graf.GetId(),S6Traduc::traduc[276]),
		_graf_reduc_carre(_graf.GetId(),S6Traduc::traduc[337]),
		_graf_14(_graf.GetId(),S6Traduc::traduc[331]),
		_graf_24(_graf.GetId(),S6Traduc::traduc[332]),
		_graf_34(_graf.GetId(),S6Traduc::traduc[333]),
		_graf_44(_graf.GetId(),S6Traduc::traduc[334]),
		_graf_nul_zoom(_graf.GetId(),S6Traduc::traduc[277])
{
}

void
ZoomGrafAgrandCarre::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	S6GereConfig::GrafAgrand(TRUE);

	cout << "ZoomGrafAgrandCarre> zoom_gra_x_min " << zoom_gra_x_min <<
	    "\nZoomGrafAgrandCarre> zoom_gra_x_max " << zoom_gra_x_max <<
	    "\nZoomGrafAgrandCarre> zoom_gra_y_min " << zoom_gra_y_min <<
	    "\nZoomGrafAgrandCarre> zoom_gra_y_max " << zoom_gra_y_max <<
	    endl;
}

void
ZoomGrafAgrand::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	S6GereConfig::GrafAgrand();

	cout << "ZoomGrafAgrand> zoom_gra_x_min " << zoom_gra_x_min <<
	    "\nZoomGrafAgrand> zoom_gra_x_max " << zoom_gra_x_max <<
	    "\nZoomGrafAgrand> zoom_gra_y_min " << zoom_gra_y_min <<
	    "\nZoomGrafAgrand> zoom_gra_y_max " << zoom_gra_y_max << endl;
}

void
ZoomGrafReducCarre::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	S6GereConfig::GrafReduc(TRUE);

	cout << "ZoomGrafReducCarre> zoom_gra_x_min " << zoom_gra_x_min <<
	    "\nZoomGrafReducCarre> zoom_gra_x_max " << zoom_gra_x_max <<
	    "\nZoomGrafReducCarre> zoom_gra_y_min " << zoom_gra_y_min <<
	    "\nZoomGrafReducCarre> zoom_gra_y_max " << zoom_gra_y_max <<
	    endl;
}

void
ZoomGrafReduc::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	S6GereConfig::GrafReduc();

	cout << "ZoomGrafReduc> zoom_gra_x_min " << zoom_gra_x_min <<
	    "\nZoomGrafReduc> zoom_gra_x_max " << zoom_gra_x_max <<
	    "\nZoomGrafReduc> zoom_gra_y_min " << zoom_gra_y_min <<
	    "\nZoomGrafReduc> zoom_gra_y_max " << zoom_gra_y_max << endl;
}

void
ZoomGrafNulZoom::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	S6GereConfig::GrafNulZoom();
}

void
ZoomGraf14::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	zoom_gra_x_min = 0.;
	zoom_gra_y_min = 0.5;
	zoom_gra_x_max = 0.5;
	zoom_gra_y_max = 1.;
	zoom_gra_coef_taille = .5;
}

void
ZoomGraf24::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	zoom_gra_x_min = 0.5;
	zoom_gra_y_min = 0.5;
	zoom_gra_x_max = 1.;
	zoom_gra_y_max = 1.;
	zoom_gra_coef_taille = .5;
}

void
ZoomGraf34::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	zoom_gra_x_min = 0.;
	zoom_gra_y_min = 0.;
	zoom_gra_x_max = 0.5;
	zoom_gra_y_max = 0.5;
	zoom_gra_coef_taille = .5;
}

void
ZoomGraf44::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);
	zoom_gra_x_min = 0.5;
	zoom_gra_y_min = 0.;
	zoom_gra_x_max = 1.;
	zoom_gra_y_max = 0.5;
	zoom_gra_coef_taille = .5;
}

// sous-menu Z = C .............................................

ZeqC::ZeqC(const Widget& parent,const char* label) :
		_scene(parent, label),
		_non(_scene.GetId(),S6Traduc::traduc[280]),
		_oui(_scene.GetId(),S6Traduc::traduc[281])
{
	_non.Attach(this);
	_oui.Attach(this);
}

void
ZeqC::Change(int& choix)
{
	_non.Change(FALSE);
	_oui.Change(FALSE);

	switch(choix)
	{
	  case -1:
	    break;
	  case 0:
	    _non.Change(TRUE);
	    break;
	  case 1:
	    _oui.Change(TRUE);
	    break;
	  default:
	    choix = 0;
	    _non.Change(TRUE);
	    break;
	}

}

void
ZeqCNon::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	int choix = 0;

	_pto->Change(choix);
	option_3d_z_eq_c = choix;
}

void
ZeqCNon::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	int choix = 0;

	_pto->Change(choix);
	option_3d_z_eq_c = choix;
}

void
ZeqCOui::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	int choix = 1;

	_pto->Change(choix);
	option_3d_z_eq_c = choix;
}

void
ZeqCOui::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	int choix = 1;

	_pto->Change(choix);
	option_3d_z_eq_c = choix;
}

// sous-menu multi bloc => mono bloc .....................................

MultiMono::MultiMono(const Widget& parent,const char* label) :
		_mulmo(parent, label),
		_non(_mulmo.GetId(),S6Traduc::traduc[280]),
		_oui(_mulmo.GetId(),S6Traduc::traduc[281])
{
}

void
MultiMono::Change(int& choix)
{
	_non.Change(FALSE);
	_oui.Change(FALSE);

	switch(choix)
	{
	    case 0 :
		_non.Change(TRUE);
		break;
	    case 1 :
		_oui.Change(TRUE);
		break;
	    default :
		choix = 0;
		_non.Change(TRUE);
		break;
	}

}

void
MultiMonoNon::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	option_3d_conv_mu_mo = 0;
}

void
MultiMonoOui::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	option_3d_conv_mu_mo = 1;
}

// ********************************************************
//           Options 3d Panneau
// ********************************************************

Options3DPanelAppel::Options3DPanelAppel(const Widget& parent,
		const char *label) : PullDownEntry(parent, label)
{
}

void
Options3DPanelAppel::SelectCB(XtPointer call_data)
{
	PullDownEntry::SelectCB(call_data);

	if(S6GereFenet::opt3dpanel == NULL)
	{
	    cout << "Options3DPanelAppel> creation pop-up Options 3d" << endl;

	    register ElementVisuel* elv = S6GereFenet::root->ElVisuel();

	    S6GereFenet::opt3dpanel = new Options3DPanel(elv->GetId());
	    S6GereFenet::ReConfigOpt3DPanel();
	    S6GereFenet::CacheExpose();
	}

	S6GereFenet::opt3dpanel->PopUp::Montre();
}

Options3DPanel::Options3DPanel(const Widget& root) :
		PopUp(root, S6Traduc::traduc[17],400,100),
		_tout(GetId(),"OPT_3D_PANEL_TOUT",-1),

		_opt_j(_tout.GetId(),"OPT_J"),
		_opt_l(_opt_j.GetId(),"OPT_l",-1),

		_opt_c(_opt_l.GetId(),"OPT_C",-1),

		_bloc_l(_opt_c.GetId(),"BLOC_l",-1),

		_nombre_j(_bloc_l.GetId(),"opt3d_nombre_j"),

		_nombre(_nombre_j.GetId(),"opt3d_nombre"),
		_nombre_label(_nombre.GetId(),S6Traduc::traduc[347]),
		_nombre_saisie(_nombre.GetId(),""),

		_numero_j(_bloc_l.GetId(),"opt3d_numero_j"),
		_numero_l(_numero_j.GetId(),"opt3d_numero_l",-1),

		_numero_min(_numero_l.GetId(),"opt3d_numero_min",-1),
		_numero_label_min(_numero_min.GetId(),S6Traduc::traduc[348]),
		_numero_slider_min(_numero_min.GetId(),"",0,1,0,
				"NumeroOptions3DSliderMin",130),

		_numero_max(_numero_l.GetId(),"opt3d_numero_max",-1),
		_numero_label_max(_numero_max.GetId(),S6Traduc::traduc[349]),
		_numero_slider_max(_numero_max.GetId(),"",0,1,0,
				"NumeroOptions3DSliderMax",130),

		_pixel_j(_bloc_l.GetId(),"PIXEL_J"),

		_pixel(_pixel_j.GetId(),"PIXEL",-1),
		_pixel_label(_pixel.GetId(),S6Traduc::traduc[304]),
		_pixel_type(_pixel.GetId(),"LISSAGE_TYPE"),
		_p3d(_pixel_type.GetId(),S6Traduc::traduc[305]),
		_p4d(_pixel_type.GetId(),S6Traduc::traduc[306]),

		_trace_j(_opt_c.GetId(),"OPT3DPANEL_TRACE_J"),
		_trace_l(_trace_j.GetId(),"OPT3DPANEL_TRACE_l",-1),

		_niveau(_trace_l.GetId(),"NIVEAU",-1),
		_niveau_label(_niveau.GetId(),S6Traduc::traduc[288]),
		_niveau_type(_niveau.GetId(),"NIVEAU_TYPE",-1),
		_n3d(_niveau_type.GetId(),S6Traduc::traduc[22]),
		_n4d(_niveau_type.GetId(),S6Traduc::traduc[23]),

		_facette(_trace_l.GetId(),"FACETTE",-1),
		_facette_label(_facette.GetId(),S6Traduc::traduc[289]),
		_facette_type(_facette.GetId(),"FACETTE_TYPE",-1),
		_f3d(_facette_type.GetId(),S6Traduc::traduc[24]),
		_f4d(_facette_type.GetId(),S6Traduc::traduc[25]),

		_filaire(_trace_l.GetId(),"FILAIRE",-1),
		_filaire_label(_filaire.GetId(),S6Traduc::traduc[290]),
		_filaire_type(_filaire.GetId(),"FILAIRE_TYPE",-1),
		_fimo(_filaire_type.GetId(),S6Traduc::traduc[26]),
		_fi3d(_filaire_type.GetId(),S6Traduc::traduc[27]),
		_fi4d(_filaire_type.GetId(),S6Traduc::traduc[28]),

		_lissage(_trace_l.GetId(),"LISSAGE",-1),
		_lissage_label(_lissage.GetId(),S6Traduc::traduc[291]),
		_lissage_type(_lissage.GetId(),"LISSAGE_TYPE",-1),
		_l3d(_lissage_type.GetId(),S6Traduc::traduc[29]),
		_l4d(_lissage_type.GetId(),S6Traduc::traduc[30]),

		_masque_j(_opt_l.GetId(),"OPT3DPANEL_MASQUE_J"),

		_masque(_masque_j.GetId(),"MASQUE",-1),
		_masque_label(_masque.GetId(),S6Traduc::traduc[302]),
		_masque_type(_masque.GetId(),"MASQUE_TYPE"),
		_sansm(_masque_type.GetId(),S6Traduc::traduc[32]),
		_masq0(_masque_type.GetId(),S6Traduc::traduc[33]),
		_masq1(_masque_type.GetId(),S6Traduc::traduc[34]),
		_masq2(_masque_type.GetId(),S6Traduc::traduc[35]),

		_standard_j(_tout.GetId(),"OPT3DPANEL_STANDARD_J"),

		_standard(_standard_j.GetId(),"OPT_3D_STANDARD",1),
		_ok(_standard.GetId(),S6Traduc::traduc[227],"BTN_OAA"),
		_annuler(_standard.GetId(),S6Traduc::traduc[228],
			"BTN_OAA"),
		_aide(_standard.GetId(),S6Traduc::traduc[229],
			"BTN_OAA")
{
	cout << "Options3DPanel> Panneau Options 3d cree" << endl;

	_n3d.Attach(this);
	_n4d.Attach(this);

	_f3d.Attach(this);
	_f4d.Attach(this);

	_fimo.Attach(this);
	_fi3d.Attach(this);
	_fi4d.Attach(this);

	_l3d.Attach(this);
	_l4d.Attach(this);

	_p3d.Attach(this);
	_p4d.Attach(this);

	_sansm.Attach(this);
	_masq0.Attach(this);
	_masq1.Attach(this);
	_masq2.Attach(this);

	_nombre_saisie.Attach(this);
	_numero_slider_min.Attach(this);
	_numero_slider_max.Attach(this);

	_ok.Attach(this);

	BloqueGeom();
}

void
Options3DPanel::CalculMasque(int choix)
{

	if(_bloc_numero_min == 0 && _bloc_numero_max == _bloc_nombre-1)
	    p_option_3d_masque = choix;
	else
	{
	    p_option_3d_masque = -1;

	    for(int i=_bloc_numero_min;i<=_bloc_numero_max;i++)
		p_option_3d_mask_bloc[i] = choix;

	}

}

void
Options3DPanel::CalculOpt3d()
{
	const int opt3d = CalculOption3d();

	if(opt3d == 511 || opt3d == 1023)
	    p_option_3d = opt3d;
	else
	{

	    if(_bloc_numero_min == 0 && _bloc_numero_max == _bloc_nombre-1)
		p_option_3d = opt3d;
	    else
	    {
		p_option_3d = -2;

		for(int i=_bloc_numero_min;i<=_bloc_numero_max;i++)
		    p_option_3d_bloc[i] = opt3d;

	    }

	}

}

int
Options3DPanel::CalculOption3d()
{
    // opt est au format Psyche

	int opt = 0;

	opt = _p4d.IsSelected();
	opt = opt << 1 | _p3d.IsSelected();
	opt = opt << 1 | _l4d.IsSelected();
	opt = opt << 1 | _l3d.IsSelected();
	opt = opt << 1 | _n4d.IsSelected();
	opt = opt << 1 | _n3d.IsSelected();
	opt = opt << 1 | _f4d.IsSelected();
	opt = opt << 1 | _f3d.IsSelected();
	opt = opt << 1 | _fi4d.IsSelected();
	opt = opt << 1 | _fi3d.IsSelected();
	opt = opt << 1 | _fimo.IsSelected();

	cout << "Options3DPanel> opt " << opt << endl;

	return (opt-1);
}

void
Options3DPanel::ChangeOpt3d(int choix)
{
    // choix est au format Psyche

	const int opt = max(choix + 1,0);

	ChangeN3d((opt>>5)%2);
	ChangeN4d((opt>>6)%2);
	ChangeF3d((opt>>3)%2);
	ChangeF4d((opt>>4)%2);
	ChangeFimo(opt%2);
	ChangeFi3d((opt>>1)%2);
	ChangeFi4d((opt>>2)%2);
	ChangeL3d((opt>>7)%2);
	ChangeL4d((opt>>8)%2);
	ChangeP3d((opt>>9)%2);
	ChangeP4d((opt>>10)%2);
}

void
Options3DPanel::ChangeMasque(int choix)
{
	ChangeSansm(choix == 0);
	ChangeMasq0(choix == 1);
	ChangeMasq1(choix == 2);
	ChangeMasq2(choix == 3);
}

void
Options3DPanel::ChangeNombre()
{
	int bloc_nombre = 1;

	bloc_nombre = max(bloc_nombre,option_3d_bloc_t);
	bloc_nombre = max(bloc_nombre,option_3d_mask_bloc_t);
	ChangeValeur(bloc_nombre);
	_bloc_nombre = bloc_nombre;

	S6String ss(bloc_nombre);
	char* ptos = ss;

	_nombre_saisie.Change(ptos);

	delete[] ptos;
}

void
Options3DPanel::ChangeValeur(int taille)
{
	((C5ConfigTabInt&) p_option_3d_bloc_c)(taille,1);
	((C5ConfigTabInt&) p_option_3d_mask_bloc_c)(taille,2);
}

void
Options3DPanel::Change(int xmin,int xmax,int pos_min,int pos_max)
{
	_bloc_nombre = xmax + 1;
	xmax = xmin+1 > xmax ? xmin+1 : xmax;
	_numero_slider_min.Change(xmin,xmax,pos_min);
	_numero_slider_max.Change(xmin,xmax,pos_max);
}

void
Options3DPanel::Charge(int bloc_num_min,int bloc_num_max)
{
    // chargement des valeurs de config dans le popup Options3DPanel

	cout << "Options3DPanel> bloc_nombre " << _bloc_nombre;
	cout << "\nOptions3DPanel> bloc_numero_min " << bloc_num_min;
	cout << "\nOptions3DPanel> bloc_numero_max " << bloc_num_max << endl;

	bloc_num_min = max(0,min(bloc_num_min,_bloc_nombre-1));
	bloc_num_max = max(0,min(bloc_num_max,_bloc_nombre-1));

	_bloc_numero_min = bloc_num_min;
	_bloc_numero_max = bloc_num_max;

	Change(0,_bloc_nombre - 1,bloc_num_min,bloc_num_max);

	if(p_option_3d != -2)
	    ChangeOpt3d(p_option_3d);
	else if(p_option_3d_bloc_t <= bloc_num_min)
	    ChangeOpt3d(1);
	else
	{
	    int popt3d = p_option_3d_bloc[bloc_num_min];

	    popt3d = popt3d == 511 || popt3d == 1023 ? 1 : popt3d;
	    ChangeOpt3d(popt3d);
	}

	if(p_option_3d_masque != -1)
	    ChangeMasque(p_option_3d_masque);
	else if(p_option_3d_mask_bloc_t <= bloc_num_min)
	    ChangeMasque(2);
	else
	    ChangeMasque(p_option_3d_mask_bloc[bloc_num_min]);

}

void
Options3DPanelSaisie::SelectCB(XtPointer call_data)
{
	Saisie::SelectCB(call_data);

	char* nombre = GetText();
	istrstream is(nombre);
	int taille = 0;

	is >> taille;

	cout << "Options3DSaisie> nombre de blocs " << taille << endl;

	if(taille >= 1000000)
	{
	    taille = 999999;

	    S6String ss(taille);
	    char* ptos = ss;

	    Change(ptos);

	    delete[] ptos;
	}

	ChangeValeur(taille);
}

void
Options3DPanelSaisie::ChangeValeur(int nombre)
{
	_pto->ChangeValeur(nombre);
	_pto->Change(0,nombre-1,0,0);
	_pto->Charge(0,0);
}

void
NumeroOptions3DSliderMin::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	int bloc_numero_min = GetValue();
	int bloc_numero_max = _pto->GetValueSliderMax();

	if(bloc_numero_min > bloc_numero_max)
	    bloc_numero_max = bloc_numero_min;

	_pto->Charge(bloc_numero_min,bloc_numero_max);
}

void
NumeroOptions3DSliderMax::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	int bloc_numero_min = _pto->GetValueSliderMin();
	int bloc_numero_max = GetValue();

	if(bloc_numero_min > bloc_numero_max)
	    bloc_numero_min = bloc_numero_max;

	_pto->Charge(bloc_numero_min,bloc_numero_max);
}

void
Options3dPanelOK::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on prend en compte les valeurs de la config partielles lues
    // precedemment

	S6GereConfig::_config = S6GereConfigP::_p_opt3d_config;
	S6GereFenet::ReConfigOpt3D();

	if(calcul_ok_cache) _pto->PopUp::Cache();

}

void
Options3dPanelAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

    // on annule les valeurs lues dans la config partielle

	S6GereConfigP::_p_opt3d_config = S6GereConfig::_config;
	S6GereFenet::ReConfigOpt3DPanel();
	S6GereFenet::opt3dpanel->PopUp::Cache();
}

void
Options3dPanelAide::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);

	if(S6GereFenet::opt3dpanel_help == NULL)
	{
	    cout << "Options3dPanelAide> creation pop-up-help Opt 3d Panel" <<
		endl;

	    S6GereFenet::opt3dpanel_help = new Help(GetId(),
		S6Traduc::traduc[287],"OPT_3D_HELP");
	}	

	S6GereFenet::opt3dpanel_help->Montre();
}

void
Options3dPanelChoixN3d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeN4d(0);
	_pto->ChangeL3d(0);
	_pto->ChangeL4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixN3d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixN4d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeN3d(0);
	_pto->ChangeL3d(0);
	_pto->ChangeL4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixN4d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixF3d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeF4d(0);
	_pto->ChangeL3d(0);
	_pto->ChangeL4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixF3d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixF4d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeF3d(0);
	_pto->ChangeL3d(0);
	_pto->ChangeL4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixF4d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixFimo::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeFi3d(0);
	_pto->ChangeFi4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixFimo::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixFi3d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeFimo(0);
	_pto->ChangeFi4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixFi3d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixFi4d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeFimo(0);
	_pto->ChangeFi3d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixFi4d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixL3d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeL4d(0);
	_pto->ChangeN3d(0);
	_pto->ChangeN4d(0);
	_pto->ChangeF3d(0);
	_pto->ChangeF4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixL3d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixL4d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeL3d(0);
	_pto->ChangeN3d(0);
	_pto->ChangeN4d(0);
	_pto->ChangeF3d(0);
	_pto->ChangeF4d(0);
	_pto->ChangeP3d(0);
	_pto->ChangeP4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixL4d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixP3d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeP4d(0);
	_pto->ChangeN3d(0);
	_pto->ChangeN4d(0);
	_pto->ChangeF3d(0);
	_pto->ChangeF4d(0);
	_pto->ChangeL3d(0);
	_pto->ChangeL4d(0);
	_pto->ChangeFimo(0);
	_pto->ChangeFi3d(0);
	_pto->ChangeFi4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixP3d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixP4d::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->ChangeP3d(0);
	_pto->ChangeN3d(0);
	_pto->ChangeN4d(0);
	_pto->ChangeF3d(0);
	_pto->ChangeF4d(0);
	_pto->ChangeL3d(0);
	_pto->ChangeL4d(0);
	_pto->ChangeFimo(0);
	_pto->ChangeFi3d(0);
	_pto->ChangeFi4d(0);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixP4d::UnSelectCB(XtPointer call_data)
{
	BoutonDeChoix::UnSelectCB(call_data);
	_pto->CalculOpt3d();
}

void
Options3dPanelChoixSansm::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->CalculMasque(0);
}

void
Options3dPanelChoixMasq0::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->CalculMasque(1);
}

void
Options3dPanelChoixMasq1::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->CalculMasque(2);
}

void
Options3dPanelChoixMasq2::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	_pto->CalculMasque(3);
}

// *************************************************************
// sous-menu maps de couleurs...................................
// *************************************************************

MapDeCouleur::MapDeCouleur(const Widget& parent,const char* label) :
		PullDownSubMenuExclusif(parent, label),
		_autres(GetId(),S6Traduc::map[0]),
		_absolute(GetId(),S6Traduc::map[1]),
		_binary(GetId(),S6Traduc::map[2]),
		_blue_green(GetId(),S6Traduc::map[3]),
		_default(GetId(),S6Traduc::map[4]),
		_negative(GetId(),S6Traduc::map[5]),
		_positive(GetId(),S6Traduc::map[6]),
		_rainbow(GetId(),S6Traduc::map[7]),
		_rainbowhls(GetId(),S6Traduc::map[8]),
		_random(GetId(),S6Traduc::map[9]),
		_red_blue(GetId(),S6Traduc::map[10]),
		_red_green(GetId(),S6Traduc::map[11]),
		_shifted(GetId(),S6Traduc::map[12]),
		_standardl3(GetId(),S6Traduc::map[13]),
		_dlpp1(GetId(),S6Traduc::map[14]),
		_xcode(GetId(),S6Traduc::map[15]),
		_invdefault(GetId(),S6Traduc::map[16])
{
	Lignes(2);

	int choix = -1;

	Change(choix);
}

void
MapDeCouleur::Change(int& choix)
{
	_autres.Change(FALSE);
	_absolute.Change(FALSE);
	_binary.Change(FALSE);
	_blue_green.Change(FALSE);
	_default.Change(FALSE);
	_negative.Change(FALSE);
	_positive.Change(FALSE);
	_rainbow.Change(FALSE);
	_rainbowhls.Change(FALSE);
	_random.Change(FALSE);
	_red_blue.Change(FALSE);
	_red_green.Change(FALSE);
	_shifted.Change(FALSE);
	_standardl3.Change(FALSE);
	_dlpp1.Change(FALSE);
	_xcode.Change(FALSE);
	_invdefault.Change(FALSE);

	switch(choix)
	{
	    case -1 :
		_autres.Change(TRUE);
		break;
	    case 0 :
		_absolute.Change(TRUE);
		break;
	    case 1 :
		_binary.Change(TRUE);
		break;
	    case 2 :
		_blue_green.Change(TRUE);
		break;
	    case 3 :
		_default.Change(TRUE);
		break;
	    case 4 :
		_negative.Change(TRUE);
		break;
	    case 5 :
		_positive.Change(TRUE);
		break;
	    case 6 :
		_rainbow.Change(TRUE);
		break;
	    case 7 :
		_rainbowhls.Change(TRUE);
		break;
	    case 8 :
		_random.Change(TRUE);
		break;
	    case 9 :
		_red_blue.Change(TRUE);
		break;
	    case 10 :
		_red_green.Change(TRUE);
		break;
	    case 11 :
		_shifted.Change(TRUE);
		break;
	    case 12 :
		_standardl3.Change(TRUE);
		break;
	    case 13 :
		_dlpp1.Change(TRUE);
		break;
	    case 14 :
		_xcode.Change(TRUE);
		break;
	    case 15 :
		_invdefault.Change(TRUE);
		break;
	    default :
		choix = -1;
		_autres.Change(TRUE);
		break;
	}

}

void
MapDeCouleurAutres::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = -1;
}

void
MapDeCouleurAbsolute::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 0;
}

void
MapDeCouleurBinary::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 1;
}
void
MapDeCouleurBlueGreen::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 2;
}

void
MapDeCouleurDefault::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 3;
}

void
MapDeCouleurNegative::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 4;
}
void
MapDeCouleurPositive::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 5;
}

void
MapDeCouleurRainbow::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 6;
}

void
MapDeCouleurRainbowHls::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 7;
}
void
MapDeCouleurRandom::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 8;
}

void
MapDeCouleurRedBlue::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 9;
}

void
MapDeCouleurRedGreen::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 10;
}

void
MapDeCouleurShifted::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 11;
}

void
MapDeCouleurStandardL3::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 12;
}

void
MapDeCouleurDlpp1::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 13;
}

void
MapDeCouleurXcode::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 14;
}

void
MapDeCouleurInvDefault::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);

	parametre_map = 15;
}
