#ifndef S6BOUTTONS8_H
#define S6BOUTTONS8_H

// %W% %G% P. Brochard
// definitions des classes de bouttons

// communication avec le panneau print de l'afficheur X11...............

class U8PrintPsyche : public U8Print
{
    public:

	U8PrintPsyche();
	~U8PrintPsyche();

	void DestFich(const char* const fichier);
	void DestFichDeb(char* const fichier);
	void DestImp(const char* const imprimante);
	void DestType(int type);
	void Couleur(int coul);
	void Ident(int ident);
	void Chrono(int chrono);
	void VideoInv(int video_inv);
	void Logo(int logo);
	void Eps(int eps);
	void TexteNoir(int texte_noir);
	void DimExacte(int dim_exacte);
	void Landscape(int landscape);
	void Titre(const char* const titre);
};

inline U8PrintPsyche::U8PrintPsyche() : U8Print()
{
}

inline U8PrintPsyche::~U8PrintPsyche()
{
}

// communication avec le panneau taille de l'afficheur X11...............

class PsycheTailleCommuniq : public TailleCommuniq
{
    public:

	PsycheTailleCommuniq();
	~PsycheTailleCommuniq();

	void Action(unsigned largeur,unsigned hauteur,REEL clip_largeur,
			REEL clip_hauteur);
};

inline PsycheTailleCommuniq::PsycheTailleCommuniq() : TailleCommuniq()
{
}

inline PsycheTailleCommuniq::~PsycheTailleCommuniq()
{
}

// communication avec le bouton break de l'afficheur X11...............

class PsycheBreakCommuniq : public BreakCommuniq
{
    public :

	PsycheBreakCommuniq();
	~PsycheBreakCommuniq();

	void Action();
};

inline PsycheBreakCommuniq::PsycheBreakCommuniq() : BreakCommuniq()
{
}

inline PsycheBreakCommuniq::~PsycheBreakCommuniq()
{
}

// sous-menu zoom graphique .............................................

class ZoomGrafAgrand : public PullDownEntry
{
    public:
   
	ZoomGrafAgrand(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGrafAgrand() {};
      
	void SelectCB(XtPointer call_data);
};

class ZoomGrafAgrandCarre : public PullDownEntry
{
    public:
   
	ZoomGrafAgrandCarre(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGrafAgrandCarre() {};
      
	void SelectCB(XtPointer call_data);
};

class ZoomGrafReduc : public PullDownEntry
{
    public :

	ZoomGrafReduc(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGrafReduc() {};

	void SelectCB(XtPointer call_data);
};

class ZoomGrafReducCarre : public PullDownEntry
{
    public :

	ZoomGrafReducCarre(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGrafReducCarre() {};

	void SelectCB(XtPointer call_data);
};

class ZoomGraf14 : public PullDownEntry
{
    public :

	ZoomGraf14(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGraf14() {};

	void SelectCB(XtPointer call_data);
};

class ZoomGraf24 : public PullDownEntry
{
    public :

	ZoomGraf24(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGraf24() {};

	void SelectCB(XtPointer call_data);
};

class ZoomGraf34 : public PullDownEntry
{
    public :

	ZoomGraf34(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGraf34() {};

	void SelectCB(XtPointer call_data);
};

class ZoomGraf44 : public PullDownEntry
{
    public :

	ZoomGraf44(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGraf44() {};

	void SelectCB(XtPointer call_data);
};

class ZoomGrafNulZoom : public PullDownEntry
{
    public :

	ZoomGrafNulZoom(const Widget& parent, const char *label) :
		PullDownEntry(parent,label) {};
	~ZoomGrafNulZoom() {};

	void SelectCB(XtPointer call_data);
};

class ZoomGraf
{
    private:

	PullDownSubMenu		_graf;
	ZoomGrafAgrand		_graf_agrand;
	ZoomGrafAgrandCarre	_graf_agrand_carre;
	ZoomGrafReduc		_graf_reduc;
	ZoomGrafReducCarre	_graf_reduc_carre;
	ZoomGraf14   		_graf_14;
	ZoomGraf24   		_graf_24;
	ZoomGraf34   		_graf_34;
	ZoomGraf44   		_graf_44;
	ZoomGrafNulZoom		_graf_nul_zoom;

    public:

	ZoomGraf(const Widget& parent,const char *label);
	~ZoomGraf();

	void Montre();
	void Cache();
};

inline ZoomGraf::~ZoomGraf()
{
}

inline void ZoomGraf::Montre()
{
	_graf.Montre();
}

inline void ZoomGraf::Cache()
{
	_graf.Cache();
}

// sous-menu z = c .............................................

class ZeqC;

class ZeqCNon : public BoutonDeChoix
{
    private:

	ZeqC* _pto;

    public:
   
	ZeqCNon(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {_pto = NULL;};
	~ZeqCNon() {};
      
	void Attach(ZeqC* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class ZeqCOui : public BoutonDeChoix
{
    private:

	ZeqC* _pto;

    public :

	ZeqCOui(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {_pto = NULL;};
	~ZeqCOui() {};

	void Attach(ZeqC* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class ZeqC
{
    private:

	PullDownSubMenu	_scene;
	ZeqCNon		_non;
	ZeqCOui		_oui;

    public:

	ZeqC(const Widget& parent,const char *label);
	~ZeqC() {};

	void Change(int& choix);
};

// sous-menu MultiMono .............................................

class MultiMonoNon : public BoutonDeChoix
{   	
    public:
   
	MultiMonoNon(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {};
	~MultiMonoNon() {};
      
	void SelectCB(XtPointer call_data);
};

class MultiMonoOui : public BoutonDeChoix
{
    public :

	MultiMonoOui(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {};
	~MultiMonoOui() {};

	void SelectCB(XtPointer call_data);
};

class MultiMono
{
    private:

	PullDownSubMenuExclusif	_mulmo;
	MultiMonoNon		_non;
	MultiMonoOui		_oui;

    public:

	MultiMono(const Widget& parent,const char *label);
	~MultiMono() {};

	void Change(int& choix);
};

// ********************************************************
//           Options 3d Panneau
// ********************************************************

class Options3DPanel;

class Options3dPanelChoix : public BoutonDeChoix
{
    protected :

	Options3DPanel* _pto;

    public :

	Options3dPanelChoix(const Widget& parent, const char *label,
		Options3DPanel* pto=NULL) :
		BoutonDeChoix(parent,label) {_pto=pto;};
	~Options3dPanelChoix() {};

	void Attach(Options3DPanel* pto) {_pto=pto;};
};

class Options3dPanelChoixN3d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixN3d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixN3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixN4d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixN4d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixN4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixF3d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixF3d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixF3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixF4d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixF4d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixF4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixFimo : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixFimo(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixFimo() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixFi3d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixFi3d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixFi3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixFi4d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixFi4d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixFi4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixL3d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixL3d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixL3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixL4d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixL4d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixL4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixP3d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixP3d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixP3d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixP4d : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixP4d(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixP4d() {};
      
	void SelectCB(XtPointer call_data);
	void UnSelectCB(XtPointer call_data);
};

class Options3dPanelChoixSansm : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixSansm(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixSansm() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dPanelChoixMasq0 : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixMasq0(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixMasq0() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dPanelChoixMasq1 : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixMasq1(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixMasq1() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dPanelChoixMasq2 : public Options3dPanelChoix
{   	
    public:
   
	Options3dPanelChoixMasq2(const Widget& parent, const char *label, 
		Options3DPanel* pto=NULL) :
		Options3dPanelChoix(parent,label,pto) {};
	~Options3dPanelChoixMasq2() {};
      
	void SelectCB(XtPointer call_data);
};

class Options3dPanelOK : public Bouton
{
    private :

	Options3DPanel* _pto;

    public :

	Options3dPanelOK(const Widget& parent, const char* label,
		const char* classe,Options3DPanel* pto=NULL) :
		Bouton(parent,label,classe) {_pto=pto;};
	~Options3dPanelOK() {};

	void Attach(Options3DPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

struct Options3dPanelAnnuler : public Bouton
{	   
	Options3dPanelAnnuler(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~Options3dPanelAnnuler() {};
      
	void SelectCB(XtPointer call_data);
};

struct Options3dPanelAide : public Bouton
{	   
	Options3dPanelAide(const Widget& parent, const char *label, 
		const char* classe) :
		Bouton(parent,label,classe) {};
	~Options3dPanelAide() {};
      
	void SelectCB(XtPointer call_data);
};

struct Options3DPanelAppel : public PullDownEntry
{
	Options3DPanelAppel(const Widget& parent,const char* label);
	~Options3DPanelAppel() {};

	void SelectCB(XtPointer call_data);
};

class Options3DPanelSaisie : public Saisie
{
    private:

	Options3DPanel* _pto;
	
    public:
   
	Options3DPanelSaisie(const Widget& parent,const char* label,
			short int taille=3,
			const char* classe = "Options3DSaisie",
			Options3DPanel* pto=NULL) :
			Saisie(parent,label,taille,classe) {_pto = pto;};
	~Options3DPanelSaisie() {};

	void Attach(Options3DPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
	void ChangeValeur(int nombre);
};

class NumeroOptions3DSliderMin : public Slider
{
   private:

	Options3DPanel* _pto;
	
   public:
   
	NumeroOptions3DSliderMin(const Widget& parent, const char *label, 
			const int& mini,const int& maxi,
			const int& ValeurInitiale,
			const char* classe,int width=200,
			Options3DPanel* pto=NULL) :
			Slider(parent,label,mini,maxi,ValeurInitiale,
					classe,width)
	{_pto=pto;};
	~NumeroOptions3DSliderMin() {};

	void Attach(Options3DPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class NumeroOptions3DSliderMax : public Slider
{
   private:

	Options3DPanel* _pto;
	
   public:
   
	NumeroOptions3DSliderMax(const Widget& parent, const char *label, 
			const int& mini, const int& maxi,
			const int& ValeurInitiale,
			const char* classe,int width=200,
			Options3DPanel* pto=NULL) :
			Slider(parent,label,mini,maxi,ValeurInitiale,
					classe,width)
	{_pto=pto;};
	~NumeroOptions3DSliderMax() {};

	void Attach(Options3DPanel* pto) {_pto=pto;};
	void SelectCB(XtPointer call_data);
};

class Options3DPanel : public PopUp
{
    private:

	ConteneurLigne			_tout;

	ConteneurJoli			_opt_j;
	ConteneurLigne			_opt_l;

	ConteneurColonne		_opt_c;

	ConteneurLigne			_bloc_l;

	ConteneurJoli                   _nombre_j;

	ConteneurColonne		_nombre;
	Label				_nombre_label;
	Options3DPanelSaisie		_nombre_saisie;

	ConteneurJoli                   _numero_j;
	ConteneurLigne   		_numero_l;

	ConteneurColonne		_numero_min;
	Label				_numero_label_min;
	NumeroOptions3DSliderMin        _numero_slider_min;

	ConteneurColonne		_numero_max;
	Label				_numero_label_max;
	NumeroOptions3DSliderMax	_numero_slider_max;

	ConteneurJoli			_pixel_j;

	ConteneurColonne		_pixel;
	Label				_pixel_label;
	ConteneurColonne		_pixel_type;
	Options3dPanelChoixP3d		_p3d;
	Options3dPanelChoixP4d		_p4d;

	ConteneurJoli			_trace_j;
	ConteneurLigne			_trace_l;

	ConteneurColonne		_niveau;
	Label				_niveau_label;
	ConteneurColonne		_niveau_type;
	Options3dPanelChoixN3d		_n3d;
	Options3dPanelChoixN4d		_n4d;

	ConteneurColonne		_facette;
	Label				_facette_label;
	ConteneurColonne		_facette_type;
	Options3dPanelChoixF3d		_f3d;
	Options3dPanelChoixF4d		_f4d;

	ConteneurColonne		_filaire;
	Label				_filaire_label;
	ConteneurColonne		_filaire_type;
	Options3dPanelChoixFimo		_fimo;
	Options3dPanelChoixFi3d		_fi3d;
	Options3dPanelChoixFi4d		_fi4d;

	ConteneurColonne		_lissage;
	Label				_lissage_label;
	ConteneurColonne		_lissage_type;
	Options3dPanelChoixL3d		_l3d;
	Options3dPanelChoixL4d		_l4d;

	ConteneurJoli			_masque_j;

	ConteneurColonne		_masque;
	Label				_masque_label;
	ConteneurExclusifColonne	_masque_type;
	Options3dPanelChoixSansm	_sansm;
	Options3dPanelChoixMasq0	_masq0;
	Options3dPanelChoixMasq1	_masq1;
	Options3dPanelChoixMasq2	_masq2;

	ConteneurJoli			_standard_j;

	ConteneurColonne		_standard;
	Options3dPanelOK		_ok;
	Options3dPanelAnnuler		_annuler;
	Options3dPanelAide		_aide;

	int				_bloc_nombre;
	int				_bloc_numero_min;
	int				_bloc_numero_max;

    public:

	Options3DPanel(const Widget& root);
	~Options3DPanel() {};

	void ChangeOpt3d(int choix);

	void ChangeN3d(int choix) {_n3d.Change(choix);};
	void ChangeN4d(int choix) {_n4d.Change(choix);};

	void ChangeF3d(int choix) {_f3d.Change(choix);};
	void ChangeF4d(int choix) {_f4d.Change(choix);};

	void ChangeFimo(int choix) {_fimo.Change(choix);};
	void ChangeFi3d(int choix) {_fi3d.Change(choix);};
	void ChangeFi4d(int choix) {_fi4d.Change(choix);};

	void ChangeL3d(int choix) {_l3d.Change(choix);};
	void ChangeL4d(int choix) {_l4d.Change(choix);};

	void ChangeP3d(int choix) {_p3d.Change(choix);};
	void ChangeP4d(int choix) {_p4d.Change(choix);};

	void ChangeMasque(int choix);

	void ChangeSansm(int choix) {_sansm.Change(choix);};
	void ChangeMasq0(int choix) {_masq0.Change(choix);};
	void ChangeMasq1(int choix) {_masq1.Change(choix);};
	void ChangeMasq2(int choix) {_masq2.Change(choix);};

	void CalculOpt3d();
	int CalculOption3d();
	void CalculMasque(int choix);

	void Change(int min,int max,int pos_min,int pos_max);
	void Charge(int bloc_num_min,int bloc_num_max);
	void ChangeValeur(int nombre);
	void ChangeNombre();

	int GetValueSliderMin() {return _numero_slider_min.GetValue();};
	int GetValueSliderMax() {return _numero_slider_max.GetValue();};
};

// *************************************************************
// sous-menu maps de couleurs...................................
// *************************************************************

class MapDeCouleurAutres : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurAutres(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurAutres() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurAbsolute : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurAbsolute(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurAbsolute() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurBinary : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurBinary(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurBinary() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurBlueGreen : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurBlueGreen(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurBlueGreen() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurDefault : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurDefault(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurDefault() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurNegative : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurNegative(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {};
	~MapDeCouleurNegative() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurPositive : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurPositive(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {};
	~MapDeCouleurPositive() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurRainbow : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurRainbow(const Widget& parent, const char* label) :
		BoutonDeChoix(parent,label) {};
	~MapDeCouleurRainbow() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurRainbowHls : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurRainbowHls(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurRainbowHls() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurRandom : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurRandom(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurRandom() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurRedBlue : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurRedBlue(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurRedBlue() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurRedGreen : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurRedGreen(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurRedGreen() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurShifted : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurShifted(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurShifted() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurStandardL3 : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurStandardL3(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurStandardL3() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurDlpp1 : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurDlpp1(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurDlpp1() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurXcode : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurXcode(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurXcode() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleurInvDefault : public BoutonDeChoix
{   	
    public:
   
	MapDeCouleurInvDefault(const Widget& parent, const char* label) :
			BoutonDeChoix(parent,label) {};
	~MapDeCouleurInvDefault() {};
      
	void SelectCB(XtPointer call_data);
};

class MapDeCouleur : public PullDownSubMenuExclusif
{
    private:

	MapDeCouleurAutres	_autres;
	MapDeCouleurAbsolute	_absolute;
	MapDeCouleurBinary	_binary;
	MapDeCouleurBlueGreen	_blue_green;
	MapDeCouleurDefault	_default;
	MapDeCouleurNegative	_negative;
	MapDeCouleurPositive	_positive;
	MapDeCouleurRainbow	_rainbow;
	MapDeCouleurRainbowHls	_rainbowhls;
	MapDeCouleurRandom	_random;
	MapDeCouleurRedBlue	_red_blue;
	MapDeCouleurRedGreen	_red_green;
	MapDeCouleurShifted	_shifted;
	MapDeCouleurStandardL3	_standardl3;
	MapDeCouleurDlpp1	_dlpp1;
	MapDeCouleurXcode	_xcode;
	MapDeCouleurInvDefault	_invdefault;

    public:

	MapDeCouleur(const Widget& parent,const char *label);
	~MapDeCouleur() {};

	void Change(int& choix);
};
#endif /* S6BOUTTONS8_H */
