#include"S6bouttonsys2.h"
#include"S6bouttons7.h"
#include"S6bouttons9.h"
#include"S6constant.h"
#include"S6gerefenet.h"
#include"S6gerefich.h"
#include"S6points.h"
#include"S6gereconfig.h"
#include"S6traduc.h"
#include"S6flagssup.h"

struct SccsIdS6Bouttons9
{
	static const char* const sccs_id;
};

const char* const SccsIdS6Bouttons9::sccs_id = "%W% %G% P. Brochard";

// ******************************************************************
//		classes bouttons (suite) de Psyche
// ******************************************************************

// Coupes logiques .....................................................

CoupeLogiqueRetour3d::CoupeLogiqueRetour3d(const Widget& parent,
		const char* label,const char* classe) :
		PullDownEntry(parent, label,classe)
{
}

void
CoupeLogiqueRetour3d::SelectCB(XtPointer call_data)
{
	ModeTrace(S6Output::Output());
	PullDownEntry::SelectCB(call_data);
	S6GereFenet::ReConfigRetour3d();
}

// On cache la fenetre et on revient en mode 3d.

void
CoupeLogiqueRetour::SelectCB(XtPointer call_data)
{
	ModeTrace(S6Output::Output());
	Bouton::SelectCB(call_data);
	S6GereFenet::ReConfigRetour3d();
}

// On cache la fenetre en restant en mode de coupe logique.

void
CoupeLogiqueAnnuler::SelectCB(XtPointer call_data)
{
	Bouton::SelectCB(call_data);
	_pto->Cache();
}

CoupeLogiqueAppel::CoupeLogiqueAppel(const Widget& parent,const char* label,
		const char* classe) :
		PullDownEntry(parent, label,classe)
{
}

void
CoupeLogiqueAppel::SelectCB(XtPointer call_data)
{
	ModeTrace(S6Output::Output());
	PullDownEntry::SelectCB(call_data);

	if(!S6GereFenet::coupelogique)
	{
	    S6GereFenet::coupelogique = new
		CoupeLogique(S6GereFenet::root->ElVisuel()->GetId());
	}	

	if(S6FlagsSup::choix_trace != S6FlagsSup::TRACE_COUPE)
	{
	    delete[] S6FlagsSup::axe_valeur_x_save;

	    S6FlagsSup::axe_valeur_x_save = new char[strlen(axe_valeur_x) + 1];
            strcpy(S6FlagsSup::axe_valeur_x_save,axe_valeur_x);
            S6FlagsSup::axe_log_x_save = axe_log_x;
    	    S6FlagsSup::axe_x_min_save = axe_x_min;
	    S6FlagsSup::axe_x_max_save = axe_x_max;

            delete[] S6FlagsSup::axe_valeur_y_save;
    
            S6FlagsSup::axe_valeur_y_save = new char[strlen(axe_valeur_y) + 1];
            strcpy(S6FlagsSup::axe_valeur_y_save,axe_valeur_y);
            S6FlagsSup::axe_log_y_save = axe_log_y;
	    S6FlagsSup::axe_y_min_save = axe_y_min;
	    S6FlagsSup::axe_y_max_save = axe_y_max;
	}

	if(S6GereFenet::coupelogique)
	{
	    S6GereFenet::coupelogique->Change();
	    S6GereFenet::ChangeCoupeLogiqueValeurs();
	    S6GereFenet::coupelogique->Montre();
	}

	S6FlagsSup::choix_trace = S6FlagsSup::TRACE_COUPE;
	S6GereFenet::CacheExpose();
}

CoupeLogique::CoupeLogique(const Widget& root) :
		_pere(root,S6Traduc::traduc[203],300,200),
		_tout(_pere.GetId(),"COUPE_LOGIQUE_TOUT"),
		_tout1(_tout.GetId(),"COUPE_LOGIQUE_TOUT",-1),
		_tout2(_tout.GetId(),"COUPE_LOGIQUE_TOUT",-1),

		_active_cont(_tout1.GetId(),"ACTIVE_CONT",-1),
		_active(_active_cont.GetId(),""),

		_coupe_en_i_joli(_tout1.GetId(),"COUPE_EN_I_JOLI"),
		_coupe_en_i_cont(_coupe_en_i_joli.GetId(),"COUPE_EN_I_CONT",-1),
		_coupe_en_i_label(_coupe_en_i_cont.GetId(),
			S6Traduc::traduc[184]),
		_coupe_en_i_slider(_coupe_en_i_cont.GetId(),"",0,1,0,
			"coupe_en_i"),

		_coupe_en_j_joli(_tout1.GetId(),"COUPE_EN_J_JOLI"),
		_coupe_en_j_cont(_coupe_en_j_joli.GetId(),"COUPE_EN_J_CONT",-1),
		_coupe_en_j_label(_coupe_en_j_cont.GetId(),
			S6Traduc::traduc[185]),
		_coupe_en_j_slider(_coupe_en_j_cont.GetId(),"",0,1,0,
			"coupe_en_j"),

		_moyenne_en_i_joli(_tout1.GetId(),"MOYENNE_EN_I_JOLI"),
		_moyenne_en_i_cont(_moyenne_en_i_joli.GetId(),"MOYENNE_EN_I_CONT",-1),
		_moyenne_imin_cont(_moyenne_en_i_cont.GetId(),"MOYENNE_IMIN_CONT",-1),
		_moyenne_imin_label(_moyenne_imin_cont.GetId(),
			S6Traduc::traduc[186]),
		_moyenne_imin_slider(_moyenne_imin_cont.GetId(),"",0,1,0,
			"moyenne_i_min"),

		_moyenne_imax_cont(_moyenne_en_i_cont.GetId(),"MOYENNE_IMAX_CONT",-1),
		_moyenne_imax_label(_moyenne_imax_cont.GetId(),
			S6Traduc::traduc[187]),
		_moyenne_imax_slider(_moyenne_imax_cont.GetId(),"",0,1,0,
			"moyenne_i_max"),

		_moyenne_en_j_joli(_tout1.GetId(),"MOYENNE_EN_J_JOLI"),
		_moyenne_en_j_cont(_moyenne_en_j_joli.GetId(),"MOYENNE_EN_J_CONT",-1),
		_moyenne_jmin_cont(_moyenne_en_j_cont.GetId(),"MOYENNE_JMIN_CONT",-1),
		_moyenne_jmin_label(_moyenne_jmin_cont.GetId(),
			S6Traduc::traduc[188]),
		_moyenne_jmin_slider(_moyenne_jmin_cont.GetId(),"",0,1,0,
			"moyenne_j_min"),

		_moyenne_jmax_cont(_moyenne_en_j_cont.GetId(),"MOYENNE_JMAX_CONT",-1),
		_moyenne_jmax_label(_moyenne_jmax_cont.GetId(),
			S6Traduc::traduc[189]),
		_moyenne_jmax_slider(_moyenne_jmax_cont.GetId(),"",0,1,0,
			"moyenne_j_max"),

		_projection_en_i_joli(_tout2.GetId(),"PROJECTION_EN_I_JOLI"),
		_projection_en_i_cont(_projection_en_i_joli.GetId(),"PROJECTION_EN_I_CONT",-1),
		_projection_imin_cont(_projection_en_i_cont.GetId(),"PROJECTION_IMIN_CONT",-1),
		_projection_imin_label(_projection_imin_cont.GetId(),
			S6Traduc::traduc[190]),
		_projection_imin_slider(_projection_imin_cont.GetId(),"",0,1,0,
			"projection_i_min"),

		_projection_imax_cont(_projection_en_i_cont.GetId(),"PROJECTION_IMAX_CONT",-1),
		_projection_imax_label(_projection_imax_cont.GetId(),
			S6Traduc::traduc[191]),
		_projection_imax_slider(_projection_imax_cont.GetId(),"",0,1,0,
			"projection_i_max"),

		_projection_ipas_cont(_projection_en_i_cont.GetId(),"PROJECTION_IPAS_CONT",-1),
		_projection_ipas_label(_projection_ipas_cont.GetId(),
			S6Traduc::traduc[192]),
		_projection_ipas_slider(_projection_ipas_cont.GetId(),"",0,1,0,
			"projection_i_pas"),

		_projection_en_j_joli(_tout2.GetId(),"PROJECTION_EN_J_JOLI"),
		_projection_en_j_cont(_projection_en_j_joli.GetId(),"PROJECTION_EN_J_CONT",-1),
		_projection_jmin_cont(_projection_en_j_cont.GetId(),"PROJECTION_JMIN_CONT",-1),
		_projection_jmin_label(_projection_jmin_cont.GetId(),
			S6Traduc::traduc[193]),
		_projection_jmin_slider(_projection_jmin_cont.GetId(),"",0,1,0,
			"projection_j_min"),

		_projection_jmax_cont(_projection_en_j_cont.GetId(),"PROJECTION_JMAX_CONT",-1),
		_projection_jmax_label(_projection_jmax_cont.GetId(),
			S6Traduc::traduc[194]),
		_projection_jmax_slider(_projection_jmax_cont.GetId(),"",0,1,0,
			"projection_j_max"),

		_projection_jpas_cont(_projection_en_j_cont.GetId(),"PROJECTION_JPAS_CONT",-1),
		_projection_jpas_label(_projection_jpas_cont.GetId(),
			S6Traduc::traduc[195]),
		_projection_jpas_slider(_projection_jpas_cont.GetId(),"",0,1,0,
				"projection_j_pas"),

		_retour_cont(_tout2.GetId(),"RETOUR_CONT",-1),
		_retour(_retour_cont.GetId(),S6Traduc::traduc[204],"BTN_OAA"),
		_annuler(_retour_cont.GetId(),S6Traduc::traduc[228],"BTN_OAA",this)

{
	_coupe_en_i_slider.Attach(&_active);
	_coupe_en_j_slider.Attach(&_active);
	_moyenne_imin_slider.Attach(&_active);
	_moyenne_imax_slider.Attach(&_active);
	_moyenne_jmin_slider.Attach(&_active);
	_moyenne_jmax_slider.Attach(&_active);
	_projection_imin_slider.Attach(&_active);
	_projection_imax_slider.Attach(&_active);
	_projection_ipas_slider.Attach(&_active);
	_projection_jmin_slider.Attach(&_active);
	_projection_jmax_slider.Attach(&_active);
	_projection_jpas_slider.Attach(&_active);

	_coupe_en_i_cont.Margin(0);
	_coupe_en_j_cont.Margin(0);
	_moyenne_imin_cont.Margin(0);
	_moyenne_imax_cont.Margin(0);
	_moyenne_jmin_cont.Margin(0);
	_moyenne_jmax_cont.Margin(0);
	_projection_imin_cont.Margin(0);
	_projection_imax_cont.Margin(0);
	_projection_ipas_cont.Margin(0);
	_projection_jmin_cont.Margin(0);
	_projection_jmax_cont.Margin(0);
	_projection_jpas_cont.Margin(0);

	_pere.BloqueGeom();
}

void
CoupeLogique::Change()
{
	register unsigned nb_bloc = S6GereFichier::pt_points->DonneeAbstraite();
	register int nx = 0;
	register int ny = 0;

	if(nb_bloc)
	{
	    nx = S6GereFichier::pt_points->DonneeAbstraite()[nb_bloc-1]->Nx();
	    ny = S6GereFichier::pt_points->DonneeAbstraite()[nb_bloc-1]->Ny();
	}

	_coupe_en_i_slider.Change(0,nx-1,coupe_val_coup_i);
	_coupe_en_j_slider.Change(0,ny-1,coupe_val_coup_j);
	_moyenne_imin_slider.Change(0,nx-1,coupe_val_moy_deb_i);
	_moyenne_imax_slider.Change(0,nx-1,coupe_val_moy_fin_i);
	_moyenne_jmin_slider.Change(0,ny-1,coupe_val_moy_deb_j);
	_moyenne_jmax_slider.Change(0,ny-1,coupe_val_moy_fin_j);
	_projection_imin_slider.Change(0,nx-1,coupe_val_proj_deb_i);
	_projection_imax_slider.Change(0,nx-1,coupe_val_proj_fin_i);
	_projection_ipas_slider.Change(1,nx-1,coupe_val_proj_pas_i);
	_projection_jmin_slider.Change(0,ny-1,coupe_val_proj_deb_j);
	_projection_jmax_slider.Change(0,ny-1,coupe_val_proj_fin_j);
	_projection_jpas_slider.Change(1,ny-1,coupe_val_proj_pas_j);

	switch(coupe_type)
	{
	  case 1 :
	    _active.Change(S6Traduc::traduc[197]);
	    break;

	  case 2 :
	    _active.Change(S6Traduc::traduc[198]);
	    break;

	  case 3 :
	    _active.Change(S6Traduc::traduc[199]);
	    break;

	  case 4 :
	    _active.Change(S6Traduc::traduc[200]);
	    break;

	  case 5 :
	    _active.Change(S6Traduc::traduc[201]);
	    break;

	  case 6 :
	    _active.Change(S6Traduc::traduc[202]);
	    break;
	}

}

void
CoupeLogique::Cache()
{
	_pere.Cache();
}

void
CoupeLogique::Montre()
{
	_pere.Montre();
}

void
SliderCoupeEni::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_coup_i = GetValue();
	coupe_type = 1;

	_pto->Change(S6Traduc::traduc[197]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_y_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_y_save);
	axe_log_x = S6FlagsSup::axe_log_y_save;
	axe_x_min = S6FlagsSup::axe_y_min_save;
	axe_x_max = S6FlagsSup::axe_y_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderCoupeEnj::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_coup_j = GetValue();
	coupe_type = 2;

	_pto->Change(S6Traduc::traduc[198]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_x_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_x_save);
	axe_log_x = S6FlagsSup::axe_log_x_save;
	axe_x_min = S6FlagsSup::axe_x_min_save;
	axe_x_max = S6FlagsSup::axe_x_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderMoyenneImin::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_moy_deb_i = GetValue();
	coupe_type = 3;

	_pto->Change(S6Traduc::traduc[199]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_y_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_y_save);
	axe_log_x = S6FlagsSup::axe_log_y_save;
	axe_x_min = S6FlagsSup::axe_y_min_save;
	axe_x_max = S6FlagsSup::axe_y_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 8];
	strcpy(axe_valeur_y,"moy de ");
	strcat(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderMoyenneImax::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_moy_fin_i = GetValue();
	coupe_type = 3;

	_pto->Change(S6Traduc::traduc[199]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_y_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_y_save);
	axe_log_x = S6FlagsSup::axe_log_y_save;
	axe_x_min = S6FlagsSup::axe_y_min_save;
	axe_x_max = S6FlagsSup::axe_y_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 8];
	strcpy(axe_valeur_y,"moy de ");
	strcat(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderMoyenneJmin::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_moy_deb_j = GetValue();
	coupe_type = 4;

	_pto->Change(S6Traduc::traduc[200]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_x_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_x_save);
	axe_log_x = S6FlagsSup::axe_log_x_save;
	axe_x_min = S6FlagsSup::axe_x_min_save;
	axe_x_max = S6FlagsSup::axe_x_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 8];
	strcpy(axe_valeur_y,"moy de ");
	strcat(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderMoyenneJmax::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_moy_fin_j = GetValue();
	coupe_type = 4;

	_pto->Change(S6Traduc::traduc[200]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_x_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_x_save);
	axe_log_x = S6FlagsSup::axe_log_x_save;
	axe_x_min = S6FlagsSup::axe_x_min_save;
	axe_x_max = S6FlagsSup::axe_x_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 8];
	strcpy(axe_valeur_y,"moy de ");
	strcat(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderProjectionImin::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_proj_deb_i = GetValue();
	coupe_type = 5;

	_pto->Change(S6Traduc::traduc[201]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_y_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_y_save);
	axe_log_x = S6FlagsSup::axe_log_y_save;
	axe_x_min = S6FlagsSup::axe_y_min_save;
	axe_x_max = S6FlagsSup::axe_y_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderProjectionImax::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_proj_fin_i = GetValue();
	coupe_type = 5;

	_pto->Change(S6Traduc::traduc[201]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_y_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_y_save);
	axe_log_x = S6FlagsSup::axe_log_y_save;
	axe_x_min = S6FlagsSup::axe_y_min_save;
	axe_x_max = S6FlagsSup::axe_y_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderProjectionIpas::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_proj_pas_i = GetValue();
	coupe_type = 5;

	_pto->Change(S6Traduc::traduc[201]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_y_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_y_save);
	axe_log_x = S6FlagsSup::axe_log_y_save;
	axe_x_min = S6FlagsSup::axe_y_min_save;
	axe_x_max = S6FlagsSup::axe_y_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderProjectionJmin::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_proj_deb_j = GetValue();
	coupe_type = 6;

	_pto->Change(S6Traduc::traduc[202]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_x_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_x_save);
	axe_log_x = S6FlagsSup::axe_log_x_save;
	axe_x_min = S6FlagsSup::axe_x_min_save;
	axe_x_max = S6FlagsSup::axe_x_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderProjectionJmax::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_proj_fin_j = GetValue();
	coupe_type = 6;

	_pto->Change(S6Traduc::traduc[202]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_x_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_x_save);
	axe_log_x = S6FlagsSup::axe_log_x_save;
	axe_x_min = S6FlagsSup::axe_x_min_save;
	axe_x_max = S6FlagsSup::axe_x_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

void
SliderProjectionJpas::SelectCB(XtPointer call_data)
{
	Slider::SelectCB(call_data);

	coupe_val_proj_pas_j = GetValue();
	coupe_type = 6;

	_pto->Change(S6Traduc::traduc[202]);

	delete[] axe_valeur_x;

	axe_valeur_x = new char[strlen(S6FlagsSup::axe_valeur_x_save) + 1];
	strcpy(axe_valeur_x,S6FlagsSup::axe_valeur_x_save);
	axe_log_x = S6FlagsSup::axe_log_x_save;
	axe_x_min = S6FlagsSup::axe_x_min_save;
	axe_x_max = S6FlagsSup::axe_x_max_save;

	delete[] axe_valeur_y;

	axe_valeur_y = new char[strlen(axe_valeur_z) + 1];
	strcpy(axe_valeur_y,axe_valeur_z);
	axe_log_y = axe_log_z;
	axe_y_min = axe_z_min;
	axe_y_max = axe_z_max;

	if(S6GereFenet::axes)
	{
	    S6GereFenet::axes->ChangeAxeX();
	    S6GereFenet::axes->ChangeAxeY();
	    S6GereFenet::axes->ChangeAxeMinX();
	    S6GereFenet::axes->ChangeAxeMaxX();
	    S6GereFenet::axes->ChangeAxeMinY();
	    S6GereFenet::axes->ChangeAxeMaxY();
	}

     // on annulle le zoom calcule 2d pour une nouvelle coupe :

	zoom_actif = 0;
	zoom_cur_x_min = 0.;
	zoom_cur_y_min = 0.;
	zoom_cur_x_max = 0.;
	zoom_cur_y_max = 0.;

	S6FlagsSup::coupe_regenere = TRUE;
}

// sous-menu mode pixmap .............................................

ModePixmap::ModePixmap(const Widget& parent,const char *label) :
		_modepixmap(parent, label),
		_oui(_modepixmap.GetId(),S6Traduc::traduc[111]),
		_non(_modepixmap.GetId(),S6Traduc::traduc[110])

{
	_non.Change(TRUE);
	_oui.Change(FALSE);
}

void
ModePixmap::Change(int& choix)
{
	_non.Change(FALSE);
	_oui.Change(FALSE);

	switch(choix)
	{
	    case 0 :
		_non.Change(TRUE);
		break;
	    case 1 :
		_oui.Change(TRUE);
		break;
	    default :
		choix = 0;
		_non.Change(TRUE);
		break;
	}

}

void
ModePixmapNon::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	afficheur_pixmap = 0;
	S6GereFenet::ReConfigModePixmapAff();
}

void
ModePixmapOui::SelectCB(XtPointer call_data)
{
	BoutonDeChoix::SelectCB(call_data);
	afficheur_pixmap = 1;
	S6GereFenet::ReConfigModePixmapAff();
}
