#ifndef S6GERECONFIG_H
#define S6GERECONFIG_H

// %W% %G% Pierre Brochard

#include "cameleon/C5tabconfig.h"

// ***************************************************************************
//    fonctions de lecture et d'ecriture de fichiers de config pour Psyche
//    pour ajouter des mots cles, ajoutez :
//        -le #define du mot cle
//        -dans le .C un new config
//	-dans le .C l'initialisation du mot cle dans la chaine de caractere
// ****************************************************************************

class S6GereConfig
{
	friend int main(int,char**);
	friend class S6Points;
	friend class S6PointsAscii;
	friend class S6PointsUcd;
	friend class S6PointsMtv;
	friend class S6Trace;
	friend class S6InitCourbe;
	friend class LitBouton;
	friend class EcritBouton;
	friend class S6GereFenet;
	friend class S6GereFichier;
	friend class Options3dTraceX;
	friend class Options3dTraceY;
	friend class Options3dTraceXY;
	friend class Options3dChoixSansm;
	friend class Options3dChoixMasq0;
	friend class Options3dChoixMasq1;
	friend class Options3dChoixMasq2;
	friend class Options3dChoixOui;
	friend class Options3dChoixNon;
	friend class Options2dChoixCour;
	friend class Options2dChoixInte;
	friend class Options2dChoixDeri;
	friend class Options2dChoixOui;
	friend class Options2dChoixNon;
	friend class Grilles;
	friend class FondNon;
	friend class FondOui;
	friend class FondGarde;
	friend class Axes;
	friend class TitresAxes;
	friend class Zoom2dUnZoom;
	friend class Zoom2dZoom;
	friend class Vue2d;
	friend class Vue3d;
	friend class CoupeLogique;
	friend class CoupeLogiqueAppel;
	friend class CoupeLogiqueRetour3d;
	friend class SliderCoupeEni;
	friend class SliderCoupeEnj;
	friend class SliderMoyenneImin;
	friend class SliderMoyenneImax;
	friend class SliderMoyenneJmin;
	friend class SliderMoyenneJmax;
	friend class SliderProjectionImin;
	friend class SliderProjectionImax;
	friend class SliderProjectionIpas;
	friend class SliderProjectionJmin;
	friend class SliderProjectionJmax;
	friend class SliderProjectionJpas;
	friend class Courbes;
	friend class GestionDonnees;
	friend class GestionDonneesOK;
	friend class NumeroDonneeNoeudSaisie;
	friend class AxeOK;
	friend class AxeAnnuler;
	friend class TitresAxeOK;
	friend class TitresAxeAnnuler;
	friend class GrilleOK;
	friend class GrilleAnnuler;
	friend class TitreOK;
	friend class TitreAnnuler;
	friend class TexteOK;
	friend class TexteAnnuler;
	friend class EchelleOK;
	friend class EchelleAnnuler;
	friend class SceneNon;
	friend class SceneOui;
	friend class SceneEfface;
	friend class CourbeOK;
	friend class CourbeAnnuler;
	friend class AxeDroit;
	friend class AxeDroitOK;
	friend class AxeDroitAnnuler;
	friend class Coord2d;
	friend class Coord2dDroit;
	friend class PointDeVueOK;
	friend class PointDeVueAnnuler;
	friend class DimensionOK;
	friend class DimensionAnnuler;
	friend class AnimationOK;
	friend class AnimationAnnuler;
	friend class GestionCouleurOK;
	friend class GestionCouleurAnnuler;
	friend class CoulSurfOK;
	friend class CoulSurfAnnuler;
	friend class PsycheTailleCommuniq;
	friend class ZoomGrafAgrand;
	friend class ZoomGrafReduc;
	friend class ZoomGrafAgrandCarre;
	friend class ZoomGrafReducCarre;
	friend class ZoomGrafNulZoom;
	friend class ZoomGraf14;
	friend class ZoomGraf24;
	friend class ZoomGraf34;
	friend class ZoomGraf44;
	friend class ModePixmapOui;
	friend class ModePixmapNon;
	friend class AvancePsyBouton;
	friend class ReculePsyBouton;
	friend class AllPsyBouton;
	friend class NomPsyFichier;
	friend class ZeqCNon;
	friend class ZeqCOui;
	friend class Options3D;
	friend class Options3DPanel;
	friend class Options3dPanelOK;
	friend class Options3dPanelAnnuler;
	friend class Coupes3dPanel;
	friend class Coupes3dPanelOK;
	friend class Coupes3dPanelAnnuler;
	friend class Echelles;
	friend class CoulSurf;
	friend class Titres;
	friend class Textes;
	friend class L3Num;
	friend class PsyNum;
	friend class MapDeCouleurAutres;
	friend class MapDeCouleurAbsolute;
	friend class MapDeCouleurBinary;
	friend class MapDeCouleurBlueGreen;
	friend class MapDeCouleurDefault;
	friend class MapDeCouleurNegative;
	friend class MapDeCouleurPositive;
	friend class MapDeCouleurRainbow;
	friend class MapDeCouleurRainbowHls;
	friend class MapDeCouleurRandom;
	friend class MapDeCouleurRedBlue;
	friend class MapDeCouleurRedGreen;
	friend class MapDeCouleurShifted;
	friend class MapDeCouleurStandardL3;
	friend class MapDeCouleurDlpp1;
	friend class MapDeCouleurXcode;
	friend class MapDeCouleurInvDefault;
	friend class DestNegs;
	friend class DestT4014;
	friend class DestVisu;
	friend class DestPost;
	friend class DestPostCoul;
	friend class DestPostCoulFich;
	friend class DestPostscript;
	friend class DestLwc;
	friend class DestLwct;
	friend class DestX11;
	friend class DestPhigs;
	friend class DestPhigsx11;
	friend class DestPhigscgm;
	friend class DestGl;
	friend class DestXgl;
	friend class DestPhigsps;
	friend class DestPhigspsc;
	friend class DestPhigsrle;
	friend class DestGif;
	friend class DestPng;
	friend class DestPgml;
	friend class DestSvg;
	friend class DestXfig;
	friend class GestionDonneesAppel;
	friend class ChoixVerticalCouleurTitres;
	friend class ChoixVerticalCouleurGrille;
	friend class ChoixVerticalCouleurTitresAxes;
	friend class ChoixVerticalCouleurDessusSurf;
	friend class ChoixVerticalCouleurDessousSurf;
	friend class ChoixVerticalCouleurTextes;
	friend class ChoixVerticalCouleurCourbes;
	friend class S6InitFich;
	friend class Options3dChoixAutresSlider;
	friend class Coupes3dChoixAutresSlider;
	friend class EtatSocketOui;
	friend class EtatSocketNon;
	friend class EtatFichierBinaire;
	friend class EtatFichierAscii;
	friend class EtatFichierUcd;
	friend class EtatFichierRien;
	friend class EtatConfigOui;
	friend class EtatConfigNon;
	friend class EtatCacheOui;
	friend class EtatCacheNon;
	friend class EtatIhmOui;
	friend class EtatIhmNon;
	friend class S6ContContBase2D;
	friend class S6Output;
	friend class Coordonnees;
	friend class MultiMonoNon;
	friend class MultiMonoOui;
	friend class U8PixmapPsyche;
	friend class U8PrintPsyche;
	friend class U8AgrandPsyche;
	friend class U8ReducPsyche;
	friend class U8UnzoomPsyche;
	friend class NumeroCoupes3dSliderMin;
	friend class NumeroCoupes3dSliderMax;

    private :

        virtual void dummy() = 0;

        static const char* _identif;
        static const char* _identifbis;

        static TabC5ConfigEntSor _config;

        static int Charge(const char* const nomfich = NULL);
	static int Charge(const TabC5ConfigEntSor& tabconf);
        static int Ecrit(const char* const nomfich = NULL);
        static void Init();

        static void InitConfig();
        static void InitPrint();

        static int ConvertOld();

        static void ChangeTexte(int num_texte,const char* label,
			const char* unite,int affiche,int couleur,int taille,
			REEL posx,REEL posy,REEL angle);
        static char* ExtractTexte(int num_texte,const char* label);
	static void GrafNulZoom();
	static void GrafAgrand(P4Boolean mode_zoom_carre = FALSE);
	static void GrafReduc(P4Boolean mode_zoom_carre = FALSE);
};

// ********************************************************
//    classe module gerant les configs partielles
// ********************************************************

class S6GereConfigP
{
	friend class S6GereConfig;
	friend class S6Points;
	friend class S6PointsAscii;
	friend class S6PointsUcd;
	friend class S6InitCourbe;
	friend class S6Trace;
	friend class PointDeVue;
	friend class SliderAzimuth;
	friend class SliderSite;
	friend class SliderRoulis;
	friend class SliderDistance;
	friend class SliderRedrh;
	friend class SliderRedrv;
	friend class Titres;
	friend class TitresSaisie;
	friend class ChoixVerticalCouleurTitres;
	friend class ChoixVerticalTailleTitres;
	friend class Textes;
	friend class NombreTextesSaisie;
	friend class TextesSaisie;
	friend class ChoixVerticalCouleurTextes;
	friend class ChoixVerticalTailleTextes;
	friend class AngleTextesSlider;
	friend class GrilleChoixNon;
	friend class GrilleChoixCreuse;
	friend class GrilleChoixSemiCreuse;
	friend class GrilleChoixPleine;
	friend class GrilleChoixNonz;
	friend class GrilleChoixDefautz;
	friend class GrilleChoixPositionz;
	friend class GrilleChoixNonc;
	friend class GrilleChoixDefautc;
	friend class GrilleChoixPositionc;
	friend class GrilleChoixNon34d;
	friend class GrilleChoixDefaut34d;
	friend class GrilleChoixPosition34d;
	friend class GrilleChoixNon2d;
	friend class GrilleChoixDefaut2d;
	friend class GrilleChoixPosition2d;
	friend class ChoixVerticalCouleurGrille;
	friend class AxeChoixLinX;
	friend class AxeChoixLogX;
	friend class AxeChoixLinY;
	friend class AxeChoixLogY;
	friend class AxeChoixLinZ;
	friend class AxeChoixLogZ;
	friend class AxeChoixLinC;
	friend class AxeChoixLogC;
	friend class AxeTitreX;
	friend class AxeTitreY;
	friend class AxeTitreZ;
	friend class TitresAxeTitreX;
	friend class TitresAxeTitreY;
	friend class TitresAxeDroitTitreY;
	friend class TitresAxeTitreZ;
	friend class AxeMinX;
	friend class AxeMaxX;
	friend class AxeAutoXBouton;
	friend class AxeMinY;
	friend class AxeMaxY;
	friend class AxeAutoYBouton;
	friend class AxeMinZ;
	friend class AxeMaxZ;
	friend class AxeAutoZBouton;
	friend class AxeMinC;
	friend class AxeMaxC;
	friend class AxeAutoCBouton;
	friend class ChoixVerticalCouleurTitresAxes;
	friend class ChoixVerticalTailleTitresAxes;
	friend class ChoixVerticalTailleLabelsAxes;
	friend class Echelles;
	friend class ChoixLinZh;
	friend class ChoixLogZh;
	friend class ChoixLinCh;
	friend class ChoixLogCh;
	friend class MinZh;
	friend class MaxZh;
	friend class AutoZhBouton;
	friend class MinCh;
	friend class MaxCh;
	friend class AutoChBouton;
	friend class NiveauSliderZ;
	friend class NiveauSliderC;
	friend class Animation;
	friend class GestionCouleur;
	friend class SliderCoulBase;
	friend class SliderCoulPalette;
	friend class SliderPasAzimuth;
	friend class SliderPasSite;
	friend class SliderNombreAnim;
	friend class Dimensions;
	friend class PositionBoiteBouton;
	friend class X1cm;
	friend class X2cm;
	friend class BoiteDefautBouton;
	friend class Y1cm;
	friend class Y2cm;
	friend class DefautDxDy;
	friend class Dxcm;
	friend class Dycm;
	friend class Zoom2dUnZoom;
	friend class Zoom2dZoom;
	friend class Vue2d;
	friend class Vue3d;
	friend class Courbes;
	friend class NombreCourbesSaisie;
	friend class CourbesSaisie;
	friend class AxeOK;
	friend class AxeAnnuler;
	friend class TitresAxeOK;
	friend class TitresAxeAnnuler;
	friend class GrilleOK;
	friend class GrilleAnnuler;
	friend class TitreOK;
	friend class TitreAnnuler;
	friend class TexteOK;
	friend class TexteAnnuler;
	friend class EchelleOK;
	friend class EchelleAnnuler;
	friend class CourbeOK;
	friend class CourbeAnnuler;
	friend class AxeDroitChoixLinY;
	friend class AxeDroitChoixLogY;
	friend class AxeDroitTitreY;
	friend class AxeDroitMinY;
	friend class AxeDroitMaxY;
	friend class AxeDroitAutoYBouton;
	friend class AxeDroitOK;
	friend class AxeDroitAnnuler;
	friend class PointDeVueOK;
	friend class PointDeVueAnnuler;
	friend class DimensionOK;
	friend class DimensionAnnuler;
	friend class AnimationOK;
	friend class AnimationAnnuler;
	friend class GestionCouleurOK;
	friend class GestionCouleurAnnuler;
	friend class CoulSurf;
	friend class CoulSurfOK;
	friend class CoulSurfAnnuler;
	friend class ChoixVerticalCouleurDessusSurf;
	friend class ChoixVerticalCouleurDessousSurf;
	friend class Options3DPanel;
	friend class Options3dPanelOK;
	friend class Options3dPanelAnnuler;
	friend class Coupes3dPanel;
	friend class Coupes3dPanelOK;
	friend class Coupes3dPanelAnnuler;
	friend class Options3D;
	friend class Options3dChoixSansm;
	friend class Options3dChoixMasq0;
	friend class Options3dChoixMasq1;
	friend class Options3dChoixMasq2;
	friend class ChoixVerticalCouleurCourbes;
	friend class TexteGenerateurHard;
	friend class TexteGenerateurSoft;
	friend class NumeroDonneeNoeudSaisie;
	friend class NumeroCoupes3dSliderMin;
	friend class NumeroCoupes3dSliderMax;

    private :

        virtual void dummy() = 0;

        static TabC5ConfigEntSor _p_axe_config;
        static TabC5ConfigEntSor _p_titreaxe_config;
        static TabC5ConfigEntSor _p_axe_droit_config;
        static TabC5ConfigEntSor _p_grille_config;
        static TabC5ConfigEntSor _p_titre_config;
        static TabC5ConfigEntSor _p_texte_config;
        static TabC5ConfigEntSor _p_echelle_config;
        static TabC5ConfigEntSor _p_courbe_config;
        static TabC5ConfigEntSor _p_point_de_vue_config;
        static TabC5ConfigEntSor _p_dimension_config;
        static TabC5ConfigEntSor _p_animation_config;
        static TabC5ConfigEntSor _p_coulsurf_config;
        static TabC5ConfigEntSor _p_opt3d_config;
        static TabC5ConfigEntSor _p_coupe3d_config;
        static TabC5ConfigEntSor _p_pcco_config;
};

// ******************************************************************
//    classe module gerant l'ancienne config de Psyche (-V0 et -V1)
// ******************************************************************

class S6GereConfigOld
{
	friend class S6GereConfig;

    private:

        virtual void dummy() = 0;

        static const char* _identif;
        static const char* _identifnew;

        static TabC5ConfigEntSor _config;

	static unsigned _pos_courbes;
	static unsigned _taille_courbes;
	static unsigned _nb_last_lus;

    // ident = FALSE => on utilise _identif comme mot cle generique
    // ident = TRUE => on utilise _identif_new comme mot cle generique :

        static int Charge(const char* const nomfich = NULL,
			P4Boolean ident = FALSE);
	static int Charge(const TabC5ConfigEntSor& tabconf,
			P4Boolean ident = FALSE);

	static void Init();
	static int ReInit(const char* const identif);
};

// on n'utilise pas les operateurs de conversion avec passage par adresse
// car ibmrs6000 AIX xlC ne les appelle pas correctement sinon 
// c'est un bug du compilateur xlC !!!

// mais sur silicon IRIX CC c'est l'inverse il interprete mal operator cast& !!!

// g++ ni l'un ni l'autre !!

#define hauteur_z_h_min        S6GereConfig::_config[57].ReelA()
#define hauteur_z_h_max        S6GereConfig::_config[58].ReelA()
#define hauteur_z_log          S6GereConfig::_config[1].IntA()
#define hauteur_z              S6GereConfig::_config[114].TabReelA()
#define hauteur_z_taille       S6GereConfig::_config[114].IntA()
#define hauteur_z_config       S6GereConfig::_config[114]
#define hauteur_z_type         S6GereConfig::_config[46].IntA()    // icolo7z
#define hauteur_z_x_min        S6GereConfig::_config[66].ReelA()   // xpos7zi ...
#define hauteur_z_x_max        S6GereConfig::_config[67].ReelA()
#define hauteur_z_y_min        S6GereConfig::_config[68].ReelA()
#define hauteur_z_y_max        S6GereConfig::_config[69].ReelA()
#define hauteur_taille_z       S6GereConfig::_config[207].IntA()
#define hauteur_c_h_min        S6GereConfig::_config[59].ReelA()
#define hauteur_c_h_max        S6GereConfig::_config[60].ReelA()
#define hauteur_c_log          S6GereConfig::_config[0].IntA()
#define hauteur_c              S6GereConfig::_config[113].TabReelA()
#define hauteur_c_taille       S6GereConfig::_config[113].IntA()
#define hauteur_c_config       S6GereConfig::_config[113]
#define hauteur_c_type         S6GereConfig::_config[47].IntA()   // icolo7c
#define hauteur_c_x_min        S6GereConfig::_config[70].ReelA()
#define hauteur_c_x_max        S6GereConfig::_config[71].ReelA()
#define hauteur_c_y_min        S6GereConfig::_config[72].ReelA()
#define hauteur_c_y_max        S6GereConfig::_config[73].ReelA()
#define hauteur_taille_c       S6GereConfig::_config[206].IntA()
#define hauteur_label          S6GereConfig::_config[121].TabCharA()
#define hauteur_label_taille   S6GereConfig::_config[121].IntA()
#define hauteur_label_config   S6GereConfig::_config[121]
#define hauteur_label_type     S6GereConfig::_config[48].IntA()   // icolo7l
#define hauteur_label_x_min    S6GereConfig::_config[74].ReelA()
#define hauteur_label_x_max    S6GereConfig::_config[75].ReelA()
#define hauteur_label_y_min    S6GereConfig::_config[76].ReelA()
#define hauteur_label_y_max    S6GereConfig::_config[77].ReelA()
#define hauteur_taille_label   S6GereConfig::_config[205].IntA()
#define option_3d              S6GereConfig::_config[2].IntA()
#define option_3d_bloc         S6GereConfig::_config[212].TabIntA()
#define option_3d_bloc_t       S6GereConfig::_config[212].IntA()
#define option_3d_couleur_up   S6GereConfig::_config[41].IntA()
#define option_3d_couleur_down S6GereConfig::_config[42].IntA()
#define option_3d_cbloc_up     S6GereConfig::_config[203].TabIntA()
#define option_3d_cbloc_up_t   S6GereConfig::_config[203].IntA()
#define option_3d_cbloc_down   S6GereConfig::_config[204].TabIntA()
#define option_3d_cbloc_down_t S6GereConfig::_config[204].IntA()
#define option_3d_trace_fil    S6GereConfig::_config[136].IntA()
#define option_3d_tbloc_fil    S6GereConfig::_config[213].TabIntA()
#define option_3d_tbloc_fil_t  S6GereConfig::_config[213].IntA()
#define option_3d_conv_mu_mo   S6GereConfig::_config[160].IntA()
#define option_3d_z_eq_c       S6GereConfig::_config[161].IntA()
#define option_3d_zc_bloc      S6GereConfig::_config[214].TabIntA()
#define option_3d_zc_bloc_t    S6GereConfig::_config[214].IntA()
#define option_3d_masque       S6GereConfig::_config[45].IntA()
#define option_3d_mask_bloc    S6GereConfig::_config[215].TabIntA()
#define option_3d_mask_bloc_t  S6GereConfig::_config[215].IntA()
#define option_3d_concatene    S6GereConfig::_config[132].IntA()
#define option_3d_marqueur     S6GereConfig::_config[209].IntA()
#define option_3d_marq_bloc    S6GereConfig::_config[216].TabIntA()
#define option_3d_marq_bloc_t  S6GereConfig::_config[216].IntA()
#define coupe_hyperplan        S6GereConfig::_config[172].IntA()
#define coupe_hyperplan_bloc   S6GereConfig::_config[217].TabIntA()
#define coupe_hyperplan_bloc_t S6GereConfig::_config[217].IntA()
#define option_2d              S6GereConfig::_config[3].IntA()
#define option_2d_concatene    S6GereConfig::_config[124].IntA()
#define coupe_type             S6GereConfig::_config[4].IntA()
#define coupe_val_coup_i       S6GereConfig::_config[5].IntA()
#define coupe_val_coup_j       S6GereConfig::_config[6].IntA()
#define coupe_val_moy_deb_i    S6GereConfig::_config[7].IntA()
#define coupe_val_moy_fin_i    S6GereConfig::_config[8].IntA()
#define coupe_val_moy_deb_j    S6GereConfig::_config[9].IntA()
#define coupe_val_moy_fin_j    S6GereConfig::_config[10].IntA()
#define coupe_val_proj_deb_i   S6GereConfig::_config[11].IntA()
#define coupe_val_proj_fin_i   S6GereConfig::_config[12].IntA()
#define coupe_val_proj_pas_i   S6GereConfig::_config[130].IntA()
#define coupe_val_proj_deb_j   S6GereConfig::_config[13].IntA()
#define coupe_val_proj_fin_j   S6GereConfig::_config[14].IntA()
#define coupe_val_proj_pas_j   S6GereConfig::_config[131].IntA()
#define coupe_plan_a           S6GereConfig::_config[162].ReelA()
#define coupe_plan_a_bloc      S6GereConfig::_config[218].TabReelA()
#define coupe_plan_a_bloc_t    S6GereConfig::_config[218].IntA()
#define coupe_plan_b           S6GereConfig::_config[163].ReelA()
#define coupe_plan_b_bloc      S6GereConfig::_config[219].TabReelA()
#define coupe_plan_b_bloc_t    S6GereConfig::_config[219].IntA()
#define coupe_plan_c           S6GereConfig::_config[164].ReelA()
#define coupe_plan_c_bloc      S6GereConfig::_config[220].TabReelA()
#define coupe_plan_c_bloc_t    S6GereConfig::_config[220].IntA()
#define coupe_plan_d           S6GereConfig::_config[165].ReelA()
#define coupe_plan_d_bloc      S6GereConfig::_config[221].TabReelA()
#define coupe_plan_d_bloc_t    S6GereConfig::_config[221].IntA()
#define coupe_plan_e           S6GereConfig::_config[166].ReelA()
#define coupe_plan_e_bloc      S6GereConfig::_config[222].TabReelA()
#define coupe_plan_e_bloc_t    S6GereConfig::_config[222].IntA()
#define coupe_plan_e_bloc_c    S6GereConfig::_config[222]
#define coupe_plan_pas         S6GereConfig::_config[223].ReelA()
#define coupe_plan_pas_bloc    S6GereConfig::_config[224].TabReelA()
#define coupe_plan_pas_bloc_t  S6GereConfig::_config[224].IntA()
#define titre_numero           S6GereConfig::_config[15].IntA()
#define titre_affiche_haut     S6GereConfig::_config[16].IntA()
#define titre_affiche_bas      S6GereConfig::_config[17].IntA()
#define titre_affiche_gauche   S6GereConfig::_config[18].IntA()
#define titre_affiche_droit    S6GereConfig::_config[19].IntA()
#define titre_taille_haut      S6GereConfig::_config[20].IntA()
#define titre_taille_bas       S6GereConfig::_config[21].IntA()
#define titre_taille_gauche    S6GereConfig::_config[22].IntA()
#define titre_taille_droit     S6GereConfig::_config[23].IntA()
#define titre_couleur_haut     S6GereConfig::_config[24].IntA()
#define titre_couleur_bas      S6GereConfig::_config[25].IntA()
#define titre_couleur_gauche   S6GereConfig::_config[26].IntA()
#define titre_couleur_droit    S6GereConfig::_config[27].IntA()
#define titre_valeur_haut      S6GereConfig::_config[104].CharA()
#define titre_valeur_bas       S6GereConfig::_config[105].CharA()
#define titre_valeur_gauche    S6GereConfig::_config[106].CharA()
#define titre_valeur_droit     S6GereConfig::_config[107].CharA()
#define texte_generateur       S6GereConfig::_config[134].IntA()
#define texte_numero           S6GereConfig::_config[28].IntA()
#define texte_affiche          S6GereConfig::_config[108].TabIntA()
#define texte_affiche_taille   S6GereConfig::_config[108].IntA()
#define texte_affiche_config   S6GereConfig::_config[108]
#define texte_couleur          S6GereConfig::_config[109].TabIntA()
#define texte_couleur_taille   S6GereConfig::_config[109].IntA()
#define texte_couleur_config   S6GereConfig::_config[109]
#define texte_taille           S6GereConfig::_config[110].TabIntA()
#define texte_taille_taille    S6GereConfig::_config[110].IntA()
#define texte_taille_config    S6GereConfig::_config[110]
#define texte_pos_x            S6GereConfig::_config[115].TabReelA()
#define texte_pos_x_taille     S6GereConfig::_config[115].IntA()
#define texte_pos_x_config     S6GereConfig::_config[115]
#define texte_pos_y            S6GereConfig::_config[116].TabReelA()
#define texte_pos_y_taille     S6GereConfig::_config[116].IntA()
#define texte_pos_y_config     S6GereConfig::_config[116]
#define texte_angle            S6GereConfig::_config[117].TabReelA()
#define texte_angle_taille     S6GereConfig::_config[117].IntA()
#define texte_angle_config     S6GereConfig::_config[117]
#define texte_valeur           S6GereConfig::_config[122].TabCharA()
#define texte_valeur_taille    S6GereConfig::_config[122].IntA()
#define texte_valeur_config    S6GereConfig::_config[122]
#define grille_couleur         S6GereConfig::_config[29].IntA()
#define grille_type            S6GereConfig::_config[37].IntA()
#define grille_ecart_x         S6GereConfig::_config[147].ReelA()
#define grille_ecart_y         S6GereConfig::_config[148].ReelA()
#define grille_ecart_z         S6GereConfig::_config[149].ReelA()
#define grille_grad_x_nb       S6GereConfig::_config[157].IntA()
#define grille_grad_y_nb       S6GereConfig::_config[158].IntA()
#define grille_grad_z_nb       S6GereConfig::_config[159].IntA()
#define grille_grad_inter      S6GereConfig::_config[175].IntA()
#define grille_label2d_gauche  S6GereConfig::_config[197].IntA()
#define grille_label2d_droit   S6GereConfig::_config[198].IntA()
#define grille_label2d_bas     S6GereConfig::_config[199].IntA()
#define grille_label2d_haut    S6GereConfig::_config[200].IntA()
#define grille_label2d_yddroit S6GereConfig::_config[201].IntA()
#define axe_couleur_titre      S6GereConfig::_config[30].IntA()
#define axe_taille_titre       S6GereConfig::_config[31].IntA()
#define axe_taille_echelle     S6GereConfig::_config[32].IntA()
#define axe_log_x              S6GereConfig::_config[33].IntA()
#define axe_log_y              S6GereConfig::_config[34].IntA()
#define axe_log_z              S6GereConfig::_config[35].IntA()
#define axe_log_c              S6GereConfig::_config[36].IntA()
#define axe_log_yd             S6GereConfig::_config[143].IntA()
#define axe_x_min              S6GereConfig::_config[49].ReelA()
#define axe_x_max              S6GereConfig::_config[50].ReelA()
#define axe_y_min              S6GereConfig::_config[51].ReelA()
#define axe_y_max              S6GereConfig::_config[52].ReelA()
#define axe_z_min              S6GereConfig::_config[53].ReelA()
#define axe_z_max              S6GereConfig::_config[54].ReelA()
#define axe_c_min              S6GereConfig::_config[55].ReelA()
#define axe_c_max              S6GereConfig::_config[56].ReelA()
#define axe_yd_min             S6GereConfig::_config[138].ReelA()
#define axe_yd_max             S6GereConfig::_config[139].ReelA()
#define axe_x_min_reel         S6GereConfig::_config[100].ReelA() // x1     ...
#define axe_x_max_reel         S6GereConfig::_config[101].ReelA() // x2     ...
#define axe_y_min_reel         S6GereConfig::_config[102].ReelA() // y1     ...
#define axe_y_max_reel         S6GereConfig::_config[103].ReelA() // y2     ...
#define axe_z_min_reel         S6GereConfig::_config[96].ReelA()
#define axe_z_max_reel         S6GereConfig::_config[97].ReelA()
#define axe_c_min_reel         S6GereConfig::_config[98].ReelA()
#define axe_c_max_reel         S6GereConfig::_config[99].ReelA()
#define axe_yd_min_reel        S6GereConfig::_config[140].ReelA()
#define axe_yd_max_reel        S6GereConfig::_config[141].ReelA()
#define axe_valeur_x           S6GereConfig::_config[118].CharA()
#define axe_valeur_y           S6GereConfig::_config[119].CharA()
#define axe_valeur_z           S6GereConfig::_config[120].CharA()
#define axe_valeur_yd          S6GereConfig::_config[144].CharA()
#define animation_pas_azimuth  S6GereConfig::_config[38].IntA()
#define animation_pas_site     S6GereConfig::_config[39].IntA()
#define animation_nombre       S6GereConfig::_config[40].IntA()
#define ptvue_azimuth          S6GereConfig::_config[61].ReelA()
#define ptvue_site             S6GereConfig::_config[62].ReelA()
#define ptvue_roulis           S6GereConfig::_config[145].ReelA()
#define ptvue_distance         S6GereConfig::_config[63].ReelA()
#define ptvue_redress_vert     S6GereConfig::_config[64].ReelA()
#define ptvue_redress_hori     S6GereConfig::_config[65].ReelA()
#define zoom_actif             S6GereConfig::_config[43].IntA()
#define zoom_cur_x_min         S6GereConfig::_config[78].ReelA()  // xpos2i ...
#define zoom_cur_x_max         S6GereConfig::_config[79].ReelA()  // xpos2a ...
#define zoom_cur_y_min         S6GereConfig::_config[80].ReelA()  // ypos2i ...
#define zoom_cur_y_max         S6GereConfig::_config[81].ReelA()  // ypos2a ...
#define zoom_gra_x_min         S6GereConfig::_config[152].ReelA()
#define zoom_gra_x_max         S6GereConfig::_config[153].ReelA()
#define zoom_gra_y_min         S6GereConfig::_config[154].ReelA()
#define zoom_gra_y_max         S6GereConfig::_config[155].ReelA()
#define zoom_gra_coef_taille   S6GereConfig::_config[156].ReelA()
#define boite_cur_x_min        S6GereConfig::_config[82].ReelA()  // xpos5i ...
#define boite_cur_x_max        S6GereConfig::_config[83].ReelA()  // xpos5a ...
#define boite_cur_y_min        S6GereConfig::_config[84].ReelA()  // ypos5i ...
#define boite_cur_y_max        S6GereConfig::_config[85].ReelA()  // ypos5a ...
#define boite_gri_x_min        S6GereConfig::_config[86].ReelA()  // xming1 ...
#define boite_gri_x_max        S6GereConfig::_config[87].ReelA()  // xmaxg1 ...
#define boite_gri_y_min        S6GereConfig::_config[88].ReelA()  // yming1 ...
#define boite_gri_y_max        S6GereConfig::_config[89].ReelA()  // ymaxg1 ...
#define boite_tai_abs_x        S6GereConfig::_config[90].ReelA()  // dcx    ...
#define boite_tai_abs_y        S6GereConfig::_config[91].ReelA()  // dcy    ...
#define parametre_fond         S6GereConfig::_config[44].IntA()
#define parametre_map          S6GereConfig::_config[135].IntA()
#define parametre_map_fond     S6GereConfig::_config[167].TabIntA()
#define parametre_map_fond_t   S6GereConfig::_config[167].IntA()
#define parametre_map_afond    S6GereConfig::_config[168].TabIntA()
#define parametre_map_afond_t  S6GereConfig::_config[168].IntA()
#define parametre_map_col      S6GereConfig::_config[169].TabIntA()
#define parametre_map_col_t    S6GereConfig::_config[169].IntA()
#define parametre_map_pal      S6GereConfig::_config[170].TabIntA()
#define parametre_map_pal_t    S6GereConfig::_config[170].IntA()
#define parametre_couleur_fond S6GereConfig::_config[173].IntA()
#define parametre_scene        S6GereConfig::_config[137].IntA()
#define courbe_type            S6GereConfig::_config[111].TabIntA()
#define courbe_type_taille     S6GereConfig::_config[111].IntA()
#define courbe_type_config     S6GereConfig::_config[111]
#define courbe_cote            S6GereConfig::_config[142].TabIntA()
#define courbe_cote_taille     S6GereConfig::_config[142].IntA()
#define courbe_cote_config     S6GereConfig::_config[142]
#define courbe_couleur         S6GereConfig::_config[112].TabIntA()
#define courbe_couleur_taille  S6GereConfig::_config[112].IntA()
#define courbe_couleur_config  S6GereConfig::_config[112]
#define courbe_label           S6GereConfig::_config[123].TabCharA()
#define courbe_label_taille    S6GereConfig::_config[123].IntA()
#define courbe_label_config    S6GereConfig::_config[123]
#define courbe_label_type      S6GereConfig::_config[126].IntA()  // icolo8 ...
#define courbe_label_x_min     S6GereConfig::_config[92].ReelA()  // xpos8i ...
#define courbe_label_x_max     S6GereConfig::_config[93].ReelA()  // xpos8i ...
#define courbe_label_y_min     S6GereConfig::_config[94].ReelA()  // xpos8i ...
#define courbe_label_y_max     S6GereConfig::_config[95].ReelA()  // xpos8i ...
#define courbe_legende_type    S6GereConfig::_config[195].IntA()
#define courbe_legende_cadre   S6GereConfig::_config[196].IntA()
#define courbe_taille_legende  S6GereConfig::_config[208].IntA()
#define fichier_sauvegarde     S6GereConfig::_config[125].CharA()
#define calcul_action          S6GereConfig::_config[127].IntA()
#define calcul_socket          S6GereConfig::_config[128].IntA()
#define calcul_socket_numero   S6GereConfig::_config[176].IntA()
#define calcul_ok_cache        S6GereConfig::_config[146].IntA()
#define calcul_ihm             S6GereConfig::_config[181].IntA()
#define maille_pique           S6GereConfig::_config[129].IntA()
#define donnee_noeud_numero    S6GereConfig::_config[133].IntA()
#define afficheur_largeur      S6GereConfig::_config[150].IntA()
#define afficheur_hauteur      S6GereConfig::_config[151].IntA()
#define afficheur_clip_largeur S6GereConfig::_config[177].ReelA()
#define afficheur_clip_hauteur S6GereConfig::_config[178].ReelA()
#define afficheur_pixmap       S6GereConfig::_config[182].IntA()
#define driver_type            S6GereConfig::_config[171].CharA()
#define config_sauvegarde      S6GereConfig::_config[174].IntA()
#define langage		       S6GereConfig::_config[179].CharA()
#define output		       S6GereConfig::_config[180].IntA()
#define impression_dest_type   S6GereConfig::_config[183].IntA()
#define impression_dest_fich   S6GereConfig::_config[184].CharA()
#define impression_dest_fichd  S6GereConfig::_config[185].CharA()
#define impression_dest_imp    S6GereConfig::_config[186].CharA()
#define impression_couleur     S6GereConfig::_config[187].IntA()
#define impression_ident       S6GereConfig::_config[188].IntA()
#define impression_chrono      S6GereConfig::_config[189].IntA()
#define impression_texte_noir  S6GereConfig::_config[190].IntA()
#define impression_logo        S6GereConfig::_config[191].IntA()
#define impression_eps         S6GereConfig::_config[192].IntA()
#define impression_video_inv   S6GereConfig::_config[193].IntA()
#define impression_dim_exacte  S6GereConfig::_config[194].IntA()
#define impression_landscape   S6GereConfig::_config[210].IntA()
#define impression_titre       S6GereConfig::_config[211].CharA()
#define grille_grad_yech_nb    S6GereConfig::_config[202].IntA()

// config locale axe

#define p_axe_log_x              S6GereConfigP::_p_axe_config[0].IntA()
#define p_axe_log_y              S6GereConfigP::_p_axe_config[1].IntA()
#define p_axe_log_z              S6GereConfigP::_p_axe_config[2].IntA()
#define p_axe_log_c              S6GereConfigP::_p_axe_config[3].IntA()
#define p_axe_x_min              S6GereConfigP::_p_axe_config[4].ReelA()
#define p_axe_x_max              S6GereConfigP::_p_axe_config[5].ReelA()
#define p_axe_y_min              S6GereConfigP::_p_axe_config[6].ReelA()
#define p_axe_y_max              S6GereConfigP::_p_axe_config[7].ReelA()
#define p_axe_z_min              S6GereConfigP::_p_axe_config[8].ReelA()
#define p_axe_z_max              S6GereConfigP::_p_axe_config[9].ReelA()
#define p_axe_c_min              S6GereConfigP::_p_axe_config[10].ReelA()
#define p_axe_c_max              S6GereConfigP::_p_axe_config[11].ReelA()
#define p_axe_x_min_reel         S6GereConfigP::_p_axe_config[12].ReelA()
#define p_axe_x_max_reel         S6GereConfigP::_p_axe_config[13].ReelA()
#define p_axe_y_min_reel         S6GereConfigP::_p_axe_config[14].ReelA()
#define p_axe_y_max_reel         S6GereConfigP::_p_axe_config[15].ReelA()
#define p_axe_z_min_reel         S6GereConfigP::_p_axe_config[16].ReelA()
#define p_axe_z_max_reel         S6GereConfigP::_p_axe_config[17].ReelA()
#define p_axe_c_min_reel         S6GereConfigP::_p_axe_config[18].ReelA()
#define p_axe_c_max_reel         S6GereConfigP::_p_axe_config[19].ReelA()

// config locale titreaxe

#define p_axe_valeur_x           S6GereConfigP::_p_titreaxe_config[0].CharA()
#define p_axe_valeur_y           S6GereConfigP::_p_titreaxe_config[1].CharA()
#define p_axe_valeur_z           S6GereConfigP::_p_titreaxe_config[2].CharA()
#define p_axe_couleur_titre      S6GereConfigP::_p_titreaxe_config[3].IntA()
#define p_axe_taille_titre       S6GereConfigP::_p_titreaxe_config[4].IntA()
#define p_axe_valeur_yd          S6GereConfigP::_p_titreaxe_config[5].CharA()

// config locale grille

#define p_grille_couleur         S6GereConfigP::_p_grille_config[0].IntA()
#define p_grille_type            S6GereConfigP::_p_grille_config[1].IntA()
#define p_hauteur_z_type         S6GereConfigP::_p_grille_config[2].IntA()
#define p_hauteur_z_x_min        S6GereConfigP::_p_grille_config[3].ReelA()   // xpos7zi ...
#define p_hauteur_z_x_max        S6GereConfigP::_p_grille_config[4].ReelA()
#define p_hauteur_z_y_min        S6GereConfigP::_p_grille_config[5].ReelA()
#define p_hauteur_z_y_max        S6GereConfigP::_p_grille_config[6].ReelA()
#define p_hauteur_c_type         S6GereConfigP::_p_grille_config[7].IntA()   // icolo7c
#define p_hauteur_c_x_min        S6GereConfigP::_p_grille_config[8].ReelA()
#define p_hauteur_c_x_max        S6GereConfigP::_p_grille_config[9].ReelA()
#define p_hauteur_c_y_min        S6GereConfigP::_p_grille_config[10].ReelA()
#define p_hauteur_c_y_max        S6GereConfigP::_p_grille_config[11].ReelA()
#define p_hauteur_label_type     S6GereConfigP::_p_grille_config[12].IntA()   // icolo7l
#define p_hauteur_label_x_min    S6GereConfigP::_p_grille_config[13].ReelA()
#define p_hauteur_label_x_max    S6GereConfigP::_p_grille_config[14].ReelA()
#define p_hauteur_label_y_min    S6GereConfigP::_p_grille_config[15].ReelA()
#define p_hauteur_label_y_max    S6GereConfigP::_p_grille_config[16].ReelA()
#define p_courbe_label_type      S6GereConfigP::_p_grille_config[17].IntA()   // icolo8 ...
#define p_courbe_label_x_min     S6GereConfigP::_p_grille_config[18].ReelA()  // xpos8i ...
#define p_courbe_label_x_max     S6GereConfigP::_p_grille_config[19].ReelA()  // xpos8i ...
#define p_courbe_label_y_min     S6GereConfigP::_p_grille_config[20].ReelA()  // xpos8i ...
#define p_courbe_label_y_max     S6GereConfigP::_p_grille_config[21].ReelA()  // xpos8i ...
#define p_axe_taille_echelle     S6GereConfigP::_p_grille_config[22].IntA()

// config locale titres

#define p_titre_numero           S6GereConfigP::_p_titre_config[0].IntA()
#define p_titre_affiche_haut     S6GereConfigP::_p_titre_config[1].IntA()
#define p_titre_affiche_bas      S6GereConfigP::_p_titre_config[2].IntA()
#define p_titre_affiche_gauche   S6GereConfigP::_p_titre_config[3].IntA()
#define p_titre_affiche_droit    S6GereConfigP::_p_titre_config[4].IntA()
#define p_titre_taille_haut      S6GereConfigP::_p_titre_config[5].IntA()
#define p_titre_taille_bas       S6GereConfigP::_p_titre_config[6].IntA()
#define p_titre_taille_gauche    S6GereConfigP::_p_titre_config[7].IntA()
#define p_titre_taille_droit     S6GereConfigP::_p_titre_config[8].IntA()
#define p_titre_couleur_haut     S6GereConfigP::_p_titre_config[9].IntA()
#define p_titre_couleur_bas      S6GereConfigP::_p_titre_config[10].IntA()
#define p_titre_couleur_gauche   S6GereConfigP::_p_titre_config[11].IntA()
#define p_titre_couleur_droit    S6GereConfigP::_p_titre_config[12].IntA()
#define p_titre_valeur_haut      S6GereConfigP::_p_titre_config[13].CharA()
#define p_titre_valeur_bas       S6GereConfigP::_p_titre_config[14].CharA()
#define p_titre_valeur_gauche    S6GereConfigP::_p_titre_config[15].CharA()
#define p_titre_valeur_droit     S6GereConfigP::_p_titre_config[16].CharA()

// config locale textes

#define p_texte_generateur       S6GereConfigP::_p_texte_config[0].IntA()
#define p_texte_numero           S6GereConfigP::_p_texte_config[1].IntA()
#define p_texte_affiche          S6GereConfigP::_p_texte_config[2].TabIntA()
#define p_texte_affiche_taille   S6GereConfigP::_p_texte_config[2].IntA()
#define p_texte_affiche_config   S6GereConfigP::_p_texte_config[2]
#define p_texte_couleur          S6GereConfigP::_p_texte_config[3].TabIntA()
#define p_texte_couleur_taille   S6GereConfigP::_p_texte_config[3].IntA()
#define p_texte_couleur_config   S6GereConfigP::_p_texte_config[3]
#define p_texte_taille           S6GereConfigP::_p_texte_config[4].TabIntA()
#define p_texte_taille_taille    S6GereConfigP::_p_texte_config[4].IntA()
#define p_texte_taille_config    S6GereConfigP::_p_texte_config[4]
#define p_texte_pos_x            S6GereConfigP::_p_texte_config[5].TabReelA()
#define p_texte_pos_x_taille     S6GereConfigP::_p_texte_config[5].IntA()
#define p_texte_pos_x_config     S6GereConfigP::_p_texte_config[5]
#define p_texte_pos_y            S6GereConfigP::_p_texte_config[6].TabReelA()
#define p_texte_pos_y_taille     S6GereConfigP::_p_texte_config[6].IntA()
#define p_texte_pos_y_config     S6GereConfigP::_p_texte_config[6]
#define p_texte_angle            S6GereConfigP::_p_texte_config[7].TabReelA()
#define p_texte_angle_taille     S6GereConfigP::_p_texte_config[7].IntA()
#define p_texte_angle_config     S6GereConfigP::_p_texte_config[7]
#define p_texte_valeur           S6GereConfigP::_p_texte_config[8].TabCharA()
#define p_texte_valeur_taille    S6GereConfigP::_p_texte_config[8].IntA()
#define p_texte_valeur_config    S6GereConfigP::_p_texte_config[8]

// config locale echelles

#define p_hauteur_z_h_min        S6GereConfigP::_p_echelle_config[0].ReelA()
#define p_hauteur_z_h_max        S6GereConfigP::_p_echelle_config[1].ReelA()
#define p_hauteur_z_log          S6GereConfigP::_p_echelle_config[2].IntA()
#define p_hauteur_z              S6GereConfigP::_p_echelle_config[3].TabReelA()
#define p_hauteur_z_taille       S6GereConfigP::_p_echelle_config[3].IntA()
#define p_hauteur_c_h_min        S6GereConfigP::_p_echelle_config[4].ReelA()
#define p_hauteur_c_h_max        S6GereConfigP::_p_echelle_config[5].ReelA()
#define p_hauteur_c_log          S6GereConfigP::_p_echelle_config[6].IntA()
#define p_hauteur_c              S6GereConfigP::_p_echelle_config[7].TabReelA()
#define p_hauteur_c_taille       S6GereConfigP::_p_echelle_config[7].IntA()

// config locale courbes

#define p_courbe_type            S6GereConfigP::_p_courbe_config[0].TabIntA()
#define p_courbe_type_taille     S6GereConfigP::_p_courbe_config[0].IntA()
#define p_courbe_type_config     S6GereConfigP::_p_courbe_config[0]
#define p_courbe_cote            S6GereConfigP::_p_courbe_config[1].TabIntA()
#define p_courbe_cote_taille     S6GereConfigP::_p_courbe_config[1].IntA()
#define p_courbe_cote_config     S6GereConfigP::_p_courbe_config[1]
#define p_courbe_couleur         S6GereConfigP::_p_courbe_config[2].TabIntA()
#define p_courbe_couleur_taille  S6GereConfigP::_p_courbe_config[2].IntA()
#define p_courbe_couleur_config  S6GereConfigP::_p_courbe_config[2]
#define p_courbe_label           S6GereConfigP::_p_courbe_config[3].TabCharA()
#define p_courbe_label_taille    S6GereConfigP::_p_courbe_config[3].IntA()
#define p_courbe_label_config    S6GereConfigP::_p_courbe_config[3]

// config locale axe droit

#define p_axe_log_yd             S6GereConfigP::_p_axe_droit_config[0].IntA()
#define p_axe_yd_min             S6GereConfigP::_p_axe_droit_config[1].ReelA()
#define p_axe_yd_max             S6GereConfigP::_p_axe_droit_config[2].ReelA()
#define p_axe_yd_min_reel        S6GereConfigP::_p_axe_droit_config[3].ReelA()
#define p_axe_yd_max_reel        S6GereConfigP::_p_axe_droit_config[4].ReelA()

// config locale point de vue

#define p_ptvue_azimuth          S6GereConfigP::_p_point_de_vue_config[0].ReelA()
#define p_ptvue_site             S6GereConfigP::_p_point_de_vue_config[1].ReelA()
#define p_ptvue_roulis           S6GereConfigP::_p_point_de_vue_config[2].ReelA()
#define p_ptvue_distance         S6GereConfigP::_p_point_de_vue_config[3].ReelA()
#define p_ptvue_redress_vert     S6GereConfigP::_p_point_de_vue_config[4].ReelA()
#define p_ptvue_redress_hori     S6GereConfigP::_p_point_de_vue_config[5].ReelA()

// config locale dimensions

#define p_boite_cur_x_min        S6GereConfigP::_p_dimension_config[0].ReelA()
#define p_boite_cur_x_max        S6GereConfigP::_p_dimension_config[1].ReelA()
#define p_boite_cur_y_min        S6GereConfigP::_p_dimension_config[2].ReelA()
#define p_boite_cur_y_max        S6GereConfigP::_p_dimension_config[3].ReelA()
#define p_boite_tai_abs_x        S6GereConfigP::_p_dimension_config[4].ReelA() 
#define p_boite_tai_abs_y        S6GereConfigP::_p_dimension_config[5].ReelA()

// config locale animation

#define p_animation_pas_azimuth  S6GereConfigP::_p_animation_config[0].IntA()
#define p_animation_pas_site     S6GereConfigP::_p_animation_config[1].IntA()
#define p_animation_nombre       S6GereConfigP::_p_animation_config[2].IntA()

// config locale couleur surface

#define p_option_3d_couleur_up   S6GereConfigP::_p_coulsurf_config[0].IntA()
#define p_option_3d_couleur_down S6GereConfigP::_p_coulsurf_config[1].IntA()
#define p_option_3d_cbloc_up     S6GereConfigP::_p_coulsurf_config[2].TabIntA()
#define p_option_3d_cbloc_up_t   S6GereConfigP::_p_coulsurf_config[2].IntA()
#define p_option_3d_cbloc_up_c   S6GereConfigP::_p_coulsurf_config[2]
#define p_option_3d_cbloc_down   S6GereConfigP::_p_coulsurf_config[3].TabIntA()
#define p_option_3d_cbloc_down_t S6GereConfigP::_p_coulsurf_config[3].IntA()
#define p_option_3d_cbloc_down_c S6GereConfigP::_p_coulsurf_config[3]

// config locale opt3d

#define p_option_3d              S6GereConfigP::_p_opt3d_config[0].IntA()
#define p_option_3d_bloc         S6GereConfigP::_p_opt3d_config[2].TabIntA()
#define p_option_3d_bloc_t       S6GereConfigP::_p_opt3d_config[2].IntA()
#define p_option_3d_bloc_c       S6GereConfigP::_p_opt3d_config[2]
#define p_option_3d_masque       S6GereConfigP::_p_opt3d_config[1].IntA()
#define p_option_3d_mask_bloc    S6GereConfigP::_p_opt3d_config[3].TabIntA()
#define p_option_3d_mask_bloc_t  S6GereConfigP::_p_opt3d_config[3].IntA()
#define p_option_3d_mask_bloc_c  S6GereConfigP::_p_opt3d_config[3]

// config locale coupe3d

#define p_coupe_plan_a           S6GereConfigP::_p_coupe3d_config[0].ReelA()
#define p_coupe_plan_a_bloc      S6GereConfigP::_p_coupe3d_config[7].TabReelA()
#define p_coupe_plan_a_bloc_t    S6GereConfigP::_p_coupe3d_config[7].IntA()
#define p_coupe_plan_a_bloc_c    S6GereConfigP::_p_coupe3d_config[7]
#define p_coupe_plan_b           S6GereConfigP::_p_coupe3d_config[1].ReelA()
#define p_coupe_plan_b_bloc      S6GereConfigP::_p_coupe3d_config[8].TabReelA()
#define p_coupe_plan_b_bloc_t    S6GereConfigP::_p_coupe3d_config[8].IntA()
#define p_coupe_plan_b_bloc_c    S6GereConfigP::_p_coupe3d_config[8]
#define p_coupe_plan_c           S6GereConfigP::_p_coupe3d_config[2].ReelA()
#define p_coupe_plan_c_bloc      S6GereConfigP::_p_coupe3d_config[9].TabReelA()
#define p_coupe_plan_c_bloc_t    S6GereConfigP::_p_coupe3d_config[9].IntA()
#define p_coupe_plan_c_bloc_c    S6GereConfigP::_p_coupe3d_config[9]
#define p_coupe_plan_d           S6GereConfigP::_p_coupe3d_config[3].ReelA()
#define p_coupe_plan_d_bloc      S6GereConfigP::_p_coupe3d_config[10].TabReelA()
#define p_coupe_plan_d_bloc_t    S6GereConfigP::_p_coupe3d_config[10].IntA()
#define p_coupe_plan_d_bloc_c    S6GereConfigP::_p_coupe3d_config[10]
#define p_coupe_plan_e           S6GereConfigP::_p_coupe3d_config[4].ReelA()
#define p_coupe_plan_e_bloc      S6GereConfigP::_p_coupe3d_config[11].TabReelA()
#define p_coupe_plan_e_bloc_t    S6GereConfigP::_p_coupe3d_config[11].IntA()
#define p_coupe_plan_e_bloc_c    S6GereConfigP::_p_coupe3d_config[11]
#define p_coupe_plan_pas         S6GereConfigP::_p_coupe3d_config[5].ReelA()
#define p_coupe_plan_pas_bloc    S6GereConfigP::_p_coupe3d_config[12].TabReelA()
#define p_coupe_plan_pas_bloc_t  S6GereConfigP::_p_coupe3d_config[12].IntA()
#define p_coupe_plan_pas_bloc_c  S6GereConfigP::_p_coupe3d_config[12]
#define p_coupe_hyperplan        S6GereConfigP::_p_coupe3d_config[6].IntA()
#define p_coupe_hyperplan_bloc   S6GereConfigP::_p_coupe3d_config[13].TabIntA()
#define p_coupe_hyperplan_bloc_t S6GereConfigP::_p_coupe3d_config[13].IntA()
#define p_coupe_hyperplan_bloc_c S6GereConfigP::_p_coupe3d_config[13]

// config locale parametre cartes de couleurs options

#define p_parametre_map_col      S6GereConfigP::_p_pcco_config[0].TabIntA()
#define p_parametre_map_col_t    S6GereConfigP::_p_pcco_config[0].IntA()
#define p_parametre_map_pal      S6GereConfigP::_p_pcco_config[1].TabIntA()
#define p_parametre_map_pal_t    S6GereConfigP::_p_pcco_config[1].IntA()
#define p_parametre_couleur_fond S6GereConfigP::_p_pcco_config[2].IntA()

#include "S6output.h"

#endif
