// *********************************************************
// identification
// *********************************************************

struct SccsIdS6GereEnv
{
	static const char* const sccs_id;
};

const char* const SccsIdS6GereEnv::sccs_id = "%W% %G% Pierre Brochard";

// *********************************************************
// includes
// *********************************************************

#include "U8machcomp.h"
#include "cameleon/C5inout.h"
#include "S6gereenv.h"
#include "S6nom.h"
#include <ctype.h>
#include "dinosaure/S6string.h"
#include "nx.h"
#include "nxsystem.h"

#if defined(SC1_0) && defined(SUNOS_4)
#   include <strings.h>
#endif

// *********************************************************
// variables statiques de classes
// *********************************************************

P4Boolean S6GereEnv::ihm = TRUE;
P4Boolean S6GereEnv::ihm_aff_iconic = FALSE;
P4Boolean S6GereEnv::ihm_aff_sans_bandeau = FALSE;
P4Boolean S6GereEnv::dest_x11 = TRUE;
P4Boolean S6GereEnv::dest_negs = FALSE;
P4Boolean S6GereEnv::dest_postcoul = FALSE;
P4Boolean S6GereEnv::dest_postcoulfich = FALSE;
P4Boolean S6GereEnv::dest_postscript = FALSE;
P4Boolean S6GereEnv::dest_gif = FALSE;
P4Boolean S6GereEnv::dest_png = FALSE;
P4Boolean S6GereEnv::dest_phigs = FALSE;
P4Boolean S6GereEnv::dest_phigsx11 = FALSE;
P4Boolean S6GereEnv::dest_phigscgm = FALSE;
P4Boolean S6GereEnv::dest_phigsps = FALSE;
P4Boolean S6GereEnv::dest_phigspsc = FALSE;
P4Boolean S6GereEnv::dest_phigsrle = FALSE;
P4Boolean S6GereEnv::dest_gl = FALSE;
P4Boolean S6GereEnv::dest_xgl = FALSE;
P4Boolean S6GereEnv::dest_pgml = FALSE;
P4Boolean S6GereEnv::dest_svg = FALSE;
P4Boolean S6GereEnv::dest_xfig = FALSE;
P4Boolean S6GereEnv::dest_inte = TRUE;
P4Boolean S6GereEnv::dest_postderive = TRUE;
P4Boolean S6GereEnv::dest_sanglier = FALSE;
char*     S6GereEnv::dest = NULL;

Tabcptchar S6GereEnv::_var_env;
Tabptchar S6GereEnv::_val_env;

Tabchar S6GereEnv::_alloc_env;

// ***************************************************************
// fonction de lecture de variables d'environnements pour Psyche
// ***************************************************************

int
S6GereEnv::ChargEnv(const char* const nomfich)
{
	const char* nom_code = S6Nom::_nom_code;
	const int nom_logiciel =
	    nom_code[0] == '\141' && nom_code[1] == '\0' &&
	    nom_code[2] == '\162' && nom_code[3] == '\21' &&
	    nom_code[4] == '\170' && nom_code[5] == '\13' &&
	    nom_code[6] == '\170' && nom_code[7] == '\35' &&
	    nom_code[8] == '\75' && nom_code[9] == '\35' &&
	    nom_code[10] == '\75' && nom_code[11] == '\35';

	if(int(_var_env) == 0)
	{
	    const char* chaine = "USER";

	    _var_env.Ajoute(chaine);
	    chaine = "COLOR_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "COLORF_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "DESTL3";
	    _var_env.Ajoute(chaine);
	    chaine = "NeGSHOST_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "PORT_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "NEGS";
	    _var_env.Ajoute(chaine);
	    chaine = nom_logiciel ? "NARCISSE_SP3" : "PSYCHE_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "IMAGES_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "REPERTOIRE_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "IMAGES_NeGS";
	    _var_env.Ajoute(chaine);
	    chaine = "DISPLAY";
	    _var_env.Ajoute(chaine);
	    chaine = "HELPPATH";
	    _var_env.Ajoute(chaine);
	    chaine = "SERVEUR_INET_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "SCALE_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "FICHIER_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "HOME";
	    _var_env.Ajoute(chaine);
	    chaine = "IHM_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "DESTIN_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "SERVEUR_ASCII_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "SERVEUR_UCD_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "TMPDIR";
	    _var_env.Ajoute(chaine);
	    chaine = "SERVEUR_UNIX_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "VISUAL_SP3";
	    _var_env.Ajoute(chaine);
	    chaine = "HOST";
	    _var_env.Ajoute(chaine);

	    const unsigned tair = _var_env;

	    for(unsigned i=0;i<tair;i++)
	    {
		char* const ptos = new char[11];

		memcpy(ptos,"          ",11);
		_val_env.Ajoute(ptos);
	    }

	    const unsigned tail = _val_env;

	    if(tair != tail)
	    {
		cerr << "S6GereEnv : erreur : mauvaise initialisation" << endl;
		return -1;
	    }

	    _alloc_env.ModValn((unsigned char) TRUE,_var_env);
	}

	C5InOut cio(TRUE);

	cio.C5AjouteConfig(_var_env,_var_env,_val_env);

	if(!nomfich)
	{
	    char username[L_U8GetUser];

	    U8GetUser(username);

	    const size_t lusername = strlen(username);

	    if(!lusername)
	    {
		strcpy(username,"@@@@");
	    }

	    char userhome[L_U8GetHome];

	    U8GetHome(userhome);

	    const size_t luserhome = strlen(userhome);

	    if(!luserhome)
	    {
		strcpy(userhome,"@@@@");
	    }

	    static const char* initvar = "@@@@ @ "
		"DESTL3 @@@@ "
		"COLOR_SP3 @@@@ "
		"COLORF_SP3 @@@@ "
		"NeGSHOST_SP3 @@@@ "
		"PORT_SP3 @@@@ "
		"NEGS @@@@ "
		"PSYCHE_SP3 @@@@ "
		"NARCISSE_SP3 @@@@ "
		"IMAGES_SP3 @@@@ "
		"REPERTOIRE_SP3 @@@@ "
		"IMAGES_NeGS @@@@ "
		"DISPLAY @@@@ "
		"HELPPATH @@@@ "
		"SERVEUR_INET_SP3 @@@@ "
		"SERVEUR_UNIX_SP3 @@@@ "
		"SERVEUR_ASCII_SP3 @@@@ "
		"SERVEUR_UCD_SP3 @@@@ "
		"SCALE_SP3 @@@@ "
		"FICHIER_SP3 @@@@ "
		"IHM_SP3 TRUE "
		"TMPDIR /tmp "
		"DESTIN_SP3 X11 "
		"VISUAL_SP3 -1 "
		"HOST @@@@ "
		"USER ";

	    const size_t linitvar = strlen(initvar);

	    char* reelvar = new char[linitvar+lusername+luserhome+8];

	    memcpy(reelvar,initvar,linitvar);
	    memcpy(reelvar+linitvar,username,lusername);
	    memcpy(reelvar+linitvar+lusername," HOME ",6);
	    memcpy(reelvar+linitvar+lusername+6,userhome,luserhome);
	    memcpy(reelvar+linitvar+lusername+6+luserhome," ",2);

	    cio.C5LectureConfig(reelvar);

	    delete reelvar;

	// Si userhome est correct, on le met dans l'environnemment
	// et on ne tient pas compte de la variable definie auparavant

	    if(strcmp(userhome,"@@@@"))
	    {
		static char* envhome = new char[luserhome+6];

		if(envhome)
		{
		    memcpy(envhome,"HOME=",5);
		    memcpy(envhome+5,userhome,luserhome+1);
		    putenv(envhome);
		}

	    }

	// Si username est correct, on le met dans l'environnemment
	// et on ne tient pas compte de la variable definie auparavant

	    if(strcmp(username,"@@@@"))
	    {
		static char* envuser = new char[lusername+6];

		if(envuser)
		{
		    memcpy(envuser,"USER=",5);
		    memcpy(envuser+5,username,lusername+1);
		    putenv(envuser);
		}

	    }

	    cio.C5LectureConfig("####");
	}
	else
	{
	    cio.C5LectureConfig(nomfich);
	}

	const int nbre_mots_cles = int(_var_env);
	Tabint tab_depass;

	tab_depass.ModValn(0,nbre_mots_cles);
	cio.C5DepassConfig(nbre_mots_cles,tab_depass);

	for(int i=0;i<nbre_mots_cles;i++)
	{

	    if(tab_depass[i] >= 0)
	    {

		if(_alloc_env[i] == TRUE) delete[] _val_env[i];

		_val_env[i] = new char[tab_depass[i]+1];
		memset(_val_env[i],32,tab_depass[i]);
		_val_env[i][tab_depass[i]] = '\0';

		cio.C5LectureConfig(i,tab_depass[i]);
		_alloc_env.ModVal((unsigned char) TRUE,i);
	    }

	}

    // variables racourcies

	ihm_aff_iconic = !strcmp(ihm_sp3,"AFF_ICONIC") ? TRUE : FALSE;
	ihm_aff_sans_bandeau = !strcmp(ihm_sp3,"AFF_SANS_BANDEAU") ?
	    TRUE : FALSE;
	ihm = !strcmp(ihm_sp3,"TRUE") || ihm_aff_iconic ||
	    ihm_aff_sans_bandeau ? TRUE : FALSE;
	InitDest(destin_sp3);

    // tests

	cio.C5EcritureConfig("cout");
	cout << endl;

	return 0;
}

int
S6GereEnv::PurgeEnv()
{
	const unsigned taille = _var_env;

	for(unsigned i=0;i<taille;i++)
	{

	    if(_alloc_env[i] == TRUE) delete[] _val_env[i];

	}

	_val_env.Enleve();

	return 0;
}

int
S6GereEnv::EstInitialise()
{

	if(int(_var_env) > 0) return TRUE;
	else return FALSE;

}

int
S6GereEnv::InitDest(const char* const new_dest)
{

	if(!new_dest) return 1;

	const int x11 = !strcasecmp(new_dest,"x11");
	const int temp_negs = !strcasecmp(new_dest,"negs");

	dest_x11 = x11 ? TRUE : FALSE;
	dest_negs = temp_negs ? TRUE : FALSE;

	const int temp_phigs = !strcasecmp(new_dest,"phigs");
	const int temp_phigsx11 = !strcasecmp(new_dest,"phigsx11");
	const int temp_phigscgm = !strcasecmp(new_dest,"phigscgm");
	const int temp_phigsps = !strcasecmp(new_dest,"phigsps");
	const int temp_phigspsc = !strcasecmp(new_dest,"phigspsc");
	const int temp_phigsrle = !strcasecmp(new_dest,"phigsrle");
	const int temp_gl = !strcasecmp(new_dest,"gl");
	const int temp_xgl = !strcasecmp(new_dest,"xgl");
	const int temp_postcoul = !strcasecmp(new_dest,"postcoul");
	const int temp_postscript = !strcasecmp(new_dest,"postscript");
	const int temp_postcoulfich = !strcasecmp(new_dest,"postcoulfich");
	const int temp_gif = !strcasecmp(new_dest,"gif");
	const int temp_png = !strcasecmp(new_dest,"png");
	const int temp_post = !strcasecmp(new_dest,"post");
	const int temp_lwc = !strcasecmp(new_dest,"lwc");
	const int temp_lwct = !strcasecmp(new_dest,"lwct");
	const int temp_pgml = !strcasecmp(new_dest,"pgml");
	const int temp_svg = !strcasecmp(new_dest,"svg");
	const int temp_xfig = !strcasecmp(new_dest,"xfig");
	const int temp_0 = !strcmp(new_dest,"0");

#ifdef GPHIGS
	dest_phigs = temp_phigs ? TRUE : FALSE;
	dest_phigsx11 = temp_phigsx11 ? TRUE : FALSE;
	dest_phigscgm = temp_phigscgm ? TRUE : FALSE;
	dest_phigsps = temp_phigsps ? TRUE : FALSE;
	dest_phigspsc = temp_phigspsc ? TRUE : FALSE;
	dest_phigsrle = temp_phigsrle ? TRUE : FALSE;
#else
	dest_phigs = FALSE;
	dest_phigsx11 = FALSE;
	dest_phigscgm = FALSE;
	dest_phigsps = FALSE;
	dest_phigspsc = FALSE;
	dest_phigsrle = FALSE;
	dest_x11 = dest_x11 || ihm && (temp_phigs || temp_phigsx11 ||
		temp_phigscgm || temp_phigsps || temp_phigspsc ||
		temp_phigsrle) ? TRUE : FALSE;
#endif

#ifdef GL
	dest_gl = temp_gl ? TRUE : FALSE;
#else
	dest_gl = FALSE;
	dest_x11 = dest_x11 || ihm && temp_gl ? TRUE : FALSE;
#endif

#ifdef XGL
	dest_xgl = temp_xgl ? TRUE : FALSE;
#else
	dest_xgl = FALSE;
	dest_x11 = dest_x11 || ihm && temp_xgl ? TRUE : FALSE;
#endif

	dest_postcoul = temp_postcoul ? TRUE : FALSE;
	dest_postscript = temp_postscript ? TRUE : FALSE;
	dest_postcoulfich = temp_postcoulfich ? TRUE : FALSE;
	dest_gif = temp_gif ? TRUE : FALSE;
	dest_png = temp_png ? TRUE : FALSE;
	dest_pgml = temp_pgml ? TRUE : FALSE;
	dest_svg = temp_svg ? TRUE : FALSE;
	dest_xfig = temp_xfig ? TRUE : FALSE;

	dest_inte = dest_negs || dest_x11 ? TRUE : FALSE;
	dest_postderive = dest_postcoul || dest_postcoulfich ||
	    dest_gif || dest_png || temp_post || temp_lwc || temp_lwct ? TRUE : FALSE;
	dest_sanglier = dest_x11 || dest_phigs || dest_phigsx11 ||
	    dest_phigscgm || dest_phigsps || dest_phigspsc ||
	    dest_phigsrle || dest_gl || dest_xgl ||
	    dest_postcoul || dest_postscript || dest_postcoulfich ||
	    dest_gif || dest_png || dest_pgml || dest_svg || dest_xfig ||
	    temp_0 ? FALSE : TRUE;

	delete[] dest;dest = S6strcasedup(new_dest);

	return 0;
}
