#ifndef S6TRACE_H
#define S6TRACE_H

// %W% %G% P. Brochard
// module de traces graphiques

#include "S6compat.h"

enum TypeTrace
{
    TRACE_BLOC=-2,
    PAS_DE_TRACE=-1,

    FILMONO=0,FIL3D=1,FIL4D=3,
    FAC3D=7,FAC4D=15,NIV3D=31,NIV4D=63,LIS3D=127,LIS4D=255,

    FIL_FAC3D=8,FIL_FAC4D=16,FIL3D_FAC3D=9,FIL3D_FAC4D=17,
    FIL4D_FAC3D=11,FIL4D_FAC4D=19,

    FIL_NIV3D=32,FIL_NIV4D=64,FIL3D_NIV3D=33,FIL3D_NIV4D=65,
    FIL4D_NIV3D=35,FIL4D_NIV4D=67,

    FAC3D_NIV3D=39,FAC3D_NIV4D=71,
    FAC4D_NIV3D=47,FAC4D_NIV4D=79,

    FIL_LIS3D=128,FIL_LIS4D=256,FIL3D_LIS3D=129,FIL3D_LIS4D=257,
    FIL4D_LIS3D=131,FIL4D_LIS4D=259,

    FIL_FAC3D_NIV3D=40,FIL_FAC3D_NIV4D=72,FIL_FAC4D_NIV3D=48,
    FIL_FAC4D_NIV4D=80,

    FIL3D_FAC3D_NIV3D=41,FIL3D_FAC3D_NIV4D=73,FIL3D_FAC4D_NIV3D=49,
    FIL3D_FAC4D_NIV4D=81,

    FIL4D_FAC3D_NIV3D=43,FIL4D_FAC3D_NIV4D=75,FIL4D_FAC4D_NIV3D=51,
    FIL4D_FAC4D_NIV4D=83,

    PIX3D = 511,PIX4D=1023
};

class P4Graf3;

#if defined(P4VERSION_AVEC_TEMPLATE) /* version avec template */
   template<class GEN> class TabGEN;

#  if P4VERSION_AVEC_TEMPLATE == 4
      typedef TabGEN<int> Tabint;
#  else
#     define Tabint TabGEN<int>
#  endif

#else // version sans template

   class Tabint;
#endif // fin version sans template

class S6Trace
{
	friend void Quit(int);
	friend int main(int,char**);
	friend class CalculImage;
	friend class TraceImage;
	friend class BreakPsyche;
	friend class S6GereFichier;
	friend class AvancePsyBouton;
	friend class ReculePsyBouton;
	friend class AllPsyBouton;
	friend class AvanceL3Bouton;
	friend class ReculeL3Bouton;
	friend class AllL3Bouton;
	friend class S6Points;
	friend class PsyNum;
	friend class L3Num;
	friend class Coord3d;
	friend class Coord2d;
	friend class Coord2dDroit;
	friend class S6ContContBase2D;
	friend class Coordonnees;
	friend class PsycheBreakCommuniq;
	friend class S6GereConfig;
	friend class U8CalcImagePsyche;
	friend class U8CalcImageL3Psyche;

    private:

        virtual void dummy() = 0;

        static P4Graf3* graf;
        static const REEL AspectTexte;
        static const REEL EchelleTexte;
        static int num_courbe;

        static VOLATILE P4Boolean breakpsyche;
        static VOLATILE P4Boolean breakgestion_fichier;
        static P4Boolean l3_init;

        static void BreakPsyche(int sig);

        static REEL Xphytolog(const REEL zmin,const REEL zmax,
			const int izech,const REEL z);
        static void TraceEchellePolyg(int sous_image,const int n,
			const REEL y[],const int icol[],const REEL xg,
			const REEL xd);
        static void TraceEchelleSegment(const int n,const REEL y[],
			const int icol[],const REEL xg,const REEL xd);
        static void TraceEchelleMarqueur(const int n,const REEL y[],
			const int icol[],const REEL xg,const REEL xd,
			const int marqueur[]);

        static void Termine();
        static void Init();

        static void Fond();

        static void Echelles34D();
        static void LegendesNiv();
        static void Legendes2D();

        static void TitresAxes2d();
        static void Titres();
        static void Textes();

        static void TraceGeom(ostream& ost);
        static void Trace2d(int cote,int nx,int ny,const Tabint& nxsto);

        static void Trace(int trace,P4Boolean trace_last_base = FALSE);
        static void Trace(P4Boolean trace_last_base = FALSE);
        static void TraceSeul();

        static void TraceFichierL3();
        static void TraceFichierL3(int trace);

	static int FilOpt(int opt3d);
	static int FacOpt(int opt3d);
	static int NivOpt(int opt3d);
	static int LisOpt(int opt3d);
	static int FilLisseOpt(int opt3d);
	static void Option3dBloc(TypeTrace opt3d,int& fil_lisse,Opt34d& fil,
			Opt34d& fac,Opt34d& niv,Opt34d& lis);
	static void Option3dTBlocFil(int tfil);
	static void Option3dMaskBloc(int masq);
	static void Option3dMarqBloc(int marq);
	static void CoupeHyp(int couphyp);
};

#endif /* fin S6TRACE_H */
