// **************************************************
// module de trace graphiques (suite)
// **************************************************

struct SccsIdS6Trace2
{
	static const char* const sccs_id;
};

const char* const SccsIdS6Trace2::sccs_id = "%W% %G% Pierre Brochard";

// **************************************************
//    includes
// **************************************************

#include "S6gerefenet.h"
#include "S6bouttons5.h"
#include "P4constant.h"
#include "S6bouttons3.h"
#include "P4constant.h"
#include "sanglier.h"
#include "sanglierP.h"
#include "S6trace.h"
#include "minotaure/P4graf3.h"
#include "S6gereconfig.h"
#include "S6gerefich.h"
#include "S6points.h"
#include "S6flagssup.h"
#include "S6traduc.h"
#include "S6gereenv.h"
#include "S6initcourbe.h"
#include "poulpe/WidAffX.h"
#include <ctype.h>
#include "poulpe/L3Manip.h"
#include "dinosaure/S6timer.h"

#ifdef TRUE
#  undef TRUE
#endif

#ifdef FALSE
#  undef FALSE
#endif

#define finl '\n'

// *********************************************************************
//               void S6Trace::Trace(int trace)
//   appelee pour traces automatiques geres avec nombre_traces_socket
//   et calcul_socket et trace (qui vaut souvent calcul_socket)
// *********************************************************************

void
S6Trace::Trace(int trace,P4Boolean trace_last_base)
{

    // ----------------------------------------------------------
    //   si calcul_socket > 1 on trace seulement tous les
    //   calcul_socket fois
    // ----------------------------------------------------------

        if(!trace) return;

	calcul_socket_numero++;

	if(calcul_socket > 1 && calcul_socket != calcul_socket_numero)
	{
	    return;
	}

	calcul_socket_numero = 0;
	Trace(trace_last_base);
}

// *********************************************************************
//                 void S6Trace::Trace()
//    appelee pour tous les traces Psyche hors L3
// *********************************************************************

void
S6Trace::Trace(P4Boolean trace_last_base)
{
	TimerDetInit();

    // ----------------------------------------------------------
    //	on montre la fenetre popup de l'afficheur x11
    //     si DESTIN_SP3 = x11 
    // ----------------------------------------------------------

	if(S6GereEnv::dest_x11)
	{
	    S6GereFenet::pt_canvas->Active();
	    S6GereFenet::pt_canvas->Clear(parametre_fond != 2);
	}

    // ----------------------------------------------------------
    //	boucle d'appels a TraceSeul pour animation 
    // ----------------------------------------------------------

	unsigned i = 0;
	unsigned anim_nb = animation_nombre;

	anim_nb = anim_nb == 0 ? 100000 : anim_nb;

	switch (S6FlagsSup::choix_trace)
	{
	  case S6FlagsSup::TRACE_BASE_2D :
	    {
		S6Points* const pt_points = S6GereFichier::pt_points;
		S6ContContBase2D sccb = pt_points->DonneeAbstraiteBase();

		sccb.Trace(trace_last_base);
	    }

	    break;

	  case S6FlagsSup::TRACE_3D :
	  case S6FlagsSup::TRACE_TRAJ_3D :

	    for(i=0;i<anim_nb;i++)
	    {

		if(i)
		{
		    ptvue_azimuth = REEL(int(ptvue_azimuth +
				    animation_pas_azimuth)%361);
		    ptvue_site = REEL(int(ptvue_site +
				    animation_pas_site)%361);
		    coupe_plan_e += coupe_plan_pas;

		    for(int i=0;i<coupe_plan_e_bloc_t;i++)
			coupe_plan_e_bloc[i] += coupe_plan_pas_bloc[i];

		    p_ptvue_azimuth = ptvue_azimuth;
		    p_ptvue_site = ptvue_site;

		    if(S6GereEnv::ihm && S6GereFenet::ptvue)
			S6GereFenet::ptvue->Change();

		}

		if(breakpsyche == TRUE) break;

		S6FlagsSup::seul = FALSE;
		TraceSeul();
	    }

	    breakpsyche = FALSE;

	    if(anim_nb > 1)
	    {
		animation_nombre = 1;
		p_animation_nombre = 1;
		coupe_plan_e = p_coupe_plan_e;
		coupe_plan_e_bloc_c = p_coupe_plan_e_bloc_c;

		if(S6GereEnv::ihm && S6GereFenet::animation)
		    S6GereFenet::animation->Change();

	    }

	    break;

	  case S6FlagsSup::TRACE_2D :

	    S6FlagsSup::seul = FALSE;
	    TraceSeul();
	    break;

	  case S6FlagsSup::TRACE_COUPE :

	    {

	    // a mettre dans une classe a part pour regeneration si
	    // on veut par exemple sauvegarder les courbes qui suivent
	    // dans un fichier

		S6Points* const pt_points_a = S6GereFichier::pt_points;
		TabS6DonneeAbstraite tsda = pt_points_a->DonneeAbstraite();
		unsigned nb_blocs = tsda;

		if(!nb_blocs) break;

		S6DonneeAbstraite* const sda = tsda[nb_blocs-1];

		REEL_S* const x = sda->X();
		REEL_S* const y = sda->Y();
		REEL_S* const z = sda->Z();
		int nx = sda->Nx();
		int ny = sda->Ny();
		int dimz = sda->Z();

		P4Boolean rect = int(sda->X()) < nx*ny*sda->Nz() ?
		    TRUE : FALSE;

		if(!S6FlagsSup::pt_points_save)
		{
		    S6FlagsSup::pt_points_save = new S6Points;
		    S6FlagsSup::coupe_regenere = TRUE;
		}
		else if(!option_2d_concatene)
		{
		    S6FlagsSup::pt_points_save->Enleve();
		    S6FlagsSup::coupe_regenere = TRUE;
		}

		if(S6FlagsSup::coupe_regenere)
		{

		    switch(coupe_type)
		    {
		      case 1 :

			{
			    S6DonneeAbstraite* sda = new S6DonneeAbstraite;

			    sda->Nx(ny);
			    sda->Ny(1);
			    sda->Nz(1);
			    sda->X().ModValn(ny);
			    sda->Y().ModValn(ny);

			    if(rect)
			    {
				memcpy(sda->X(),y,ny*sizeof(REEL_S));

				register int cvci = coupe_val_coup_i;
				register REEL_S* const yn = sda->Y();

				if(dimz)
				{

				    for(register int ii=0;ii<ny;ii++)
				    {
					yn[ii] = z[cvci + ii * nx];
				    }

				}

			    }
			    else
			    {
				register int cvci = coupe_val_coup_i;
				register REEL_S* const xn = sda->X();
				register REEL_S* const yn = sda->Y();

				if(dimz)
				{

				    for(register int ii=0;ii<ny;ii++)
				    {
					xn[ii] = y[cvci + ii * nx];
					yn[ii] = z[cvci + ii * nx];
				    }

				}
				else
				{

				    for(register int ii=0;ii<ny;ii++)
				    {
					xn[ii] = y[cvci + ii * nx];
				    }

				}

			    }

			    S6FlagsSup::pt_points_save->Ajoute(sda);
			}

			break;

		      case 2 :

			{
			    S6DonneeAbstraite* sda = new S6DonneeAbstraite;

			    sda->Nx(nx);
			    sda->Ny(1);
			    sda->Nz(1);
			    sda->X().ModValn(nx);
			    sda->Y().ModValn(nx);

			    if(rect)
			    {
				memcpy(sda->X(),x,nx*sizeof(REEL_S));

				register int cvcj = coupe_val_coup_j;

				if(dimz)
				{
				    memcpy(sda->Y(),z+cvcj*nx,nx*sizeof(REEL_S));
				}

			    }
			    else
			    {
				register int cvcj = coupe_val_coup_j;

				memcpy(sda->X(),x+cvcj*nx,nx*sizeof(REEL_S));

				if(dimz)
				{
				    memcpy(sda->Y(),z+cvcj*nx,nx*sizeof(REEL_S));
				}

			    }

			    S6FlagsSup::pt_points_save->Ajoute(sda);
			}

			break;

		      case 3 :

			{
			    S6DonneeAbstraite* sda = new S6DonneeAbstraite;

			    sda->Nx(ny);
			    sda->Ny(1);
			    sda->Nz(1);
			    sda->X().ModValn(ny);
			    sda->Y().ModValn(ny);

			    int borne_min = min(coupe_val_moy_deb_i,
					    coupe_val_moy_fin_i);
			    int borne_max = max(coupe_val_moy_deb_i,
					    coupe_val_moy_fin_i);

			    for(register int ii=0;ii<ny;ii++)
			    {
				sda->X()[ii] = ii + 1;
				sda->Y()[ii] = 0.;
			    }

			    if(dimz)
			    {

				for(int j=borne_min;j<borne_max;j++)
				{
				    REEL xxco = 1.;

				    if(borne_min != borne_max)
				    xxco = 1./(borne_max - borne_min);

				    if(borne_min != borne_max && j == borne_min)
				    xxco = .5 * xxco;

				    if(borne_min != borne_max && j == borne_max)
				    xxco = .5 * xxco;

				    for(register int ii2=0;ii2<ny;ii2++)
				    {
					sda->Y()[ii2] += xxco * z[j + ii2 * nx];
				    }

				}

			    }

			    S6FlagsSup::pt_points_save->Ajoute(sda);
			}

			break;

		      case 4 :

			{
			    S6DonneeAbstraite* sda = new S6DonneeAbstraite;

			    sda->Nx(nx);
			    sda->Ny(1);
			    sda->Nz(1);
			    sda->X().ModValn(nx);
			    sda->Y().ModValn(nx);

			    int borne_min = min(coupe_val_moy_deb_j,
					    coupe_val_moy_fin_j);
			    int borne_max = max(coupe_val_moy_deb_j,
					    coupe_val_moy_fin_j);

			    for(register int ii=0;ii<nx;ii++)
			    {
				sda->X()[ii] = ii + 1;
				sda->Y()[ii] = 0.;
			    }

			    if(dimz)
			    {

				for(int j=borne_min;j<borne_max;j++)
				{
				    REEL xxco = 1.;

				    if(borne_min != borne_max)
				    xxco = 1./(borne_max - borne_min);

				    if(borne_min != borne_max && j == borne_min)
				    xxco = .5 * xxco;

				    if(borne_min != borne_max && j == borne_max)
				    xxco = .5 * xxco;

				    for(register int ii2=0;ii2<nx;ii2++)
				    {
					sda->Y()[ii2] += xxco * z[ii2 + j * nx];
				    }

				}

			    }

			    S6FlagsSup::pt_points_save->Ajoute(sda);
			}

			break;

		      case 5 :

			{
			    int borne_min = min(coupe_val_proj_deb_i,
					    coupe_val_proj_fin_i);
			    int borne_max = max(coupe_val_proj_deb_i,
					    coupe_val_proj_fin_i);

			    int nb_cc = borne_max - borne_min + 1;

			    for(int j = 0;j<nb_cc;j+=coupe_val_proj_pas_i)
			    {
				S6DonneeAbstraite* sda = new S6DonneeAbstraite;

				sda->Nx(ny);
				sda->Ny(1);
				sda->Nz(1);
				sda->X().ModValn(ny);
				sda->Y().ModValn(ny);

				if(rect)
				{
				    memcpy(sda->X(),y,ny*sizeof(REEL_S));

				    register REEL_S* const yn = sda->Y();

				    if(dimz)
				    {

					for(register int ii=0;ii<ny;ii++)
					{
					    yn[ii] = z[j + borne_min + ii * nx];
					}

				    }

				}
				else
				{
				    register REEL_S* const xn = sda->X();
				    register REEL_S* const yn = sda->Y();

				    if(dimz)
				    {

					for(register int ii=0;ii<ny;ii++)
					{
					    xn[ii] = y[j + borne_min + ii * nx];
					    yn[ii] = z[j + borne_min + ii * nx];
					}

				    }
				    else
				    {

					for(register int ii=0;ii<ny;ii++)
					{
					    xn[ii] = y[j + borne_min + ii * nx];
					}

				    }

				}

				S6FlagsSup::pt_points_save->Ajoute(sda);
			    }

			}

			break;

		      case 6 :

			{
			    int borne_min = min(coupe_val_proj_deb_j,
					    coupe_val_proj_fin_j);
			    int borne_max = max(coupe_val_proj_deb_j,
					    coupe_val_proj_fin_j);

			    int nb_cc = borne_max - borne_min + 1;

			    for(int j = 0;j<nb_cc;j+=coupe_val_proj_pas_j)
			    {
				S6DonneeAbstraite* sda = new S6DonneeAbstraite;

				sda->Nx(nx);
				sda->Ny(1);
				sda->Nz(1);
				sda->X().ModValn(nx);
				sda->Y().ModValn(nx);

				if(rect)
				{
				    memcpy(sda->X(),x,nx*sizeof(REEL_S));

				    if(dimz)
				    {
					memcpy(sda->Y(),z + (j + borne_min)*nx,
							nx*sizeof(REEL_S));
				    }

				}
				else
				{
				    memcpy(sda->X(),x + (j + borne_min)*nx,
						    nx*sizeof(REEL_S));

				    if(dimz)
				    {
					memcpy(sda->Y(),z + (j + borne_min)*nx,
							nx*sizeof(REEL_S));
				    }

				}

				S6FlagsSup::pt_points_save->Ajoute(sda);
			    }

			}

			break;
		    }

		}

		S6GereFichier::pt_points = S6FlagsSup::pt_points_save;
		S6InitCourbe::Init();
		S6GereFenet::ReConfigCourbes();

		if(S6GereEnv::ihm && S6GereFenet::courbes)
		{
		    unsigned nbcourbes = S6GereFichier::pt_points->
			DonneeAbstraite();

		    S6GereFenet::courbes->Change(nbcourbes);
		}

		S6FlagsSup::seul = FALSE;
		S6FlagsSup::choix_trace = S6FlagsSup::TRACE_2D;
		S6FlagsSup::coupe_regenere = FALSE;

		TraceSeul();

		S6FlagsSup::choix_trace = S6FlagsSup::TRACE_COUPE;
		S6GereFichier::pt_points = pt_points_a;
	    }
	    break;
	}

	TimerDetReport(1,1,"Temps calcul trace image");
}

void
S6Trace::TraceSeul()
{

  // ----------------------------------------------------------
  //	sous-programme d'appels graphiques pour Psyche V1 2.x
  // ----------------------------------------------------------

	int nnx = grille_grad_x_nb;
	int nny = grille_grad_y_nb;
	int nnz = grille_grad_z_nb;
	int ninter = grille_grad_inter; // a parametrer

    // -message----------------------------------------------------------

	const int ihm_existe = S6GereEnv::ihm && S6GereFenet::root;
	const int ihm_misajour = ihm_existe && calcul_ihm;

	if(ihm_misajour) S6GereFenet::info->Change(S6Traduc::traduc[7]);

    // -calcul des parametres de boite-----------------------------------

	P4Boolean auto_boite = P4Boolean(boite_cur_x_min == 0. &&
		boite_cur_y_min == 0. && boite_cur_x_max == 0. &&
		boite_cur_y_max == 0.);

	REEL     xpos6i = min(boite_cur_x_min, boite_cur_x_max);
	boite_cur_x_max = max(boite_cur_x_min, boite_cur_x_max);
	boite_cur_x_min = xpos6i;
	REEL     ypos6i = min(boite_cur_y_min, boite_cur_y_max);
	boite_cur_y_max = max(boite_cur_y_min, boite_cur_y_max);
	boite_cur_y_min = ypos6i;

	REEL       xcen = .5, ycen = .55, scalx = .75, scaly = .75;

	if(!auto_boite && S6FlagsSup::choix_trace != S6FlagsSup::TRACE_2D)
	{
	    xcen = (boite_cur_x_min + boite_cur_x_max) * .5;
	    ycen = (boite_cur_y_min + boite_cur_y_max) * .5;
	    scalx = abs(boite_cur_x_max - boite_cur_x_min);
	    scaly = abs(boite_cur_y_max - boite_cur_y_min);
	}

	ostrstream& ost = *new ostrstream();
	SetOStream(&ost);

    // -initialisations, mise en page----------------------------------

	Init();

    // -legende des courbes 2d-------------------------------------------

	Legendes2D();

    // -TITRES------------------------------------------------------- 

	S6Trace::Titres();

    // -3d-4d------------------------------------------------------------

	if(S6FlagsSup::choix_trace != S6FlagsSup::TRACE_2D &&
		option_3d != int(PAS_DE_TRACE))
	{
	    graf->P4Time(TRUE);
	    graf->P4TimeGeom(TRUE);
	    graf->P4ChercheMaillesInit(P4Boolean(maille_pique));
	    graf->P4Dcolo(option_3d_couleur_up);
	    graf->P4Defpa(BAS_TRACE,option_3d_couleur_down);
	    graf->P4Marqueur(option_3d_marqueur);

	    REEL decal_x = grille_ecart_x;
	    REEL decal_y = grille_ecart_y;
	    REEL decal_z = grille_ecart_z;

	    const int type_masque = int(option_3d_masque);

	    graf->P4Def2(type_masque,2,decal_z);
	    graf->P4Dtron(TRONC3D_GAUDROI);

	// init point de vue

	    graf->P4PtvueScxyGen(ptvue_site,ptvue_azimuth,ptvue_roulis,
			    ptvue_distance,xcen,ycen,scalx,scaly,
			    ptvue_redress_vert,ptvue_redress_hori);

	// init grilles

	    if(S6FlagsSup::seul || grille_type == 0)
	    {
		graf->P4AnnuleGrilles();
	    }
	    else if(!S6FlagsSup::seul && grille_type != 0)
	    {
		int type_axe = AXE_ABSENT;

		switch(grille_type)
		{
		  case 1 :
		    type_axe = AXE_CREUX;
		    break;

		  case 2 :
		    type_axe = AXE_SEMICREUX;
		    break;

		  case 3 :
		    type_axe = AXE_PLEIN;
		    break;

		  default :
		    break;
		}

		graf->P4Dcolo(axe_couleur_titre);

		REEL coef_taille = zoom_gra_coef_taille != 0. ?
		    1./zoom_gra_coef_taille : 1.;

		graf->P4DefCaracGrille(int(axe_taille_titre*coef_taille),
				int(axe_taille_echelle*coef_taille));

		char decodx[256],decody[256],decodz[256];

		L3TranscodeChaine(axe_valeur_x,decodx);
		L3TranscodeChaine(axe_valeur_y,decody);
		L3TranscodeChaine(axe_valeur_z,decodz);

		graf->P4DefTitreAuto(decodx,decody,decodz,"","","");

		graf->P4Dcolo(grille_couleur);

		int grad_inter[6];

		grad_inter[0] = ninter;
		grad_inter[1] = ninter;
		grad_inter[2] = ninter;
		grad_inter[3] = ninter;
		grad_inter[4] = ninter;
		grad_inter[5] = ninter;

		graf->P4DefGrilleAuto(decal_x,decal_y,decal_z,FALSE,
				nnx,nny,nnz,type_axe,grad_inter);
	    }

	// -init bornes de trace 3d-------------------------

	    graf->P4DefEchelles(REEL(axe_x_min),REEL(axe_y_min),
			    REEL(axe_z_min),REEL(axe_c_min),
			    REEL(axe_x_max),REEL(axe_y_max),
			    REEL(axe_z_max),REEL(axe_c_max),
			    axe_log_x,axe_log_y,axe_log_z,axe_log_c);

	// -caracteristiques 3d a tracer----------------------

	    TabS6DonneeAbstraite tsda = S6GereFichier::pt_points->
		DonneeAbstraite();
	    unsigned nombre_blocs = tsda;
	    int ierv = graf->P4VideGeom();

	    ierv = graf->P4VideGeomCoupe();

	    for(unsigned numero_bloc=0;numero_bloc<nombre_blocs;numero_bloc++)
	    {
		S6DonneeAbstraite* const sda = tsda[numero_bloc];

		REEL_S* x = sda->X();
		REEL_S* y = sda->Y();
		REEL_S* z = sda->Z();
		REEL_S* c = sda->C();

		const int nx = sda->Nx();
		const int ny = sda->Ny();
		const int nz = sda->Nz();

		const unsigned* const mailles = sda->Mailles();
		int dimmailles = sda->Mailles();
		const unsigned nmailles = sda->Nmailles();

		const unsigned* const volumes = sda->Volume();
		int dimvolumes = sda->Volume();
		const unsigned nvolumes = sda->Nvolume();

		const TypeC typec = sda->Typec();
		int dimc = sda->C();
		TypeDonnee4d typedon =  DONNEE_MAILLE; 

		const REEL_S* zz = z;
		const REEL_S* cc = c;

		if(typec == S6DONNEE_NOEUD)
		{
		    dimc = nx;
		    typedon = DONNEE_NOEUD;

		    if(option_3d_z_eq_c == 1 || option_3d_z_eq_c == -1 &&
				    numero_bloc <
				    unsigned(option_3d_zc_bloc_t) &&
				    option_3d_zc_bloc[numero_bloc] == 1)
		    {
			zz = c;
			cc = z;
		    }

		}

		register int dimx = nx;
		register int dimy = nx;
		register const unsigned nxyz = nx*ny*nz;

		if(unsigned(sda->X()) < nxyz)
		{
		    dimx = 0;
		    dimy = -1;
		}

		const int dimz = unsigned(sda->Z()) < nxyz ? 0 : nx;

		ierv = graf->P4AjouteGeom(x,y,zz,cc,dimx,dimy,dimz,dimc,
				nx,ny,nz,mailles,nmailles,dimmailles,
				volumes,nvolumes,dimvolumes,typedon);
	    }

	// -init hauteurs

	    const int taille_col = parametre_map_col_t/3 + 2;
	    const int taille_tot = parametre_map_pal_t/3 + taille_col - 1;

	    graf->P4BornesAuto(FALSE);

	    if(option_3d == PIX3D || option_3d == PIX4D)
	    {
		ierv = graf->P4BornesLogiques();
	    }
	    else
	    {
		ierv = graf->P4Bornes();
	    }

	    ierv = graf->P4InitHauteurs(hauteur_z,hauteur_z_taille,
			hauteur_z_h_min,hauteur_z_h_max,
			OPT_3D,taille_col,taille_tot,P4Boolean(hauteur_z_log),
			P4Boolean(axe_log_z),TRUE);
	    ierv = graf->P4InitHauteurs(hauteur_c,hauteur_c_taille,
			hauteur_c_h_min,hauteur_c_h_max,
			OPT_4D,taille_col,taille_tot,P4Boolean(hauteur_c_log),
			P4Boolean(axe_log_c),TRUE);

	// -trace des echelles de couleur pour le 3d-4d------------------------

	    Echelles34D();

	// -legendes des courbes de niveaux 4d------------------------------

	    LegendesNiv();

	// trace surface ou trajectoire monocouleur, 3d ou 4d

	    TraceGeom(ost);
	}

    // *******************************************************************
    // -2d + coupes 3d-4d-------------------------------------------------
    // *******************************************************************

	else if(S6FlagsSup::choix_trace == S6FlagsSup::TRACE_2D &&
		option_2d >= 0 && option_2d <= 2)
	{
	    REEL_S* xi = NULL;REEL_S* yi = NULL;
	    TabS6DonneeAbstraite tsda = S6GereFichier::pt_points->
		DonneeAbstraite();
	    Tabint nxsto;
	    int ny = tsda;
	    int nx = 0;

	    nxsto.ModValn(ny);

	    for(register int i=0;i<ny;i++)
	    {
		nxsto[i] = tsda[i]->Nx();
		nx = max(nx,nxsto[i]);
	    }

	// cas courbes integrales

	    if(option_2d == 1)
	    {
		xi = new REEL_S[nx*ny];
		yi = new REEL_S[nx*ny];
	
		if(!xi || !yi)
		{
		    cerr << "S6Trace> Pas assez de place memoire :\n"
			"\ton ne trace pas la courbe integrale" << endl;
		    delete[] xi;delete[] yi;
		    return;
		}

		for(register int ii=0;ii<ny;ii++)
		{
		    REEL_S* x = tsda[ii]->X();
		    REEL_S* y = tsda[ii]->Y();

                    memcpy(xi + ii*nx,x,nxsto[ii]*sizeof(REEL_S));
                    memcpy(yi + ii*nx,y,nxsto[ii]*sizeof(REEL_S));
		}

		for(register int j=0;j<ny;j++)
		{
		    REEL_S* x = tsda[j]->X();
		    REEL_S* y = tsda[j]->Y();

		    for(register int iin=1;iin<nxsto[j];iin++)
		    {
			y[iin] = y[iin-1] + (yi[iin-1+j*nx] + yi[iin+j*nx]) *
				(x[iin] -x[iin-1])*.5;
		    }

		}

		for(register int jj=0;jj<ny;jj++)
		{
		    REEL_S* y = tsda[jj]->Y();

		    for(register int iip=0;iip<nxsto[jj];iip++)
		    {
			y[iip] = max(min(y[iip],REEL_S(Bmax)),REEL_S(-Bmax));
		    }

		}

	    }

	// cas courbes derivees

	    else if(option_2d == 2)
	    {
		xi = new REEL_S[nx*ny];
		yi = new REEL_S[nx*ny];
	
		if(!xi || !yi)
		{
		    cerr << "Pas assez de place memoire dans P4trace,\n"
			"on ne trace pas la courbe derivee" << endl;
		    delete[] xi;delete[] yi;
		    return;
		}

		for(int ii2=0;ii2<ny;ii2++)
		{
		    REEL_S* x = tsda[ii2]->X();
		    REEL_S* y = tsda[ii2]->Y();

                    memcpy(xi + ii2*nx,x,nxsto[ii2]*sizeof(REEL_S));
                    memcpy(yi + ii2*nx,y,nxsto[ii2]*sizeof(REEL_S));
		}

		for(int j=0;j<ny;j++)
		{

		    if(nxsto[j] < 2) continue;

		    REEL_S* x = tsda[j]->X();
		    REEL_S* y = tsda[j]->Y();
		    REEL dx = x[1] -x[0];
		    P4Boolean init1 = FALSE;

		    if(dx != 0.)
		    {
			y[0] = (yi[1+j*nx]-yi[j*nx])/dx;
			init1 = FALSE;
		    }
		    else
		    {
			init1 = TRUE;
		    }

		    for(register int i1=1;i1<nxsto[j];i1++)
		    {
			dx = x[min(i1+1,nxsto[j]-1)] - x[i1-1];

			if(dx != 0.)
			{
			    y[i1] = (yi[min(i1+1,nxsto[j]-1)+j*nx] -
				yi[i1-1+j*nx])/dx;
			}
			else
			{
			    y[i1] = y[i1-1];
			}

		    }

		    if(init1)
		    {
			y[0] = y[1];
		    }

		    for(register int ii=0;ii<nxsto[j];ii++)
		    {
			y[ii] = max(min(y[ii],REEL_S(Bmax)),REEL_S(-Bmax));
		    }

		}

	    }

	// *****************************************************
	//        cas general
	// *****************************************************

	// cas non zoome

	    if(zoom_actif == 0)
	    {

	    // calcul des bornes automatiques

		int jst = 0;
		int j;

		for(j=0;j<ny && (courbe_type[j]<0 || courbe_cote[j]==1);j++)
		{
		    jst = j+1;
		}

		if(jst < ny)
		{
		    REEL_S* x = tsda[jst]->X();
		    REEL_S* y = tsda[jst]->Y();

		    axe_x_max_reel = axe_x_min_reel = x[0];
		    axe_y_max_reel = axe_y_min_reel = y[0];
		}

		for(j=0;j<ny;j++)
		{
		    REEL_S* x = tsda[j]->X();
		    REEL_S* y = tsda[j]->Y();

		    if(courbe_type[j] >= 0 && courbe_cote[j] == 0)
		    {

			for(int i4=0;i4<nxsto[j];i4++)
			{
			    axe_x_min_reel = min(axe_x_min_reel,REEL(x[i4]));
			    axe_x_max_reel = max(axe_x_max_reel,REEL(x[i4]));
			    axe_y_min_reel = min(axe_y_min_reel,REEL(y[i4]));
			    axe_y_max_reel = max(axe_y_max_reel,REEL(y[i4]));
			}
			
		    }

		}

		jst = 0;

		for(j=0;j<ny && (courbe_type[j]<0 || courbe_cote[j]==0);j++)
		{
		    jst = j+1;
		}

		if(jst < ny)
		{
		    REEL_S* y = tsda[jst]->Y();

		    axe_yd_min_reel = y[0];
		    axe_yd_max_reel = y[0];
		}

		for(j=0;j<ny;j++)
		{
		    REEL_S* x = tsda[j]->X();
		    REEL_S* y = tsda[j]->Y();

		    if(courbe_type[j] >= 0 && courbe_cote[j] == 1)
		    {

			for(register int i2=0;i2<nxsto[j];i2++)
			{
			    axe_x_min_reel = min(axe_x_min_reel,REEL(x[i2]));
			    axe_x_max_reel = max(axe_x_max_reel,REEL(x[i2]));
			    axe_yd_min_reel = min(axe_yd_min_reel,REEL(y[i2]));
			    axe_yd_max_reel = max(axe_yd_max_reel,REEL(y[i2]));
			}
			
		    }

		}

		P4Boolean auto2d = P4Boolean(axe_x_min == 0. &&
			axe_x_max == 0. && axe_y_min == 0. && axe_y_max == 0.);

		if(!auto2d)
		{

		    if(axe_x_min != 0. || axe_x_max != 0.)
		    {
			axe_x_min_reel = axe_x_min;
			axe_x_max_reel = axe_x_max;
		    }

		    if(axe_y_min != 0. || axe_y_max != 0.)
		    {
			axe_y_min_reel = axe_y_min;
			axe_y_max_reel = axe_y_max;
		    }

		}

		if(axe_yd_min != 0. || axe_yd_max != 0.)
		{
		    axe_yd_min_reel = axe_yd_min;
		    axe_yd_max_reel = axe_yd_max;
		}

	    }

	// cas avec zoom

	    else
	    {
		REEL xpos3i = min(zoom_cur_x_min,zoom_cur_x_max)*99.+1.;
		REEL xpos3a = max(zoom_cur_x_min,zoom_cur_x_max)*99.+1.;
		REEL ypos3i = min(zoom_cur_y_min,zoom_cur_y_max)*99.+1.;
		REEL ypos3a = max(zoom_cur_y_min,zoom_cur_y_max)*99.+1.;

		REEL x1a = S6FlagsSup::axe_x_min_reel_anc;
		REEL x2a = S6FlagsSup::axe_x_max_reel_anc;
		REEL y1a = S6FlagsSup::axe_y_min_reel_anc;
		REEL y2a = S6FlagsSup::axe_y_max_reel_anc;

		REEL yd1a = S6FlagsSup::axe_yd_min_reel_anc;
		REEL yd2a = S6FlagsSup::axe_yd_max_reel_anc;

		if(x1a == 0. && x2a == 0. && y1a == 0. && y2a == 0.)
		{
		    int jst = 0;
		    int j;

		    for(j=0;j<ny && (courbe_type[j] < 0 ||
				    courbe_cote[j] == 1);j++)
		    {
			jst = j+1;
		    }

		    if(jst < ny)
		    {
			REEL_S* x = tsda[jst]->X();
			REEL_S* y = tsda[jst]->Y();

			x1a = x[0];
			x2a = x[0];
			y1a = y[0];
			y2a = y[0];
		    }

		    for(j=0;j<ny;j++)
		    {

			if(courbe_type[j] >= 0 && courbe_cote[j] == 0)
			{
			    REEL_S* x = tsda[j]->X();
			    REEL_S* y = tsda[j]->Y();

			    for(register int i3=0;i3<nxsto[j];i3++)
			    {
				x1a = min(x1a,REEL(x[i3]));
				x2a = max(x2a,REEL(x[i3]));
				y1a = min(y1a,REEL(y[i3]));
				y2a = max(y2a,REEL(y[i3]));
			    }
			
			}

		    }

		    jst = 0;

		    for(j=0;j<ny && (courbe_type[j] < 0 ||
			courbe_cote[j] == 0);j++)
		    {
			jst = j+1;
		    }

		    if(jst < ny)
		    {
			REEL_S* y = tsda[jst]->Y();

			yd1a = y[0];
			yd2a = y[0];
		    }

		    for(j=0;j<ny;j++)
		    {

			if(courbe_type[j] >= 0 && courbe_cote[j] == 1)
			{
			    REEL_S* x = tsda[j]->X();
			    REEL_S* y = tsda[j]->Y();

			    for(register int i5=0;i5<nxsto[j];i5++)
			    {
				x1a = min(x1a,REEL(x[i5]));
				x2a = max(x2a,REEL(x[i5]));
				yd1a = min(yd1a,REEL(y[i5]));
				yd2a = max(yd2a,REEL(y[i5]));
			    }
			
			}

		    }

		}

		P4Vrbor(x1a,x2a,7.,P4Boolean(axe_log_x),0);
		P4Vrbor(y1a,y2a,7.,P4Boolean(axe_log_y),0);
		P4Vrbor(yd1a,yd2a,7.,P4Boolean(axe_log_yd),0);

		axe_x_min_reel = (x2a-x1a)/(boite_gri_x_max-boite_gri_x_min) *
		    (xpos3i-boite_gri_x_min)+x1a;
		axe_x_max_reel = (x2a-x1a)/(boite_gri_x_max-boite_gri_x_min) *
		    (xpos3a-boite_gri_x_min)+x1a;
		axe_y_min_reel = (y2a-y1a)/(boite_gri_y_max-boite_gri_y_min) *
		    (ypos3i-boite_gri_y_min)+y1a;
		axe_y_max_reel = (y2a-y1a)/(boite_gri_y_max-boite_gri_y_min) *
		    (ypos3a-boite_gri_y_min)+y1a;

		axe_yd_min_reel = (yd2a-yd1a)/(boite_gri_y_max-boite_gri_y_min)*
		    (ypos3i-boite_gri_y_min)+yd1a;
		axe_yd_max_reel = (yd2a-yd1a)/(boite_gri_y_max-boite_gri_y_min)*
		    (ypos3a-boite_gri_y_min)+yd1a;

		if(axe_log_x)
		{
		    axe_x_min_reel = P4Exp10(axe_x_min_reel);
		    axe_x_max_reel = P4Exp10(axe_x_max_reel);
		}

		if(axe_log_y)
		{
		    axe_y_min_reel = P4Exp10(axe_y_min_reel);
		    axe_y_max_reel = P4Exp10(axe_y_max_reel);
		}

		if(axe_log_yd)
		{
		    axe_yd_min_reel = P4Exp10(axe_yd_min_reel);
		    axe_yd_max_reel = P4Exp10(axe_yd_max_reel);
		}

	    // -fin differences pour zoom--------------------------

	    }

	// -suite cas general (on arrondi axe_x_min_reel,axe_x_max_reel,-
	// -axe_y_min_reel,axe_y_max_reel et on ecarte ------------------
	// -s'ils sont egaux)--------------------------------------------

	    REEL xp1 = axe_x_min_reel,xp2 = axe_x_max_reel;
	    REEL yp1 = axe_y_min_reel,yp2 = axe_y_max_reel;
	    REEL ydp1 = axe_yd_min_reel,ydp2 = axe_yd_max_reel;

	    P4Vrbor(xp1,xp2,7.,P4Boolean(axe_log_x),0);
	    P4Vrbor(yp1,yp2,7.,P4Boolean(axe_log_y),0);
	    P4Vrbor(ydp1,ydp2,7.,P4Boolean(axe_log_yd),0);

	    axe_x_min_reel = xp1,axe_x_max_reel = xp2;
	    axe_y_min_reel = yp1,axe_y_max_reel = yp2;
	    axe_yd_min_reel = ydp1,axe_yd_max_reel = ydp2;

	    if(axe_log_x)
	    {
		axe_x_min_reel = P4Exp10(axe_x_min_reel);
		axe_x_max_reel = P4Exp10(axe_x_max_reel);
	    }

	    if(axe_log_y)
	    {
		axe_y_min_reel = P4Exp10(axe_y_min_reel);
		axe_y_max_reel = P4Exp10(axe_y_max_reel);
	    }

	    if(axe_log_yd)
	    {
		axe_yd_min_reel = P4Exp10(axe_yd_min_reel);
		axe_yd_max_reel = P4Exp10(axe_yd_max_reel);
	    }

	// -trace de la grille------------------------------------

	    int jst = 0;

	    for(int j=0;j<ny && (courbe_type[j] < 0 || courbe_cote[j] == 0);j++)
	    {
		jst = j+1;
	    }

	    P4Boolean exist_axe_droit = P4Boolean(jst < ny);

	    if(grille_type && !S6FlagsSup::seul)
	    {
		int modes = 0;
		REEL coef_taille = zoom_gra_coef_taille != 0. ?
		    1./zoom_gra_coef_taille : 1.;

		if(axe_log_x) modes = modes+XCOLOG;

		if(axe_log_y) modes = modes+YCOLOG;

		int type_axe = AXE_VIDE;

		if(grille_type == 1) type_axe = AXE_CREUX;

		if(grille_type == 2) type_axe = AXE_SEMICREUX;

		if(grille_type == 3) type_axe = AXE_PLEIN;

		L3DefTexte(1,int(axe_taille_echelle*coef_taille),0.);
		L3Couleur(grille_couleur);
		L3DefGrille(1,GAUCHE,type_axe,grille_label2d_gauche,
				ninter,AUCUNE);

		if(exist_axe_droit)
		{
		    L3DefGrille(1,DROITE,AXE_VIDE,TRUE,ninter,AUCUNE);
		}
		else
		{
		    L3DefGrille(1,DROITE,type_axe,grille_label2d_droit,
				    ninter,AUCUNE);
		}

		L3DefGrille(1,BAS,type_axe,grille_label2d_bas,ninter,AUCUNE);
		L3DefGrille(1,HAUT,type_axe,grille_label2d_haut,ninter,AUCUNE);
		L3Grille(1,axe_x_min_reel,axe_y_min_reel,
				axe_x_max_reel,axe_y_max_reel,nnx,nny,modes);
	    }
	    else
	    {
		L3DefSpaceLog(1,axe_x_min_reel,axe_y_min_reel,
				axe_x_max_reel,axe_y_max_reel,
				axe_log_x,axe_log_y);
	    }

	// -trace des courbes 2d------------------------------------

	    Trace2d(0,nx,ny,nxsto);

	// -trace de l'axe droit---------------------------

	    if(exist_axe_droit && grille_type && !S6FlagsSup::seul)
	    {
		REEL coef_taille = zoom_gra_coef_taille != 0. ?
			1./zoom_gra_coef_taille : 1.;
		int modes = 0;

		if(axe_log_x) modes = modes+XCOLOG;

		if(axe_log_yd) modes = modes+YCOLOG;

		int type_axe = AXE_VIDE;

		if(grille_type == 1) type_axe = AXE_CREUX;

		if(grille_type == 2) type_axe = AXE_SEMICREUX;

		if(grille_type == 3) type_axe = AXE_PLEIN;

		L3DefTexte(1,int(axe_taille_echelle*coef_taille),0.);
		L3Couleur(grille_couleur);
		L3DefGrille(1,GAUCHE,AXE_ABSENT,TRUE,ninter,AUCUNE);
		L3DefGrille(1,DROITE,type_axe,grille_label2d_yddroit,
				ninter,AUCUNE);
		L3DefGrille(1,BAS,AXE_ABSENT,TRUE,ninter,AUCUNE);
		L3DefGrille(1,HAUT,AXE_ABSENT,TRUE,ninter,AUCUNE);
		L3Grille(1,axe_x_min_reel,axe_yd_min_reel,
				axe_x_max_reel,axe_yd_max_reel,nnx,nny,modes);
	    }
	    else
	    {
		L3DefSpaceLog(1,axe_x_min_reel,axe_yd_min_reel,
			axe_x_max_reel,axe_yd_max_reel,axe_log_x,axe_log_yd);
	    }

	// -trace des courbes 2d droites--------------------------------

	    Trace2d(1,nx,ny,nxsto);

	// -titres des textes echelles x et y---------------------------

	    TitresAxes2d();

	// remise a zero dans le cas integral et derivees

	    if(option_2d == 1 || option_2d == 2)
	    {

		for(int j2=0;j2<ny;j2++)
		{
		    REEL_S* x = tsda[j2]->X();
		    REEL_S* y = tsda[j2]->Y();

                    memcpy(x,&xi[j2*nx],nxsto[j2]*sizeof(REEL_S));
                    memcpy(y,&yi[j2*nx],nxsto[j2]*sizeof(REEL_S));
		}

		delete[] xi;delete[] yi;
	    }

	}

    // -textes------------------------------------------------------------

	S6Trace::Textes();

    // fin image

	if(parametre_scene)
	    L3FlushBuffers();
	else
	    L3SautDePage();

	ost << ends;

	char* const ptost = ost.str();

	cout << ptost;
	cout << "S6Trace> FIN TRACE" << endl;
	SetOStream(NULL);
	delete &ost;
	delete[] ptost;

    // -message----------------------------------------------------------

	if(ihm_misajour) S6GereFenet::info->Change(S6Traduc::traduc[8]);

}

// *********************************************************
//       trace de fichier graphique L3
// *********************************************************

void
S6Trace::TraceFichierL3(int trace)
{

    // ----------------------------------------------------------
    //   si calcul_socket > 1 on trace seulement tous les
    //   calcul_socket fois
    // ----------------------------------------------------------

        if(!trace) return;

	calcul_socket_numero++;

	if(calcul_socket > 1 && calcul_socket != calcul_socket_numero)
	{
	    return;
	}

	calcul_socket_numero = 0;
	TraceFichierL3();
}

void
S6Trace::TraceFichierL3()
{
	TimerDetInit();

    //----------------------------------------------------------
    //    on montre la fenetre popup de l'afficheur x11
    //    si DESTIN_SP3 = x11 
    //----------------------------------------------------------

	if(S6GereEnv::dest_x11)
	{
	    S6GereFenet::pt_canvas->Active();
	    S6GereFenet::pt_canvas->Clear(parametre_fond != 2);
	}

	if(!l3_init)
	{
	    L3Ingraf();
	    l3_init = TRUE;
	}

    //----------------------------------------------------------
    //     Trace du fichier
    //----------------------------------------------------------

	num_courbe++;

	cout << "\nS6Trace> TRACE NUMERO " << num_courbe << endl;

	if(zoom_gra_x_min == 0. && zoom_gra_x_max == 0. &&
		zoom_gra_y_min == 0. && zoom_gra_y_max == 0.)
	{
	    
	    if(parametre_scene)
	    {
		S6FlagsSup::num_scene++;

		if(S6FlagsSup::num_scene > 1) TraceDisplayList(SOP_SCL);
		else TraceDisplayList(AVOP_SCL);

	    }
	    else if(S6FlagsSup::num_scene > 0) 
	    {
		S6FlagsSup::num_scene = 0;
		TraceDisplayList(SOP_AVCL);
	    }
	    else
	    {
		TraceDisplayList(AVOP_AVCL);
	    }

	}
	else
	{

	    if(parametre_scene)
	    {
		S6FlagsSup::num_scene++;

		if(S6FlagsSup::num_scene > 1)
		{
		    TraceDisplayListMod(SOP_SCL,zoom_gra_x_min,zoom_gra_x_max,
		        zoom_gra_y_min,zoom_gra_y_max);
		}
		else
		{
		    TraceDisplayListMod(AVOP_SCL,zoom_gra_x_min,zoom_gra_x_max,
		        zoom_gra_y_min,zoom_gra_y_max);
		}

	    }
	    else if(S6FlagsSup::num_scene > 0) 
	    {
		S6FlagsSup::num_scene = 0;
		TraceDisplayListMod(SOP_AVCL,zoom_gra_x_min,zoom_gra_x_max,
		        zoom_gra_y_min,zoom_gra_y_max);
	    }
	    else
	    {
		TraceDisplayListMod(AVOP_AVCL,zoom_gra_x_min,zoom_gra_x_max,
		        zoom_gra_y_min,zoom_gra_y_max);
	    }

	}

	TimerDetReport(1,1,"Temp calcul trace image L3");
}
