#ifndef S6TRADUC_H
#define S6TRADUC_H

// %W% %G% P. Brochard

class S6Traduc
{
	friend int main(int,char**);
	friend class S6GereFenet;
	friend class S6Points;
	friend class S6PointsAscii;
	friend class S6PointsUcd;
	friend class S6PointsMtv;
	friend class S6Trace;
	friend class Configuration;
	friend class Options3D;
	friend class Options2D;
	friend class Titres;
	friend class Textes;
	friend class TextesAppel;
	friend class Grilles;
	friend class Fond;
	friend class PointDeVue;
	friend class Axes;
	friend class TitresAxes;
	friend class AxeDroit;
	friend class Echelles;
	friend class Animation;
	friend class GestionCouleur;
	friend class GestionCouleurAide;
	friend class Dimensions;
	friend class Zoom2d;
	friend class Coordonnees;
	friend class CoulSurf;
	friend class CoupeLogique;
	friend class SliderCoupeEni;
	friend class SliderCoupeEnj;
	friend class SliderMoyenneImin;
	friend class SliderMoyenneImax;
	friend class SliderMoyenneJmin;
	friend class SliderMoyenneJmax;
	friend class SliderProjectionImin;
	friend class SliderProjectionImax;
	friend class SliderProjectionIpas;
	friend class SliderProjectionJmin;
	friend class SliderProjectionJmax;
	friend class SliderProjectionJpas;
	friend class Courbes;
	friend class GestionDonnees;
	friend class AxeAide;
	friend class TitresAxeAide;
	friend class AxeDroitAide;
	friend class GrilleAide;
	friend class TitreAide;
	friend class TexteAide;
	friend class EchelleAide;
	friend class Scene;
	friend class GestionFichier;
	friend class GestionFichierAide;
	friend class CourbeAide;
	friend class PointDeVueAide;
	friend class DimensionAide;
	friend class AnimationAide;
	friend class CoulSurfAide;
	friend class ConfigurationAide;
	friend class ZoomGraf;
	friend class ModePixmap;
	friend class ZeqC;
	friend class Options3DPanel;
	friend class Options3dPanelAide;
	friend class Coupes3dPanel;
	friend class Coupes3dPanelAide;
	friend class ChoixVertical;
	friend class ChoixVerticalPanel;
	friend class MapDeCouleur;
	friend class DestDriver;
	friend class Etat;
	friend class MultiMono;
	friend class GestionDonneesAide;

    private :

	virtual void dummy() = 0;

	static void Init(const char* const lang);

	static void InitTraduc(const char* const lang,int nom_logiciel);
	static void InitTraducAnglais(int nom_logiciel);
	static void InitTraducFrancais(int nom_logiciel);
	static void InitTraducAutre(int nom_logiciel);

	static void InitCouleur(const char* const lang);
	static void InitMap(const char* const lang);
	static void InitDest(const char* const lang);
	static void InitAffx(const char* const lang);
	static void InitRepert(const char* const lang);

	static int version;
	static const char** traduc;
	static const char** couleur;
	static const char** map;
	static const char** dest;
        static const char** affx;
	static const char** repert;

	static unsigned taille_traduc;
	static unsigned taille_couleur;
	static unsigned taille_map;
	static unsigned taille_dest;
	static unsigned taille_affx;
	static unsigned taille_repert;
};

#endif
