#ifndef UCD_H
# define UCD_H

/* %W% %G% P. Letexier modifs P. Brochard */

#ifdef __cplusplus
extern "C" {
#endif

#define LLAB 1024

typedef struct _ctype_struct
{
  int id, mat, n, cell_type;
} Ctype;

typedef struct _ntype_struct
{
  int n;
  int *node_list;
} Ntype;

typedef struct _model_stats_struct
{
  char node_data_labels[LLAB], cell_data_labels[LLAB], model_data_labels[LLAB];
  char node_data_units[LLAB], cell_data_units[LLAB], model_data_units[LLAB];

  int num_nodes, num_cells;
  int num_node_data, num_cell_data, num_model_data;
  int num_node_comp, num_cell_comp, num_model_comp;
  int num_nlist_nodes;

  /* ??? It's a bit misterious ... ??? */

  int *node_comp_list, *node_active_list;
  int *cell_comp_list, *cell_active_list;
  int *model_comp_list, *model_active_list;
} Mtype;

int readucd(FILE* file_num);
int printucd(FILE* file_num,int choix_ascii);
int freeucd(void);
void purgeucd(void);

Ctype* GetCells();
void SetCells(Ctype*);
Ntype* GetCellNlists();
void SetCellNlists(Ntype*);
Mtype* GetModelStats();
void SetModelStats(Mtype);

float* GetXc();
void SetXc(float*);
float* GetYc();
void SetYc(float*);
float* GetZc();
void SetZc(float*);

float* GetNodeData();
void SetNodeData(float*);
float* GetCellData();
void SetCellData(float*);
float* GetModelData();
void SetModelData(float*);

float* GetMinNodeData();
void SetMinNodeData(float*);
float* GetMaxNodeData();
void SetMaxNodeData(float*);

float* GetMinCellData();
void SetMinCellData(float*);
float* GetMaxCellData();
void SetMaxCellData(float*);

float* GetMinModelData();
void SetMinModelData(float*);
float* GetMaxModelData();
void SetMaxModelData(float*);

#ifdef __cplusplus
}
#endif

#endif /* UCD_H */
