#ifndef NXERROR_H
#define NXERROR_H

/* %W% %G% Pierre Brochard */                                                    

/* correspondance NXERRNO - errors messages */

/*
                                                             NXERRNO
    "no error"                                                0
    "fnxopen : cant open file"                                1
    "fnxopen : too many files"                                2
    "net_addr : incorrect file name"                          3
    "Nxwrite/read : erroneous unit"                           4
    "Nxwrite : file not open"                                 5
    "nxwrite : callrpc error"                                 6
    "nxwriti : callrpc error"                                 7
    "nxwritf : callrpc error"                                 8
    "nxwritt : callrpc error"                                 9
    "nxdialo : callrpc error"                                 10
    "nxread : cant open socket in read mode"                  11
    "nxreadi :  cant open socket in read mode"                12
    "nxreadf :  cant open socket in read mode"                13
    "nxreadt : cant open socket in read mode"                 14
    "nxclose: erroneous fd index"                             15
    "clientop : unknown host"                                 16
    "initform : unknown format"                               17
    "read_char_xdr error"                                     18
    "read_int_xdr error"                                      19
    "read_float_xdr error"                                    20
    "write_char_xdr error"                                    21
    "write_int_xdr error"                                     22
    "write_float_xdr error"                                   23
    "nxreadt ou nxwritt : bad value icod ou ocod"             24
    "nxreadt - code type 1 error"                             25
    "nxwritt - code type 2 error"                             26
    "nxwritt - code type 1 error"                             27
    "Double Cray to float Ieee conversion not allowed"        28
    "Float Ieee to double Cray conversion not allowed"        29
    "nxchfrm - unknown format"                                30
    "nxseek - unit is not a disk file"                        31
    "nxseek - error"                                          32
    "nxtell - unit is not a disk file"                        33
    "nxwrite: cant open socket in write mode"                 34
    "nxwriti :  cant open socket in write mode"               35
    "nxwritf :  cant open socket in write mode"               36
    "nxwritt : cant open socket in write mode"                37
    "conversion 64-32 sp on ieee host : underflow"            38
    "conversion 64-32 sp on ieee host : overflow"             39
    "conversion 64-32 dp on ieee host : underflow"            40
    "conversion 64-32 dp on ieee host : overflow"             41
    "conversion 64-32 int on ieee host : overflow"            42
    "conversion 64-32 sp on cray host : underflow"            43
    "conversion 64-32 sp on cray host : overflow"             44
    "conversion 64-32 dp on cray host : underflow"            45
    "conversion 64-32 dp on cray host : overflow"             46
    "conversion 64-32 int on cray host : overflow"            47
    "fnxopen : format error"                                  48
    "clientop : hostname not found"                           49
    "clientop : not INET address"                             50
    "clientop : cant alloc memory"                            51
    "clientop : cant find temp name for bind"                 52
    "fnxaccept2 : hostname not found"                         53
    "fnxaccept2 : not INET or UNIX address"                   54
    "net_addr : cant find temp name for bind"                 55
    "net_addr : service is not existant"                      56
    "net_addr : hostname not found"                           57
    "net_addr : cant alloc memory"                            58
    "net_addr : username not found"                           59
    "fnxaccept2 : too many files"                             60
    "fnxsetsyserror : cant alloc memory"                      61
    "serverop : cant alloc memory"                            62
    "serverop : host name not found"                          63
    "fnxaccept2 : user name not found"                        64
    "serverreg : user name not equal to result of U8GetUser"  65
    "serverecri : serverinfo already allocated"               66
    "nx_lance_rpc_port : daemon not thrown"                   67
    "nx_lance_rpc_port : host name not found"                 68
    "fnx_find_port : host name not found"                     69
    "fnx_find_port : rpc dispatching server not found"        70
    "clientop : cant find server's port"                      71
    "net_addr : /UNIX/ is reserved for server's side only"    72
    "fnx_find_port : UNIX socket asked on another machine"    73
    "clientop : serverinfo deja alloue"                       74
    "nx_init_access : conversion not implemented"             75
    "conversion vms32-ie32 on ieee host : underflow"          76
    "conversion vms32-ie32 on cray host : underflow"          77
    "conversion ie32-vms32 on ieee host : overflow"           78
    "conversion ie32-vms32 on cray host : overflow"           79
    "type not implemented"                                    80
    "fnx_find_port : server not found"                        81
*/

#include "nxnarcisseP.h"
#include "nxoptim.h"

int nxpioerror(const char* fcname);

extern THREAD_LOCAL int NXERRNO;  /* error number : index of nxerror_list[]  */

#endif
