#ifndef NXFONC_H
#define NXFONC_H

/* Pierre Brochard (pierre.brochard.1982@m4x.org) */
                          
#include "nxnarcisseP.h"
#include "nxoptim.h"

int nx_init_access(int nf,int fmt);

typedef struct _ACCESS ACCESS; /* defini dans nxfrmt.h */

DLL_LOCAL const ACCESS* nx_init_access_xdr(void);
DLL_LOCAL const ACCESS* nx_init_access_same(void);

DLL_LOCAL const ACCESS* nx_init_access_ieee_cr64(void);
DLL_LOCAL const ACCESS* nx_init_access_ieee_li32(void);
DLL_LOCAL const ACCESS* nx_init_access_ieee_ie32(void);
DLL_LOCAL const ACCESS* nx_init_access_ieee_ie64(void);
DLL_LOCAL const ACCESS* nx_init_access_ieee_li64(void);
DLL_LOCAL const ACCESS* nx_init_access_ieee_vms32(void);

DLL_LOCAL const ACCESS* nx_init_access_cray_ie32(void);
DLL_LOCAL const ACCESS* nx_init_access_cray_li32(void);
DLL_LOCAL const ACCESS* nx_init_access_cray_ie64(void);
DLL_LOCAL const ACCESS* nx_init_access_cray_li64(void);
DLL_LOCAL const ACCESS* nx_init_access_cray_cr64(void);

DLL_LOCAL const ACCESS* nx_init_access_little_ie32(void);
DLL_LOCAL const ACCESS* nx_init_access_little_li32(void);
DLL_LOCAL const ACCESS* nx_init_access_little_cr64(void);
DLL_LOCAL const ACCESS* nx_init_access_little_ie64(void);
DLL_LOCAL const ACCESS* nx_init_access_little_li64(void);

DLL_LOCAL const ACCESS* nx_init_access_mpp_ie32(void);
DLL_LOCAL const ACCESS* nx_init_access_mpp_cr64(void);
DLL_LOCAL const ACCESS* nx_init_access_mpp_li32(void);
DLL_LOCAL const ACCESS* nx_init_access_mpp_ie64(void);
DLL_LOCAL const ACCESS* nx_init_access_mpp_li64(void);

bool_t DLL_LOCAL xdr_nxtexte(XDR* xdrs, struct NxTexte* p);

void DLL_LOCAL _nx_wfc_not_implemented(FILE* fd,int nb,const char* buff,int* rc);
void DLL_LOCAL _nx_nblk_wfc_not_implemented(FILE* fd,const char* buff,int nb,
		int* nbecrits,int* rc);

void DLL_LOCAL _nx_rfc_not_implemented(FILE* fd,int nb,char* buff,int* rc);
void DLL_LOCAL _nx_nblk_rfc_not_implemented(FILE* fd,char* buff,int nb,
		int* nblus,int* rc);
#endif
