#ifndef NXFRMT_H
#define NXFRMT_H

/* %W% %G% P. Brochard */

#include "nxnarcisseP.h"

extern DESC nx_desc_table[];
extern FILE* nx_fdin_table[];
extern FILE* nx_fdout_table[];

struct _ACCESS
{
	void (*ReadChar)(FILE* fd,char* buff,int nb,int* nlu,int* rc);
	void (*ReadInt)(FILE* fd,int nb,char* buff,int* rc);
	void (*ReadLong)(FILE* fd,int nb,char* buff,int* rc);
	void (*ReadLongLong)(FILE* fd,int nb,char* buff,int* rc);
	void (*ReadFloat)(FILE* fd,int nb,char* buff,int* rc);
	void (*ReadDouble)(FILE* fd,int nb,char* buff,int* rc);
	void (*ReadType)(FILE* fd,int nb,char* buff,
			const char* icod,const char* ocod,int* rc);
	void (*ReadIntNblk)(FILE* fd,char* buff,int nb,int* nblus,int* rc);
	void (*ReadLongNblk)(FILE* fd,char* buff,int nb,int* nblus,int* rc);
	void (*ReadLongLongNblk)(FILE* fd,char* buff,int nb,int* nblus,int* rc);
	void (*ReadFloatNblk)(FILE* fd,char* buff,int nb,int* nblus,int* rc);
	void (*ReadDoubleNblk)(FILE* fd,char* buff,int nb,int* nblus,int* rc);
	void (*ReadTypeNblk)(FILE* fd,char* buff,int nb,const char* icod,
			const char* ocod,int* nblus,int* rc);
	void (*WriteChar)(FILE* fd,const char* buff,int nb,int* nbecrit,int* rc);
	void (*WriteInt)(FILE* fd,int nb,const char* buff,int* rc);
	void (*WriteLong)(FILE* fd,int nb,const char* buff,int* rc);
	void (*WriteLongLong)(FILE* fd,int nb,const char* buff,int* rc);
	void (*WriteFloat)(FILE* fd,int nb,const char* buff,int* rc);
	void (*WriteDouble)(FILE* fd,int nb,const char* buff,int* rc);
	void (*WriteType)(FILE* fd,int nb,const char* buff,const char* icod,
			const char* ocod,int* rc);
	void (*WriteIntNblk)(FILE* fd,const char* buff,int nb,int* nbecrits,
			int* rc);
	void (*WriteLongNblk)(FILE* fd,const char* buff,int nb,int* nbecrits,
			int* rc);
	void (*WriteLongLongNblk)(FILE* fd,const char* buff,int nb,int* nbecrits,
			int* rc);
	void (*WriteFloatNblk)(FILE* fd,const char* buff,int nb,int* nbecrits,
			int* rc);
	void (*WriteDoubleNblk)(FILE* fd,const char* buff,int nb,int* nbecrits,
			int* rc);
	void (*WriteTypeNblk)(FILE* fd,const char* buff,int nb,const char* icod,
			const char* ocod,int* nbecrits,int* rc);
};

extern const struct _ACCESS* nx_ptio[];
       
#endif /* NXFRMT_H */
