/***********************************************************/
/*    driver gl pour sgi                                   */
/***********************************************************/

#ifndef lint
    static const char sccs_id[] = "%W% %G% G. Colin de Verdiere";
#endif

#ifdef GL /* si gl existe */

#include <stdio.h>
#include <stdlib.h>

#include <gl/gl.h>
#include <gl/device.h>
#include <fmclient.h>

#include "L3ListeDesCodes.h"
#include "poulpe/U8gl.h"

static fmfontinfo      info;
static int             done = FALSE;
static int             openfait = FALSE;
static long            winid = 0;
static float           vert[4];
static fmfonthandle    fh0, fh, fhb, fhtitre /* handler du font manager */ ;
static long            orgX, orgY, sizeX, sizeY;
static float           ech, ht, lg;

#define NCOLORS 256
static int Ncolors = NCOLORS;

static int IsOpen = FALSE;

void
closegl(void)
{

   if(winid) winclose(winid);

   openfait = FALSE;
   IsOpen = FALSE;
}

void
s3l3gl(int it[])
{
   static int IsVide = TRUE;
   static int codel3open[2] = {2, CODEL3OPEN};

   int i = 0;

   if(!IsOpen && it[1] == CODEL3CLOSE) return;

   if(!IsOpen && it[1] != CODEL3OPEN) s3l3gl(codel3open);

   switch (it[1])
   {
    case CODEL3OPEN:

      if(IsOpen) break;

      if (!openfait)
      {
         minsize(512, 512);
         stepunit(8, 8);
         keepaspect(1, 1);

         /*prefposition(0, 800, 0, 800);*/

	 /* on force le process a rester en avant plan */
         /* pour la version de developpement uniquement */
	 foreground();

	 winid = winopen("Afficheur L3 GL");

	 /*doublebuffer();*/
	 gconfig();
	 openfait = TRUE;
      }

      winset(winid);
      mmode(MVIEWING);

      if (done == FALSE)
      {
	 fminit();
	 fh0 = fmfindfont("Times-Roman");
	 fh = fmscalefont(fh0, 10.0);
	 fhb = fmscalefont(fh0, 12.0);
	 done = TRUE;
      }

      getorigin(&orgX, &orgY);
      getsize(&sizeX, &sizeY);
      linewidth(1);
      viewport(0., sizeX, 0., sizeY);
      ortho2(XPAGEMIN, XPAGEMAX, YPAGEMIN, YPAGEMAX);
      reshapeviewport();
      subpixel(TRUE);

      /* Ecran blanc au depart */
      color(WHITE);
      clear();
      color(BLACK);
      concave(TRUE);

      IsOpen = TRUE;
      IsVide = TRUE;

      break;

    case CODEL3CLOSE:

      if(IsVide || !IsOpen) break;

      /* swapbuffers(); */
      IsOpen = FALSE;
      break;

    case CODEL3PIXEL:

      IsVide = FALSE;
      break;

    case CODEL3TEXTE:

      IsVide = FALSE;
      ech = 40.;
      fhtitre = fmscalefont(fh0, ech);
      /* lg = fmgetstrwidth(fhtitre, titregeneral); */
      fmgetfontinfo(fhtitre, &info);
      ht = info.height;
      fmsetfont(fhtitre);
      /* cmov((sizeX * 0.90 - lg) / 2, (sizeY * 0.10 - ht) / 2.0, 0.); */
      /* fmprstr(titregeneral); */
      break;

    case CODEL3COULEUR:

      color(it[2]);
      break;

    case CODEL3BRILLANCE:

      break;

    case CODEL3MARQUEUR:

      IsVide = FALSE;
      break;

    case CODEL3SEGMENT:

      IsVide = FALSE;
      bgnline();

      v2i((long int*) &it[2]);
      v2i((long int*) &it[4]);

      endline();
      break;

    case CODEL3CADRE:

      break;

    case CODEL3POLYGONE:

      IsVide = FALSE;
      bgnpolygon();

      for (i = 2; i < it[0]; i += 2)
      {
	 v2i((long int*) &it[i]);
      }

      endpolygon();
      break;

    case CODEL3FLUSH:

      break;

    case CODEL3RESEAU:

      break;

    case CODEL3SEPARATEUR:

      break;

    case CODEL3COLORMAP:

      if (it[0] < 8) break;
      
      Ncolors = it[2] > NCOLORS ? NCOLORS : it[2];

      for (i = 0; i < Ncolors; i++)
      {
         mapcolor(i,(short) it[3 * (i + 1)    ],
		(short) it[3 * (i + 1) + 1],
		(short) it[3 * (i + 1) + 2]);
      }

      color(0);
      clear();

      break;

    case CODEL3DIALOGUE:

      switch (it[2])
      {
       case SOUSCODEL3_MGRAPH:
	 break;
       case SOUSCODEL3_MGRAPHCLEAR:
	 break;
       case SOUSCODEL3_ALPHA:
	 break;
       case SOUSCODEL3_ALPHACLEAR:
	 break;
       case SOUSCODEL3_CLOCHE:
	 break;
       case SOUSCODEL3_HARDCOPY:
	 break;
       case SOUSCODEL3_SETCUR:
	 break;
       case SOUSCODEL3_ANCRERETI:
	 break;
       case SOUSCODEL3_PURGENEGS:
	 break;
       case SOUSCODEL3_SAVECUR:
	 break;
       case SOUSCODEL3_GETPOS:
	 break;
       case SOUSCODEL3_FENETRE:
	 break;
       default:;
      }

      break;

    default:;
   }

}

#endif /* fin GL */
