/*****************/
/* L3Brillance.c */
/*****************/

#include <stdio.h>

#include "L3Environnement.h"
#include "L3Brillance.h"

#ifndef lint
    static const char sccs_id[] = "%W% %G% G. Colin de Verdiere";
#endif

/*******************************************************************************
 * Procedure utilisateur : L3Brillance                                         *
 *-----------------------------------------------------------------------------*
 * Parametres :                                                                *
 *   brillance : valeur de la brillance entre 0.0 et 2.0                       *
 * 								               *
 * Valeur de retour : aucune                                                   *
 * 								               *
 * Description : voir document CEL.V DMA/SIE/IG NT 58.9 de juillet 1987        *
 *  "GRAF CIGALE"                                                              *
 *                                                                             *
 * Erreurs :                                                                   *
 *   valeur de la brillance interdite                                          *
 *******************************************************************************/

void
L3Brillance(double brillance)
{
	int             codel3[3];
	int             bril;

	if ((brillance >= 0.0) && (brillance <= 2.0))
	{
	    bril = (int) (brillance * 1024.0);

	    if (bril > 1024)
		bril = 1024;

	    if (bril != BRILLANCECOURANTE)
	    {
		BRILLANCECOURANTE = bril;
		codel3[0] = 3;
		codel3[1] = CODEL3BRILLANCE;
		codel3[2] = bril;
		L3AppelDrivers(codel3);
	    }

	}
	else
	{
	/*-------------------------------*/
	/* Erreur : brillance interdite. */
	/*-------------------------------*/
	    fprintf(stderr, "L3Brillance : "
			    "valeur de la brillance incorrecte :%f\n",
			    brillance);
	}

}
