/*************/
/* L3Cadre.c */
/*************/

#include <stdio.h>

#include "L3Environnement.h"
#include "L3Cadre.h"

#ifndef lint
    static const char sccs_id[] = "%W% %G% G. Colin de Verdiere";
#endif

/******************************************************************************
 * Procedure utilisateur : L3Cadre                                            *
 *----------------------------------------------------------------------------*
 * Parametres :                                                               *
 *   base    : valeur de la base de l'image en centimetres                    *
 *   hauteur : valeur de la hauteur de l'image en centimetres                 *
 *                                                                            *
 * Valeur de retour : aucune                                                  *
 *                                                                            *
 * Description : voir document CEL.V DMA/SIE/IG NT 58.9 de juillet 1987       *
 *    "GRAF CIGALE"                                                           *
 *                                                                            *
 * Erreurs :                                                                  *
 *   base incorrecte                                                          *
 *   hauteur incorrecte                                                       *
 ******************************************************************************/

void
L3Cadre(double base,double hauteur)
{
	int             codel3[4];

	if ((base > 0.0) && (base <= 3276.7))
	{

	    if ((hauteur > 0.0) && (hauteur <= 3276.7))
	    {
		codel3[0] = 4;
		codel3[1] = CODEL3CADRE;
		codel3[2] = (int) (base * 10.0);
		codel3[3] = (int) (hauteur * 10.0);
		L3AppelDrivers(codel3);
	    }
	    else
	    {
	    /*------------------------------*/
	    /* Erreur : hauteur incorrecte. */
	    /*------------------------------*/
		fprintf(stderr,"L3Cadre : hauteur incorrecte :%f\n",hauteur);
	    }

	}
	else
	{
	/*---------------------------*/
	/* Erreur : base incorrecte. */
	/*---------------------------*/
	    fprintf(stderr, "L3Cadre : base incorrecte :%f\n", base);
	}

}
