/******************/
/* L3MiseEnPage.c */
/******************/

#include <stdio.h>

#include "L3Environnement.h"
#include "L3MiseEnPage.h"

#ifndef lint
    static const char sccs_id[] = "%W% %G% modifs P. Brochard";
#endif

/*************************************************************************************************
 * Procedure utilisateur : L3MiseEnPage                                                          *
 *-----------------------------------------------------------------------------------------------*
 * Parametres :                                                                                  *
 *   sousimage : numero de la sous-image concernee                                               *
 *   xa,ya     : coordonnees relatives de l'angle inferieur gauche de la sous-image dans l'image *
 *   xb,yb     : coordonnees relatives de l'angle superieur droit de la sous-image dans l'image  *
 *   xp,yp     : coordonnees de l'angle inferieur gauche de l'image                              *
 *   xq,yq     : coordonnees de l'angle superieur droit de l'image                               *
 *                                                                                               *
 * Valeur de retour : aucune                                                                     *
 *                                                                                               *
 * Description : voir document CEL.V DMA/SIE/IG NT 58.9 de juillet 1987 "GRAF CIGALE"            *
 *                                                                                               *
 * Erreurs :                                                                                     *
 *   mise en page incorrecte                                                                     *
 *************************************************************************************************/

void
L3MiseEnPage(int sousimage, REEL xa, REEL ya, REEL xb, REEL yb,
		REEL xp, REEL yp, REEL xq, REEL yq)
{

	if((xa < xb) && (ya < yb) && (xp < xq) && (yp < yq)) 
	{
		SETSOUSIMAGE(sousimage);
		XA = xa;
		YA = ya;
		XB = xb;
		YB = yb;
		XP = xp;
		YP = yp;
		XQ = xq;
		YQ = yq;
		L3CalculValClip();

		if (CLIPPING == VRAI) L3Troncature(sousimage, CLIPPINGACTIF);

		L3CalculConvCoord();
	}
	else
	{
		/*-----------------------------------*/
		/* Erreur : mise en page incorrecte. */
		/*-----------------------------------*/

		fprintf(stderr,"L3MiseEnPage : ");
		fprintf(stderr,"mise en page incorrecte.\n");
	}

}
