/********************/
/* L3PointCourant.c */
/********************/

#include <stdio.h>

#include "L3Environnement.h"
#include "L3PointCourant.h"

#ifndef lint
    static const char sccs_id[] = "%W% %G% DMA/AIM/LM";
#endif

/**************************************************************************************
 * Procedure utilisateur : L3PointCourant                                             *
 *------------------------------------------------------------------------------------*
 * Parametres :                                                                       *
 *   sousimage : numero de la sous-image concernee                                    *
 *   x,y       : coordonnees du nouveau point courant dans l'espace utilisateur       *
 *                                                                                    *
 * Valeur de retour : aucune                                                          *
 *                                                                                    *
 * Description : voir document CEL.V DMA/SIE/IG NT 58.9 de juillet 1987 "GRAF CIGALE" *
 *                                                                                    *
 * Erreurs : aucune                                                                   *
 **************************************************************************************/

void
L3PointCourant(int sousimage, REEL x, REEL y)
{
	int             xpage, ypage;

	SETSOUSIMAGE(sousimage);
	L3ConversionCoordonnees(x, y, &xpage, &ypage);

	XPAGECOURANT = xpage;
	YPAGECOURANT = ypage;
}
