/******************/
/* L3Troncature.c */
/******************/

#include <stdio.h>

#include "L3Environnement.h"
#include "L3Troncature.h"

#ifndef lint
    static const char sccs_id[] = "%W% %G% DMA/AIM/LM";
#endif

/*****************************************************************************
 * Procedure utilisateur : L3Troncature                                      *
 *---------------------------------------------------------------------------*
 * Parametres :                                                              *
 *   sousimage : numero de la sous-image concernee                           *
 *   modtronc  : mode de troncature                                          *
 *                                                                           *
 * Valeur de retour : aucune                                                 *
 *                                                                           *
 * Description : voir document CEL.V DMA/SIE/IG NT 58.9 de juillet 1987      *
 *                      "GRAF CIGALE"                                        *
 *                                                                           *
 * Erreurs :                                                                 *
 *   mode de troncature incorrect                                            *
 *****************************************************************************/

void
L3Troncature(sousimage, modtronc)
	int             sousimage;
	int             modtronc;

{
	SETSOUSIMAGE(sousimage);

	if (modtronc == CLIPPINGACTIF)
	{
		CLIPPING = VRAI;
		XCLIPMIN = L3Max(XMIN,XPAGEMIN);
		YCLIPMIN = L3Max(YMIN,YPAGEMIN);
		XCLIPMAX = L3Min(XMAX,XPAGEMAX);
		YCLIPMAX = L3Min(YMAX,YPAGEMAX);
	}
	else if (modtronc == CLIPPINGINACTIF)
	{
		CLIPPING = FAUX;
		XCLIPMIN = XPAGEMIN;
		YCLIPMIN = YPAGEMIN;
		XCLIPMAX = XPAGEMAX;
		YCLIPMAX = YPAGEMAX;
	}
	else
	{
		/*----------------------------------------*/
		/* Erreur : mode de troncature incorrect. */
		/*----------------------------------------*/

		fprintf(stderr,"L3Troncature : ");
		fprintf(stderr,"mode de troncature incorrect :%d\n",modtronc);
	}

}
