/*                           N X - A M                                 */
/*                           ---------                                 */
/*                          C interface                                */

/*
*************************************************************************
* 			 Limeil National Center				*
*  Division for Supercomputing, Networking and Workstation Applications	*
*************************************************************************
*  December 23, 1992
*  (C) Copyright 1992 The Board of Trustees of MA/AIM of Limeil.
*
*  Permission is granted to any individual or institution to use, copy,
*  modify, or redistribute this software and its documentation provided
*  this notice and the copyright notices are retained.  This software
*  may not be distributed for profit, either in original form or in
*  derivative works.  MA/AIM of Limeil makes no representations
*  about the suitability of this software for any purpose.
*  MA/AIM OF LIMEIL GIVES NO WARRANTY,
*  EITHER EXPRESS OR IMPLIED, FOR THE PROGRAM AND/OR DOCUMENTATION PROVIDED,
*  INCLUDING, WITHOUT LIMITATION, WARRANTY OF MERCHANTABILITY AND WARRANTY
*  OF FITNESS FOR A PARTICULAR PURPOSE.
*/

/***************************************************************************/

#ifndef lint
    static const char sccsid[] = "%W% %G% Copyr 1992    MA/AIM";
#endif

/* origine : U8psycheinfo.c de Narcisse (Psyche) copyright CEA */
/* auteur Pierre Brochard */

/***************************************************************************/

#include "U8machcomp.h"
#include "nxinfo.h"

/* serveurs anciens pour Psyche (compatibilite avec libs de version anterieures
   a la date du 20/11/96) */

bool_t
xdr_psycheinfo_in(XDR* handle,psycheinfo_in* pii)
{

	if(xdr_vector(handle,pii->user_name,sizeof(pii->user_name),1,
		      (xdrproc_t) xdr_char) == FALSE)
	{
	    return FALSE;
	}

	if(xdr_int(handle,&pii->num_psyche) == FALSE)
	{
	    return FALSE;
	}

	return TRUE;
}

bool_t
xdr_psycheinfo_out(XDR* handle,psycheinfo_out* pio)
{

	if(xdr_int(handle,&pio->num_process) == FALSE)
	{
	    return FALSE;
	}

	if(xdr_int(handle,&pio->num_port) == FALSE)
	{
	    return FALSE;
	}

	if(xdr_int(handle,&pio->num_psyche) == FALSE)
	{
	    return FALSE;
	}

	return TRUE;
}

bool_t
xdr_psycheinfo_out_old(XDR* handle,psycheinfo_out_old* pio)
{

	if(xdr_int(handle,&pio->num_process) == FALSE)
	{
	    return FALSE;
	}

	if(xdr_int(handle,&pio->num_port) == FALSE)
	{
	    return FALSE;
	}

	return TRUE;
}

/* nouveau serveur info generique dans nx */

bool_t
xdr_nxinfo_in(XDR* handle,nxinfo_in* nii)
{
	int taille;

	if(!nii || !handle) return FALSE;

	taille = nii->luser_name;

	if(taille > LNX_USER_NAME)
	{
	    taille = LNX_USER_NAME;
	    nii->user_name[taille-1] = '\0';
	}

	if(xdr_int(handle,&taille) == FALSE)
	{
	    return FALSE;
	}

	nii->luser_name = taille;
	
	if(taille)
	{

	    if(xdr_vector(handle,nii->user_name,taille,1,
			(xdrproc_t) xdr_char) == FALSE)
	    {
		return FALSE;
	    }

	}

	taille = nii->lport_service;

	if(taille > LNX_FILE_NAME)
	{
	    taille = LNX_FILE_NAME;
	    nii->port_service[taille-1] = '\0';
	}

	if(xdr_int(handle,&taille) == FALSE)
	{
	    return FALSE;
	}

	nii->lport_service = taille;

	if(taille)
	{

	    if(xdr_vector(handle,nii->port_service,taille,1,
			(xdrproc_t) xdr_char) == FALSE)
	    {
		return FALSE;
	    }

	}

	if(xdr_int(handle,&nii->port_which) == FALSE)
	{
	    return FALSE;
	}

	return TRUE;
}

bool_t
xdr_nxinfo_out(XDR* handle,nxinfo_out* nio)
{
	int taille;

	if(!nio || !handle) return FALSE;

	taille = nio->lport_name;

	if(taille > LNX_FILE_NAME)
	{
	    taille = LNX_FILE_NAME;
	    nio->port_name[taille-1] = '\0';
	}

	if(xdr_int(handle,&nio->process) == FALSE)
	{
	    return FALSE;
	}

	if(xdr_int(handle,&nio->port) == FALSE)
	{
	    return FALSE;
	}

	if(xdr_int(handle,&taille) == FALSE)
	{
	    return FALSE;
	}

	nio->lport_name = taille;

	if(taille)
	{

	    if(xdr_vector(handle,nio->port_name,taille,1,
			(xdrproc_t) xdr_char) == FALSE)
	    {
		return FALSE;
	    }

	}

	if(xdr_int(handle,&nio->port_which) == FALSE)
	{
	    return FALSE;
	}

	return TRUE;
}
