#ifndef NXRW_H
#define NXRW_H

/* %W% %G% Pierre Brochard */

/* Macros de lecture */

#define READ_CHAR(fd,buf,nb,nblu,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadChar) \
	  nx_ptio[fd_index]->ReadChar(fd, buf, nb, nblu, rc); \
	else \
	  NX_READ_NBLK(fd,buf,1,nb,nblu,"read_char",rc);

#define WRITE_CHAR(fd,buf,nb,nbecrit,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteChar)	\
	  nx_ptio[fd_index]->WriteChar(fd, buf, nb, nbecrit, rc) ; \
	else \
	  NX_WRITE_NBLK(fd,buf,1,nb,nbecrit,"write_char",rc);

#define READ_FLOAT(fd,nb,buf,rc)\
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadFloat)\
	  nx_ptio[fd_index]->ReadFloat(fd, nb, buf, rc);\
	else \
	  NX_READ(fd,buf,NX_SIZE_CFLT,nb,"read_float",rc);

#define READ_DOUBLE(fd,nb,buf,rc)\
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadDouble)\
	  nx_ptio[fd_index]->ReadDouble(fd, nb, buf, rc);\
	else \
	  NX_READ(fd,buf,NX_SIZE_CDBLE,nb,"read_double",rc);

#define READ_FLOAT_NBLK(fd,buf,nb,nblu,rc)\
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadFloatNblk) \
	  nx_ptio[fd_index]->ReadFloatNblk(fd, buf, nb, nblu, rc) ; \
	else \
	  NX_READ_NBLK(fd,buf,NX_SIZE_CFLT,nb,nblu,"read_float_nblk",rc);

#define READ_DOUBLE_NBLK(fd,buf,nb,nblu,rc)\
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadDoubleNblk) \
	  nx_ptio[fd_index]->ReadDoubleNblk(fd, buf, nb, nblu, rc) ; \
	else \
	  NX_READ_NBLK(fd,buf,NX_SIZE_CDBLE,nb,nblu,"read_double_nblk",rc);

/* le cas else de READ_TYPE* est utile seulement si sizeof(float) ==
   sizeof(NXFLT) == sizeof(NXDBLE) c'est a dire pour l'instant jamais  */

#define READ_TYPE(fd,nb,buf,icod,ocod,rc)\
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadType)\
	  nx_ptio[fd_index]->ReadType(fd, nb, buf, icod, ocod, rc);\
	else \
	  NX_READ(fd,buf,NX_SIZE_FLT,nb,"read_type",rc);

#define READ_TYPE_NBLK(fd,buf,nb,icod,ocod,nblu,rc) \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadTypeNblk)\
	  nx_ptio[fd_index]->ReadTypeNblk(fd, buf, nb, icod,ocod,nblu, rc);\
	else \
	  NX_READ_NBLK(fd,buf,NX_SIZE_FLT,nb,nblu,"read_type_nblk",rc);

#define READ_INT(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadInt)	\
	  nx_ptio[fd_index]->ReadInt(fd, nb, buf, rc) ; \
	else \
	  NX_READ(fd,buf,NX_SIZE_INT,nb,"read_int",rc);

#define READ_LONG(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadLong)	\
	  nx_ptio[fd_index]->ReadLong(fd, nb, buf, rc) ; \
	else \
	  NX_READ(fd,buf,NX_SIZE_LONG,nb,"read_long",rc);

#define READ_LONGLONG(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadLongLong)	\
	  nx_ptio[fd_index]->ReadLongLong(fd, nb, buf, rc) ; \
	else \
	  NX_READ(fd,buf,NX_SIZE_LONGLONG,nb,"read_longlong",rc);

#define READ_INT_NBLK(fd,buf,nb,nblu,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadIntNblk)  \
	  nx_ptio[fd_index]->ReadIntNblk(fd, buf, nb, nblu, rc) ; \
	else \
	  NX_READ_NBLK(fd,buf,NX_SIZE_INT,nb,nblu,"read_int_nblk",rc);

#define READ_LONG_NBLK(fd,buf,nb,nblu,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadLongNblk)  \
	  nx_ptio[fd_index]->ReadLongNblk(fd, buf, nb, nblu, rc) ; \
	else \
	  NX_READ_NBLK(fd,buf,NX_SIZE_LONG,nb,nblu,"read_long_nblk",rc);

#define READ_LONGLONG_NBLK(fd,buf,nb,nblu,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->ReadLongLongNblk)  \
	  nx_ptio[fd_index]->ReadLongLongNblk(fd, buf, nb, nblu, rc) ; \
	else \
	  NX_READ_NBLK(fd,buf,NX_SIZE_LONGLONG,nb,nblu,"read_longlong_nblk",rc);

/* Macros d'ecritures */

#define WRITE_FLOAT(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteFloat)	\
	  nx_ptio[fd_index]->WriteFloat(fd, nb, buf, rc) ; \
	else \
	  NX_WRITE(fd,buf,NX_SIZE_CFLT,nb,"write_float",rc);

#define WRITE_DOUBLE(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteDouble)	\
	  nx_ptio[fd_index]->WriteDouble(fd, nb, buf, rc) ; \
	else \
	  NX_WRITE(fd,buf,NX_SIZE_CDBLE,nb,"write_double",rc);

#define WRITE_FLOAT_NBLK(fd,buf,nb,nbecrit,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteFloatNblk) \
	  nx_ptio[fd_index]->WriteFloatNblk(fd, buf, nb, nbecrit, rc); \
	else \
	  NX_WRITE_NBLK(fd,buf,NX_SIZE_CFLT,nb,nbecrit,"write_float_nblk",rc);

#define WRITE_DOUBLE_NBLK(fd,buf,nb,nbecrit,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteDoubleNblk) \
	  nx_ptio[fd_index]->WriteDoubleNblk(fd, buf, nb, nbecrit, rc); \
	else \
	  NX_WRITE_NBLK(fd,buf,NX_SIZE_CDBLE,nb,nbecrit,"write_double_nblk",rc);

/* le cas else de WRITE_TYPE* est utile seulement si sizeof(float) ==
   sizeof(NXFLT) == sizeof(NXDBLE) c'est a dire pour l'instant jamais  */

#define WRITE_TYPE(fd,nb,buf,icod,ocod,rc)\
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteType)\
	  nx_ptio[fd_index]->WriteType(fd, nb, buf, icod, ocod, rc);\
	else \
	  NX_WRITE(fd,buf,NX_SIZE_FLT,nb,"write_type",rc);

#define WRITE_TYPE_NBLK(fd,buf,nb,icod,ocod,nbecrit,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteTypeNblk)  \
	  nx_ptio[fd_index]->WriteTypeNblk(fd, buf, nb,icod,ocod,nbecrit, rc);\
	else \
	  NX_WRITE_NBLK(fd,buf,NX_SIZE_FLT,nb,nbecrit,"write_type_nblk",rc);

#define WRITE_INT(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteInt)	\
	  nx_ptio[fd_index]->WriteInt(fd, nb, buf, rc) ; \
	else \
	  NX_WRITE(fd,buf,NX_SIZE_INT,nb,"write_int",rc);

#define WRITE_LONG(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteLong)	\
	  nx_ptio[fd_index]->WriteLong(fd, nb, buf, rc) ; \
	else \
	  NX_WRITE(fd,buf,NX_SIZE_LONG,nb,"write_long",rc);

#define WRITE_LONGLONG(fd,nb,buf,rc)  \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteLongLong)	\
	  nx_ptio[fd_index]->WriteLongLong(fd, nb, buf, rc) ; \
	else \
	  NX_WRITE(fd,buf,NX_SIZE_LONGLONG,nb,"write_longlong",rc);

#define WRITE_INT_NBLK(fd,buf,nb,nbecrit,rc) \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteIntNblk) \
	  nx_ptio[fd_index]->WriteIntNblk(fd, buf, nb, nbecrit, rc); \
	else \
	  NX_WRITE_NBLK(fd,buf,NX_SIZE_INT,nb,nbecrit,"write_int_nblk",rc);

#define WRITE_LONG_NBLK(fd,buf,nb,nbecrit,rc) \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteLongNblk) \
	  nx_ptio[fd_index]->WriteLongNblk(fd, buf, nb, nbecrit, rc); \
	else \
	  NX_WRITE_NBLK(fd,buf,NX_SIZE_LONG,nb,nbecrit,"write_long_nblk",rc);

#define WRITE_LONGLONG_NBLK(fd,buf,nb,nbecrit,rc) \
	if (nx_ptio[fd_index] && nx_ptio[fd_index]->WriteLongLongNblk) \
	  nx_ptio[fd_index]->WriteLongLongNblk(fd, buf, nb, nbecrit, rc); \
	else \
	  NX_WRITE_NBLK(fd,buf,NX_SIZE_LONGLONG,nb,nbecrit,\
			  "write_longlong_nblk",rc);

#define ISITOPEN(fd_ind) \
	if ((fd_ind >= NX_MAX_DESC) || (fd_ind <= 2) || \
	  (nx_desc_table[fd_ind].ds == 0)) \
	  { \
	    if(!isitopen(fd_ind)) \
	      {	\
	        return  (-1); \
	      } \
	  }

#endif /* !NXRW_H */
