#! /bin/sh

MAIL=mailx
CGIBIN=/usr/local/www/bin/cgi-bin
GNUBIN=/usr/local/gnu/bin
NARCISSEROOT=`home -ap`/distribs/NarcisseWWW
FTPDIR=/tmp
FTPSERVEUR=ftp.bruyeres.cea.fr
TMPDIR=`home -t`
AT="at -s "

#

NARCISSEBIN=$NARCISSEROOT/Produits
NARCISSEPROC=$NARCISSEROOT/Proc/bin
#NARCISSECODE=changetampon.AIX_3__ibmrs6000
NARCISSECODE="changetampon $NARCISSEPROC"

#
# Recommandation du CERN pour un fonctionnement correct de la
# methode POST
#

eval `$CGIBIN/cgiparse -init`

#

DATE=`date '+%A %e %B %Y'`

#
# Verification des parametres requis
#

NOM="`$CGIBIN/cgiparse -value nom`"
PRENOM="`$CGIBIN/cgiparse -value prenom`"
UNITE="`$CGIBIN/cgiparse -value unite`"
CENTRE="`$CGIBIN/cgiparse -value centre`"
EMAIL="`$CGIBIN/cgiparse -value email`"
ARCH=`$CGIBIN/cgiparse -value arch -sep " "`

if [  "$NOM" = ""  -o "$PRENOM" = "" -o "$UNITE" = "" -o "$CENTRE" = "" -o "$EMAIL" = "" -o "$ARCH" = "" ]
then
	echo 'Location: http://xxx.xxx.xxx/xxxreplocalxxx/V1.3/reform.html'
	echo ''
	exit
fi

FAX=`$CGIBIN/cgiparse -value fax`
FORMAT=`$CGIBIN/cgiparse -value format`
TEL=`$CGIBIN/cgiparse -value tel`

#
# Renvoi de la confirmation d'acceptation de la demande
#

echo 'Content-Type: text/html'
echo ''
echo '<HTML>'
echo '<HEAD>'
echo '<TITLE>'
echo Enregistrement de la demande
echo '</TITLE>'
echo '</HEAD>'
echo '<BODY>'
echo '<P>'
echo 'Votre demande a &eacute;t&eacute; enregistr&eacute;e avec les param&egrave;tres suivants :'

echo '<PRE>'
echo Nom : $NOM
echo Prenom : $PRENOM
echo Centre : $CENTRE
echo Unite : $UNITE
echo E-mail : $EMAIL
echo Fax : $FAX
echo Telephone : $TEL
echo Architectures demandees : $ARCH
echo '</PRE>'

echo '</P>'
echo '<P>'
echo "Vous allez recevoir &agrave; l'adresse $EMAIL un courrier &eacute;lectronique vous donnant toutes les informations "
echo 'n&eacute;cessaires pour r&eacute;cup&eacute;rer votre exemplaire du logiciel.'
echo '</P>'
echo '</BODY>'
echo '</HTML>'


#
# Fabrication et envoi du mail destine a l'equipe Narcisse
#

cat << EOF > ${TMPDIR}/mail_bruyeres_$$
Demande de Narcisse 
=================

Nom : $NOM
Prenom : $PRENOM
Centre : $CENTRE
Unite : $UNITE
E-mail : $EMAIL
Fax : $FAX
Telephone : $TEL
Architectures demandees : $ARCH

EOF

$MAIL -sDemande_de_Narcisse xxx@cea.fr < ${TMPDIR}/mail_bruyeres_$$
rm -f ${TMPDIR}/mail_bruyeres_$$

cat << FIN > ${TMPDIR}/exe_$$
#! /bin/sh
#
# Fabrication du fichier tar au format demande en tenant compte
# des architectures selectionnees
#

mkdir ${TMPDIR}/${NOM}$$
cd ${TMPDIR}/${NOM}$$
zcat $NARCISSEBIN/NarcisseGen.tar.Z | tar xf -
rm -f ${TMPDIR}/log$$

for i in $ARCH
do
	zcat $NARCISSEBIN/Narcisse\${i}.tar.Z | tar xf -
	cat <<EOF | $NARCISSEPROC/$NARCISSECODE >> ${TMPDIR}/log$$
$DATE
$NOM $PRENOM $UNITE $CENTRE
Narcisse/V1.3/exe/\$i/narcisse
EOF

done

rm -f ${TMPDIR}/log$$
nomtar=${EMAIL}.${$}.tar
tar cf \$nomtar Narcisse
rm -rf Narcisse

nomtarcomp=${EMAIL}.${$}${FORMAT}

if [ "$FORMAT" = ".tar.Z" ]
then
	compress \$nomtar
else
	$GNUBIN/gzip \$nomtar
fi

rcp \$nomtarcomp $FTPSERVEUR:$FTPDIR
rm -f \$nomtarcomp

#
# Envoi du mail au demandeur donnant les instructions de recuperation
#

cat << EOF > mail_download
Suite a votre demande, un exemplaire personnalise du logiciel Narcisse a ete
fabrique pour vous.

Vous pouvez la recuperer sur le serveur FTP anonyme $FTPSERVEUR dans le
directory $FTPDIR sous le nom \$nomtarcomp.

ATTENTION : Vous ne pouvez pas penetrer dans ce directory ! 
CECI EST NORMAL. Pour recuperer Narcisse, faites un get direct sous ftp.

Exemple :

      ftp $FTPSERVEUR
      Login : anonymous
      Password : ( votre adresse e-mail )
      binary
      get ${FTPDIR}/\$nomtarcomp
      
Cet exemplaire restera sur ce serveur pendant 24 h. Au dela de ce delai, il
sera detruit.

EOF

$MAIL -s"Re : Demande de Narcisse $DATE" $EMAIL < mail_download
$MAIL -s"Re : Demande de Narcisse $DATE $EMAIL" xxx@cea.fr < mail_download

cd ${TMPDIR}
rm -rf ${NOM}$$
FIN
chmod +x ${TMPDIR}/exe_$$
nohup ${TMPDIR}/exe_$$ >&- <&- 2>&- &
echo "rm ${TMPDIR}/exe_$$ >&- 2>&-" | $AT now + 1 hour >&- 2>&-
