#!/bin/sh

if [ "$PROJECT_HOME" = "" ] ;then
	echo "Il faut faire un source du .project.csh de Narcisse"
	exit 1
fi

if [ "$LM_TARGET" = "" ] ;then
	echo "LM_TARGET doit-etre defini"
	exit 1
fi

# $1 = nom de la librarie psyche

cd $PROJECT_HOME/bin/Test

HOME_LM=`home lm`
LM_LIB=$HOME_LM/produits/lib/${LM_TARGET}
LM_INCLUDE=$HOME_LM/produits/include
LD_LIBRARY_PATH=$LM_LIB:$LD_LIBRARY_PATH;export LD_LIBRARY_PATH
REP_TEMP=/tmp/$USER
LIBDISTRIB=$1

EXE=$REP_TEMP/TestLib$$
OBJ=$REP_TEMP/TestLib$$.o
SRC=TestLib.c
INCLUDE="-I$LM_INCLUDE"

if [ ! -d $REP_TEMP ] ;then
	mkdir -p $REP_TEMP
fi

case $LM_TARGET in
  HP_UX_*__hp9000)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lnx \
      -L/usr/local/sr/lib -luser -lV3 -lm"
    LD=gcc
    CC=gcc ;;

  AIX_*__ibmrs6000)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lnx \
      -L/usr/local/sr/lib -luser -lm"
    LD=cc
    CC=cc ;;

  OSF1_V*__alpha)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lnx \
      -L/usr/local/sr/lib -luser -lm"
    LD=cc
    CC=cc ;;

  unicos*CRAY_Y-T3D)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lnx \
      -L/usr/local/sr/lib -luser -lm"
    LD="MPP_NPES=1;export MPP_NPES;cc"
    CC="MPP_NPES=1;export MPP_NPES;cc" ;;

  unicos*CRAY*)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lnx \
      -L/usr/local/sr/lib -luser -lm"
    LD=cc
    CC=cc ;;

  SunOS_4__sun4)
    LIB="-L$LM_LIB -l${LIBDISTRIB} /usr/openwin/lib/libXt.a \
	-lX11 -lnx -L`home -ap`/Psyche/user/lib -luser -lm -lc"
    LD=acc
    CC=acc ;;

  SunOS_5*__sun4)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lXt -lX11 -lnx \
      -L/usr/local/sr/lib -luser -lsocket -lnsl -lsunmath -lm"
#     -L/usr/local/sr/lib -luser -lsunmath -lm -lc \
#     -lsocket -lrpcsvc -lnsl -lintl -lw -lgen -L/usr/ucblib -lucb"
    LD=cc
    CC=cc ;;

  IRIX_4__sgi4d)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lnx \
      -L/usr/local/sr/lib -luser -lisam -lm -lmalloc"
    LD=cc
    CC=cc ;;

  IRIX_5__sgi4d)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lXt -lX11 -lnx \
      -L/usr/local/sr/lib -luser -lisam -lm -lmalloc"
    LD=cc
    CC=cc ;;

  IRIX_6__sgi4d)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lXt -lX11 -lnx \
      -L/usr/local/sr/lib -luser -lm -lmalloc"
    LD=cc
    CC=cc ;;

  IRIX_6__sgi4d-64)
    LIB="-L$LM_LIB -l${LIBDISTRIB} -lXt -lX11 -lnx \
      -lm -lmalloc"
    LD="cc -64"
    CC="cc -64" ;;

  *)
    echo "Test non implemente sur cette machine"
    exit 0
esac

$CC -c -o $OBJ $INCLUDE $SRC 
$LD -o $EXE $OBJ $LIB
rm -f $OBJ $REP_TEMP/toto$$.sp3 $REP_TEMP/test$$

$EXE $REP_TEMP/toto$$.sp3
diff $REP_TEMP/toto$$.sp3 TestLib.sp3 > $REP_TEMP/test$$

rm -f $EXE $REP_TEMP/toto$$.sp3

if [ -s $REP_TEMP/test$$ ] ;then
	echo "Librairie mal generee : attention" >& 2
	rm $REP_TEMP/test$$
	exit 1
fi

rm -f $REP_TEMP/test$$
