#
# Macros par defaut pour le systeme+architecture SunOS_5__sun4-64
# Pour solaris 7 en mode 64 bits (sur Ultra seulement)
#

#.SCCS_GET:
#MAKE        = make -k
MAKE        = gmake -k
TOUCH       = /usr/5bin/touch
ATLAS_EXTRACT_INCLUDE = \
	$(PROJECT_HOME)/cfg/.Atlas/Makefiles/Reference_Public_Includes_GNU.mk

MAKEMODEXESUP = cd $(LST);TEMPDIRSUN=$(TEMPLATE_DIR)/SunWS_cache;\
                if [ -f $$TEMPDIRSUN/CC_state ] ;then \
                  for fic in `ls $$TEMPDIRSUN/*/*.o 2> /dev/null` ;do \
                    bfic=`basename $$fic`;\
                    if [ -f $$bfic ] ;then \
                      $(RM) $$bfic;\
                    fi \
                  done;\
		  $(TOUCH) -c $$TEMPDIRSUN/*/*.o 2> /dev/null;\
                fi

ARR         = $(AR) r $(LIBAR) *.o;$(AR) x $(LIBAR);\
                for fic in `ls *.o 2> /dev/null` ; do\
                  if [ "`cat $$fic|wc -c`" -eq "0" ] ;then\
                    $(RM) $$fic;fi;done;\
                $(RM) $(LIBAR);CC $(MARFLAGS_SunOS_5__sun4) -xar -o

MKDEP_ACTION = cd $(LST);$(TOUCH) $%;$(AR) r $(LIBAR) $%

TEMPLATE_ACT = \
          if [ -d $(LST) ] ;then \
            if [ ! -d $(LST)/$(OPT) ] ;then \
              mkdir $(LST)/$(OPT); \
            fi; \
          else \
            echo "erreur : espace remote non installe ou make "\
                 "newlib non fait";\
          fi

CC          = cc -xtarget=ultra -xarch=v9 -xstrconst -DSUNOS -DSUNOS_5 \
		$(CFLAGS) $(MCFLAGS_SunOS_5__sun4)
CC++        = CC -xtarget=ultra -xarch=v9 -DSUNOS -DSUNOS_5 $(C++FLAGS) \
		$(MC++FLAGS_SunOS_5__sun4)
CPP         = /usr/ccs/lib/cpp -P -DSUNOS -DSUNOS_5 -DNDEBUG \
		$(CPPFLAGS) $(MCPPFLAGS_SunOS_5__sun4)
FC          = f77 -xtarget=ultra -xarch=v9 -xstrconst $(FFLAGS) $(MFFLAGS_SUN4)
LD          = $(PURIFY) CC -v -xtarget=ultra -xarch=v9 $(LDFLAGS) \
		$(MLDFLAGS_SunOS_5__sun4)
LDY         = ld -G
LDYSUFF     = .so

OPGS_HOME   = /usr/local/g5g/OPGS

LIBMOTIF    = -lMrm -lXm
LIBXTK      = -lXt -lX11 -lXaw -lXmu
#LIBGRA      = -L$(OPGS_HOME)/lib -lgphigsc

INCMOTIF    = /usr/dt/include
INCXTK      = /usr/dt/include
INCX11      = /usr/openwin/include
INCGRA      = $(OPGS_HOME)/include
INCXGL      = /opt/SUNWits/Graphics-sw/xgl-3.0/include

INCSAN      = $(PROJECT_HOME)/src/sanglier/.include
INCSANESP   = $(MODIF_HOME)/src/sanglier

ADDLIBMAC    = -lsocket -lrpcsvc -lnsl -lintl -lw -lgen -ldl -lsunmath

ADDLIBMACFTN = -lF77 -lM77

LIBMOD      = $(LIBMOD_SunOS_5__sun4)
LIBPROJ     = $(LIBRAIRIES)/libnx.a $(LIBRAIRIES)/libsanglier.a
