#ifndef lint
    static const char sccsid[] = "@(#)lance.c	1.1 12/02/10 Pierre Brochard";
#endif

#include <stdio.h>
#include <math.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include "narcisse.h"

/* Utilisation : setenv RHOST machine_ou_lancer_Narcisse;lance */

static int
NarcisseOuvre(char port[])
{
	int num_nouveau = 0;
	const char* const machine = getenv("RHOST");

	if(!machine)
	{
	    printf("Donnez le nom de la machine avec la variable RHOST\n");
	    port[0] = '\0';

	    return -1;
	}

	strcpy(port,machine);
	strcat(port,"+NARCISSE.0");

	if((num_nouveau = SpxWhich(port)) > 0)
	{
	    sprintf(port,"%s+NARCISSE.%d@ie32",machine,num_nouveau);
	    printf("Narcisse trouve numero : %d, port %s\n",num_nouveau,port);
	}
	else
	{
	  char str[1024];
	  char* const narloc = getenv("NARLOC");
	  char* const racine = narloc ? narloc : getenv("PROJECT_HOME");

	  if(narloc)
	    {
	      strcpy(str,racine);
	      strcat(str,"/../bin/Narcisse > /dev/null 2> /dev/null");
	    }
	  else if(racine)
	    {
	      strcpy(str,". ");
	      strcat(str,racine);
	      strcat(str,"/.project.sh;");
	      strcat(str,racine);
	      strcat(str,"/bin/Utils/NarcisseTest > /dev/null 2> /dev/null");
	    }
	  else
	    strcpy(str,"/usr/local/produits/Narcisse/bin/Narcisse 2> /dev/null");

	  printf("str = %s\n",str);
	  num_nouveau = SpxLance(str,"",machine,"NARCISSE",port);
	  strcat(port,"@ie32");
	  printf("Narcisse lance numero : %d, port %s\n",num_nouveau,port);
  	}

	return num_nouveau;
}

/*                      ====>    M A I N     <====              */

int
main() 
{
    /* exemple de lancement de Narcisse s'il est non existant et utilisation
     de celui existant sinon */

#define nx_max 100
#define ny_max 100
        float x[nx_max];
        float y[ny_max];
        float z[ny_max][nx_max];
        const int nx = 100;
	const int ny = 100;
	const int dimz = nx_max;
        
        int i = 0,j = 0;
        const float pasx = 3.0/(nx-1);
        const float pasy = 3.0/(ny-1);

	SPXFILE* spx_file;
	int num;
	char port[256];

	num = NarcisseOuvre(port);

	if(num < 0) return -1;

    /* Ouverture connection */

	spx_file = SpxOpen(port);

    /* Exemple envoi de donnees */

        for(i=0;i<nx;i++)
        {
            x[i] = -1.5 + i*pasx;
        }
        for(j=0;j<ny;j++)
        {
            y[j] = -1.5 + j*pasy;
        }

        for(i=0;i<nx;i++)
        {

            for(j=0;j<ny;j++)
            {
	      const double xy2 = x[i]*x[i]+y[j]*y[j];
	      const double sxy2 = sin(xy2);

	      z[j][i] = sxy2;
            }

        }

        SpxRect3d(nx, ny, x, y, (float*) z, dimz, spx_file);

    /* Fermeture connection */

	SpxClose(spx_file);

	return 0;
}
