      program testte

c     ----------------------------------------------------------
      character*80 sccsid
      data sccsid/" @(#)pyrnonstrucm.f	1.1 12/02/10 P. Brochard"/
c     ----------------------------------------------------------

c     
c*****************************************************************
c     
c     Il genere une pyramide echantillonnee entre 2 valeurs
c     choisies ( interpolation lineaire ou logarithmique)
c     et envoit des chaines ' ' dans la config => il y avait un bug
c     de belier
c******************************************************************
c     
c     
c     ATTENTION : nx et ny doivent etre des nombres impairs !
c     
      parameter(nx=21,ny=21,idimx=21,idimy=21)
      parameter(nxs2=(nx/2)+1,nys2=(ny/2)+1)
      parameter(xmin=1.,xmax=2.,ymin=1.,ymax=2.,zmin=1.,zmax=1.e4)
      parameter(ilogz=1)
      dimension x(idimx,idimy),y(idimx,idimy)
      dimension z(idimx,idimy),t((idimx-1)*(idimy-1))
      dimension zt(nx)
      integer mailles(5*(idimx-1)*(idimy-1))
      integer nmailles,dimmailles
      integer spxfile,spxopen
c     
c     generation du maillage en x
c     
      dx=(xmax-xmin)/(nx-1)
      dxs2=0.5*dx
      dx3s2=1.5*dx

      do j=1,ny
         x(1,j)=xmin+mod(j,2)*0.5*dxs2
         do i=2,nx
            x(i,j)=x(i-1,j)+mod(i+1,2)*dxs2+mod(i,2)*dx3s2
         enddo
      enddo
c     
c     generation du maillage en y
c     
      dy=(ymax-ymin)/(ny-1)
      dys2=0.5*dy
      dy3s2=1.5*dy

      do i=1,nx
         y(i,1)=ymin+mod(i,2)*0.5*dys2
         do j=2,ny
            y(i,j)=y(i,j-1)+mod(j+1,2)*dys2+mod(j,2)*dy3s2
         enddo
      enddo
c     
c     Calcul des valeurs de z a generer
c     
      nmin=min(nx/2,ny/2)
      nz=nmin+1

      if ( ilogz.eq.0 ) then
         dz=(zmax-zmin)/(nz-1)
      else
         dz=(log10(zmax)-log10(zmin))/(nz-1)
      endif

      do k=1,nz
         if ( ilogz.eq.0 ) then
            zt(nz+1-k)=zmin+(k-1)*dz
         else
            zt(nz+1-k)=10**(log10(zmin)+(k-1)*dz)
         endif
      enddo
c     
c     Remplissage du tableau z par courbe de niveaux
c     
      id0=1+nmin
      if0=nx-nmin
      jd0=1+nmin
      jf0=ny-nmin
      
      do k=1,nz
         id=id0-(k-1)
         if=if0+(k-1)
         jd=jd0-(k-1)
         jf=jf0+(k-1)
         i=id

         do j=jd,jf
            z(i,j)=zt(k)
         enddo

         i=if

         do j=jd,jf
            z(i,j)=zt(k)
         enddo

         j=jd

         do i=id,if
            z(i,j)=zt(k)
         enddo

         j=jf

         do i=id,if
            z(i,j)=zt(k)
         enddo

      enddo

c     tableau de mailles pour test non structure

      nmailles = (nx-1) * (ny-1)
      dimmailles = 5 * nmailles

      do i=1,nmailles
         mailles(i) = 4*i
         t(i) = i
      enddo

      do i=nmailles+1,dimmailles
         l = (i - nmailles - 1) / 4
         j = mod(l,nx-1)
         k = l/(nx-1)

         if(mod(i-nmailles,4).eq.1) mailles(i) = j + k * nx
         if(mod(i-nmailles,4).eq.2) mailles(i) = j + (k + 1) * nx
         if(mod(i-nmailles,4).eq.3) mailles(i) = j+1 + (k + 1) * nx
         if(mod(i-nmailles,4).eq.0) mailles(i) = j+1 + k * nx

      enddo

      spxfile = spxopen(' ')
      call spx4nscm(nx*ny,x,y,z,t,nmailles,dimmailles,mailles,spxfile)
      call spxclose(spxfile)

      end
