      program test

      call tst2mo1
      call tst2mo2
      call tst2mu
      call tst3pr
      
      stop
      end

c      
c      2D monocourbe
c
      subroutine tst2mo1
      implicit none
      integer nx, i
      parameter( nx= 51 )

        real xtab(nx), ytab(nx)
        character*1 nomsp3
        character*8 tit1, tit2
        character*1 ctith, ctitg, ctitb, ctitd
        character*1 tex1, tex2, tex3, tex4

      data nomsp3/' '/
      data tit1/'essai'/
      data tit2/' '/
      data ctith/' '/
      data ctitg/' '/
      data ctitb/' '/
      data ctitd/' '/
      data tex1/' '/
      data tex2/' '/
      data tex3/' '/
      data tex4/' '/
      do 1, i=1,51
            xtab(i) = (i-1)*3.141592654/50.0
            ytab(i) = sin(xtab(i))
    1 continue
      call spx2mo(xtab,ytab,nx,
     >            tit1, tit2,
     >            ctith, ctitg, ctitb, ctitd,
     >            tex1, tex2, tex3, tex4,
     >            nomsp3)

      return
      end

c      
c      2D monocourbe
c
      subroutine tst2mo2
      implicit none
      integer nx
      parameter( nx= 4 )

        real xtab(nx), ytab(nx)
        character*1 nomsp3
        character*7 tit1, tit2
        character*12 ctith, ctitg, ctitb, ctitd
        character*7 tex1, tex2, tex3, tex4

      data xtab/18.,1.,10.,0.1/
      data ytab/1.,2.,3.,4./
      data nomsp3/' '/
      data tit1/'titre x'/
      data tit2/'titre y'/
      data ctith/'titre haut  '/
      data ctitg/'titre gauche'/
      data ctitb/'titre bas   '/
      data ctitd/'titre droite'/
      data tex1/'texte 1'/
      data tex2/'texte 2'/
      data tex3/'texte 3'/
      data tex4/'texte 4'/
      
      call spx2mo(xtab,ytab,nx,
     >            tit1, tit2,
     >            ctith, ctitg, ctitb, ctitd,
     >            tex1, tex2, tex3, tex4,
     >            nomsp3)

      return
      end

c      
c      2D multicourbe
c
      subroutine tst2mu
      implicit none
      integer n1,n2,ny
      parameter( n1=5, n2=5, ny=3 )
      integer nxsto(ny)

        real xtab(n1,ny), ytab(n2,ny)
        character*1 nomsp3
        character*7 tit1, tit2
        character*12 ctith, ctitg, ctitb, ctitd
        character*7 tex1, tex2, tex3, tex4

      data nxsto/5,5,5/
      data xtab/      1.,2.,3.,4.,5.,
     >                  1.,2.,3.,4.,5.,
     >                  1.,2.,3.,4.,5./
      data ytab/      1. ,2. ,3. ,4. ,5. ,
     >                  1.5,2.5,3.5,4.5,5.5,
     >                  1.8,2.8,3.8,4.8,5.8/
      data nomsp3/' '/
      data tit1/'titre x'/
      data tit2/'titre y'/
      data ctith/'titre haut  '/
      data ctitg/'titre gauche'/
      data ctitb/'titre bas   '/
      data ctitd/'titre droite'/
      data tex1/'texte 1'/
      data tex2/'texte 2'/
      data tex3/'texte 3'/
      data tex4/'texte 4'/
      
      call spx2mu(xtab,n1,ytab,n2,nxsto,ny,
     >            tit1, tit2,
     >            ctith, ctitg, ctitb, ctitd,
     >            tex1, tex2, tex3, tex4,
     >            nomsp3)

      return
      end

c
c      tableau (i,j)
c
      subroutine tst3pr
      implicit none
      integer nx,ny,nz
      parameter(nx=25, ny=25, nz=25)
      integer i,j
      
      real z(nx,ny)
        character*1 nomsp3
        
        real x,y,r
        
      data nomsp3/' '/
      
      do i=1,nx
       do j=1,ny
             x = 0.1*float(i)
             y = 0.1*float(j)
             r = x*x+y*y
             z(i,j)=sin(r)/r
       end do
      end do
      call spx3pr(nx,ny,z,nz,nomsp3)

      return
      end
