      program testte

!c ----------------------------------------------------------
      character*80 sccsid
      data sccsid/"@(#)fipyram.f	1.1 12/02/10 P. Brochard"/
!c ----------------------------------------------------------

!c
!c*****************************************************************
!c
!c Il genere une pyramide echantillonnee entre 2 valeurs
!c choisies ( interpolation lineaire ou logarithmique)
!c
!c******************************************************************
!c
!c
!c  ATTENTION : nx et ny doivent etre des nombres impairs !
!c
      integer*4 nx,ny,idimx
      integer*4 spxfile,spxopen
      parameter(nx=21,ny=41,idimx=201,idimy=201)
      parameter(xmin=1.,xmax=2.,ymin=1.,ymax=2.,zmin=1.,zmax=1.e4)
      parameter(ilogz=1)
      dimension x(idimx,idimy),y(idimx,idimy)
      dimension z(idimx,idimy),t(idimx,idimy)
      dimension zt(nx)
!c
!c     generation du maillage en x
!c
      dx=(xmax-xmin)/(nx-1)
      dxs2=0.5*dx
      dx3s2=1.5*dx
      do 1 j=1,ny
      x(1,j)=xmin+mod(j,2)*0.5*dxs2
      do 1 i=2,nx
      x(i,j)=x(i-1,j)+mod(i+1,2)*dxs2+mod(i,2)*dx3s2
    1 continue
!c
!c     generation du maillage en y
!c
      dy=(ymax-ymin)/(ny-1)
      dys2=0.5*dy
      dy3s2=1.5*dy
      do 2 i=1,nx
      y(i,1)=ymin+mod(i,2)*0.5*dys2
      do 2 j=2,ny
      y(i,j)=y(i,j-1)+mod(j+1,2)*dys2+mod(j,2)*dy3s2
    2 continue
!c
!c  Calcul des valeurs de z a generer
!c
      nmin=min(nx/2,ny/2)
      nz=nmin+1
      if ( ilogz.eq.0 ) then
      dz=(zmax-zmin)/(nz-1)
      else
      dz=(log10(zmax)-log10(zmin))/(nz-1)
      endif
      do 3 k=1,nz
      if ( ilogz.eq.0 ) then
      zt(nz+1-k)=zmin+(k-1)*dz
      else
      zt(nz+1-k)=10**(log10(zmin)+(k-1)*dz)
      endif
    3 continue
!c
!c  Remplissage du tableau z par courbe de niveaux
!c
      id0=1+nmin
      if0=nx-nmin
      jd0=1+nmin
      jf0=ny-nmin
      
      do 4 k=1,nz
      
      id=id0-(k-1)
      if=if0+(k-1)
      jd=jd0-(k-1)
      jf=jf0+(k-1)
      
      i=id
       do 41 j=jd,jf
       z(i,j)=zt(k)
       t(i,j)=1./z(i,j)
   41  continue
      i=if
       do 42 j=jd,jf
       z(i,j)=zt(k)
       t(i,j)=1./z(i,j)
   42  continue
      j=jd
       do 43 i=id,if
       z(i,j)=zt(k)
       t(i,j)=1./z(i,j)
   43  continue
      j=jf
       do 44 i=id,if
       z(i,j)=zt(k)
       t(i,j)=1./z(i,j)
   44  continue
  
    4 continue

!c envoi pyramide

      spxfile = spxopen('toto')
      call spx4tecd(nx,ny,x,idimx,y,idimx,z,idimx,t,idimx,spxfile)
      call spxclose(spxfile)

      end
