#! /usr/bin/python3

import sys
import math
from _pi_narcisse import ffi, lib
from time import monotonic

if len(sys.argv) > 1:
    niter = int(sys.argv[1])
else:
    niter = 10

x = ffi.new("REEL_S[320]")
y = ffi.new("REEL_S[222]")
tab = ffi.new("REEL_S[71040]")
  
def mandelbrot(N_iteration):
  
    for i in range(320):
        x[i] = i
        
    for j in range(222):
        y[j] = j

    for i in range(320):
        for j in range(222):
            z = complex(0,0)
            # Rescale to fit the drawing screen 320x222
            c = complex(3.5*i/319-2.5, -2.5*j/221+1.25)
            k = 0
            while (k < N_iteration) and abs(z) < 2:
                k = k + 1
                z = z*z + c
            tab[i + j * 320] = 255 * k /N_iteration

t = monotonic()
mandelbrot(niter)
spx = lib.SpxOpen(b" ")
#lib.SpxRect3d(320,222,x,y,tab,320,spx)
lib.SpxPrintSurf(320,222,tab,320,spx)
lib.SpxClose(spx)

print(monotonic() - t, " secondes")
