function [X,EGX,Y,EGY,P,EG]=ener(x0,xmin,xmax,lambda)

// ===========================================================
// On trace intg0 pour xmax donne (grille 21 x 21)
// ===========================================================

// dP/dW

coef=lambda;

deff('[f]=p0(x,xmin,xmax)','lbda=coef*xmin+(1-coef)*xmax;f=1-exp((xmax-lbda)^2*(x-xmin)/(x-xmax))-exp((xmin-lbda)^2*(x-xmax)/(x-xmin))');

// Efficacite

deff('[f]=e0(x,x0,xmin,xmax)','f=(1.-exp(-x/x0))*p0(x,xmin,xmax)');

// scalaire (avec intg : integration integrale definie)

deff('[f]=q0(x)','f=p0(x,xmin,xmax)');
deff('[f]=g0(x)','f=e0(x,x0,xmin,xmax)');
deff('[f,err]=intq0(xmin,xmax)','[f,err]=intg(xmin,xmax,q0,0,1.e-10)');
deff('[f,err]=intg0(x0,xmin,xmax)','[f,err]=intg(xmin,xmax,g0,0,1.e-10)');

// boucle integrale definie

npas=20;
//eps=.0001;
eps=.00001;
pas=(xmax-2*eps)/npas;
i=1;X=0;EGX=0;Y=0;EGY=0;P=0;EG=0;

// coupe xmin fixe

if (x0 == 0) & ~(xmin == 0) then
  for ind0=eps:pas:xmax,
    X(1,i)=ind0;,
    EGX(1,i)=intg0(ind0,xmin,xmax)/intq0(xmin,xmax);,
    if ind0>xmin then
      P(1,i)=p0(ind0,xmin,xmax)/intq0(xmin,xmax);,
    else
      P(1,i)=0.;,
    end;,
    i=i+1;,
  end;,
end

// coupe x0 fixe

i=1;
if (xmin == 0) & ~(x0 == 0) then
  for ind1=eps*1.5:pas:xmax,
   Y(1,i)=ind1;,
   i0=intq0(ind1,xmax);,
   EGY(1,i)=intg0(x0,ind1,xmax)/i0;,
   i=i+1;,
  end;,
end

// 3d

i=1;
if (x0 == 0) & (xmin == 0) then
  for ind0=eps:pas:xmax,
    X(1,i)=ind0;,
    j=1;,
    for ind1=eps*1.5:pas:xmax,
      Y(1,j)=ind1;,
      EG(i,j)=intg0(ind0,ind1,xmax)/intq0(ind1,xmax);,
      j=j+1;,
    end,
    i=i+1;,
  end;,
end

