#include "stack-c.h"
/******************************************
 * SCILAB function : spxopen, fin = 1
 ******************************************/

int intsspxopen(char *fname)
{
 int m1,n1,l1,un=1,l2;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable filename */
 GetRhsVar(1,"c",&m1,&n1,&l1);
 /* cross variable size checking */
 CreateVar(2,"i",&un,&un,&l2);/* named: spxfile */
 C2F(spxopenr)(cstk(l1),istk(l2),m1);
 LhsVar(1)= 2;
 return 0;
}
/******************************************
 * SCILAB function : spxclose, fin = 2
 ******************************************/

int intsspxclose(char *fname)
{
 int m1,n1,l1;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /* cross variable size checking */
 C2F(spxclose)(istk(l1));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxsync, fin = 3
 ******************************************/

int intsspxsync(char *fname)
{
 int m1,n1,l1;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /* cross variable size checking */
 C2F(spxsync)(istk(l1));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx2mo, fin = 4
 ******************************************/

int intsspx2mo(char *fname)
{
 int m1,n1,l1,mn1,m2,n2,l2,mn2,m3,n3,l3;
 CheckRhs(3,3);
 CheckLhs(1,1);
 /*  checking variable x */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 CheckRow(1,m1,n1);
 mn1=m1*n1;
 /*  checking variable y */
 GetRhsVar(2,"r",&m2,&n2,&l2);
 CheckRow(2,m2,n2);
 mn2=m2*n2;
 /*  checking variable spxfile */
 GetRhsVar(3,"i",&m3,&n3,&l3);
 CheckScalar(3,m3,n3);
 /* cross variable size checking */
 CheckDimProp(1,2,n1 != n2);
 C2F(spx2moc)(sstk(l1),sstk(l2),&n1,istk(l3));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx2mu, fin = 5
 ******************************************/

int intsspx2mu(char *fname)
{
 int m1,n1,l1,mn1,m2,n2,l2,mn2,m3,n3,l3,mn3,m4,n4,l4;
 CheckRhs(4,4);
 CheckLhs(1,1);
 /*  checking variable x */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 CheckRow(1,m1,n1);
 mn1=m1*n1;
 /*  checking variable y */
 GetRhsVar(2,"r",&m2,&n2,&l2);
 CheckRow(2,m2,n2);
 mn2=m2*n2;
 /*  checking variable nxsto */
 GetRhsVar(3,"i",&m3,&n3,&l3);
 CheckRow(3,m3,n3);
 mn3=m3*n3;
 /*  checking variable spxfile */
 GetRhsVar(4,"i",&m4,&n4,&l4);
 CheckScalar(4,m4,n4);
 /* cross variable size checking */
 CheckDimProp(1,2,n1 != n2);
 C2F(spx2muc)(sstk(l1),sstk(l2),istk(l3),&n3,istk(l4));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx3pr, fin = 6
 ******************************************/

int intsspx3pr(char *fname)
{
 int m1,n1,l1,m2,n2,l2;
 CheckRhs(2,2);
 CheckLhs(1,1);
 /*  checking variable z */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 /*  checking variable spxfile */
 GetRhsVar(2,"i",&m2,&n2,&l2);
 CheckScalar(2,m2,n2);
 /* cross variable size checking */
 C2F(spx3prc)(&m1,&n1,sstk(l1),&m1,istk(l2));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx3re, fin = 7
 ******************************************/

int intsspx3re(char *fname)
{
 int m1,n1,l1,mn1,m2,n2,l2,mn2,m3,n3,l3,m4,n4,l4;
 CheckRhs(4,4);
 CheckLhs(1,1);
 /*  checking variable x */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 CheckRow(1,m1,n1);
 mn1=m1*n1;
 /*  checking variable y */
 GetRhsVar(2,"r",&m2,&n2,&l2);
 CheckRow(2,m2,n2);
 mn2=m2*n2;
 /*  checking variable z */
 GetRhsVar(3,"r",&m3,&n3,&l3);
 /*  checking variable spxfile */
 GetRhsVar(4,"i",&m4,&n4,&l4);
 CheckScalar(4,m4,n4);
 /* cross variable size checking */
 CheckDimProp(1,3,n1 != m3);
 CheckDimProp(2,3,n2 != n3);
 C2F(spx3rec)(&n1,&n2,sstk(l1),sstk(l2),sstk(l3),&n1,istk(l4));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx3te, fin = 8
 ******************************************/

int intsspx3te(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3,m4,n4,l4;
 CheckRhs(4,4);
 CheckLhs(1,1);
 /*  checking variable x */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 /*  checking variable y */
 GetRhsVar(2,"r",&m2,&n2,&l2);
 /*  checking variable z */
 GetRhsVar(3,"r",&m3,&n3,&l3);
 /*  checking variable spxfile */
 GetRhsVar(4,"i",&m4,&n4,&l4);
 CheckScalar(4,m4,n4);
 /* cross variable size checking */
 CheckDimProp(1,2,m1 != m2);
 CheckDimProp(2,3,m2 != m3);
 CheckDimProp(1,2,n1 != n2);
 CheckDimProp(2,3,n2 != n3);
 C2F(spx3tec)(&m1,&n1,sstk(l1),&m1,sstk(l2),&m1,sstk(l3),&m1,istk(l4));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx4re, fin = 9
 ******************************************/

int intsspx4re(char *fname)
{
 int m1,n1,l1,mn1,m2,n2,l2,mn2,m3,n3,l3,m4,n4,l4,m5,n5,l5;
 CheckRhs(5,5);
 CheckLhs(1,1);
 /*  checking variable x */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 CheckRow(1,m1,n1);
 mn1=m1*n1;
 /*  checking variable y */
 GetRhsVar(2,"r",&m2,&n2,&l2);
 CheckRow(2,m2,n2);
 mn2=m2*n2;
 /*  checking variable z */
 GetRhsVar(3,"r",&m3,&n3,&l3);
 /*  checking variable c */
 GetRhsVar(4,"r",&m4,&n4,&l4);
 /*  checking variable spxfile */
 GetRhsVar(5,"i",&m5,&n5,&l5);
 CheckScalar(5,m5,n5);
 /* cross variable size checking */
 CheckDimProp(1,3,n1 != m3);
 CheckDimProp(3,4,m3 != m4);
 CheckDimProp(2,3,n2 != n3);
 CheckDimProp(3,4,n3 != n4);
 C2F(spx4rec)(&n1,&n2,sstk(l1),sstk(l2),sstk(l3),&n1,sstk(l4),&n1,istk(l5));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx4te, fin = 10
 ******************************************/

int intsspx4te(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3,m4,n4,l4,m5,n5,l5;
 CheckRhs(5,5);
 CheckLhs(1,1);
 /*  checking variable x */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 /*  checking variable y */
 GetRhsVar(2,"r",&m2,&n2,&l2);
 /*  checking variable z */
 GetRhsVar(3,"r",&m3,&n3,&l3);
 /*  checking variable c */
 GetRhsVar(4,"r",&m4,&n4,&l4);
 /*  checking variable spxfile */
 GetRhsVar(5,"i",&m5,&n5,&l5);
 CheckScalar(5,m5,n5);
 /* cross variable size checking */
 CheckDimProp(1,2,m1 != m2);
 CheckDimProp(2,3,m2 != m3);
 CheckDimProp(3,4,m3 != m4);
 CheckDimProp(1,2,n1 != n2);
 CheckDimProp(2,3,n2 != n3);
 CheckDimProp(3,4,n3 != n4);
 C2F(spx4tec)(&m1,&n1,sstk(l1),&m1,sstk(l2),&m1,sstk(l3),&m1,sstk(l4),&m1,istk(l5));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spx4ns, fin = 11
 ******************************************/

int intsspx4ns(char *fname)
{
 int m1,n1,l1,mn1,m2,n2,l2,mn2,m3,n3,l3,mn3,m4,n4,l4,mn4,m5,n5,l5,m6,n6,l6,mn6,m7,n7,l7;
 CheckRhs(7,7);
 CheckLhs(1,1);
 /*  checking variable x */
 GetRhsVar(1,"r",&m1,&n1,&l1);
 CheckRow(1,m1,n1);
 mn1=m1*n1;
 /*  checking variable y */
 GetRhsVar(2,"r",&m2,&n2,&l2);
 CheckRow(2,m2,n2);
 mn2=m2*n2;
 /*  checking variable z */
 GetRhsVar(3,"r",&m3,&n3,&l3);
 CheckRow(3,m3,n3);
 mn3=m3*n3;
 /*  checking variable c */
 GetRhsVar(4,"r",&m4,&n4,&l4);
 CheckRow(4,m4,n4);
 mn4=m4*n4;
 /*  checking variable nmailles */
 GetRhsVar(5,"i",&m5,&n5,&l5);
 CheckScalar(5,m5,n5);
 /*  checking variable mailles */
 GetRhsVar(6,"r",&m6,&n6,&l6);
 CheckRow(6,m6,n6);
 mn6=m6*n6;
 /*  checking variable spxfile */
 GetRhsVar(7,"i",&m7,&n7,&l7);
 CheckScalar(7,m7,n7);
 /* cross variable size checking */
 CheckDimProp(1,2,n1 != n2);
 CheckDimProp(2,3,n2 != n3);
 CheckDimProp(3,4,n3 != n4);
 C2F(spx4nsc)(&n1,sstk(l1),sstk(l2),sstk(l3),sstk(l4),istk(l5),&n6,sstk(l6),istk(l7));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvsv, fin = 12
 ******************************************/

int intsspxvsv(char *fname)
{
 int m1,n1,l1;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /* cross variable size checking */
 C2F(spxvsv)(istk(l1));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvpa, fin = 13
 ******************************************/

int intsspxvpa(char *fname)
{
 int m1,n1,l1;
 CheckRhs(1,1);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /* cross variable size checking */
 C2F(spxvpa)(istk(l1));
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvsai, fin = 14
 ******************************************/

int intsspxvsai(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3;
 CheckRhs(3,3);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /*  checking variable motcle */
 GetRhsVar(2,"c",&m2,&n2,&l2);
 /*  checking variable valeur */
 GetRhsVar(3,"i",&m3,&n3,&l3);
 CheckScalar(3,m3,n3);
 /* cross variable size checking */
 C2F(spxvsai)(istk(l1),cstk(l2),istk(l3),m2);
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvsar, fin = 15
 ******************************************/

int intsspxvsar(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3;
 CheckRhs(3,3);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /*  checking variable motcle */
 GetRhsVar(2,"c",&m2,&n2,&l2);
 /*  checking variable valeur */
 GetRhsVar(3,"r",&m3,&n3,&l3);
 CheckScalar(3,m3,n3);
 /* cross variable size checking */
 C2F(spxvsar)(istk(l1),cstk(l2),sstk(l3),m2);
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvsac, fin = 16
 ******************************************/

int intsspxvsac(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3;
 CheckRhs(3,3);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /*  checking variable motcle */
 GetRhsVar(2,"c",&m2,&n2,&l2);
 /*  checking variable valeur */
 GetRhsVar(3,"c",&m3,&n3,&l3);
 /* cross variable size checking */
 C2F(spxvsac)(istk(l1),cstk(l2),cstk(l3),m2,m3);
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvsati, fin = 17
 ******************************************/

int intsspxvsati(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3,m4,n4,l4;
 CheckRhs(4,4);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /*  checking variable motcle */
 GetRhsVar(2,"c",&m2,&n2,&l2);
 /*  checking variable valeur */
 GetRhsVar(3,"i",&m3,&n3,&l3);
 CheckScalar(3,m3,n3);
 /*  checking variable indice */
 GetRhsVar(4,"i",&m4,&n4,&l4);
 CheckScalar(4,m4,n4);
 /* cross variable size checking */
 C2F(spxvsati)(istk(l1),cstk(l2),istk(l3),istk(l4),m2);
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvsatr, fin = 18
 ******************************************/

int intsspxvsatr(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3,m4,n4,l4;
 CheckRhs(4,4);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /*  checking variable motcle */
 GetRhsVar(2,"c",&m2,&n2,&l2);
 /*  checking variable valeur */
 GetRhsVar(3,"r",&m3,&n3,&l3);
 CheckScalar(3,m3,n3);
 /*  checking variable indice */
 GetRhsVar(4,"i",&m4,&n4,&l4);
 CheckScalar(4,m4,n4);
 /* cross variable size checking */
 C2F(spxvsatr)(istk(l1),cstk(l2),sstk(l3),istk(l4),m2);
 LhsVar(1)=0;
 ;return 0;
}
/******************************************
 * SCILAB function : spxvsatc, fin = 19
 ******************************************/

int intsspxvsatc(char *fname)
{
 int m1,n1,l1,m2,n2,l2,m3,n3,l3,m4,n4,l4;
 CheckRhs(4,4);
 CheckLhs(1,1);
 /*  checking variable spxfile */
 GetRhsVar(1,"i",&m1,&n1,&l1);
 CheckScalar(1,m1,n1);
 /*  checking variable motcle */
 GetRhsVar(2,"c",&m2,&n2,&l2);
 /*  checking variable valeur */
 GetRhsVar(3,"c",&m3,&n3,&l3);
 /*  checking variable indice */
 GetRhsVar(4,"i",&m4,&n4,&l4);
 CheckScalar(4,m4,n4);
 /* cross variable size checking */
 C2F(spxvsatc)(istk(l1),cstk(l2),cstk(l3),istk(l4),m2,m3);
 LhsVar(1)=0;
 ;return 0;
}
