/* @(#)L3ListeDesCodes.h	1.2 10/12/10 G. Colin de Verdiere*/

#ifndef L3LISTEDESCODES_H
#define L3LISTEDESCODES_H

/*-------------------------------------------*/
/* Definition des limites des coordonnees L3 */
/*-------------------------------------------*/

extern const int XPAGEMIN;
extern const int YPAGEMIN;
extern const int XPAGEMAX;
extern const int YPAGEMAX;

/*-------------------------------------------------------*/
/* Definition de la largeur en coordonnees d'une page L3 */
/*-------------------------------------------------------*/

extern const double LARGEURPAGEL3;

/*----
				#        #####
				#       #     #
				#             #
				#        #####
				#             #
				#       #     #
				#######  #####



	On appelle item L3 un paquet elementaire du langage L3
	Un paquet L3 est compose de cellules de 16bits signes donc
	adressant un espace -32K, +32K. Chaque paquet a la structure 
	suivante:
		LONGUEUR    CODEL3    [[ARGUMENT1] ... ... ARGUMENTn]
		
	Longueur designe le nombre total de cellules du paquet.
	Codel3 designe la primitive concernee
	ARGUMENT designe les parametres eventuels de la primitive
	
----*/
/*------------------------------------*/
/* Definition des codes du langage L3 */
/*------------------------------------*/

#define CODEL3DIALOGUE  0 
/* voir sous code apres */
#define CODEL3OPEN      1
/* argument d'identification de l'images a faire pour l'instant rien */
#define CODEL3CLOSE     2
/* pas d'arg */
#define CODEL3PIXEL     3
#define CODEL3TEXTE     4
#define CODEL3COULEUR   5
#define CODEL3BRILLANCE 6
#define CODEL3MARQUEUR  7
#define CODEL3SEGMENT   8
#define CODEL3CADRE     9
#define CODEL3POLYGONE  10
#define CODEL3FLUSH  	20
#define CODEL3ARC       30
#define CODEL3RESEAU  		100
#define CODEL3SEPARATEUR	102
#define CODEL3EPAISSEUR  	103
#define CODEL3COLORMAP  	200

/*
	items de marquage des elements graphiques
	il est place avant ET apres l'element designe
*/

/* Identifie un texte soft (forme d'un ensemble de segments) */
#define CODEL3TEXTESOFT  	900
/* images incluses dans la page totale */
#define CODEL3SOUSIMAGE  	901
/* Identifie un axe (ensemble de segments) */
#define CODEL3AXE		902

/*-----------------------------------------------------*/
/* Definition des sous-codes L3 du code CODEL3DIALOGUE */
/*-----------------------------------------------------*/

#define SOUSCODEL3_MGRAPH	1
#define SOUSCODEL3_MGRAPHCLEAR	2
#define SOUSCODEL3_ALPHA	3
#define SOUSCODEL3_ALPHACLEAR	4
#define SOUSCODEL3_CLOCHE	5
#define SOUSCODEL3_HARDCOPY	6
#define SOUSCODEL3_SETCUR	7
/* 5, 0, 7, ix, iy, lf */
#define SOUSCODEL3_ANCRERETI	8
#define SOUSCODEL3_PURGENEGS	9
#define SOUSCODEL3_SAVECUR	101
#define SOUSCODEL3_GETPOS	102
#define SOUSCODEL3_FENETRE	200


#define GRANDECROIX 0
#define PETITECROIX 1

#define SANSELASTIQUE      0
#define VECTEURELASTIQUE   1
#define RECTANGLEELASTIQUE 2

#define SANSMARQUE 0

#define SANSTRACE      0
#define VECTEURTRACE   1
#define RECTANGLETRACE 2

#endif
