#ifndef C5INOUT_H
#define C5INOUT_H

// @(#)C5inout.h	1.8 10/12/10 Pierre Brochard

#include "dinosaure/P4tabgenbase.h"
#include "C5constant.h"
#include "cameleon/C5tabconfig.h"
#include "cameleon/C5tabptchar.h"

class C5InOut
{
    private:

	TabC5ConfigEntSor _tabc;
	Tabint            _taiinit;
	Tabint            _tai;
	Tabptchar         _val;
	Tabint            _depass;

    public:

	C5InOut(P4Boolean desalloue = FALSE) ;
	~C5InOut() ;

	int C5LectureConfig(int taii,int tair,int taic,
			char* motcle[],int vali[],REEL_S valr[],char* valc[],
			char* nomfich);
	int C5EcritureConfig(int taii,int tair,int taic,
			char* motcle[],int vali[],REEL_S valr[],char* valc[],
			char* nomfich);

	int C5AjouteConfig(int taii,char* motcle[],int vali[]);
	int C5AjouteConfig(int tair,char* motcle[],REEL_S valr[]);
	int C5AjouteConfig(int taic,char* motcle[],char* valc[])
		{
			return C5AjouteConfig(taic,(S6constPString*) motcle,
					valc);
		}
	int C5AjouteConfig(int taic,S6constPString motcle[],char* valc[]);
	int C5AjouteConfig(char* motcle,const int taille,int vali[]);
	int C5AjouteConfig(char* motcle,const int taille,REEL_S valr[]);

	int C5AjouteConfig(int taii,char* identif,char* motcle[],
			int vali[]);
	int C5AjouteConfig(int tair,char* identif,char* motcle[],
			REEL_S valr[]);
	int C5AjouteConfig(int taic,char* identif,char* motcle[],
			char* valc[]);
	int C5AjouteConfig(char* identif,char* motcle,const int taille,
			int vali[]);
	int C5AjouteConfig(char* identif,char* motcle,const int taille,
			REEL_S valr[]);

	int C5AjouteConfig(TabC5ConfigEntSor& tabconf);

	int C5DepassConfig(const int taille,int depass[]);
	int C5EnleveConfig();
	int C5NettoieConfig(); // a utiliser seulement pour binding Fortran

	int C5LectureConfig(const char* const nomfich);
	int C5LectureConfig(const int num,const int taille);
	int C5EcritureConfig(const char* const nomfich);

    // remplacement de la chaine ident_ori par ident_new dans tous les
    // C5Config de _tabc

	void C5ChangeIdent(const char* const ident_ori,
			const char* const ident_new);

	unsigned NbLastLus() const;
	unsigned NbLastOrig() const;
};

inline unsigned
C5InOut::NbLastLus() const
{
	return _tabc.NbLastLus();
}

inline unsigned
C5InOut::NbLastOrig() const
{
	return _tabc.NbLastOrig();
}

#endif
