#ifndef C5TABCONFIG_H
#define C5TABCONFIG_H

// @(#)C5tabconfig.h	1.7 10/12/10 Pierre Brochard

#include "S6compat.h"

#if defined(P4VERSION_AVEC_TEMPLATE) /* version avec template */
#   include "dinosaure/P4tabgenbasec.h"
#   include "cameleon/C5config.h"

    typedef TabGEN<ptrC5Config> TabC5Config;
    typedef TabGENbuf<ptrC5Config> TabC5Configbuf;
#else // version sans template
#   include "cameleon/C5config.h"

#   define GEN ptrC5Config
#   define TabGEN TabC5Config
#   define TabGENbuf TabC5Configbuf
#   include "dinosaure/P4tabgen.h"
#   undef GEN
#   undef TabGEN
#   undef TabGENbuf
#endif // fin version sans template

class TabC5ConfigEntSor : public TabC5Config 
{
    private:

	P4Boolean _desalloue;
    // nbre de mots cles lus lors de la derniere lecture :
	unsigned _nb_last_lus;
    // nbre de mots cles originels lors de la derniere lecture avant 
    // reconnaissance et affectation
	unsigned _nb_last_orig;

    public:

	TabC5ConfigEntSor();
	TabC5ConfigEntSor(P4Boolean desalloue);
	TabC5ConfigEntSor(ptrC5Config* ptc,unsigned tai);
	TabC5ConfigEntSor(const TabC5ConfigEntSor& tc,
			P4Boolean desalloue = FALSE);
	~TabC5ConfigEntSor();

	void Enleve();

	unsigned NbLastLus() const;
	unsigned NbLastOrig() const;

	C5Config& operator[] (unsigned i) const;
	C5Config& operator[] (int i) const;

// = on trie les deux TabC5ConfigEntSor puis on affecte

	void operator = (const TabC5ConfigEntSor& tc);

// >> on lit et on agrandi avec des C5ConfigChar jusqu'a la fin du fichier

	friend istream& operator >> (istream& ist,TabC5ConfigEntSor& tc);

// << on ecrit

	friend ostream& operator << (ostream& ost,TabC5ConfigEntSor tc);
};

inline
TabC5ConfigEntSor::TabC5ConfigEntSor() :
		TabC5Config(),
		_desalloue(TRUE),
		_nb_last_lus(0),
		_nb_last_orig(0)
{
}

inline
TabC5ConfigEntSor::TabC5ConfigEntSor(P4Boolean desalloue) :
		TabC5Config(),
		_desalloue(desalloue),
		_nb_last_lus(0),
		_nb_last_orig(0)
{
}

inline
TabC5ConfigEntSor::TabC5ConfigEntSor(ptrC5Config* ptc,unsigned tai) :
		TabC5Config(ptc,tai),
		_desalloue(TRUE),
		_nb_last_lus(0),
		_nb_last_orig(0)
{
}

inline unsigned
TabC5ConfigEntSor::NbLastLus() const
{
	return _nb_last_lus;
}

inline unsigned
TabC5ConfigEntSor::NbLastOrig() const
{
	return _nb_last_orig;
}

inline C5Config&
TabC5ConfigEntSor::operator[] (unsigned i) const
{
	return *_tab[i];
}

inline C5Config&
TabC5ConfigEntSor::operator[] (int i) const
{
	return *_tab[i];
}

#endif
