#ifndef U8AFFX_H
#define U8AFFX_H

// @(#)U8affx.h	1.14 01/17/23 Pierre Brochard

#include "P4types.h"
#include "poulpe/U8getpos.h"

typedef XSegment Trait;
typedef XPoint Point;

#define MAX_COLORS 256

// **********************************************************
//  classe U8Coord (pour calcul de coordonnees en cliquant)
// **********************************************************

class U8Coord
{
    public:

	U8Coord() {};
	virtual ~U8Coord() {};

	virtual void Action(REEL,REEL) {};
};

// **********************************************************
//  classe U8Pixmap (pour communication du mode pixmap)
// **********************************************************

class U8Pixmap
{
    public:

	U8Pixmap() {};
	virtual ~U8Pixmap() {};

	virtual void Action(P4Boolean) {};
};

// **********************************************************
//  classe U8Agrand (pour calcul de zoom agrandissement)
// **********************************************************

class U8Agrand
{
    public:

	U8Agrand() {};
	virtual ~U8Agrand() {};

	virtual void Action() {};
};

// **********************************************************
//  classe U8Reduc (pour calcul de zoom reduction)
// **********************************************************

class U8Reduc
{
    public:

	U8Reduc() {};
	virtual ~U8Reduc() {};

	virtual void Action() {};
};

// **********************************************************
//  classe U8Unzoom (pour annulation des zooms)
// **********************************************************

class U8Unzoom
{
    public:

	U8Unzoom() {};
	virtual ~U8Unzoom() {};

	virtual void Action() {};
};

// **********************************************************
//  classe U8CalculImage (pour Calcul Image)
// **********************************************************

class U8CalcImage
{
    public:

	U8CalcImage() {};
	virtual ~U8CalcImage() {};

	virtual void Action() {};
};

// **********************************************************
//  classe U8CalculImageL3 (pour Calcul Image L3)
// **********************************************************

class U8CalcImageL3
{
    public:

	U8CalcImageL3() {};
	virtual ~U8CalcImageL3() {};

	virtual void Action() {};
};

// **********************************************************
//     classe U8AfficheurX
// **********************************************************

class U8AfficheurX : public U8Motion
{
    public:

        U8AfficheurX(U8Coord* const ptc = NULL,U8Pixmap* const ptm = NULL,
			U8Agrand* const pta = NULL,U8Reduc* const ptr = NULL,
			U8Unzoom* const ptu = NULL,U8CalcImage* const pti = NULL,
			U8CalcImageL3* const ptl = NULL);
        ~U8AfficheurX();

	static int poulpe_flag_sig_usr2;

    // pour interface avec sanglier et gestion des couleurs

	inline static void L3X11Sanglier(int codel3[]);
	inline static void Driver(U8AfficheurX* const);
	static U8AfficheurX* Driver();

    // driver X11

	void L3X11(int codel3[]);

	void L3Dialogue(int bloc_l3[]);
	void L3Pixel(const int bloc_l3[]);
	void L3Marqueur(const int bloc_l3[]);
	void l3_to_x11(int bloc_l3[]);
        void l3_tabwid_init(const Widget* const tabw);
	void l3_init_pix(int n_colors,int flag,const Colormap* const colormap,
			 const int* const readwrite);
	void l3_donne_pix(Pixel tab[],int taille,int* nb_pix_used);
	void l3_set_vdc(Widget wid, double x0, double x1, double y0, double y1,
			const int newwin);
	void l3_del_vdc();
	void l3_set_geom(const int width,const int height);
	unsigned GetWidth();
	unsigned GetHeight();
	void L3_init_clear_auto(int clear);
	void L3_to_x11_clear();
	void L3_to_x11_picking_auto(int picking);
	void RelitDisplayList();
	void ImprimeDisplayList();
	int SauveDisplayList(const char* file_sdl);

        void ModePixmap(P4Boolean mp);
        P4Boolean ModePixmap() const;

        void ModeZoomCarre(P4Boolean zc);
        P4Boolean ModeZoomCarre() const;

	Cursor Curseur() const {return _curseur;}

    // callbacks

	void SelectKeyPress(XtPointer calldata);
	void SelectKeyRelease(XtPointer calldata);
	void SelectButtonPress(XtPointer calldata);
	void SelectButtonRelease(XtPointer calldata);
	void SelectEnterWindow(XtPointer calldata);
	void SelectLeaveWindow(XtPointer calldata);
	void SelectPointerMotion(XtPointer calldata);

	void AddKeyPress();
	void AddKeyRelease();
	void AddEnterWindow();
	void AddLeaveWindow();

	void RemoveKeyPress();
	void RemoveKeyRelease();
	void RemoveEnterWindow();
	void RemoveLeaveWindow();

    // pour communication avec les clients

        inline void EnterWindowClient(Window w);
        inline void LeaveWindowClient(Window w);
        inline void ButtonPressClient(Window w);
        inline void ButtonReleaseClient(Window w);
        inline void MotionNotifyClient(Window w);

        inline void ButtonPressBaseClient(Window w);
        inline void ButtonReleaseBaseClient(Window w);
        inline void MotionNotifyBaseClient(Window w);

        inline Window EnterWindowClient() const;
        inline Window LeaveWindowClient() const;
        inline Window ButtonPressClient() const;
        inline Window ButtonReleaseClient() const;
        inline Window MotionNotifyClient() const;

        inline Window ButtonPressBaseClient() const;
        inline Window ButtonReleaseBaseClient() const;
        inline Window MotionNotifyBaseClient() const;

	void SetCurseur(unsigned cur);
	inline unsigned GetCurseur() const;

	void SetFont(const char* const name);
	void SetFont(int taille);

    // appcontext X11

	static XtAppContext _l3Appcontext;

    private:

	static int _mask;

	Widget _widget;

    // mode avec ou sans pixmap

        P4Boolean _mp;

    // variable de modification du GC

	XGCValues xgcv;

    // pour les fontes

	char* menu_font_name;
	XFontStruct* MenuFont;

	struct fenetreX
	{
	    // Definition des coeffs de passage l3 -> pixels
		float ca;
		float cc;
		int cb;
		int cd;

	    // A Revoir
		int largeur;	// largeur de la fenetre pour les marqueurs
		int hauteur;	// hauteur de la fenetre pour les marqueurs

	    // elements indispensables pour effectuer un trace sous Xlib
		GC GrafCont;
		Display* Dpy;
		Window Win;
		int text_flag;
		Point* BufPts; // bufferisation du contour d'un polygone
		int keep; // nombre de segments bufferises
		Trait* BufSeg; // bufferisation des requetes de trace de ligne
		int colorb; // couleur lue
		int brill; // brillance
		int color; // couleur actuelle
		int ncolors;

		fenetreX() {};
		~fenetreX() {};
	};

	fenetreX fen;
	Pixmap _pixmap;
	Drawable _draw;
	float    cx; // Constantes de cadrage
	float    cy; // Constantes de cadrage
	int      opened;

	struct	Lespixels // attributs du pixel au sens X11
	{
		Pixel           pixel;

	    // couleurs en cours pour chacun des pixels

		int             Red;
		int             Green;
		int             Blue;
	};

	Lespixels pix[MAX_COLORS];
	int NbPixUsed;
	int CarteFlag;
	Colormap CarteCourante;
	int ReadWrite;

	unsigned compteur_x11;
	int clear_auto;
	int clear_first_open;
	int clear_first_map;

	int picking_auto;

	void l3_flush_segments();

    // nettoyage X11 (expose + ...)

	static Bool purge_x11(Display*,XEvent*,XPointer);

    // pour enregistrement des Widget dont il faut mettre
    // a jour la colormap

	Widget* tabwid; 

    // gestion de la liste chainee contenant les codes L3

	void DetruitDisplayList();
	void AjouteItemDisplayList(int codel3[]);

	void* AlloueBuffer(unsigned taille);
	int VideBuffer();

	struct ChaineL3
	{
		struct ChaineL3* prec;
		struct ChaineL3* suiv;
		int* code;
	};

	char** pt_buffer_alloue;
	int taille_alloue;

	unsigned pointeur_max;
	int alloue_buffer_reentrant;

	ChaineL3* debut;
	ChaineL3* fin;
	int ChangeDisplayList;

    // pour l'item pixel

	int x_coin_hautgauche_sto;
	int y_coin_hautgauche_sto;
	int width_sto;
	int height_sto;
	int nx_sto;
	int ny_sto;
	int ncolors_sto;
	float a_sto;
	float c_sto;
	int b_sto;
	int d_sto;
	XImage* xim;
	void* data;
	int* pp_sto;

    // flags de L3X11

	int Opened;
	int A_Detruire;
	int couleur_old;

	static int codel3open[2];

    // pour interfacer avec sanglier

	static U8AfficheurX* _affx;

    // pour communication avec un client des EnterWindow, des LeaveWindow,
    // des ButtonPress, des ButtonRelease et des MotionNotify

        Window _enter_window_client;
        Window _leave_window_client;
        Window _button_press_client;
        Window _button_release_client;
        Window _motion_notify_client;

    // pour communication avec un client des MotionNotify,
    // des ButtonPress et des ButtonRelease + conversion espace
    // utilisateur de type base de Psyche (sous-image 4 de sanglier)

        Window _button_press_client_base;
        Window _button_release_client_base;
        Window _motion_notify_client_base;

	static int ErrorWindow(Display*,XErrorEvent*);

    // curseur

	unsigned _curseur_id;
	Cursor _curseur;

    // pour action si on clique sur c (calcul de coordonnees)

	U8Coord* pt_coord;

    // pour action si on clique sur p (mode pixmap)

	U8Pixmap* pt_pixmap;

    // pour action si on clique sur a (zoom agrandissement)

	U8Agrand* pt_agrand;

    // pour action si on clique sur r (zoom reduction)

	U8Reduc* pt_reduc;

    // pour action si on clique sur u (unzoom)

	U8Unzoom* pt_unzoom;

    // pour action si on clique sur i (calcul image)

	U8CalcImage* pt_calcimage;

    // pour action si on clique sur l (calcul image L3)

	U8CalcImageL3* pt_calcimage_l3;

    // Callbacks (partie privee)

	static void MyInputKeyPress(Widget widgetid,XtPointer client_data,
			XEvent* event,Boolean*);
	static void MyInputKeyRelease(Widget widgetid,XtPointer client_data,
			XEvent* event,Boolean*);
	static void MyInputEnterWindow(Widget widgetid,XtPointer client_data,
			XEvent* event,Boolean*);
	static void MyInputLeaveWindow(Widget widgetid,XtPointer client_data,
			XEvent* event,Boolean*);
};

// *****************************************
//     pour interfacer avec sanglier
// *****************************************

inline void
U8AfficheurX::L3X11Sanglier(int codel3[])
{

	if(_affx) _affx->L3X11(codel3);

}

inline void
U8AfficheurX::Driver(U8AfficheurX* const affx)
{
	_affx = affx;
}

inline U8AfficheurX*
U8AfficheurX::Driver()
{
	return _affx;
}

inline void
U8AfficheurX::EnterWindowClient(Window w)
{
	_enter_window_client = w;
}

inline Window
U8AfficheurX::EnterWindowClient() const
{
	return _enter_window_client;
}

inline void
U8AfficheurX::LeaveWindowClient(Window w)
{
	_leave_window_client = w;
}

inline Window
U8AfficheurX::LeaveWindowClient() const
{
	return _leave_window_client;
}

inline void
U8AfficheurX::ButtonPressClient(Window w)
{
	_button_press_client = w;
}

inline Window
U8AfficheurX::ButtonPressClient() const
{
	return _button_press_client;
}

inline void
U8AfficheurX::ButtonReleaseClient(Window w)
{
	_button_release_client = w;
}

inline Window
U8AfficheurX::ButtonReleaseClient() const
{
	return _button_release_client;
}

inline void
U8AfficheurX::MotionNotifyClient(Window w)
{
	_motion_notify_client = w;
}

inline Window
U8AfficheurX::MotionNotifyClient() const
{
	return _motion_notify_client;
}

inline void
U8AfficheurX::ButtonPressBaseClient(Window w)
{
	_button_press_client_base = w;
}

inline Window
U8AfficheurX::ButtonPressBaseClient() const
{
	return _button_press_client_base;
}

inline void
U8AfficheurX::ButtonReleaseBaseClient(Window w)
{
	_button_release_client_base = w;
}

inline Window
U8AfficheurX::ButtonReleaseBaseClient() const
{
	return _button_release_client_base;
}

inline void
U8AfficheurX::MotionNotifyBaseClient(Window w)
{
	_motion_notify_client_base = w;
}

inline Window
U8AfficheurX::MotionNotifyBaseClient() const
{
	return _motion_notify_client_base;
}

inline unsigned
U8AfficheurX::GetCurseur() const
{
	return _curseur_id;
}

#endif
