#ifndef U8GETPOS_H
#define U8GETPOS_H

// @(#)U8getpos.h	1.7 01/09/23 Pierre Brochard

#include "P4types.h"

// **********************************************************
//     classe U8GetPos
// **********************************************************

class U8Motion;

class U8GetPos
{
    public:

        U8GetPos(U8Motion* motion);
        ~U8GetPos();

    // initialisations utiles

	void init(XtAppContext appc,Widget widget);
	void del_dial();
	
	void Pixel(unsigned long pixel) {_pixel = pixel;}
	void DeleteGC() {
		if(_curseur_gc && _disp)
		{
		    XFreeGC(_disp,_curseur_gc);_curseur_gc = NULL;
		}
	}
	void CreateGC(XGCValues& xgcv) {if(_disp && _win)
	    _curseur_gc = XCreateGC(_disp,_win,GCFunction,&xgcv);}

	P4Boolean ModeZoomCarre() const {return _picking_carre;}
	void ModeZoomCarre(P4Boolean zc) {_picking_carre = zc;}

    // Fonctions obtention d'un point par clic de souris

	void Clear(); // remise a zero des coordonnees
	void Dialogue(int typecroix,int typeelastique); // obtention d'1 point
	void BoutonPress(const XEvent* cdtevent); // evenement clic souris
	void BoutonRelease(const XEvent* cdtevent); // evenement clic souris
	void PointeurMotion(const XEvent* cdtevent); // evenement deplacement

    // Coordonnees du point clique calcule par Dialogue

	int X() const {return _x;};
	int Y() const {return _y;};

    private:

	XtAppContext _l3Appcontext;

	Display* _disp;
	Widget _widget;
	Window _win;
	GC _curseur_gc;
	Cursor _curseur_dial;
	unsigned long _pixel;

	U8Motion* _motion;

	int _x_cur_save;
	int _y_cur_save;
	int _x_cur_min_save;
	int _y_cur_min_save;
	int _x_cur_max_save;
	int _y_cur_max_save;
	int _picking_grandecroix;
	int _picking_elastique;
	P4Boolean _picking_carre;

	int _getpos_possible;
	int _Alire;
	int _Disponible;
	int _x;
	int _y;
};

// **********************************************************
//     classe U8Motion
// **********************************************************

class U8Motion
{
    public:

        U8Motion() : _getpos(this),
	    _is_buttonpress(False),
	    _is_buttonrelease(False),
	    _is_pointermotion(False) {}
        virtual ~U8Motion() {}

    // Ajout callbacks au Widget ou l'on marque les positions avec la souris

	void AddButtonPress(Widget);
	void AddButtonRelease(Widget);
	void AddPointerMotion(Widget);

    // Suppression callbacks

	void RemoveButtonPress(Widget);
	void RemoveButtonRelease(Widget);
	void RemovePointerMotion(Widget);

    // Test callbacks

	Bool IsButtonPress() const {return _is_buttonpress;}
	Bool IsButtonRelease() const {return _is_buttonrelease;}
	Bool IsPointerMotion() const {return _is_pointermotion;}

    // Curseur par defaut

	virtual Cursor Curseur() const {return None;}
	
    // Fonctions appelees par les callbacks

	virtual void SelectButtonPress(XtPointer calldata);
	virtual void SelectButtonRelease(XtPointer calldata);
	virtual void SelectPointerMotion(XtPointer calldata);

    protected:

    // pour gestion d'un curseur (grand ou petit)

	U8GetPos _getpos;

    private:

	Bool _is_buttonpress;
	Bool _is_buttonrelease;
	Bool _is_pointermotion;

	static void MyInputButtonPress(Widget widgetid,XtPointer client_data,
			XEvent* event,Boolean*);
	static void MyInputButtonRelease(Widget widgetid,XtPointer client_data,
			XEvent* event,Boolean*);
	static void MyInputPointerMotion(Widget widgetid,XtPointer client_data,
			XEvent* event,Boolean*);
};

#endif
