#ifndef SANGLIERP_H
#define SANGLIERP_H

/* @(#)sanglierP.h	1.2 10/12/10 */

#ifndef SANGLIER_H
#   include "sanglier.h"
#endif

/*-------------------------------------------------------------------*
 *                            Partie privee                          *
 *                          interne a sanglier                       *
 *-------------------------------------------------------------------*/
 
#ifdef __cplusplus
extern  "C" {
#endif

    typedef struct
    {
	    REEL            valeur;
	    double          taille;
	    int             label;
	    int             nsignif;
	    int		   principal /* pour le passage en gras */;
    } GRADUATION;

    void    L3ToPostscript(int codel3[] /* IN */);

    void    L3PostscriptDriverInit(void);

    void    L3SetOptPostSave(void);

    void    L3PostscriptDriver(int codel3[] /* IN */ );

    void    L3PostscriptDriverLwc(int codel3[] /* IN */ );

    void    L3PostscriptDriverLwct(int codel3[] /* IN */ );

    void    L3VisuDriver(int codel3[] /* IN */ );

    void    L3T4014Driver(int codel3[] /* INOUT */ );

    int     L3ClippingSegment(int xpage1 /* IN */ ,
		    int ypage1 /* IN */ ,
		    int xpage2 /* IN */ ,
		    int ypage2 /* IN */ ,
		    int xypage[] /* OUT */ );

    int     L3ClippingSegmentGen(int XClipMin /* IN */,
		    int XClipMax /* IN */,
		    int YClipMin /* IN */,
		    int YClipMax /* IN */,
		    int xpage1 /* IN */ ,
		    int ypage1 /* IN */ ,
		    int xpage2 /* IN */ ,
		    int ypage2 /* IN */ ,
		    int xypage[] /* OUT */ );

    void    L3ClippingPolygoneDroite(int xmin /* IN */ ,
		    int signe /* IN */ ,
		    int x[] /* IN */ ,
		    int y[] /* IN */ ,
		    int xres[] /* OUT */ ,
		    int yres[] /* OUT */ ,
		    int *p_nsom /* OUT */ );

    int     L3ClippingPoint(int xl3 /* IN */ ,
		    int yl3 /* IN */ );

    void    L3NegsInitialize(void);

    void    L3NegsDriver(int codel3[] /* INOUT */ );

    void    L3CopieDriver(int codel3[] /* IN */ );

    void    L3GrignoteLabel(char texte[] /* INOUT */ ,
		    int Impose
		    );

    void    L3AppelDrivers(int codel3[]	/* INOUT : Tableau de communication
					   avec les drivers */ );


    void    TransType(void *source /* IN */ ,
		    REEL * destin /* OUT: */ ,
		    int type	/* IN : enum {Simple = 1, Double,
				   Entier} */ ,
		    int incre /* IN */ ,
		    int taille /* IN : nb d'elements a convertir */ );
		          
    void    L3SelectionSousImage(int sousimage /* IN */ );

    void    L3CalculValClip(void);

    void    L3CalculConvCoord(void);

    void    L3TexteNumerique(int ssim, char *txt);
    void    L3TailleTexteNumerique(int ssim, char *txt, int *dx, int *dy);
    void    L3BeauLabelScientifique(REEL valeur,
		    int nsignif,
		    char txteout[],
		    int Impose /* IN */
		    );
    void    L3VerifieBorne(REEL xmin, REEL xmax, REEL *rmin, REEL *rmax);

    void    L3CalculValeurs(REEL min,
		    REEL max,
		    const int nintervalles,
		    const int modelog,
		    const int gradinter,
		    const int label,
		    const int typeaxe,
		    const int factorisation,
		    int* const p_ninter,
		    int* const lgtabval, /* taille du tableau tabvaleur */
		    GRADUATION** const p_tabvaleur,
		    double* const p_facteur
		    );

    int L3ChiffresSignificatifs(double inf,
		    double val,
		    double sup
		    );
    double L3TailleGraduation(int typegraduation,
		    int typeaxe
		    );
    double L3PasDeGraduation(double largeur,
		    int nintervalles,
		    double *p_nf
		    );
    double L3BaseMin(double min,
		    double pas
		    );
    double L3BaseMax(double max,
		    double pas
		    );
    double L3BaseMinLog(double min,
		    double pas
		    );
   
    double L3BeauNombre(double x,
		    int round,
		    double *p_nf
		    );
   
    void L3Realloue(int i /* nombre d'element utilise */ ,
		    int *lgtabval /* taille du tableau */ ,
		    GRADUATION ** p_tabvaleur	/* tableau a surveiller */
		    );

    int cb_to_cmap(int c,
		    int b
		    );

    int L3Nint(double d
		    );

    int L3Egal(const double x, const double y, const double ratio);

    void L3Axe(void);

#ifdef __cplusplus
	    }
#endif /* __cplusplus */

#endif /* SANGLIERP_H */
